---
title: Installation
permalink: /docs/installation/
jumbotron:
  title: Installation
  tagline: Deploy Cerb in Docker, the cloud, or on your own servers
  breadcrumbs:
  -
    label: Docs &raquo;
    url: /docs/home/
---

## Docker

For self-hosted evaluation, testing, and development, we _strongly_ recommend using our pre-configured [Docker container](/docs/installation/docker/).

This allows you to start using Cerb in a few minutes without any server configuration. We also provide sample data to simulate real-world use.

## Cerb Cloud

[Cerb Cloud](/cloud/) is a subscription-based service that provides a ready-to-use, highly available, durable, and secure instance of Cerb in an ideal environment. We'll handle the technical details so you can focus on your mission.

All you need is a web browser. You can optionally bring your own domain name (e.g. `support.example.com`). We provide inbound and outbound email services, or you can connect to your existing email provider (e.g. O365, Gmail, Fastmail).

[Sign up](/signup/) for a free trial of Cerb Cloud with no time limit (as long as you're actively using it).

## On-Premises

If you wish to self-host Cerb in production, or you have a requirement to do so (e.g. HIPAA, GDPR, government), you can [install](/docs/installation/self-hosted/) the software on servers you control.

Your servers must meet the minimum requirements. You should have team members with experience managing servers and deploying web services using PHP and MySQL.

We also provide enterprise support contracts for technical assistance outside the scope of Cerb functionality.
