---
title: Introduction
permalink: /docs/intro/
toc:
  title: Introduction
jumbotron:
  title: Introduction
  tagline: 
  breadcrumbs:
  -
    label: Docs &raquo;
    url: /docs/home/
---

<div class="cerb-screenshot">
<img src="{{ "/assets/images/docs/getting-started/cerb_browser_dark.png" | prepend: site.cdn.baseurl }}" class="screenshot" width="2763" height="1662">
</div>

# What is Cerb?

[**Cerb**](/) is a fully customizable, web-based platform for enterprise communication and process automation. The project has continuously evolved for 22+ years based on the feedback of thousands of teams around the world in almost every industry. It is used by everyone from solo founders to 1,000+ person teams managing millions of customer requests.

Cerb integrates with any API-based service. It can automate nearly any repetitive digital workflow with its specialized [KATA](/docs/kata/) language and browser-based coding tools. [Automations](/docs/automations/) add conditional actions to any event. [Interactions](/docs/interactions/) extend any toolbar for complex multistep workflows that require user input.

Teams and individuals can build a personalized "[mission control](/docs/dashboards/)" using highly customizable workspace widgets to stay focused on their most important tasks. [Custom records](/docs/records/#custom-records) and [fields](/docs/custom-fields/) organize of any kind of task (email, calls, social media, orders, survey responses, todo, etc). Pre-built solutions can be easily shared within the community using [packages](/docs/packages/).

The most common use case is converting standard POP3/IMAP mailboxes like Gmail or O365 (e.g. support@, team@) into high-volume team-based webmail with automated triage, internal discussions with @mentions, built-in productivity tools, custom actions, reporting, and a shared history.

An emerging use case is integrating with large language models (LLMs) to automatically suggest answers to customer requests based on existing team knowledge (documentation, FAQs, articles).

You can run Cerb on your own hardware, in Docker, or in [Cerb Cloud](/pricing/) as a fully managed service.

We share 100% of our source code on [GitHub](https://github.com/cerb/cerb-release/). Cerb is free to use for a single seat (no license required). This allows you to maintain an archive of your historical data on the latest version in perpetuity at no ongoing cost. It's your data.

# Next steps

* [Admin Guide](/docs/installation/)
* [Worker Guide](/docs/guide/workers/user-interface/)
* [Developer Guide](/docs/scripting/)