---
title: User Interface
permalink: /docs/guide/workers/user-interface/
redirect_from:
  - /docs/navigation/
jumbotron:
  title: User Interface
  tagline: 
  breadcrumbs:
  -
    label: Docs &raquo;
    url: /docs/home/
  -
    label: Worker Guide &raquo;
---

The global navigation controls are at the top of every page in Cerb.

<div class="cerb-screenshot">
<img src="/assets/images/docs/ui/navbar.png">
</div>

## Pages

The _navigation bar_ displays shortcuts to your favorite [workspace pages](/docs/workspaces/).

<div class="cerb-screenshot">
<img src="/assets/images/docs/ui/pages.png">
</div>

You can use your mouse to drag workspace pages into a different order. The first item in your navbar is your default page.

New pages are added by clicking on the downward-pointing arrow at the end of the list.

## Logo

You can click on the logo in the top left from anywhere in Cerb to quickly return to your default page. This is a shortcut for clicking on the the first page in your [navigation bar](#pages).

<div class="cerb-screenshot">
<img src="/assets/images/docs/ui/logo_shortcut.png" class="screenshot">
</div>

## Worker Menu

Clicking on your name in the top right reveals the worker menu with actions specific to your account.

<div class="cerb-screenshot">
<img src="/assets/images/docs/ui/worker_menu.png">
</div>

## Light/Dark Mode

You can toggle between light and dark mode with the button in the top right.

<div class="cerb-screenshot">
<img src="/assets/images/docs/ui/light_dark.png">
</div>

## Notifications

When you have unread [notifications](/docs/notifications/), a red alert box will appear in the top right. You can click on it to view them in a popup.

<div class="cerb-screenshot">
<img src="/assets/images/docs/ui/notifications.png">
</div>

## Search

You can quickly view and filter records of any type from the [search](/docs/search/) menu in the top right. Each search popup is a temporary [workspace](/docs/workspaces/).

The search menu automatically suggests record types based on your recent activity. You can pin specific record types to the search menu by clicking on your name in the top right and clicking **Settings >> Search**.

<div class="cerb-screenshot">
<img src="/assets/images/docs/ui/search.png">
</div>

## Setup

If you're an administrator, you'll see a [Setup](/docs/setup/) link at the end of navbar.

<div class="cerb-screenshot">
<img src="/assets/images/docs/setup/setup_menus.png" class="screenshot">
</div>
