---
title: Philosophy
excerpt: Cerb is more than just code, it's a philosophy about our increasingly digital world.
permalink: /docs/philosophy/
jumbotron:
  title: Philosophy
  tagline: Cerb is more than just code, it's a philosophy about our increasingly digital world
---

## We believe in platforms and toolkits

- We don't want to build schizophrenic software that forces everyone's conflicting opinions on each other. People deserve the freedom to customize their own environment according to their needs. They should be trusted as the experts of their domain. Software should do what they ask; not the other way around.
- Some complexity is necessary to do interesting things, and we are not afraid of it. We're proud to focus on the niche market for _"tech-savvy do-it-yourselfers"_. They are the future.
- We want you to see our work as a solid foundation for building the solution you've always wanted. We'll give you the tools and assistance to add the finishing touches.
- We're rewarded by seeing people use our tools to solve challenges we never anticipated in creative ways we hadn't thought of.

## We believe in commercial open source

- We've never felt completely comfortable using tools that hide their source code, so we share __100%__ of [our code](http://github.com/cerb/cerb-release) and [planning tools](https://github.com/jstanden/cerb/issues). The value we provide is more than bits and bytes.
- Our community lends thousands of critical eyes and minds. Shoddy work wouldn't make it past their constructive scrutiny. 
- There will always be people who bypass software licensing, steal code, or copycat innovative concepts. We're not going to be paranoid about it and mistrust everyone.
- If people have to be forced into financially supporting our work, then we went very wrong somewhere.  Our target audience wants us to succeed.

## We believe in privacy

- We will [respect your privacy](/privacy/) regarding any information we may collect while providing our services.
- You are not the product. We sell software, not advertising.
- Your data is your property. We don't monetize it, and we only share it to the degree necessary to provide the services you request, or to comply with the law.

## We believe well-designed software is art

- Encyclopedia Britannica defines art as _"A visual object or experience consciously created through an expression of skill or imagination."_
- We do not believe art means _"indulging in design fads"_.
- Subtle beauty in design is important; but it looks like clown makeup when aesthetics try to conceal a lack of depth.
- Form follows function. Usability, flexibility, stability, scalability, and maintainability will always take priority. Those things must have an artistic level of detail.

{% comment %}
## We believe in agile development

- We're not interested in holding back useful improvements just to have a more marketable announcement.
- We aim to publish updates every few weeks based on community feedback.
- We don't want to make hostages out of bug fixes and usability tweaks.  We won't charge you for them.

{% endcomment %}