---
title: Credits
permalink: /docs/credits/
layout: docs
jumbotron:
  title: Credits
  tagline: Cerb wouldn't exist without these building blocks and contributions
---

# Developers

- [Jeff Standen](http://www.linkedin.com/in/jeffstanden) has nearly 30 years of software development experience, and is the founding partner at Webgroup Media LLC. He has been Cerb's software architect and lead programmer from the first line of code in January 2002[^bdfl].

- [Dan Hildebrandt](http://www.linkedin.com/in/danielhildebrandt) is a partner at Webgroup Media LLC and an active Cerb developer since 2005.

# Contributors

- [Ben Halsted](http://www.linkedin.com/in/bhalsted)
- [Brenan Cavish](http://www.linkedin.com/pub/brenan-cavish/21/a89/57b)
- Corey Cohen
- [Darren Sugita](http://www.linkedin.com/pub/darren-sugita/24/234/978)
- [Jacob Cavish](https://www.linkedin.com/in/jacob-cavish-coding/)
- [Jeremy Johnstone](http://www.linkedin.com/in/jsjohnst)
- [Jerry Kanoholani](http://www.linkedin.com/pub/jerry-kanoholani/19/74/977)
- Joe Geck
- [Mike Fogg](http://www.linkedin.com/in/mikefogg)
- [Niek Beernink](http://nl.linkedin.com/in/nbeernink)
- [Robert Middleswarth](http://www.linkedin.com/in/robertmiddleswarth)
- [Ryan Bantz](https://www.linkedin.com/in/ryanbantz)
- [Scott Luther](http://www.linkedin.com/pub/scott-luther/7/3b3/98)
- [Trent Ramseyer](http://www.linkedin.com/in/trentramseyer)

# Platform

- **Devblocks** is a software development framework created by Webgroup Media that has evolved in parallel with Cerb. It provides the application framework, development platform, plugin architecture, and software development philosophy for all Cerb functionality and third-party plugins.

- [HTML5](https://en.wikipedia.org/wiki/HTML5) is a markup language used for structuring and presenting content on the World Wide Web. It is the fifth and current version of the HTML standard.

- [PHP](http://www.php.net/) is a popular programming language for web development.

- [MySQL](http://www.mysql.com/) is the world's most popular open source database.

# Infrastructure

- [Amazon Web Services](https://aws.amazon.com/)

- [Docker](https://www.docker.com)

- [GitHub](https://github.com/)

# Libraries

- [Ace](https://ace.c9.io) is a high performance code editor for the web. It provides syntax highlighting in 110+ languages, themes, code autocompletion, indent/outdent, parentheses matching, code folding, and much more.

- [Ace-Diff](https://ace-diff.github.io/ace-diff/) extends Ace Editor with diff/merging functionality.

- [Amazon S3 PHP Class](http://undesigned.org.za/2007/10/22/amazon-s3-php-class) is a PHP library by Donovan Schönknecht for working with Amazon's S3[^s3] web service.

- [C3.js](https://c3js.org) is a Javascript charting library built on top of D3.

- [Composer](https://getcomposer.org/) is a package manager for PHP.

- [D3.js](https://d3js.org) is a Javascript library for manipulating documents based on data.

- [Guzzle](https://github.com/guzzle/guzzle/) is an extension PHP HTTP client library.

- [HumanizeDuration](https://github.com/EvanHahn/HumanizeDuration.js) is a Javascript library for generating human-friendly relative times from a measure of time (e.g. days, hours, seconds, milliseconds).

- [jQuery](http://jquery.com/) is a fast and concise JavaScript library that simplifies HTML document traversal, event handling, animation, and asynchronous interactions (Ajax).

- [jQuery UI](http://jqueryui.com/) is a curated set of user interface interactions, effects, widgets, and themes built on top of the jQuery JavaScript Library.

- [jQuery UI Touch Punch](http://touchpunch.furf.com) converts mouse-based events in jQuery UI to touch gestures for mobile devices (e.g. tap, slide, drag/drop).

- [mtdownling/cron-expression](https://github.com/mtdowling/cron-expression) is a PHP library for generating time intervals using Unix crontab syntax.

- [Parsedown](http://michelf.com/projects/php-markdown/) is a PHP library for converting lightweight Markdown[^markdown] text into HTML.

- [php-encryption](https://github.com/defuse/php-encryption) is a secure library for encrypting data in PHP.

- [php-saml](https://github.com/onelogin/php-saml) is a PHP library for single-sign on (SSO) authentication using SAML.

- [phpseclib](https://github.com/phpseclib/phpseclib) is a PHP library for secure communications.

- [PHPUnit](https://phpunit.de/) is a programmer-oriented unit testing framework for PHP.

- [Smarty](http://www.smarty.net/) is a template engine for PHP. It facilitates the separation of presentation (HTML/CSS) from application logic.

- [steverhoades/oauth2-openid-connect-server](https://github.com/steverhoades/oauth2-openid-connect-server/) is a PHP library for implementing OpenID Connect server functionality.

- [Swift Mailer](http://swiftmailer.org/) is a component-based library for sending email from PHP applications.

- [thephpleague/oauth2-client](https://github.com/thephpleague/oauth2-client/) is a PHP library for simplified integration with OAuth 2.0 service providers.

- [thephpleague/oauth2-server](https://oauth2.thephpleague.com/) is a PHP library for implementing standards compliant OAuth 2.0 servers.

- [Twig](http://www.twig-project.org/) is an open source template engine for the PHP programming language by Fabien Potencier. It focuses on being fast, secure, and flexible.

# Licenses

- [GLYPHICONS](http://glyphicons.com) is a library of precisely prepared monochromatic icons and symbols, created with an emphasis to simplicity and easy orientation.

# References

[^bdfl]: <https://en.wikipedia.org/wiki/Benevolent_dictator_for_life>
[^s3]: <http://aws.amazon.com/s3/>
[^markdown]: <http://daringfireball.net/projects/markdown/>