---
title: "Extension Point: Page Section"
permalink: /docs/plugins/extensions/points/cerberusweb.ui.page.section/
toc:
  title: "Page Section"
  expand: Plugins
jumbotron:
  title: "Page Section"
  tagline: 
  breadcrumbs:
  -
    label: Docs &raquo;
    url: /docs/home/
  -
    label: Plugins &raquo;
    url: /docs/plugins/
  -
    label: Extension Points &raquo;
    url: /docs/plugins/#extensions
---

|---
|-|-
| **Name:** | Page Section
| **Identifier (ID):** | cerberusweb.ui.page.section

{% include docs/plugins/points/cerberusweb.ui.page.section.md %}

# Extensions

| Abstract Custom Record Section | `core.page.profiles.abstract_custom_record`
| Address Section | `core.page.profiles.address`
| Attachment Section | `core.page.profiles.attachment`
| Authentication Section | `core.page.setup.auth`
| Avatars Section | `core.page.setup.avatars`
| Behavior Section | `core.page.profiles.behavior`
| Bot Scripting Tester | `core.page.setup.developers.bot_scripting_tester`
| Bot Section | `core.page.profiles.bot`
| Branding Section | `core.page.setup.branding`
| Bucket Section | `core.page.profiles.bucket`
| Cache Section | `core.page.setup.cache`
| Calendar Event Section | `core.page.profiles.calendar_event`
| Calendar Recurring Profile Section | `core.page.profiles.calendar_recurring_profile`
| Calendar Section | `core.calendars.page.profiles.calendar`
| Call Section | `calls.page.profiles.call`
| Card Widget Section | `cerb.page.profiles.card_widget`
| Classifier Class Section | `core.page.profiles.classifier_class`
| Classifier Entity Section | `core.page.profiles.classifier_entity`
| Classifier Example Section | `core.page.profiles.classifier.example`
| Classifier Section | `core.page.profiles.classifier`
| Comment Section | `core.page.profiles.comment`
| Community Portal Section | `core.page.profiles.community_tool`
| Connected Account Section | `core.page.profiles.connected_account`
| Connected Service Section | `core.page.profiles.connected_service`
| Contact Section | `core.page.profiles.contact`
| Currency Section | `core.page.profiles.currency`
| Custom Field Section | `core.page.profiles.custom_field`
| Custom Fields Section | `core.page.setup.fields`
| Custom Fieldset Section | `core.page.profiles.custom_fieldset`
| Custom Record Section | `core.page.profiles.custom_record`
| Data Query Builder | `core.page.setup.developers.data_query_builder`
| Data Query Tester | `core.page.setup.developers.data_query_tester`
| Domain Section | `cerberusweb.datacenter.page.profiles.domain`
| Draft Section | `core.page.profiles.draft`
| Email Signature Section | `core.page.profiles.email_signature`
| Export Bots | `core.page.setup.developers.export.bots`
| Feed Item Page Section | `feeds.page.profiles.feed_item`
| Feed Page Section | `feeds.page.profiles.feed`
| File Bundle Section | `core.page.profiles.file_bundle`
| Gpg Public Key Section | `core.page.profiles.gpg_public_key`
| Group Section | `core.page.profiles.group`
| HTML Template Section | `core.page.profiles.mail_html_template`
| Icon Reference | `core.page.setup.developers.reference.icons`
| Incoming Mail Section | `core.page.setup.mail_incoming`
| Internal Section Calendars | `core.internal.section.calendars`
| Internal Section Notifications | `core.internal.section.notifications`
| Internal Section Portals | `core.internal.section.portals`
| Internal Section Records | `core.internal.section.records`
| Internal Section Watchers | `core.internal.section.watchers`
| Internal Section Worklists | `core.internal.section.worklists`
| Jira Issue Section | `jira.page.profiles.jira_issue`
| Jira Project Section | `jira.page.profiles.jira_project`
| KB Article Section | `cerberusweb.page.profiles.kb_article`
| Kb Category Section | `kb.page.profiles.kb_category`
| License Section | `core.page.setup.license`
| Localization Section | `core.page.setup.localization`
| Mail Transport Section | `core.page.profiles.mail_transport`
| Mailbox Account Section | `core.page.profiles.mailbox`
| Message Section | `core.page.profiles.message`
| OAuth App Section | `core.page.profiles.oauth_app`
| OAuth2 Token Generator | `core.page.setup.developers.oauth2_token_generator`
| Opp Section | `crm.page.profiles.opportunity`
| Organization Section | `core.page.profiles.organization`
| Outgoing Mail Section | `core.page.setup.mail_outgoing`
| PGP Private Key Section | `core.page.profiles.gpg_private_key`
| Package Import Section | `core.page.setup.package.import`
| Package Library Section | `core.page.setup.package.library`
| Package Section | `core.page.profiles.package_library`
| Plugins Section | `core.page.setup.plugins`
| Profile Tab Section | `core.page.profiles.profile_tab`
| Profile Widget Section | `core.page.profiles.profile_widget`
| Project Board Column Section | `projects.page.profiles.project_board_column`
| Project Board Section | `core.page.profiles.project_board`
| Reminder Section | `core.page.profiles.reminder`
| Role Section | `core.page.profiles.role`
| Saved Search Section | `core.page.profiles.context_saved_search`
| Scheduled Behavior Section | `core.page.profiles.scheduled_behavior`
| Scheduled Behavior Section | `core.page.setup.scheduled_behavior`
| Scheduler Section | `core.page.setup.scheduler`
| Search Section | `core.page.setup.search`
| Security Section | `core.page.setup.security`
| Sensor Page Section | `cerberusweb.profiles.sensor`
| Server Page Section | `cerberusweb.profiles.server`
| Sessions Section | `core.page.setup.sessions`
| Setup Page Translations Section | `translators.setup.section.translations`
| Snippet Section | `core.page.profiles.snippet`
| Snippets Section | `core.page.setup.snippets`
| Storage Attachments Section | `core.page.setup.storage_attachments`
| Storage Content Section | `core.page.setup.storage_content`
| Storage Profiles Section | `core.page.setup.storage_profiles`
| Task Section | `core.page.profiles.task`
| Team Section | `core.page.setup.team`
| Ticket Section | `core.page.profiles.ticket`
| Time Tracking Activity Section | `cerb.page.profiles.timetracking_activity`
| Time Tracking Page Section | `cerberusweb.profiles.time_tracking`
| WebApi Credentials Section | `api.page.profiles.webapi_credentials`
| Webhook Listener Section | `webhooks.page.profiles.webhook_listener`
| Worker Section | `core.page.profiles.worker`
| Workspace List Section | `core.page.profiles.workspace_list`
| Workspace Page Section | `core.page.profiles.workspace_page`
| Workspace Tab Section | `core.page.profiles.workspace_tab`
| Workspace Widget Section | `core.page.profiles.workspace_widget`

<div class="section-nav">
	<div class="left">
		<a href="/docs/plugins/extensions/#extension-points" class="prev">&lt; Extension Points</a>
	</div>
	<div class="right align-right">
	</div>
</div>
<div class="clear"></div>