---
title: Setup
permalink: /docs/setup/
jumbotron:
  title: Setup
  tagline: A guide for Administrators
  breadcrumbs:
  -
    label: Docs &raquo;
    url: /docs/home/
---

<div class="cerb-screenshot">
<img src="/assets/images/docs/setup/setup_menus.png" class="screenshot">
</div>

The **setup** page in the top right of the navigation bar provides a central location for administrators to configure Cerb and any plugins that have been installed.

The page is divided into sections, each with a blue menu designated by a downward-pointing arrow. You can hover over each menu to display the configuration options for that section.

- **Configure**
  - [Branding](/docs/setup/configure/branding/)
  - [Cache](/docs/setup/configure/cache/)
  - [License](/docs/setup/configure/license/)
  - [Localization](/docs/setup/configure/localization/)
  - [Scheduler](/docs/setup/configure/scheduler/)
  - [Search](/docs/setup/configure/search/)
- **Security**
  - [Configure](/docs/setup/configure/security/)
  - [Authentication](/docs/setup/configure/authentication/)
  - [Sessions](/docs/setup/configure/sessions/)
- **Records**
  - [Avatars](/docs/setup/records/avatars/)
  - [Custom Fields](/docs/setup/records/custom-fields/)
  - [Snippets](/docs/setup/records/snippets/)
- **Team**
  - [Roles](/docs/setup/team/roles/)
  - [Groups](/docs/setup/team/groups/)
  - [Workers](/docs/setup/team/workers/)
- **Mail**
  - **Incoming Mail**
    - [Settings](/docs/setup/mail/incoming/)
    - [Mailboxes](/docs/setup/mail/mailboxes/)
    - [Filtering](/docs/setup/mail/filtering/)
    - [Routing](/docs/setup/mail/routing/)
    - HTML
    - [Import](/docs/setup/mail/import/)
    - [Failed Messages](/docs/setup/mail/failed/)
    - [External Relay](/docs/setup/mail/relay/)
  - **Outgoing Mail**
    - [Email Transports](/docs/setup/mail/transports/)
    - [Sender Addresses](/docs/setup/mail/sender-addresses/)
    - [Settings](/docs/setup/mail/outgoing/)
    - [Automated Email Templates](/docs/setup/mail/templates/)
    - [Queue](/docs/setup/mail/queue/)
- **Packages**
  - [Library](/docs/setup/packages/library/)
  - [Import](/docs/setup/packages/import/)
- **Storage**
  - [Overview](/docs/setup/storage/overview/)
  - [Profiles](/docs/setup/storage/profiles/)
  - [Objects](/docs/setup/storage/objects/)
- **Developers**
  - Automation Logs
  - Bot Scripting Tester
  - Data Query Tester
  - Export Bots
  - Icon Reference
  - OAuth2 Token Generator
  - Platform
- **Plugins**
  - [Configure](/docs/setup/plugins/installed/)