---
title: Create a new Support Center community portal
excerpt: This guide provides step-by-step instructions for creating a new Support Center portal.
layout: integration
topic: Portals
jumbotron:
  title: Create a new Support Center community portal
  tagline: ""
  breadcrumbs:
  -
    label: Resources &raquo;
    url: /resources/
  -
    label: Guides &raquo;
    url: /resources/guides/
  -
    label: Portals &raquo;
    url: /resources/guides/#portals
---

* TOC
{:toc}

# Introduction

The most popular [community portal](/docs/portals/) is the **Support Center**. This provides a place for customers to read recent announcements, search your knowledgebase, fill out contact forms, edit their profile, and review their [ticket](/docs/tickets/) history.

<div class="cerb-screenshot">
<img src="/assets/images/guides/portals/support-center/sc.png" class="screenshot">
</div>

# Install the Support Center plugin

First, make sure that the necessary [plugin](/docs/plugins/) is enabled.

Navigate to **Setup >> Plugins >> Installed**.

Type `support` in the search box and verify that the Support Center plugin is installed. If not, enable it.

# Create a new community portal

Now we're ready to create a new Support Center.

Navigate to **Search >> Community Portals**.

Click the **(+)** icon above the worklist.

Enter the following values:

* **Name:** `Support Center`
* **Type:** `Support Center`
* **Path:** `support`

<div class="cerb-screenshot">
<img src="/assets/images/guides/portals/support-center/create.png" class="screenshot">
</div>

Click the **Save Changes** button.

# Configure the Support Center

Click on **Support Center** in the community portal worklist to open its profile.

Select the **Configure** tab.

### Branding

<div class="cerb-screenshot">
<img src="/assets/images/guides/portals/support-center/branding.png" class="screenshot">
</div>

### Modules

<div class="cerb-screenshot">
<img src="/assets/images/guides/portals/support-center/modules.png" class="screenshot">
</div>

Click the **Save Changes** button.

# Deploy the Support Center

Switch to the **Deploy** tab and follow the instructions.

