---
layout: post
title:  "6.5"
excerpt: Cerb 6.5 is a major feature update released in September 2013 with 144+ new features and improvements from community feedback.
author: The Cerb Team
date:   2013-09-20 00:00:00 -0700
permalink: /releases/6.5/
redirect_from:
  - /6.5/
  - /wiki/6.5/
tags: cerb announcements releases
release:
  type: feature upgrade
  count: 144
---

**Cerb ({{ page.title }})** is a **{{ page.release.type }}** released on {{ page.date | date:"%B %d, %Y" }}.  It contains over **{{ page.release.count }}** new features and improvements from community feedback.

* TOC
{:toc}

<div class="cerb-box note">
	<p>
		To check if you qualify for this release as a free update, view <b>Setup &raquo; Configure &raquo; License</b>. If your software updates expire on or after <b>September 20, 2013</b> then you can upgrade without renewing your license.
	</p>
</div>

* [Visit the project website](https://cerb.ai/pricing/) to subscribe to feature updates on your existing license.

* To upgrade your installation, [follow the instructions here](https://cerb.ai/docs/upgrading/).

# Important Release Notes 

* **Make a [backup](https://cerb.ai/docs/backups/) before upgrading.**

# Mobile plugin

### Platform-independent mobile interface

* [CHD-1056] [CHD-1108] [CHD-2378] A 'Mobile Interface' plugin has been added to the Plugin Library. We had originally held off on creating a mobile interface because most workers use desktop computers and Cerb's UI workflow design is heavily dependent on multiple layers of popups to enable multiple actions from the same page. With the introduction of custom workspace pages in 6.0 and distinct Virtual Attendants in 6.5, the components of a mobile interface clicked into place. Rather than seeking to replace all the functionality in Cerb's normal UI, the mobile UI provides access to previously curated content. The primary focus is on providing access to notifications, workspaces, and special Virtual Attendant mobile behaviors. The mobile plugin is built using jQuery Mobile, so there is a large list of supported devices: iPhone, iPad, Android, Windows Phone, Blackberry, WebOS, etc. We feel that a slim web interface is an ideal mobile strategy for Cerb because the functionality is contained within a plugin that is always in sync with the version of the main project. With mobile apps in various app stores using Cerb's API, users would constantly run into issues with version incompatibilities.  Once logged in, the mobile interface can be accessed from any mobile browser by visiting the '/m' page at your normal Cerb URL.  This can be bookmarked or saved to your device's home screen.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile.png" class="screenshot">
</div>

### Mobile notifications

* Notifications can be viewed in the mobile interface. At the moment they open up a new browser tab to the full Cerb UI. In the near future we plan to implement mobile-friendly profiles for all record types. A count of unread notifications is displayed on a badge at the bottom of the app.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_notifications.png" class="screenshot">
</div>

* The unread notification count in the mobile interface now updates every time a new page is displayed.  The count is still efficiently cached on the server.

* Clicking on a mobile notification will now display its profile instead of opening up a browser to the full site.  This allows a notification to be researched without leaving the mobile interface.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_notification_profiles.png" class="screenshot">
</div>

* Mobile notification profiles provide a 'Mark as read' button that clears the notification and returns to the previous page.  This allows notifications to be saved for later if they're not currently actionable.

### Mobile workspaces

* [CHD-891] Workspaces can be viewed in the mobile interface. All workspaces that the current worker has access to will be displayed. The worker is prompted in several steps to select a workspace, a tab, and finally a worklist or a widget.  The pages for tabs, worklists, and widgets provide shortcuts to jump back to the previous selections (for instance, from a widget to a page or tab). A filter box above the list narrows down the choices (for example, only showing pages with a specific owner). At the moment, clicking on a worklist row opens up the record in the full Cerb UI in the default browser.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_workspaces.png" class="screenshot">
</div>

* The Workspaces shortcut in the mobile footer now displays a worker's workspaces in the same order that they appear in the full site.  Previously this was displaying a list of all pages in alphabetical order.

### Mobile behavior

* Added a new 'Mobile behavior' event to Virtual Attendants. These behaviors can be run from mobile devices for any kind of workflow.  For instance, mobile behaviors can create or search tickets, create tasks or notifications, search external systems for information, etc. Any public behavior variables will prompt the current worker for additional information. These behaviors can also be implemented on app-owned VAs so they are available to all workers by default. Mobile behaviors can respond with various types of messages that are displayed in a mobile device (e.g. text, html, maps, etc).

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_behavior.png" class="screenshot">
</div>

* Virtual Attendants with mobile behaviors can be viewed in the mobile interface. All VAs that the current worker has access to will be displayed. When a Virtual Attendant is selected, a list of its available mobile behaviors is displayed. Selecting a behavior will prompt for the input of any public behavior variables (for instance, a mobile behavior to create a task would prompt for the task's name and due date). The response from the Virtual Attendant is displayed in a message reminiscent of a chat bubble. This functionality is incredibly powerful; Virtual Attendant powered mobile behaviors can provide workers with shortcuts to accomplish almost any workflow. Those behaviors are built inside Cerb's normal web interface.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_behavior_run.png" class="screenshot">
</div>

* Mobile Virtual Attendant behaviors now return their response on a new page. Previously the response was displayed below the submit button. The state of the response page is now cached so that the back button works properly. This allows responses to include links to new records, with the back button returning to the response without re-running the behavior. By not caching the behavior page, the mobile app can now instantly see any changes made to the behavior in Cerb.

* Mobile Virtual Attendants can now return different types of responses.  Previously, all messages had to be text-based.

* Mobile Virtual Attendants can return HTML responses. Any provided Javascript is evaluated, which makes interactive responses possible.  For example, a Virtual Attendant can return a real-time chart using an HTML5 canvas.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_response_html.png" class="screenshot">
</div>

* Mobile Virtual Attendants can return interactive worklists as responses.  Previously, behavior variables that contained a list of records had to be displayed as text with links back to each record.  Now any list variable on the behavior can be sent to a worker's mobile device. This displays a mobile worklist that's sortable, pageable, and filterable.  The results also display properties about each record, and clicking on a record will display its mobile profile.  The back button can be used to return to the worklist.  For example, a mobile VA can send a list of tasks or tickets to a worker, and the worker can use that worklist in place as if they had searched for those results themselves.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_response_worklist.png" class="screenshot">
</div>

* Mobile Virtual Attendants can return multiple responses to a single request.  For example, a text response can state "Here are the results I found for you" and a second response can display the results as an interactive worklist.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_responses_multiple.png" class="screenshot">
</div>

### iOS Support

* The Cerb mobile interface now supports being added to the iOS home screen as a web app. This removes the location bar and footer from Mobile Safari so the experience feels more like a native app. Device-specific icons and start screens are provided (e.g. iPhone, iPad, retina).

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_ios.png" class="screenshot">
</div>

### Mobile sidebar

* Implemented a sidebar panel in the mobile interface.  This provides access to more functionality than can fit in the footer shortcuts: favorites, compose, pages, search, etc.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_sidebar.png" class="screenshot">
</div>

### Mobile pages

* The mobile interface now provides access to both workspaces and pages. The distinction is that a workspace is a page added by a worker to their navigation menu. Pages represent everything that a worker could choose to add to their menu as a workspace.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_pages.png" class="screenshot">
</div>

### Mobile profiles

* The mobile interface now provides a profile page for every record type in Cerb.  This makes it possible to gather more information without leaving the mobile site. Profiles also provide automatic links between related records. For example, from a ticket profile you can quickly view the sender's profile, their org's profile, the assigned group's profile, the ticket owner's profile, etc.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_profiles.png" class="screenshot">
</div>

### Mobile search

* The mobile interface now provides a 'Search' page in the menu panel.  This displays a list of every record type in Cerb.  When a record type is selected then a mobile worklist is displayed with the matching records.  Clicking on a record displays its mobile profile.  The profile also contains a link to open the record in the full site.  This improvement makes the mobile interface very useful for workers who need to perform quick record lookups while away from their desk.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_search.png" class="screenshot">
</div>

### Filter mobile worklists

* Mobile worklists now display their current filters above the list.  Clicking a filter removes it.

* New filters can be added to mobile worklists using quick search functionality.  Clicking the filters button above the list opens a popup that displays all searchable fields.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_worklist_filters.png" class="screenshot">
</div>

* Mobile worklists can use existing filter presets.  After clicking on the filters button, all presets are displayed as buttons in a popup.  Clicking one of these buttons will instantly replace the filters.  This is particularly useful in a mobile environment, especially when performing ad-hoc searches rather than using prebuilt workspaces.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_worklist_filter_presets.png" class="screenshot">
</div>

### Mobile worklist sorting

* Mobile worklists can be sorted in ascending or descending order on any available column.  The field currently being sorted by is displayed above the list, and the arrow next to the label indicates the sort direction (i.e. asc, desc).

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_worklist_sorting.png" class="screenshot">
</div>

### Mobile worklist paging

* Mobile worklists can be paged forward and backward.  On subsequent pages, an option is provided to instantly jump back to the first page.  In a slight deviation from the full UI, paging displays the current and total pages along with the total number of results.  In the full UI, paging displays the current position in the results and the total number of results (i.e. no indication is given for the total number of pages).

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_worklist_paging.png" class="screenshot">
</div>

* Mobile worklists can now be paged, sorted, filtered, and searched in place using Ajax. Previously, these actions were initiating a full page reload due to the way that popups work in jQuery Mobile. The reload was displaying a 'flash of unstyled content' on mobile devices.

### Mobile worklist record properties

* Mobile worklists can now display any number of fields for each row.  Since screen space is generally limited on mobile devices, these fields are not displayed as horizontal columns like in the full UI, but as smaller vertical rows beneath each result's heading.  At the moment, the displayed fields are based on useful defaults for each record type.  In the near future this feature will support the ability to decide which fields should be displayed per worklist or worklist type.  This functionality is actually more advanced than the main UI, since it uses the placeholders from Virtual Attendants and snippets instead of being confined by the results from the database.  In the main UI, only a limited amount of information from related records is available as columns (e.g. ticket -> organization).  With the placeholder approach, even content at the end of a long chain of related records can be displayed (e.g. ticket -> first message -> sender -> org -> custom field).

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_worklist_fields_dict.png" class="screenshot">
</div>

### Mobile performance

* Implemented caching for the common navigation pages in the mobile interface: search, workspaces, workspace tabs, pages, and Virtual Attendants.  The content in these pages rarely changes; they'll now be pulled from the server once per session.  Closing and reopening the app, or switching to the app from another app, will clear the cache.  This significantly reduces mobile bandwidth usage and improves perceived performance.

### Mobile profile plugin extensions

* Implemented a 'mobile.profile.block' extension point for plugins to provide custom content on profiles in the mobile interface.

### Mobile conversation view

* Ticket profiles in the mobile interface now display the most recent message on the ticket, and the conversation history can be paged forward and backward.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_ticket_profile_messages.png" class="screenshot">
</div>

### Reply via mobile interface

* Tickets can be replied to from the mobile interface. The reply button will automatically quote the currently displayed message, and the status and reopen date can be set.  In order to reduce extra work from a mobile device when pruning quotes, only the most recent message worth of comments is displayed.  In other words, quotes like ">>> Something said three messages ago" are automatically removed.  When possible, signatures in quoted text are also automatically removed.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_ticket_profile_reply.png" class="screenshot">
</div>

### Edit record properties from mobile interface

* Basic ticket properties can be edited from mobile profiles: status, reopen date, owner, and spam training.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_ticket_profile_edit.png" class="screenshot">
</div>

* Basic task properties can be edited from mobile profiles: title, status, and due date.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_task_profile_edit.png" class="screenshot">
</div>

* Message profiles in the mobile interface show the full email content.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_message_profiles.png" class="screenshot">
</div>

* Basic email address properties can be edited from mobile profiles: first name, last name, is banned, is defunct, and organization.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_address_profiles_edit.png" class="screenshot">
</div>

* Mobile email address profiles provide a 'Search ticket history' button that lists all tickets where the address is a requester.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_address_profile_ticket_history.png" class="screenshot">
</div>

* Basic organization properties can be edited from mobile profiles: name, street, city, province, postal, country, phone, and website.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_org_profiles_edit.png" class="screenshot">
</div>

* Organization mobile profiles provide a 'Search contacts' button which lists all associated email addresses in a worklist.

* Organization mobile profiles provide a 'Search ticket history' button which lists all associated tickets in a worklist.

### Mobile calendars

* Calendars are now displayed in a compact format in the mobile interface.  These mobile calendars are displayed on workspace tabs, in workspace widgets, and on calendar profiles.  Days that have events are indicated with a white circle.  Clicking a day will select it, denoted by a pale blue circle, and its events will be listed below the calendar.  Clicking an event from the list will display its profile, and the back button will return to the list with the previously selected date still highlighted.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_calendars.png" class="screenshot">
</div>

* In mobile calendars, the current day is now highlighted as a filled in circle compared to the outlined circles denoting days with events.

* Mobile calendars can be paged forward and backward to adjacent months.  A 'today' button is also provided to quickly reset the calendar on the current month with the current day selected.  The selected month and year will be remembered per calendar for the duration of the session.

* Mobile calendars now tag daily events as a block of 'available' or 'busy' time.

* Virtual Attendant custom behaviors are now available on mobile profiles.  These are the same behaviors that show up in the desktop interface, enabling powerful automation from mobile devices.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_profile_vas.png" class="screenshot">
</div>

### Mobile bookmarks

* The mobile interface now allows any page to be added to the menu as a bookmark. This provides one-click access to frequently used widgets, profiles, Virtual Attendant behaviors, etc. To add a bookmark, navigate to a page and then click the 'menu' button in the top right. In the bookmarks section there will be an 'add' button if the page isn't a bookmark yet, and a 'remove' button if it is. Bookmarks are stored locally on each device, so different devices can have different mobile bookmarks even when the same user is logged in. Bookmarks are currently organized alphabetically.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_bookmarks.png" class="screenshot">
</div>

### Compose new mail from the mobile interface

* Added a 'Compose' page to the mobile interface. This can send mail from any group the current worker is a member of. The 'To' field offers autocompletion for multiple email address recipients. An 'Insert signature' button will use the proper signature for the selected group and bucket. After sending the message, the worker will be redirected to the new ticket's profile.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_compose.png" class="screenshot">
</div>

* Mobile email address profiles provide a 'Compose' button that switches to the compose page with the email address pre-filled.  This provides a similar workflow to the full interface where an organization is selected in order to determine the appropriate contacts.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_address_profile_compose.png" class="screenshot">
</div>

### Read and write comments on mobile profiles

* Mobile profiles now display all the comments on a record.  The most recent comment is displayed first, and buttons allow navigation forward and backward.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_profiles_comments.png" class="screenshot">
</div>

* New comments can be created from mobile profiles, with the ability to notify specific workers.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_mobile_profiles_add_comment.png" class="screenshot">
</div>

# Virtual Attendants

### First-class Virtual Attendants

* Virtual Attendants are now first-class records (like groups and workers), with worklists, profiles, peek, ownership rights, etc.  Previously, Virtual Attendant behaviors were owned directly by roles, groups, and workers; but this was creating clutter and confusion because some behaviors are related but there was no indication of this in the UI.  Now, multiple Virtual Attendants can be created to contain any number of behaviors, and each VA can be owned by a worker, group, or role.  All existing behaviors have been migrated to a new default Virtual Attendant record for each distinct owner.  Virtual Attendants now show up in the global 'Search' menu, and clicking into a VA profile is where you will find the behavior trees and scheduled behavior.  This also provides many new possibilities for future expansion; for example, Virtual Attendants can log errors to their profile in an easy-to-find tab.  You can export and import behaviors between Virtual Attendants to place related behaviors together.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_worklists.png" class="screenshot">
</div>

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_profiles.png" class="screenshot">
</div>

* Virtual Attendants may now be disabled, which treats all of their behaviors as being disabled.  These behaviors will not trigger during events, and will now show up as macros on profiles.  This makes it very simple to simultaneously deactivate all related behaviors, which was a tedious process in earlier versions.  Additionally, a worker can disable a Virtual Attendant while building and testing its behaviors.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_disabled.png" class="screenshot">
</div>

* Activity Log entries that are created in response to Virtual Attendant actions will now log each Virtual Attendant as the actor.  Previously, these entries were created as if the behavior's owner (e.g. worker, group) had performed them, which could lead to some confusion of accountability.  Since Virtual Attendants are now first-class objects, they can be held accountable individually for actions they take.  The Activity Log will also specify the name of the responsible behavior next to the Virtual Attendant.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_actors_activities.png" class="screenshot">
</div>

* Virtual Attendants can own custom fieldsets, providing them with long-term storage for arbitrary data on any record.  This enables some very interesting new automation workflows.  For instance, a monitoring Virtual Attendant can remember the last time it notified each worker about something by using a custom fieldset with a date on worker records.  Similarly, a sales Virtual Attendant can keep track of its progress through an automated sales process with a custom fieldset that it saves on opportunities.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_own_fieldset.png" class="screenshot">
</div>

* Calendar records can now also be owned by Virtual Attendants or the Application.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_own_calendar.png" class="screenshot">
</div>

* The 'Virtual Attendants' button on profiles now organizes behaviors by Virtual Attendant.  This makes it much easier to find the behavior you're looking for.  Additionally, the macro menu no longer displays two lines for each entry; instead, behaviors are indented below their Virtual Attendant.  This allows more options to be displayed in a smaller space, and it's less visually confusing.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_button.png" class="screenshot">
</div>

* The 'Virtual Attendants' button that is displayed when replying to a message will now display macros grouped by Virtual Attendant.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_button_replies.png" class="screenshot">
</div>

* The 'Scheduled Behavior' tabs have moved to Virtual Attendant profiles.  Previously, scheduled behavior was shown on worker and group profiles, since those records directly owned behaviors.  The records targeted by scheduled behavior still show a summary at the top of their profile.

### Public and private VA behaviors

* Virtual Attendant macro behavior may now be marked as public or private.  A public behavior is visible to everyone with access to the VA (on profiles, etc).  A private behavior is only visible to the VA itself.  Private behaviors are useful for implementing helper macros within a VA that shouldn't be exposed to the outside world.  These are generally used from 'Run behavior' or 'Schedule behavior' actions.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_pubpriv_behavior.png" class="screenshot">
</div>

### Restrict VAs to specific events and actions

* Admins can choose which events each Virtual Attendant is capable of creating behaviors for.  The options are 'allow all', 'allow these:', and 'deny these:'.  This provides a way to offer limited Virtual Attendant functionality to workers with all use cases requiring prior approval.  After the upgrade, all existing Virtual Attendants will default to 'allow all' events.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_acl_events.png" class="screenshot">
</div>

* Admins can choose which plugin-provided actions a Virtual Attendant is capable of using in behaviors.  The options are 'allow all', 'allow these:', and 'deny these:'.  For example, the actions for JIRA and Twilio may be restricted to admin-controlled global VAs that worker VAs can delegate to.  Actions that directly communicate with external apps and services can be restricted from use by most workers.  After the upgrade, all existing Virtual Attendants will default to 'allow all' actions.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_acl_actions.png" class="screenshot">
</div>

### VAs can run behaviors in real-time

* Virtual Attendant behaviors may now use a global '(Run behavior)' action.  This is similar to 'Schedule behavior', except it runs the behavior immediately and allows the caller to retrieve values from the delegate behavior.  For example, if one Virtual Attendant delegates another VA's behavior in order to create a task, then the caller can afterwards retrieve information about the created task from the delegate.  This greatly improves the reusability of Virtual Attendants, as specialized VAs can handle routine actions, and helper VAs can delegate requests to them.  This also makes it possible to build mediator VAs that listen on channels like SMS, IM, and Campfire; with requests being delegated to VAs that can do almost anything possible in Cerb: send reminders; create and complete tasks; check and change calendars; interact with Twitter, Facebook, JIRA; etc.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_run_behavior.png" class="screenshot">
</div>

* Any Virtual Attendant behaviors that respond an event trigger will now be returned along with a snapshot of their data at their conclusion.  This allows the caller to retrieve detailed information from those responders, and in an arbitrary way.

### VA custom behaviors

* Implemented a 'Custom virtual attendant behavior' event.  This is the ideal place to implement generic behaviors that don't rely on a specific record type.  For example, a Twitter Bot could schedule a recurring behavior to look for new @mentions, and it wouldn't make sense to target this behavior to any particular record.  Previously, we had recommended to bind these generic behaviors on worker records just because it made them easy to manage from a profile.  Now we recommend that these behaviors be migrated to Virtual Attendant profiles.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_custom_behavior.png" class="screenshot">
</div>

### Global VAs create global workflow macros

* Application-owned Virtual Attendants can now create custom behaviors for any record type.  This allows global macros that are accessible by all workers, which greatly simplifies many workflows.  Previously, these macros could only be created by VAs owned by groups, roles, or workers.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_global_macros.png" class="screenshot">
</div>

### Simulator improvements

* When using the Virtual Attendant simulator, it is now possible to choose the exact record that the current behavior is being tested against.  Previously, the simulator would choose random records to help test behaviors, but this often required opening up the simulator many times in order to find a suitable record.  For macros, it was possible to run the simulator from a record profile in order to test using that record, but this option wasn't available to events like 'New message on a group conversation'.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_sim_select_target.png" class="screenshot">
</div>

* The public variables of Virtual Attendant behaviors may now be changed from within the simulator.  This makes it much easier to test macros.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_sim_pub_vars.png" class="screenshot">
</div>

* Public worklist variables in Virtual Attendant behaviors can now be tested properly in the simulator.

* In the Virtual Attendant simulator, data entry for parameters and values have been moved to tabs.  When a behavior provides parameters (public variables for entry by a worker), the parameters section is shown by default and the long list of values is hidden on a second tab, which improves usability by reducing clutter.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_sim_tabs.png" class="screenshot">
</div>

* When simulating the Virtual Attendant 'Run behavior' and 'Schedule behavior' actions, the simulator output will now show behavior variables being set.

* Implemented Virtual Attendant simulator output for the 'Send email to notified worker' action in 'New notification for me' behaviors.

* The output of the Virtual Attendant simulator no longer has a maximum height before introducing scrollbars.  Having multiple scrollable sections made it more difficult to read the output or to scroll down the page.

* Added an indent to the form elements in the Virtual Attendant Simulator to improve readability.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_sim_indent.png" class="screenshot">
</div>

### Behavior variable improvements

* Virtual Attendant behavior variables now support parameters based on each type of variable.  This provides more control over how they operate, and it also makes new variable types possible (like a picklist of pre-defined options).

* Text-based Virtual Attendant behavior variables can be configured for single-line or multiple-line input.  Previously, all text variables were single-line input, which made it difficult to enter certain kinds of data (e.g. long comments).

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_var_text.png" class="screenshot">
</div>

* Virtual Attendant behaviors may specify picklist (drop down) variables.  Picklists require a worker to pick an option from a list of predefined options.  Previously, only freeform text entry was available.  This is particularly useful for macro behaviors.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_var_picklist.png" class="screenshot">
</div>

* Virtual Attendant behavior variables can be reordered by dragging them in the UI.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_var_drag.png" class="screenshot">
</div>

* The 'Schedule behavior' and 'Run behavior' actions in Virtual Attendants can now include placeholders in the parameters being passed to the other behavior.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_sched_placeholders.png" class="screenshot">
</div>

*  When a Virtual Attendant behavior has a list variable, the resulting worklist view_id will now be saved in the dictionary in the format 'var_name_view_id'.  This allows reuse of the underlying worklist for all kinds of functionality.  Notably, it's currently used to send worklists to the mobile app.  It could also overcome the 100 object limit of list variables now.

### Set custom placeholder

* The Virtual Attendant 'Set custom placeholder' action can specify a format for its output of either 'text' or 'JSON'. JSON output will be automatically be converted to an object when it is saved to a placeholder.  This is particularly useful to simulate JSON responses from actions that perform API calls.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_setplaceholder_output.png" class="screenshot">
</div>

* The Virtual Attendant 'Set custom placeholder' action can be configured to only set the placeholder when in simulator mode.  This assists with providing test data in the simulator without affecting the outcome of a behavior when it runs normally.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_setplaceholder_sim.png" class="screenshot">
</div>

### Custom API requests to VAs

* Added a new 'Custom API request' event to Virtual Attendants.  This can be utilized by app-owned and worker-owned VAs.  These behaviors work similarly to macros, except they are only triggered through the API from external apps and services.  This allows for interaction with Virtual Attendants through mobile text messages, email, instant messages, Campfire/Hipchat, mobile applications, browser plugins, etc.  Custom API request behaviors always target the owning Virtual Attendant, and they provide an 'Add to API response message' action that appends text to the '_response' value of the API response.  Using the '_response' value is optional, but it provides for generalized interaction with Virtual Attendants through the API.  For example, an iOS app could display a list of all Virtual Attendants and their API-enabled behaviors.  Running any behavior could prompt for its public parameters, and the response message could be displayed.  It's also possible to use the 'custom placeholder' action for additional outputs.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_api_behavior.png" class="screenshot">
</div>

### Access VA data through the API

See: http://cerbweb.com/book/latest/developer_guide/rest_api/virtual_attendants.html

* Implemented '/rest/va/list.json' in the Web API for retrieving the list of Virtual Attendants that are visible to the current worker.  This can include an 'expand' parameter with the options 'owner' or 'behaviors' to list all of the defined behaviors.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_api_list.png" class="screenshot">
</div>

* Implemented '/rest/va/123.json' in the Web API for retrieving the a particular Virtual Attendant.  This can include an 'expand' parameter with the options 'owner' or 'behaviors' to list all of its defined behaviors.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_api_get.png" class="screenshot">
</div>

* Implemented '/rest/va/behavior/123/run.json' in the Web API for running a 'Custom API request' Virtual Attendant behavior.  This provides a standardized way for external applications and services to communicate with Virtual Attendants in Cerb.  For example, a Campfire Bot can listen for messages in a chat room and relay a specific pattern (e.g. "@Cerb do something") to a specific VA behavior through the Cerb API.  The response is a dictionary of all the behavior's values after running, including public and private variables.  If a behavior retrieves a list of tickets, then their details will be available in the response for use outside of Cerb.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_api_run.png" class="screenshot">
</div>

### New HTTP Request action

* A new 'Execute an HTTP request' action in Virtual Attendants allows them to send and receive data with other apps and services.  The results of an HTTP request are stored in a custom placeholder that can be used by subsequent outcomes and actions. JSON responses are automatically converted to an object.  Image resources as a response (e.g. PNG, GIF, JPEG) are converted to base64 text.  For example, when new mail is received a Virtual Attendant could send relevant details to an external URL (like a webhook).  A behavior could also request information from any source as a URL; e.g. datacenter temperature, website traffic, monitoring metrics, etc.

### Usability improvements

* The 'Setup->Configure->Virtual Attendants' page now displays a worklist of Virtual Attendants with links to profiles.  Previously, a funky interface was used that required an admin to pick an owner from a list to view their owned behaviors in a tab.  The new process is consistent with the way the rest of Cerb works.

* When a Virtual Attendant action is missing, the behavior editor will now provide more helpful information, including an indication of what it was supposed to be.  Previously, a blank action box was shown without providing any clue about what was missing.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_missing_action.png" class="screenshot">
</div>

* In Virtual Attendants, the actions for setting variables are now displayed at the top of the available actions.  As with other global actions, they are surrounded by parentheses. Previously these were sorted alphabetically with other 'Set' options, which made them more difficult to find.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_global_actions.png" class="screenshot">
</div>

* The 'custom script' condition in Virtual Attendant outcomes now shows a placeholders menu and script tester.

* The Virtual Attendant action for entering custom scripts no longer auto wraps the contents of the text box.  This makes it easier to read source code.

### Miscellaneous improvements

* [CHD-3460] All Virtual Attendant behaviors may now use 'calendar availability' as a condition in outcomes.  For example, this can be used to send different auto-replies based on availability.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_misc_calavail_cond.png" class="screenshot">
</div>

* [CHD-3340] Virtual Attendant behaviors on the 'Before sending worker message' event may now add custom mail headers to the outgoing message.  This was requested as a way to force read receipts, among other workflows.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_va_beforesend_headers.png" class="screenshot">
</div>

* The 'Schedule behavior' and 'Unschedule behavior' actions in Virtual Attendants are now global. They are available in all events and plugin-provided events do not need to implement them. Additionally, the action names are wrapped in parentheses so they appear at the top of the list of available actions.

* Fixed an issue with the 'Schedule behavior' and 'Unschedule behavior' actions in Virtual Attendants.  Disabled behaviors were not included in the list of available options, so if the actions referred to a behavior while it was disabled, and that action was edited and saved, then it would no longer refer to the behavior afterwards.  Disabled behaviors are now displayed in the action, but they're marked as being disabled in case this is unintentional.

* [CHD-2866] The 'new message on a watched conversation' event will now always include a ticket's owner even if they aren't a watcher.

* Added a new application-level 'Before sending worker message' event.  Previously this was only possible at the group level.

* Added a new application-level 'After sending worker message' event.  Previously this was only possible at the group level.

* When a Virtual Attendants dictionary is converted to an array (e.g. for use by the Web API), any nested dictionaries will also be converted to arrays.  Previously, if a behavior contained extra dictionaries (e.g. a list of records from a worklist search), it would return the IDs of those records but not their values.

* The <tt>/debug/export_attendants</tt> page will now export all behaviors grouped by Virtual Attendant.

# JIRA plugin

* Added a 'JIRA Integration' plugin to the Plugin Library. This automatically synchronizes JIRA project and issue information.  It also extends Virtual Attendants with the ability to remote control JIRA data.  JIRA Projects and Issues can be accessed from Cerb's global Search menu.  JIRA data can also be linked to other records (e.g. addresses, orgs) to track customer interest in issues and provide Virtual Attendants with data for following up on that interest.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_jira_plugin.png" class="screenshot">
</div>

* Implemented an 'Execute an API request to JIRA' action in Virtual Attendants. Rather than being restricted to a few options, this can make any API calls to JIRA that the given credentials are authorized to do.  For this reason, it is important to restrict this action to only trusted Virtual Attendants.  Other VAs can still delegate actions to the behaviors on trusted VAs with access to JIRA.  Check the online documentation for examples.

* Implemented Virtual Attendant custom behaviors for JIRA Issue records.  For example, a 'Resolve' behavior could close a JIRA issue from Cerb.

# Activity Log

*  Activity Logs for actor profiles (address, worker, group, virtual attendant) now display entries where the record was either an actor or a target of the activity.  Previously, the log only showed actor activity for those records, and target activity for everything else.  This meant that when viewing an address's activity from its profile, you wouldn't see log entries for when that address replied to conversations (as an actor), only when workers performed actions on that address (as a target).  This change provides a more comprehensive view of the activities a record was involved with.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_activity_actor_target.png" class="screenshot">
</div>

* Group profiles now display an Activity Log tab.

# Calendars

* On calendars, worklist datasources were previously inconsistent in that the 'end date' could use placeholders while the 'start date' required a specific date field.  This option was provided so that events could be arbitrary lengths; however, it wasn't possible to efficiently determine the events that needed to be displayed for a given month because the placeholders would have to be evaluated for every record in the database.  In order to fix this issue, the 'end date' for worklist datasources on calendars now requires an explicit date field.  Event durations can be set by using the new 'offset' fields for the start and end dates.  For example, an event can end using the same field as the start date, but with a "+2 hours" offset.  These offsets are much more efficient to process algorithmically in the database than open-ended placeholders.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_calendar_datasources_end.png" class="screenshot">
</div>

* [CHD-3515] [Calendars/Datasources] Fixed an issue with displaying worklist records on calendars when the events didn't start and end within the same calendar month.  For example, if an event started on August 31 2013 and ran for 3 days, it wasn't being displayed on the September calendar.

# Custom fields

### File-based custom fields

* [CHD-1086] Implemented two new custom field types: file and multiple files. These types allow arbitrary attachments to be attached to records through custom fields. Internally, these fields use the attachments system and they store file IDs.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_custom_field_files.png" class="screenshot">
</div>

# Custom Fieldsets

* Custom fieldsets may now be owned by the application.  These fieldsets are readable by all workers but only configurable by admins.

# Mail

### Filtering

* The **Setup->Mail->Filtering** page now shows the mail filtering behavior from all global Virtual Attendants on a single page.  Previously, it was only possible to have a single global Virtual Attendant and its use was implied on this page.

* When an admin views the **Setup->Mail->Filtering** page for the first time, Cerb will offer to create the first global Virtual Attendant if one doesn't exist already.  This improves the onboarding experience.

### Manually import messages in Setup

* Raw email messages can be imported from **Setup->Mail** by pasting them into a textbox. This simplifies development, training, and evaluations.  Previously, these messages had to be saved in the /storage/mail/new/ directory and then the parser scheduler job had to be manually run.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_setup_mail_import.png" class="screenshot">
</div>

### Manage failed messages in Setup

* [CHD-957] [CHD-3037] [CHD-3173] Incoming mail messages that failed to parse can now be viewed, retried, or deleted from the **Setup->Mail->Failed Messages** page.  Previously, administrators had to proactively monitor these files on the disk in the /storage/mail/fail/ directory, occasionally move them to /storage/mail/new/, and run the parser scheduled job manually in order to inspect the output.  Failed mail is now displayed in a familiar worklist format with a peek popup to view each message source.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_setup_mail_failed.png" class="screenshot">
</div>

# Localization

* A **Setup->Configure->Localization** page has been added for selecting the default date/time format for everywhere dates are displayed.  Admins can choose between 12hr or 24hr formats, and this selection will cover all workers that don't have an established preference.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_setup_localization_clock.png" class="screenshot">
</div>

* [CHD-3064] [CHD-2973] Each worker can choose their desired time format (12-hour or 24-hour) from the 'Settings' page in their worker menu.

# Placeholders and scripting

* Implemented two new placeholders for comment records.  The 'record_watchers' placeholder is a list of watchers on the record containing the comment.  The 'record_watchers_emails' placeholders contains a comma-delimited list of watcher email addresses.  This was requested by several people who wanted a way to relay an email to all watchers about comments on records of any type using Virtual Attendants; however, it can also be used to display a list of watchers anywhere the comment is referenced.

* Implemented a new 'json_decode()' function for snippets and placeholders to convert a JSON string to an associative array.  This can be used to easily reference JSON results from API calls within Virtual Attendant behaviors (or snippets in special situations).

* Implemented a new 'json_pretty' filter for snippets and placeholders to optimize the human readability of a JSON string.  This is mainly useful for advanced Virtual Attendant actions that exchange JSON with remote apps and services.

* Implemented a new 'jsonpath_set()' function for snippets and placeholders to dynamically create deeply nested JSON objects from inside scripts.  This is mainly useful for advanced Virtual Attendant actions that exchange JSON with remote apps and services.

* The placeholder for message content is now lazy-loaded only when it is needed.  This reduces extraneous queries from hitting the database when Virtual Attendants or snippets use message fields but ignore content.

* The generic label for Message records now shows the sender email, ticket mask, and ticket subject.  Previously this just showed an unhelpful '(message)' placeholder.  The label is used in Virtual Attendants, the Web-API, and the mobile app.

* The placeholder tester now displays output with a fixed width font that preserves whitespace. Previously, the tester output stripped whitespace.  This made it impossible to check the style of indentation (e.g. at the beginning of paragraphs, or in fragments of code).

* Activity Log contexts now provide actor_* and target_* placeholders.  These can be used in Virtual Attendant behaviors, snippets, and the Web-API.

* Activity Log contexts now provide a human-readable 'event' placeholder to describe the activity being logged.  This can be used in Virtual Attendant behaviors, snippets, and the Web-API.

* Worker contexts now provide 'is_disabled' and 'is_superuser' placeholders.  These can be used in Virtual Attendant behaviors, snippets, and the Web-API.

* Added 'last activity date' to worker placeholders.

* The 'devblocks_prettytime' modifier in placeholders now outputs 'just now' instead of '0 secs'.

# Platform

* Popups are now limited to a height no more than 85% of the current browser height.  Previously, popups could be so tall that they scrolled off the page.  This made them difficult to work with; particularly when dragging them around.

* Choosers can be opened in 'single selection' mode, where the first selection closes the chooser and returns control to the caller.  This provides all the benefits of choosers for situations where a single record must be selected.

* The Devblocks HTML5 charting library now mediates all mouse interaction with the charts. Listeners can bind to 'devblocks-chart-click' or 'devblocks-chart-mouseover' to receive updates about user input.  The returned event includes information about the closest data point to the mouse cursor, including chart coordinates.  This saves the caller a lot of work when designing interactive charting elements.

# Support Center

* [CHD-3113] When a Support Center page requires a login, a visitor will be redirected to their original destination after successfully logging in.  Previously, the Support Center didn't even provide a login form to anonymous visitors if they requested a protected resource, it just displayed the default page.  The new process should make it much easier to send contacts direct links to a specific ticket history, or protected knowledgebase articles.

* By default, the logo image on the Support Center is now a shortcut link back to the default page.

* [CHD-3441] When a customer views a ticket in the Support Center, there is now a reply button per message and no reply from is shown by default.  Previously, a single reply form was always displayed at the top of the ticket which led to much confusion.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_sc_inline_reply.png" class="screenshot">
</div>

* [CHD-3148] When a customer replies to a ticket in the Support Center, the original message will now be automatically quoted in the response.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_sc_reply_quoting.png" class="screenshot">
</div>

* Fixed warnings created by the Support Center when a customer replies to a ticket without any attachments.

# Web-API

### QR codes for setting up mobile credentials

* Added a QR code image to the Web API Credentials peek popup.  This allows mobile apps to quickly scan the QR code to copy the access and secret keys rather than requiring a user to laboriously type them.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_webapi_qrcode.png" class="screenshot">
</div>

# Workspaces

### Dashboards

* Line chart dashboard widgets now display a horizontal line through the selected data point to make lateral comparisons easier.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_dashboard_line_horiz.png" class="screenshot">
</div>

* Scatterplot dashboard widgets now display crosshairs that intersect at the selected data point. This makes comparisons easier in both dimensions by creating quadrants.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_dashboard_scatterplot_crosshairs.png" class="screenshot">
</div>

* Gauge dashboard widgets now display their labels below the widget for uniformity.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_dashboard_gauge_labels.png" class="screenshot">
</div>

### Multiple value custom fields in worklist columns

* [CHD-1050] When displaying a multiple value custom field as a worklist column, all of the selected values will now be displayed.  Previously, only a single value per custom field was displayed based on what matched the search filters.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.5/650_worklists_cfields_multiple_vals.png" class="screenshot">
</div>

# Maintenance Updates

## 6.5.1

Cerb6 (6.5.1) is a maintenance update released on October 7, 2013; it contains 17 minor fixes and usability enhancements from community feedback covering the recent 6.5 update.  You can [follow these instructions](https://cerb.ai/docs/upgrading/) to upgrade.

* [Virtual Attendants/Simulator/HTTP Requests] When a Virtual Attendant executes an HTTP request as an action, a new "Also execute HTTP request in simulator mode" option is available.  This is useful for testing behaviors when an HTTP request is read-only (e.g. GET), and it's also useful for testing live PUT/POST requests without leaving the simulator.

* [Virtual Attendants/Simulator/Run Behavior] Virtual Attendants using the 'Run behavior' action may now enable an 'Also run behavior in simulator mode' option.  Previously, the simulator only showed that a behavior would have run.  Now delegate behaviors can also run in simulator mode, which makes it much easier to test and troubleshoot complex chained behavior.

* [Virtual Attendants/Scheduled Behavior/Usability] The scheduled behavior popup on profiles now provides enough room for the "When:" text box.  Previously, if the drop down of date fields was very wide then the text box could be compressed to only a few characters.  If the dropdown is exceptionally wide now, the text box will wrap to a new line.

* [Devblocks/Platform/Resources] TTF and WOFF font resources will now be transferred through the resource proxy with the proper mime types.

* [Virtual Attendants] In Virtual Attendant actions, the Virtual Attendant itself will now always appear as a target in the 'On:' parameter.  This happened in some places (e.g. mobile behaviors, API behaviors) but not everywhere else.  This makes it much easier to delegate behaviors between Virtual Attendants using the 'Custom virtual attendant behavior' event.

* [Virtual Attendants/Links] Virtual Attendants can use a new 'Get Links' action to load links of any type on any related record into a variable or placeholder.  For example, when new mail is received a Virtual Attendant could check for a specific type of link (e.g. product, license) on the organization of the message sender.

* [CHD-3557] [Workspaces/Dashboards/Subtotals] Fixed a bug where filters with NULL (e.g. blank) values in worklist-based widgets were being ignored in some cases.  For instance, a pie chart showing task assignments based on a worker custom field, with an 'assignee is not blank' filter, would show all workers including 'nobody'.

* [Setup/Branding/Usability] Renamed 'Logo & Title' to 'Branding' in the Setup->Configure menu.

* [Setup/Branding] The favicon used by Cerb is now configurable on the Setup->Configure->Branding page.  Thanks to Niek Beernink @ Oxilion.nl for the contribution!

* [CHD-3464] [Consistency] Fixed a consistency issue where the refresh button on some profiles (e.g. task, worker) said "Reload this ticket" in the tooltip.  This was due to the reuse of text from the translation system.  These tooltips now show 'Refresh'.

* [CHD-3561] [Setup/Mail/Filters] Fixed an issue on the Setup->Mail->Filtering page where 'Create behavior' buttons weren't being displayed for each of the Virtual Attendants listed.

* [CHD-3565] [Virtual Attendants/Comments] The 'New comment on a record' event can now use the comment's parent record or author as 'On:' targets for actions.  These were previously ignored because they are abstract (i.e. they can end up being various record types, and it's not possible for the simulator to know in advance).  The author and parent record of a comment still can't be used in the 'On:' parameter of run behavior, schedule behavior, or unschedule behavior actions; instead, the desired record should be loaded into a private variable of a specific type (using {% raw %}{{comment_record_*}}{% endraw %} placeholder fields), and that variable can be used as a target.

* [Comments/Worklists/Choosers] Implemented subtotals, filters, and choosers for comment worklists.

* [Worklists/Export] Fixed errors when exporting virtual fields from a worklist.

* [Virtual Attendants/Comments] When simulating new Virtual Attendant behaviors on the 'New comment on a record' event, a specify comment record can now be targeted for testing.  Previously this wasn't possible due to a lack of comment choosers.

* [Support Center/Code Cleanup] Fixed a bug in the Support Center that ignored the sort order of the menu options.

* [CHD-3566] [Time Tracking/Code Cleanup] Fixed an error being displayed in the 'Time Spent' field on Time Tracking profiles.

## 6.5.2

Cerb6 (6.5.2) is a maintenance update released on October 18, 2013; it contains 12 minor fixes and usability enhancements from community feedback covering the recent 6.5 update.  You can [follow these instructions](https://cerb.ai/docs/upgrading/) to upgrade.

* [CHD-3569] [Virtual Attendants/Mail/Headers] In 'Before sending worker message' Virtual Attendant behaviors, the 'Set header' action is now capable of replacing existing headers like 'Subject:' and 'X-Mailer:'.  Previously, duplicate headers were being added.

* [CHD-3519] [Virtual Attendants/Mail] In the 'Before sending worker message' Virtual Attendant behavior, the 'Bucket' condition is now available again.

* [CHD-3568] [Worklists/Usability] Fixed an issue when editing 'Owner' filters on worklists where the existing values weren't displayed as defaults. This meant if you were filtering by a list of 5 owners, you had to reselect them in addition to any other changes you were making.

* [Virtual Attendants/Groups] Fixed an issue with bucket names always being 'Inbox' in some Virtual Attendant behaviors.

* [CHD-3508] [Virtual Attendants/Usability] When building Virtual Attendant outcomes and actions, the 'Insert placeholder' menu will now include the `|date` modifier on placeholders by default.  Otherwise they are displayed as Unix timestamps (e.g. 1381874586).  This used to happen in earlier versions, but the `|date` option was hardcoded for various fields; now it happens automatically based on the field type.

* [CHD-3470] [Mail/Reply/Usability] On ticket profiles, if the reply form is already open then clicking the 'Reply' button or pressing the 'r' shortcut will focus the existing form rather than discarding its contents and opening a new one.

* [CHD-3433] [Mail/Setup/Usability] Added a warning to POP3 setup that downloaded messages will be deleted from the mailbox.  There have been a few instances where users included an IMAP mailbox with a long history where clearing the mailbox was not desirable.

* [CHD-3378] [Virtual Attendants/Worklists] 'While displaying a worklist' behaviors can now be created by role-owned Virtual Attendants.

* [Setup/Custom Fields/Usability] In Setup, custom fields can now be quickly dragged into the desired order rather than having to manually number them.

* [Setup/Custom Fields/Usability] When deleting custom fields in Setup, a confirmation step is now shown prior to deleting the fields and their data.

* [CHD-3372] [Setup/Custom Fields/Fieldsets] In Setup, global custom fields can now be easily migrated to fieldsets of the same type.

* [CHD-3341] [Mail/Reply/Usability] After clicking the 'Reply' button in a ticket conversation, a loading indicator is shown in a popup until the form is displayed.  This was requested several times by clients who experience occasional latency so they have a visual cue that something is happening.

## 6.5.3

Cerb6 (6.5.3) is a maintenance update released on December 27, 2013; it contains 14 minor fixes and usability enhancements from community feedback covering the recent 6.5 update.  You can [follow these instructions](https://cerb.ai/docs/upgrading/) to upgrade.

* [Virtual Attendants/Snippets/Placeholders] Implemented a new 'xml_decode()' function for placeholder scripts.  This converts an XML string into an associative array of nested nodes.  Attributes can also be accessed through an '@attributes' key on any node.  Check the Cerb docs for more details.

* [Web-API/Tickets] Ticket records can be filtered using 'group_id' and 'bucket_id' in the Web-API.

* [Quick Search/Performance] When using the quick search feature, text-based searches will no longer include leading and trailing wildcards by default.  This was requiring every record to be scanned in the database.  Instead, wildcards can be explicitly specified with an asterisk (e.g. *@example.com).

* [Mail/Parser] Fixed a bug in the parser where multiple 'attached_message.txt' (message/rfc822) or 'delivery_status.txt' (message/delivery-status) attachments on an incoming message were ignored and only the last one was kept.  They are now sequentially numbered like 'attached_message_001.txt'.

* [CHD-3596] [Worklists/Custom Fields] Fixed an issue where number-based custom fields didn't sort properly as worklist columns.  Rather than sorting in numerical order (e.g. 64, 256, 1024) the results were sorted lexicographically (e.g. 1024, 256, 64).  This bug was introduced by an earlier feature that separated multiple custom field values with commas, as it converted the field to text from integers.

* [CHD-3595] [Parser/HTML] Fixed an obscure issue with nonbreaking spaces in HTML-only mimeparts encoded in quoted-printable format as Unicode (=A0).  These were not being treated as whitespace, and code like hyperlink-detection was including them.

* [CHD-3590] [Worklists/Quick Search] Fixed an issue when using quick search on the ticket 'spam score' column with decimal numbers (e.g. '> 0.33').

* [CHD-3585] [Workspaces/Tabs/Usability] Fixed an issue where pressing ENTER in the 'Label:' field when adding a new tab would lead to a JSON response from the Ajax request being printed in the browser.

* [Platform] Updated the copyright years in the footer to 2002-2014.

* [Storage/Devblocks/Platform] The Devblocks storage service will no longer unarchive objects for attachments or message content.  The original purpose of the unarchiving feature was to relocate frequently accessed objects back to active storage (e.g. from S3 back to the local filesystem).  This was causing issues because large objects could be constantly moved between storage engines like S3 and the local filesystem based on minor activity. Generally, once an object is moved to a long-term storage engine like S3 it is desirable to always retrieve it from there in the future.

* [Storage/Devblocks/Platform] The Devblocks storage service will now only archive objects that are currently in the active storage profile.  Previously, any objects would be archived if they weren't already in the archive storage profile.  This caused problems if some objects (e.g. very old or large) were moved to a different storage profile manually.  It is now possible to partition the storage of objects in whatever way is desirable, and the auto-migration features of the storage service won't get in the way.

* [CHD-3603] [Virtual Attendants/Usability] When attempting to view the profile of a non-existent Virtual Attendant (e.g. after deleting it), a worker will be redirected to a worklist of valid VAs using the /search page.

* [CHD-3598] [Scheduler/POP3] Previously, Cerb was incapable of determining if a POP3/IMAP connection timed out while downloading the contents of a message.  This could lead to tickets being created with valid headers but blank content.  Cerb will now discard a message if it took more than 95% of the IMAP_READTIMEOUT value (default 60 seconds) to download it, and it will retry the next time the mailbox is checked.

* [Scheduler/POP3/Performance] The POP3 scheduler job now saves message contents directly to the disk rather than reading them into memory first. This uses significantly less memory and can handle much larger message sizes.

## 6.5.4

Cerb6 (6.5.4) is a maintenance update released on January 14, 2014; it contains 8 minor fixes and usability enhancements from community feedback covering the recent 6.5 update.  You can [follow these instructions](https://cerb.ai/docs/upgrading/) to upgrade.

* [Activity Log/Usability] Fixed an issue where some Activity Log entries were still being created with hardcoded actor permalinks.  These are now generated using a dynamic format which will adapt if Cerb is moved to a new base URL.

* [Activity Log/Migration] Fixed an issue in the 6.0.0 migration script where knowledgebase articles referenced in the Activity Log weren't converted to the new ctx:// URL format.

* [Activity Log/Migration] Fixed an issue in the 6.0.0 migration script where a query attempted to retrieve *all* of the Activity Log entries as a single resultset in order to convert them to a new format.  This could overwhelm the available PHP memory_limit and prevent an upgrade from completing.  These records are now broken up into chunks of 5,000 rows.

* [Workspaces/Migration] Fixed an issue from the 5.6.0 migration script where certain ticket worklist filters weren't fully converted to their newer counterparts.  This resulted in worklists with nameless filters on them which didn't filter as expected.  While these could be cleaned up manually after the upgrade, some Cerb instances have hundreds of worklists and this process would be tedious.  These rows will be converted properly for people migrating from a version earlier than 5.6.0, and the rows will be fixed retroactively for any later versions by the 6.5.4 upgrade script.

* [Development/POP3] Added a script to /install/extras/developers/ for running a mock POP3 server in order to debug esoteric issues (like sporadic 30+ second connection timeouts).  These conditions are harder to simulate with a live mail server.

* [Virtual Attendants/Migration] Fixed an issue in the 5.4.0 migration script where Group Inbox Routing rules were not properly converted to Virtual Attendant group behaviors if there was only a 'To/Cc' condition.

* [Virtual Attendants/Migration] The 5.4.0 migration script will now create separate 'To:' and 'Cc:' header checks when converting Group Inbox Routing 'To/Cc:' rules to Virtual Attendant behaviors.  Previously it just created a 'To:' header check.

* [Update/Plugin Library] Fixed an issue in 4.x and 5.x migrations where the Plugin Library attempted to download its updates before the 5.7.0 patch created its database tables.  This didn't interrupt the upgrade process, it just logged an error.

## 6.5.5

Cerb6 (6.5.5) is a maintenance update released on January 22, 2014; it contains 6 minor fixes and usability enhancements from community feedback covering the recent 6.5 update.  You can [follow these instructions](https://cerb.ai/docs/upgrading/) to upgrade.

* [CHD-3615] [Virtual Attendants/Scheduled Behavior] Fixed a bug where a deleted Virtual Attendant behavior could remain in the scheduled behavior queue and cause an error when viewing an associated profile.

* [CHD-3494] [Virtual Attendants/Relay] Fixed an issue where new tickets created by workers from the UI didn't relay their attachments to external worker email addresses.

* [CHD-3616] [Mail/Merge/Usability] Fixed an issue where the merge popup on a ticket profile failed to complete properly if any of the tickets in the chooser had their peek popup opened during the process.

* [CHD-3617] [Mail/Reply] Fixed an issue that occurred when multiple workers attempted to reply to the same ticket within a short time period.  Normally this displays a warning with a 'Continue replying' option, but clicking this button wasn't doing anything.

* [CHD-3444] [Mail/Peek/Usability] Added the relative time to the 'Date:' header on the ticket peek popup.  For example: "Tue, 21 Jan 2014 01:30 am (45 mins ago)".  Previously this only showed the absolute date.

* [CHD-3414] [Mail/Profiles/Masks] Fixed an issue with ticket mask patterns that are purely numeric (e.g. date-based like: 201401220001) which prevented their profiles from displaying.  This had to do with Cerb assuming their masks were internal IDs.  Now masks are always checked first, and IDs are only checked if there's no match.  The performance of this lookup was also improved, because it was previously looking up ticket metadata in two database queries (mask->id, then id->metadata).  A single query (mask->metadata) now retrieves the record in most cases.  For sanity's sake, it is still important that ticket masks don't overlap with IDs, so a date-based mask format would be improved by adding hyphens between the components (e.g. 2014-01-22-0001).


