---
layout: post
title:  "6.8"
excerpt: Cerb 6.8 is a major feature update released in September 2014 with 79+ new features and improvements from community feedback.
author: The Cerb Team
date:   2014-09-17 00:00:00 -0700
permalink: /releases/6.8/
redirect_from:
  - /6.8/
  - /wiki/6.8/
tags: cerb announcements releases
release:
  type: feature upgrade
  count: 79
---

**Cerb ({{ page.title }})** is a **{{ page.release.type }}** released on {{ page.date | date:"%B %d, %Y" }}.  It contains over **{{ page.release.count }}** new features and improvements from community feedback.

* TOC
{:toc}

<div class="cerb-box note">
	<p>
		To check if you qualify for this release as a free update, view <b>Setup &raquo; Configure &raquo; License</b>. If your software updates expire on or after <b>September 15, 2014</b> then you can upgrade without renewing your license.
	</p>
</div>

* [Visit the project website](https://cerb.ai/pricing/) to purchase a new license or extend feature updates on your existing license.

* To upgrade your installation, [follow the instructions here](https://cerb.ai/docs/upgrading/).

# Important Release Notes 

* **Make a [backup](https://cerb.ai/docs/backups/) before upgrading.**

# @mentions

### Worker @mention nicknames

* Added an '@Mention Name' field to each worker. During the upgrade this will default to the worker's first and last name with no spaces. This will enable new functionality like quickly notifying workers from a comment.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_mentions_worker_edit.png" class="screenshot">
</div>

### @mention notifications in comments

* [CHD-2630] [CHD-3183] When commenting on a record from a peek popup or its profile, workers can now be selected to receive notifications by using the '@mention' syntax in the text. This has the added benefit of also organically documenting which workers received notifications about the comment, and it also makes it easier for a notified worker to see which comments need their attention. The same feature is also supported on sticky notes.  This replaces the "Also notify these workers" option, which required workers to be selected as an extra step.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_mentions_comments.png" class="screenshot">
</div>

# File Bundles

### File bundles for frequently used attachments

* Added a 'File Bundle' record type.  A file bundle contains one or more pre-uploaded attachments that can be quickly added to a record.  For instance, workers using the mobile interface could include common attachments from bundles without having to upload them every time.  Additionally, file bundles will allow Virtual Attendants to include common attachments on outgoing messages.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_filebundles.png" class="screenshot">
</div>

### Use file bundles in the chooser popup

* The file chooser popup now allows attachments to be added from pre-existing bundles, in addition to allowing the upload of new files.  This is particularly useful on mobile devices that lack the ability or bandwidth to routinely upload files.  Bundles can be quickly selected using an autocomplete field, or they can be searched and filtered using a chooser popup.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_filebundles_chooser.png" class="screenshot">
</div>

# Mail

### #commands and @mentions on compose

* When composing a message, #commands and @mentions are now supported in the text editor.  The effect of these commands on the message content is shown in the preview option, and a preview action has been added to plaintext mode. The worker's signature has been replaced with a '#signature' placeholder, which wasn't auto-inserted previously because its contents could change depending on the selected group and bucket.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_commands_mentions_compose.png" class="screenshot">
</div>

### #commands and @mentions on replies

* When replying to a message, #commands and @mentions are now supported in the text editor.  The effect of these commands on the message content is shown in the preview option, and a preview action has been added to plaintext mode. The worker's signature has been replaced with a '#signature' placeholder, which is offers more flexibility about how the signature is generated (e.g. in the near future, HTML templates could override the signature format).

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_commands_mentions_reply.png" class="screenshot">
</div>

* Added a worker preference for controlling whether 'Insert signature above quoted message' includes a #cut command or not.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_signature_cut.png" class="screenshot">
</div>

### HTML signatures per template

* Each HTML mail template can now override the group/worker signature format.  This makes it much easier to have consistent branding.  If the template's signature is blank, then the default signature will be used.  Previously, mail templates could only add a signature at the bottom of the message body, which didn't work properly with top-posted replies, and which also required workers to explicitly disable their personal signatures (which was a disaster to coordinate).  Worker signatures now use the '#signature' placeholder, which is replaced by the template in the appropriate location in the message.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_html_signatures.png" class="screenshot">
</div>

* Email signatures on HTML mail templates now support worker placeholders (e.g. full name, title, custom fields).

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_html_signature_placeholders.png" class="screenshot">
</div>

### Embedded images on HTML templates

* HTML mail templates now support uploading inline images directly from the popup editor. These images are stored as attachments linked to the template.  When an HTML template is sent, the attachments are automatically embedded without requiring external URL resources.  To reduce clutter, embedded images are also not saved as attachments in the outgoing message record in Cerb (but they are sent to recipients as expected).  This feature should make it much easier to work with images on HTML templates.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_html_template_inline_images.png" class="screenshot">
</div>

### POP3 timeouts are configurable per mailbox

* [CHD-3871] Timeouts can now be configured per mailbox in Setup.  Previously these were hardcoded and had to be modified in the source code.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_pop3_timeouts.png" class="screenshot">
</div>

# Mobile

### #commands and @mentions when composing from the mobile UI

* When composing mail from the mobile interface, #commands and @mentions are now supported.  The #attach command makes it possible to attach pre-uploaded files to outgoing messages. When @mentions are used in a #comment, the referenced workers are notified automatically.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_mobile_compose_commands.png" class="screenshot">
</div>

### #commands and @mentions when replying from the mobile UI

* When sending a reply in the mobile interface, a series of #commands are now available while typing. #comment quickly adds an internal comment to the ticket being replied to (the recipients won't see it, and @mention autocompletes may be used to notify specific workers). #cut prevents the remainder of the message from being sent to the recipients (for instance, it's no longer necessary to tediously delete long quoted blocks with mobile device gestures). '#delete quote from here' removes quoted lines from the cursor's current position (useful for responding to fragments of quoted text). #signature inserts the worker's signature based on the current ticket's group/bucket. #watch adds the current ticket to the worker's watchlist. #unwatch removes the current ticket from the worker's watchlist. #attach makes it possible to attach pre-uploaded files to outgoing messages.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_mobile_reply_commands.png" class="screenshot">
</div>

### Mobile settings

* Added a 'Settings' page to the menu in the mobile interface.  This provides a place for each worker to configure their mobile preferences.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_mobile_settings.png" class="screenshot">
</div>

* In the mobile interface, a worker can now decide if their signature is automatically inserted above or below the quoted message, or not inserted at all.  Previously, the signature was always inserted below the quoted text.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_mobile_settings_reply.png" class="screenshot">
</div>

### @mentions on comments

* When writing a comment in the mobile UI, @mentions can now be used to notify individual workers.  This replaces the more cumbersome "Also notify these workers:" option.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_mobile_comment_mentions.png" class="screenshot">
</div>

### Updated mobile framework

* Updated jQuery Mobile library from 1.3.2 to 1.4.3.  Removed the custom jQuery Flat theme and modified the default themes to look the same while being more future-proof.

# Workspaces

### Improved the Help Me Create a Page popup

* When using the "Help me create a page!" option on workspace pages, a "New page created:" link is now displayed above the worklist.  Previously this just added another item to the list, which could go unnoticed if there were already several items.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_pages_wizard_link.png" class="screenshot">
</div>

* The 'Help me create a page!' wizard can now create a new Knowledgebase browser page if that plugin is enabled.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_pages_wizard_kb.png" class="screenshot">
</div>

* The 'Help me create a page!' wizard can now create a new Reports page if that plugin is enabled.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_pages_wizard_reports.png" class="screenshot">
</div>

* When a worker uses the 'Help me create a page' wizard, the newly created page will be automatically added to their menu.

###  App-owned workspace pages

* [CHD-3815] Workspace pages may now be owned by the application. Previously, pages had to be owned by a role, group, or worker. This simplifies globally available pages compared to using an 'Everyone' role.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_pages_app_owned.png" class="screenshot">
</div>

### Editing pages with peek popups

* Added the 'peek' feature to workspace page worklists.  The icon only shows up when the page is editable by the worker (e.g. group manager, admin, owner, etc).  Previously, pages could only be edited from the 'Edit page' menu item when viewing them.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_pages_peek.png" class="screenshot">
</div>

### Knowledgebase browser tabs can start at a specific topic or category

* On workspaces, Knowledgebase tabs can now be configured to use a specific default category.  Previously, the knowledgebase browser always started by showing every topic and requiring a worker to drill-down to a specific category.  Now, several knowledgebase tabs could be added to the same workspace as shortcuts to specific topics or categories.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_kb_tab_roots.png" class="screenshot">
</div>

# Search

### Improved full-text search relevance

* [CHD-3790] Full-text searches using the 'MySQL Fulltext' engine can now consider every matching record when using additional filters.  This is accomplished by reading data into a temporary database table while constructing the worklist, which provides a more balanced compromise between performance and relevancy.  In 6.7, search performance was improved by checking full-text terms first and then applying the remaining worklist filters.  The initial full-text results weren't affected at all by other filters like date ranges, status, or sender.  This could lead to situations where very common search terms combined with very specific additional filters didn't return expected results.  For instance, the full-text results for a worker's name could return 500 of 100,000 records (with no basis for determining relevance), and any additional filtering would only be working with a subset of the total results.  An additional 'created date' filter only applied to those 500 results rather than the total set.  This situation could be avoided by searching for more specific terms, but it wasn't obvious to a worker from the UI that extra results were being ignored based on their search term matching too many records.

### Maximum search results

* The 'MySQL Fulltext' search engine can now be configured to return a specific maximum number of results.  When this setting is blank there is no enforced limit.  A higher maximum provides more results when common search terms are used, which increases the likelihood that additional filtering will produced the desired results.  A lower maximum improves performance by considering the most relevant full-text matches, and preventing situations where 100,000+ results are retrieved and joined.  The previous hardcoded limit was 500, which is now the editable default.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_search_limit.png" class="screenshot">
</div>

# Virtual Attendants

### Placeholder and scripting syntax help

* When editing a text field that supports placeholder syntax, a help button is now displayed. When clicked, a help popup explains placeholders and scripting along with common examples.  This is implemented when editing snippet records, editing group signatures, editing reply-to signatures, and editing Virtual Attendants outcomes and actions.  Previously, workers had to separately open the documentation to research the available options.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_placeholder_help.png" class="screenshot">
</div>

* When writing in a text field that supports placeholder syntax, scripting commands (`{% raw %}{%...%}{% endraw %}`) and filters (`|`) are now suggested and autocompleted.  This is supported when editing group signatures, when editing reply-to signatures, when editing snippets, and when editing Virtual Attendant outcomes and actions.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_placeholder_autocomplete_commands.png" class="screenshot">
</div>

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_placeholder_autocomplete_filters.png" class="screenshot">
</div>

* The syntax tester on snippets will no longer complain about temporary variables being unknown placeholders.

### Permissions on app-owned behaviors

* Application-owned Virtual Attendant behaviors now have read and write permission on all records.

### Global new message behaviors

* [CHD-3884] Added a new 'Message added to a conversation' event at the application-level.  Previously it was only possible to do this at the group-level.  This makes it possible to create behaviors like auto-responses and SLA handling in a single place.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_global_mail_behaviors.png" class="screenshot">
</div>

### Using snippets in Virtual Attendant actions

* [CHD-3747] Virtual Attendants can use snippets with a new 'Set a custom placeholder using a snippet' action.  This can use snippets for any record linked to the current target (e.g. a ticket sender's org), including prompted placeholders.  Once the placeholder is set, it can be sent as an auto-response, used as a comment, etc.  The most common use case for this feature is to allow snippets to be editable by workers who do not have permissions to modify Virtual Attendants directly.  It also makes snippets reusable within and between Virtual Attendant behaviors.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_action_snippet_fill_in.png" class="screenshot">
</div>

### New placeholder for a list of requester email addresses

* Ticket records have a new 'requester_emails' placeholder that contains a comma-separated list of recipients on the ticket.  This can be used to simplify email-based actions on Virtual Attendants.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_placeholder_requester_emails.png" class="screenshot">
</div>

### Creating tickets with a specific status

* The 'Create Ticket' action in Virtual Attendant behaviors may now specify a status and reopen date.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_create_ticket_status.png" class="screenshot">
</div>

### Default values for Yes/No behavior variables

* Virtual Attendant 'Yes/No' behavior variables can now be configured to have a default state in the input form. Previously the form value always defaulted to 'No'.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_yesno_default.png" class="screenshot">
</div>

### Load record links into behavior variables

* [CHD-3878] Virtual Attendants can now retrieve record links into behavior variables. Previously, links could only be saved into a placeholder.  By using variables, additional behaviors can be run or scheduled on the results.  For instance, from a ticket record, all of the linked time tracking entries can be saved into a variable so they can be added together and reported on.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_set_links_var.png" class="screenshot">
</div>

### Behavior variables using contact person records

* Virtual Attendant behaviors may now create list variables for contact person records.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_listvar_contacts.png" class="screenshot">
</div>

### Behavior variables using message records

* Virtual Attendant behaviors may now create list variables for message records.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_listvar_messages.png" class="screenshot">
</div>

### Placeholder on email addresses to detect known contacts

* [CHD-3886] Virtual Attendants can use a new 'is contact' placeholder on email address records to detect when an email address belongs to a known contact.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_addy_is_contact.png" class="screenshot">
</div>

### Improved date-based custom fields in Virtual Attendant actions

* [CHD-3805] If a date-based custom field contains a placeholder then it will no longer be automatically translated into an absolute timestamp.  The previous behavior was causing problems with the 'Create ticket', 'Create task', and 'Create call' actions when relative dates like "+2 hours" were desired.  Relative dates can still be used by formatting them like placeholders: <nowiki>{{"+2 hours"}}</nowiki>

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_set_cfield_dates.png" class="screenshot">
</div>

### Create calendar events from Virtual Attendant actions

* Virtual Attendant behaviors can now add events to calendars using the 'Create calendar event' action.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_create_cal_event.png" class="screenshot">
</div>

### Create sticky notes on messages from Virtual Attendant actions

* [CHD-3869] Virtual Attendant behaviors can now add sticky notes to messages.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_create_sticky_notes.png" class="screenshot">
</div>

### Create records with worker-based custom fields using variables and placeholders

* [CHD-3697] Virtual Attendant behaviors can set worker-based custom fields on 'Create task' actions using placeholders and variables.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_va_create_task_worker_vars.png" class="screenshot">
</div>

* Virtual Attendant behaviors can set worker-based custom fields on 'Create ticket' actions using placeholders and variables.

* Virtual Attendant behaviors can set worker-based custom fields on 'Create calendar event' actions using placeholders and variables.

# Profiles

### Organization mail history now includes reassigned tickets

* [CHD-3630] The 'Mail History' tab on organization profiles now shows tickets assigned directly to an organization in addition to those with recipients who are its members.

### Email address chooser on the People tab of organizations

* [CHD-2647] When viewing the 'People' tab on an organization profile, a chooser is now displayed to find and select addresses.  Previously, the only option was to create new address records (which is still possible from the chooser when needed).

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_people_chooser.png" class="screenshot">
</div>

### Improved merge on ticket profiles

* [CHD-2598] When opening the merge popup from a ticket profile, an autocomplete field is now provided to quickly look up records by partial mask or subject.  Previously, the ticket chooser always had to be opened and searched.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_ticket_merge_autocomplete.png" class="screenshot">
</div>

# Snippets

### App-owned snippets

* Snippets may now be owned by the application. Previously, snippets had to be owned by a role, group, or worker. This simplifies globally available snippets compared to using an 'Everyone' role as the owner.

### Fill-in placeholders

* Improved the 'fill-in' placeholders on snippets.  Previously these were defined by using arcanely formatted "(___type here___)" placeholders; now they are called 'prompted placeholders', and they're formally configured on snippet records.  Previously, custom placeholders were limited to text fields; now they can use other data types like checkboxes.  Prompted placeholders are used in a snippet in the same way as the other placeholders, and they can be given a type, a human-readable name, a label for prompting worker input, and a default value.  The same placeholder can be used multiple times in the snippet, and its value now only needs to be set once.  Prompted placeholders can now also be used conditionally to change the output of the snippet.  For instance, a prompted checkbox placeholder could toggle a special paragraph on and off in the reply.  Prompted placeholder values are now set in their own form, independent of the snippet, and a preview option is provided.  Previously, custom placeholders were handled inline on the snippet preview, but this made them less flexible.  As well, previously it wasn't possible for a blank custom placeholder to be omitted.  The 6.8 migration script will automatically convert custom placeholders on all snippets to prompted placeholders.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_snippets_fill_in.png" class="screenshot">
</div>

### Placeholder reuse

* [CHD-3758] Custom placeholders on snippets can be used multiple times after being set once.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_snippets_placeholder_repeat.png" class="screenshot">
</div>

# Activity Log

### Splitting tickets is recorded in the activity log

* [CHD-3715] The Activity Log now records message splits in both the source and the destination tickets.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_activity_log_split.png" class="screenshot">
</div>

### Fixed ticket status change actors in the Support Center

* Fixed an issue where activity log entries for ticket status changes from the Support Center could be improperly attributed to the wrong email address. These entries are retroactively corrected during the update.

# Calendar

### Start weeks on Sunday or Monday

* [CHD-1238] [CHD-3831] Each calendar can now be configured to start the week on either Sunday or Monday.  Availability calendars will use the setting from the calendar they are based on (e.g. a worker's schedule).

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_calendar_weeks_monday.png" class="screenshot">
</div>

### Start times on calendar events

* [CHD-3540] Calendars can now be configured to display start times for all displayed events in the grid.  These times use the 12-hour or 24-hour clock from each worker's preferences.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_calendars_start_times.png" class="screenshot">
</div>

### Miscellaneous fixes

* Fixed an issue on calendars where available events with no duration (i.e. same start and end time) weren't displayed properly.

# Knowledgebase

### Embedding uploaded images into knowledgebase articles

* When writing knowledgebase articles, inline images may now be added more easily by clicking a new 'upload image' button in the editor toolbar.  This presents a file chooser popup, which automatically links the new attachment to the article and inserts the appropriate markup to display the image (in Markdown or HTML).  In the past, these images weren't easily handled by Cerb and writers usually resorted to storing images on external sites.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_kb_embed_images.png" class="screenshot">
</div>

* When viewing a knowledgebase article, any attachments displayed as inline images are removed from the list of downloadable files.  These images can still be saved by right-clicking on them.

### Miscellaneous improvements

* The knowledgebase profile page now supports keyboard shortcuts for quickly changing the active tab.

* Fixed an issue where the knowledgebase profile page could become stuck always displaying a different tab than 'Article', with no way to reset it.

* Fixed an issue where attachments that were removed from a knowledgebase article could remove links to that file from other records as well.

# Support Center

### Custom fieldsets are prefixed to custom field labels

* [CHD-3882] When adding contact situations to a Support Center contact form, fieldsets are now prefixed to custom field names.

* When configuring which custom fields are displayed on the My Account page in the Support Center, custom fieldsets are prefixed to custom field names.

### Fixed file-based custom fields in the Support Center

* [CHD-3883] File-based custom fields and fieldsets now work properly when included in Support Center contact forms.

### Embedded attachments on knowledgebase articles

* In the Support Center, when a knowledgebase article contains attachments that are displayed as inline images, the image URLs will be automatically rewritten to use the portal's location.  Normally such attachments would require logging in to Cerb to view.  These images will also not be included in the list of downloadable files.  This simplifies the display of inline images as attachments by making them viewable to both internal workers and external portal visitors without having to host images on a third-party site.

# Web-API

### Miscellaneous improvements

* Fixed an issue with the 'sortBy' option in API searches not working properly.  This was due to how Cerb prevents MySQL errors from sorting on a non-displayed column.  When using the API, fields that are sorted by or filtered on will now automatically be added as columns in the underlying worklist that provides search results.

# Platform

### Browser tab labels

* [CHD-334] When viewing a ticket profile, the title of the current browser tab will now include the ticket mask and subject.  This helps differentiate multiple tabs without having to click into each of them.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_browser_tab_labels.png" class="screenshot">
</div>

* When displaying workspace pages, the browser title will now include the current page and tab information.

* When using the search pages, the browser title will now display the current record type being searched to help differentiate tabs.

* When viewing a knowledgebase article profile, the title of the current browser tab will now display the article title.

### View the entire comment history in peek popups

* [CHD-3506] All record peek popups that displayed comments are now capable of navigating through the comment history with next and previous links.  Previously these popups only showed the latest comment.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_peek_comment_history.png" class="screenshot">
</div>

### Add comments on the address peek popup

* Comments can now be viewed and created from address peek popups.

### Miscellaneous improvements

* [CHD-2135] Fixed an issue on email address peek popups where opening a linked organization popup would replace the original popup.

* When viewing a contact person record from a peek popup, a comment can now be added.  Previously this required viewing the full profile page.

* Fixed an issue where the merge helper could be improperly shown on deleted tickets that weren't merged.

* Peek popups now provide helpful tooltips when certain fields are focused or hovered over.  This removes some instructional clutter in the interface and provides better guidance when a field's purpose isn't entirely clear from its name.

<div class="cerb-screenshot">
<img src="/assets/images/releases/6.8/680_peek_tooltips.png" class="screenshot">
</div>

* [CHD-3618] The debug report now shows the engine and record count for every database table.  This is useful when sending debug reports to the development team for support.

* The debug report now displays usage information about the following PHP extensions: tidy, XCache, XDebug, memcache, memcached, and redis.

# Maintenance updates

### 6.8.1

Cerb (6.8.1) is a maintenance update released on October 6, 2014; it contains 6 minor features, fixes, and usability enhancements from community feedback covering the recent 6.8 update.  You can [follow these instructions](https://cerb.ai/docs/upgrading/) to upgrade.

* [Platform/Tooltips/Usability] Moved the form tooltips to the top-right of textareas rather than below them.  This doesn't obscure the text box as it grows.

* [CHD-3896] [Mail/Forward] Removed the default #cut command below the #signature when forwarding mail.

* [CHD-3898] [Custom Fields] Fixed an issue where custom fields were always displayed in alphabetical order, rather the order that they were dragged into.

* [Snippets/Usability] When using prompted placeholders from the insert snippet popup, single line inputs no longer auto-grow in the form.  This was a relic from the previous "madlibs" style input.

* [Platform/Update] Fixed some minor issues that prevented direct upgrades from 4.x versions to 6.8

* [CHD-3905] [Snippets] Fixed an issue where non-admin workers couldn't create new snippets.

### 6.8.2

Cerb (6.8.2) is a maintenance update released on October 20, 2014; it contains 9 minor features, fixes, and usability enhancements from community feedback covering the recent 6.8 update.  You can [follow these instructions](https://cerb.ai/docs/upgrading/) to upgrade.

* [CHD-3911] [Snippets] Fixed an issue with snippets containing prompted placeholders where 'current worker' based placeholders didn't replace their values properly on ticket snippets.

* [CHD-3912] [Mail/Drafts] Fixed an issue where multiple drafts are created if a worker is composing or replying to mail while in impersonation mode.

* [Mail/Parser/Localization] Fixed an issue where older Korean character sets (e.g. ks_c_5601_xxxx) weren't parsing properly when mixed with ASCII text.  These messages are now treated as the 'cp949' character set instead.

* [CHD-3907] [Time Tracking] Fixed an issue with the time tracking counter where closing the popup without saving it would leave the timer in an unusable state until the page refreshed.

* [CHD-3913] [Snippets] Administrators can now bulk update the owner of snippets to 'Application: Cerb' (global).

* [CHD-3915] [Scheduler] The scheduler can now run multiple named jobs in sequence in a single request when they are separated by a comma.  For instance: "/cron/cron.pop3,cron.parser".  This is useful for making jobs like mail processing run more frequently while ensuring the jobs happen in the right order and never concurrently.

* [CHD-3919] [Web-API/Tickets] In the Web-API, the 'group_id' and 'bucket_id' fields on ticket records can now be updated.

* [CHD-3922] [Web-API/Mail/HTML] Mail HTML templates can now be created, updated, searched, and deleted through the Web-API.

* [CHD-3922] [Web-API/Mail/HTML] When composing and replying through the Web-API, the 'content_format' and 'html_template_id' options allow HTML formatted mail to be sent.

### 6.8.3

Cerb (6.8.3) is a maintenance update released on October 27, 2014; it contains 5 minor features, fixes, and usability enhancements from community feedback covering the recent 6.8 update.  You can [follow these instructions](https://cerb.ai/docs/upgrading/) to upgrade.

* [Popups/Usability] Updated the jQuery UI library from 1.10.3 to 1.10.4 to fix issues with popups scrolling unexpectedly when clicking on form elements.  This was first introduced in Cerb 6.6.

* [Popups/Usability] Removed the jQuery UI floating tooltips introduced in 6.8.0 for popup forms.  These could cause a scrolling popup to constantly scroll back to the top of the window when a form element was clicked.

* [Virtual Attendants/Dates] Fixed an issue with date-based behavior variables and custom fields in the 'Create task' and 'Create ticket' actions of Virtual Attendants.  It was possible in some situations for strange dates to be generated, like "monday +2 weeks" resulting in a date 90 years in the future.

* [CHD-3850] [Mail/Virtual Attendants] Improved the 'Ticket conversation viewed by worker' event so it runs before the record is loaded on a ticket profile.  As a consequence, any changes to the ticket by that behavior will now be properly reflected on the profile when it loads (previously, this required a page refresh).

* [Setup/Translations] Fixed some PHP notices in the Translation Editor when using the 'Synchronize languages' feature.

### 6.8.4

Cerb (6.8.4) is a maintenance update released on November 13, 2014; it contains 11 minor features, fixes, and usability enhancements from community feedback covering the recent 6.8 update.  You can [follow these instructions](https://cerb.ai/docs/upgrading/) to upgrade.

* [Search/Usability] Fixed a PHP notice when performing a full-text search without a default 'max results' value.

* [CHD-3927] [Worklists/Custom Fields] Fixed an issue when filtering a worklist by a multi-value custom field where the 'not in' operators didn't work properly.

* [CHD-3917] [Virtual Attendants/Mail] Fixed an issue with 'Before sending worker message' behaviors where custom mail headers weren't being set when composing new messages.

* [CHD-3811] [Mail/Snippets/Keyboard] Fixed an issue with the Ctrl+Shift+I shortcut on mail compose/reply where it formatted with italics rather than focusing the snippets quick search.

* [CHD-1802] [Records/Custom Fields] Fixed an issue where custom fields could be set on record #0 if a record failed to be created (e.g. an invalid email address).

* [Mail/Parser] When converting HTML to plaintext, the email parser now provides special handling of Microsoft Word-formatted quotes, apostrophes, and ellipses.

* [CHD-3953] [Snippets/Windows] Fixed an issue with snippets that contain CRLF (carriage return + line feed) endings.  When these were inserted into a reply, the cursor would advance an extra character beyond the inserted content for each invisible CR.

* [CHD-1967] [Setup/Workers] The worker edit popup now enforces valid email addresses in the UI.

* [CHD-3114] [Mail/Drafts/Links] When composing a message from 'Create + Link' on the Links tab, the resulting draft will now currently remember the link to the current record.

* [Profiles/Usability] On the Links tab on profiles, the 'Create + Link' popups now open at 750px default width, like 'Find + Link' already did.  Previously the create popups opened at 500px width, which is pretty small on modern displays.

* [CHD-3823] [Scheduler/Import] When importing worker records from XML files, existing MD5 hashes will be converted to Cerb's salted SHA1 password format.

### 6.8.5

Cerb (6.8.5) is a maintenance update released on December 3, 2014; it contains 11 minor features, fixes, and usability enhancements from community feedback covering the recent 6.8 update.  You can [follow these instructions](https://cerb.ai/docs/upgrading/) to upgrade.

* [CHD-3957] [Virtual Attendants/Messages] Fixed a typo in Virtual Attendant message behaviors that referred to 'Message ender' rather than 'Message sender'.

* [CHD-3956] [Virtual Attendants/Picklists] Fixed an issue with Virtual Attendants not being able to set the value of 'picklist' behavior variables.

* [CHD-3555] [Virtual Attendants/Simulator] Virtual Attendants that use the 'Run behavior' action in the simulator will now properly pass the values of any public behavior variables being set.

* [CHD-3971] [Web-API/Tickets] The ticket 'owner_id' field can now be set through the Web-API.

* [Web-API/Tickets] The ticket 'org_id' field can now be set through the Web-API.

* [Setup/POP3/Timeout] Fixed an issue that prevented the 'timeout' option on POP3/IMAP mailboxes from working properly.

* [CHD-3775] [Scheduler/Mail] Each POP3/IMAP mailbox can now specify a maximum message size. This defaults to 25MB.  Any messages that exceed this size will not be fully downloaded, and instead a placeholder ticket will be created with the From/To/Subject headers and a warning message. This fixes a significant issue where very large messages (e.g. 50MB+) can block a mailbox from downloading any new mail (most providers limit attachments to 10-25MB).  These rewritten messages also include an 'X-Cerb-Parser-Error: message-size-limit-exceeded' header, and a 'X-Cerb-Parser-ErrorMsg' header with a human readable error; which can be used to generate bounces and reject delivery from a Virtual Attendant mail filter.

* [Setup/Mail] The POP3/IMAP mailbox tester will now utilize the timeout setting when connecting to the mailbox.

* [Setup/Mail/Security] Previously, POP3-SSL and IMAP-SSL mailboxes ignored SSL certificate validation in order to work with self-signed certificates on local mail servers. Now SSL certificate validation is a toggle (Enforce/Ignore), which defaults to Enforce.  If you have a self-signed certificate, edit your mailbox in Setup->Mail to disable SSL validation.

* [CHD-3903] [Mail/Reply/Compose] Fixed an issue that trimmed leading whitespace from messages sent by compose and reply.  This made it difficult to paste indented code fragments, XML fragments, Virtual Attendant export JSON, etc.

* [CHD-3969] [Notifications/Explore] Fixed an issue with explore mode on notification worklists.  It was possible for explore mode to start at an invalid position based on duplicate notifications being combined.

### 6.8.6

Cerb (6.8.6) is a maintenance update released on December 11, 2014; it contains 14 minor features, fixes, and usability enhancements from community feedback covering the recent 6.8 update.  You can [follow these instructions](https://cerb.ai/docs/upgrading/) to upgrade.

* [Mail/Filtering/Virtual Attendants] When a Virtual Attendant changes the 'Subject:', 'In-Reply-To:', or 'References:' headers in mail filtering behavior, Cerb will now check again to see if the message is a reply to an existing ticket.  Previously, the new/reply distinction was made before VAs ran and header changes didn't affect it.  This allows VAs to thread new mail based on anything (independent reference IDs, sender + subject, etc).

* [Mail/Filtering/Virtual Attendants] The 'Set header' action on Virtual Attendant mail filtering behaviors now internally handles the header name in lowercase.  It was previously possible for VA behaviors to create duplicate headers with different cases (e.g. 'Subject:' vs 'subject:').

* [CHD-3980] [Worklists/Quick Search/Workers] On worker worklists, it is now possible to quick search by group membership.

* [Worklists/Import/Usability] When importing records from a CSV file on worklists, the 'Match' column now provides a tooltip with more information about how it should be used.  Previously, some workers were clicking 'Match' for too many fields and preventing imports from working properly.  Fields are matched to determine uniqueness.

* [CHD-3980] [Worklists/Quick Search/Workers] When quick search filtering a worker worklist by the Groups field, it is now possible to use placeholders that contain a group id.  This is particularly useful in Virtual Attendants; for instance, to build a list of workers based on the roster of the current ticket's group.

* [Virtual Attendants/Simulator/Relay] Implemented simulator output for the 'Relay email' action in Virtual Attendants.

* [Virtual Attendants/Mail/Relay] When Virtual Attendants use the 'Relay mail' action, worker-based behavior variables can now be used to specify worker recipients.  Previously only owner, watchers, and explicitly selected workers could be specified.  Now it's possible to define a worker list behavior variable and use it as a relay list.  For instance, this is very useful for behaviors like 'Relay new mail to all group members'.

* [CHD-3976] [Worklists/Import/Mail] When importing CSV files on ticket worklists, records may now be matched on the 'ID' or 'Mask' columns.  Previously records were required to match exclusively on the mask column.

* [Worklists/Message] Message worklists now show ticket status icons: waiting, closed, deleted.

* [Worklists/Message] Message worklists can now include 'ticket status' as a column.

* [CHD-3977] [Reports/Workers] The 'Worker History' report can now be filtered by ticket status.

* [Reports/Workers] The 'Worker History' report worklist now shows the 'response time' column by default.

* [CHD-3978] [Search/Sphinx] Fixed a PHP error regarding DevblocksSearchEngineSphinx::prepareText()

* [CHD-3982] [Mail/Parser] Fixed an issue with inline images on incoming messages that didn't have a file name.  These were being saved with a blank attachment filename which prevented them from being clicked normally or displayed inline on the original_message.html attachment.  These files now have a filename properly generated for them again.

### 6.8.7

Cerb (6.8.7) is a maintenance update released on December 17, 2014; it contains 12 minor features, fixes, and usability enhancements from community feedback covering the recent 6.8 update.  You can [follow these instructions](https://cerb.ai/docs/upgrading/) to upgrade.

* [CHD-3984] [Support Center/Security] A banned email address can no longer be used to sign in to the Support Center.

* [CHD-3984] [Support Center/Security] A banned email address can no longer be used to register an account in the Support Center.

* [Support Center/Security] A banned email address can no longer be added as an alternate to an existing account in the Support Center.

* [CHD-3984] [Support Center/Security] A banned email address can no longer be used to recover an account login in the Support Center.

* [CHD-3975] [Workspaces/Dashboards/Widgets] Chart widgets on dashboards can now format the x-axis and y-axis as: number, decimal, percentage, bytes, secs elapsed, or mins elapsed.

* [Workspaces/Dashboards/Counters] The value of counter widgets on dashboards can now be formatted as minutes elapsed (particularly useful for time tracking records).

* [Workspaces/Dashboards/Gauges] The value of gauge widgets on dashboards can now be formatted as minutes elapsed (particularly useful for time tracking records).

* [CHD-3991] [Virtual Attendants/Ticket] In Virtual Attendants, the 'Create Ticket' action can now assign an owner.

* [Dependencies/Swiftmailer] Fixed a PHP log entry regarding "Notice: Undefined property: Swift_Transport_StreamBuffer::$_sequence"

* [Translations/Localization] The Translation Editor plugin will now export TMX files with the proper XML DTD and header.  This makes the file more compatible with external translation tools.

* [Translations/Localization] When exporting multiple languages into a single TMX file using the Translation Editor, multiple languages are grouped for each distinct term.  A language without a translation for the current text will now include a blank value.  Previously, each language created redundant entries, and only languages with translations were included.  These issues confused some external translation tools.

* [Mail/History] The 'Mail History' tab on organization and ticket profiles now properly handles all cases: ticket is assigned to org, ticket original sender is in org, and any ticket requester is in org.

### 6.8.8

Cerb (6.8.8) is a maintenance update released on January 20, 2015; it contains 5 minor features, fixes, and usability enhancements from community feedback covering the recent 6.8 update.  You can [follow these instructions](https://cerb.ai/docs/upgrading/) to upgrade.

* [Virtual Attendants/Relay] Fixed an issue with the 'Relay email' action in Virtual Attendants that prevented some messages from being sent.

* [Virtual Attendants] Fixed an issue with the 'Schedule behavior' action in Virtual Attendants.  There were situations where given public variables on a scheduled behavior could be ignored.

* [CHD-4007] [Setup/Workers] Fixed an issue where worker email addresses could be created or modified in mixed cases (e.g. workerName@Example.Com).  These are now always stored in lowercase.

* [Workspaces/Dashboards/Pie] Fixed an issue on pie chart widgets where the counts weren't showing properly in the legend.

* [Virtual Attendants/Actions/HTTP] Fixed an issue with the 'Execute HTTP Request' action in Virtual Attendants where the 'custom headers' option wasn't displayed by default until saved or a new HTTP verb was selected (e.g. GET/PUT).


