---
layout: post
title:  "7.0.3"
excerpt: Cerb 7.0.3 is a maintenance update released in July 2015 with 20 fixes and minor features from community feedback.
author: The Cerb Team
date:   2015-07-27 13:00:00 -0700
permalink: /releases/7.0.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 20
---

**Cerb ({{ page.title }})** is a **{{ page.release.type }}** released on {{ page.date | date: "%B %d, %Y" }}; it contains **{{ page.release.count }}** improvements from community feedback covering the [7.0](/releases/7.0/) update. You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[CHD-4142] [Mail/History/Usability]** When clicking into a ticket profile from a worklist, the Timeline/Conversation tab will now always be displayed first. When using next/previous in Explore Mode, the currently selected tab will continue to be used (e.g. cycling through many ticket histories or audit logs). Previously, as of the 7.0 update, clicking into a ticket profile from the Recipient History tab on another ticket would display the History tab first on the next record (because viewing the tab set it as the default).

* **[CHD-4141] [Worklists/Customize]** Fixed an issue where a worklist configured to display no additional columns would display the record's default columns instead.

* **[CHD-4135] [Worklists/Subtotals/Mail]** Ticket worklists can now be subtotaled by 'Bucket' directly. Previously, the 'Group' option totaled groups with nested buckets within each group. This made it difficult to use bucket counts on dashboard pie chart widgets, etc.

* **[CHD-4121] [Virtual Attendants/Record Changed]** Fixed an issue in Virtual Attendants with 'Record changed' behaviors where the 'old_' placeholders of custom fields weren't being loaded properly if no custom fields were currently set on the record. In this situation, the 'old' and 'new' placeholders for all custom fields were the same. The 'old' placeholders are now properly defaulted to null values.

* **[Search/Worklists]** Fixed an issue where some search and chooser worklists defaulted to displaying no columns.

* **[Search/Mail]** The search worklist for tickets now hides the recommendations column by default. This allows all records to be searched, rather than only those in the current worker's responsibilities.

* **[CHD-4148] [Calendars/Workers]** Fixed an issue where deleting a worker didn't also delete their owned calendars.

* **[Updater]** Fixed an issue where the 'Mailbox Checker' scheduled job wasn't added in some environments. This will be added retroactively if it's missing.

* **[Updater]** Fixed an issue when upgrading directly to 7.x from versions prior to 6.5. If Virtual Attendant behaviors were owned by missing records (e.g. deleted groups/roles/workers), then the update aborted when applying the 6.5.0 migration patch.

* **[Code Cleanup]** Fixed a PHP error when viewing the profile of an invalid group.

* **[Scheduler/Import]** Fixed an issue in the 'Import' scheduler job. When an importing record describes a new Group or Bucket, it was possible for the bucket to be created multiple times. If the bucket was 'Inbox', this was already being created in 7.0+ when the new group is created, but it wasn't being recached. This should all work properly now.

* **[Mail/HTML]** Fixed an issue with displaying HTML messages that contain malformed CSS stylesheets. In some cases, these were causing an infinite loop where the 'Loading: Timeline' tab never completed.

* **[CHD-4164] [Virtual Attendants/Workers]** Fixed an issue with Virtual Attendant 'Set worker' actions when using the 'round robin' option. This option could behave erratically when conditions on the behavior skipped the action in some situations (e.g. only pick a record owner if there is no current owner). This led to workers seemingly being selected out of order, one selected twice in a row, etc. This should behave as expected now.

* **[Virtual Attendants/Worklists]** Fixed an issue with 'Set list variable' actions on Virtual Attendants.  When reopening a worklist data source, the previously selected filters weren't being displayed correctly.

* **[Mail/HTML/Usability]** Optimized the way large and/or complex HTML messages are displayed. Previously, relatively small but complex messages (like those generated by Microsoft Office) could exhaust the available memory in PHP if the memory_limit was low enough (sometimes even at 128MB). This resulted in a 'Loading: Timeline' message on a ticket that never completed.

* **[Mail/HTML]** When displaying HTML formatted messages in the conversation history of a ticket, needlessly complex Microsoft Office markup will be removed automatically if the 'Tidy' extension is installed and enabled in PHP. For some test instances, this reduced 1.9MB HTML messages to 183KB. On the same message, Cerb's generated plaintext part was only 39KB.

* **[Mail/HTML]** Fixed an issue with displaying HTML messages that contain a large amount of CSS in a <style> block (e.g. 20KB+). In some environments, the PHP process could die in a regular expression in the CssToInlineStyles library intended to strip @media queries.  This has been reported to the project and we're using a workaround.

* **[CHD-4172] [Import/Scheduler]** Fixed an issue in the 'Background Import' scheduler job that prevented attachments and comments from importing properly on tickets.

* **[Worklists]** Fixed an issue with custom worklists on a workspace when the 'In groups of worker' filter referenced a deleted worker.  This could prevent the worklist/tab from displaying.

* **[Virtual Attendants/Simulator]** Fixed an issue in the Virtual Attendant simulator when a behavior variable is also a condition in an outcome.  The same behavior variable then shows up in both the 'Parameters' tab and the 'Conditions' tab, and the latter always takes precedence (and is usually blank), which ends up ignoring the given value.  Now a given field will only show up in one tab or the other (giving precedence to the Parameters tab).