---
layout: post
title:  "7.0.5"
excerpt: Cerb 7.0.5 is a maintenance update released in September 2015 with 19 fixes and minor features from community feedback.
author: The Cerb Team
date:   2015-09-02 13:00:00 -0700
permalink: /releases/7.0.5/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 19
---

**Cerb ({{ page.title }})** is a **{{ page.release.type }}** released on {{ page.date | date: "%B %d, %Y" }}; it contains **{{ page.release.count }}** improvements from community feedback covering the [7.0](/releases/7.0/) update. You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Worklists/Export]** Fixed an issue where exporting records from a worklist could change its underlying display columns and length.

* **[Security/XSS]** Fixed a potential cross-site scripting (XSS) vulnerability in the chooser popup. If HTML markup (e.g. script tags) existed in the text of a records link, then they were evaluated when the chooser popup opened or when those rows were selected. This was due to the links being converted to bold tags without escaping their content, which bypassed the normal sanitization in the rest of Cerb.

* **[Web-API/Knowledgebase]** Implemented an 'expand=categories' option for knowledgebase articles in the Web-API. This returns breadcrumb trails for all the categories the article exists in. Redundant categories paths are automatically removed. For instance, if an article exists in categories A, A->B, and A->B->C, only A->B->C will be shown since A and A->B are already part of that path.

* **[CHD-4208] [Installer/Updater]** Fixed a SQL error when upgrading directly from a version prior to 6.6 to a version prior to 7.0.5. This was harmless, but it could cause output to occur before the headers were sent in some environments, which prevented the update process from redirecting to the login form.

* **[CHD-4123] [Installer]** Fixed an issue in the installer where the worker's first and last name were reset if there was an error with the form (e.g. passwords didn't match).

* **[CHD-4127] [Notifications/Sticky Notes]** When viewing a ticket profile, message-based notifications (like sticky notes) are now also displayed and automatically marked read.

* **[CHD-4137] [Profiles/Notifications]** Fixed an issue on profiles where notifications weren't always listed in reverse chronological order (e.g. newest first).

* **[Usability/Worklists]** Slightly reduced the contrast of idle (gray) watcher/recommendation counter buttons in worklists. This fades them out a little so the green highlighted buttons are more apparent.

* **[CHD-4158] [Reports/Worker]** The 'Worker History over Date Range' report no longer includes broadcasted messages in the totals.

* **[Reports/Workers]** Improved the 'Average Response Time' worker report. Previously, the report attempted to calculate response times itself. Now it simply uses the 'response time' field that we already track and display on conversations (since 6.1 in Aug 2012).

* **[CHD-4174] [Groups/Buckets]** Fixed an issue where non-admin group managers couldn't edit bucket properties.

* **[CHD-4183] [Web-API/Mail]** Fixed an issue with the tickets/compose and tickets/reply API calls where the 'reopen_at' option wasn't working properly. It can now contain a string ("tomorrow 2pm", "+2 hours") or integer (unix timestamp) value.

* **[CHD-4176] [Support Center/Contact]** Fixed an issue when configuring the contact situations in the Support Center. The labels for custom fieldsets weren't displaying for new contact situations until they were saved.

* **[CHD-4187] [Activity Log/Worklists]** Fixed an issue on Activity Log worklists when filtering by more than one actor or target. This was making some filters optional. For instance, filtering by "activity = worker logged in" and "worker is Kina or Janey" could show more than just 'logged in' activities.

* **[CHD-4201] [Mail/Broadcast/Reply]** Fixed an issue with the 'broadcast reply' option in bulk update on ticket worklists. The broadcast preview wasn't filling in placeholder values.

* **[CHD-4206] [Worklists/Usability/Performance]** Fixed an issue with worklists where some customizations weren't being saved properly. If a worklist had the same ID as its default, the worklist was constantly overwritten by the default. This was noticeable with lists like Setup->Storage->Attachments, but it also created extra queries elsewhere by persisting the default worklists even if they were never used.

* **[CHD-4205] [Setup/Mailbox/Usability]** Corrected a minor inconsistency in Setup->Mail->Mailboxes. The column label for 'Max message size (KB)' on the worklist had the explicit 'KB' suffix, but the values are automatically scaled (e.g. bytes, KB, MB, GB). The column label now just refers to 'Max Message SIze'.

* **[CHD-4078] [Security/Worklists/Export]** Fixed an issue where exporting a worklist could bypass a worker's group permissions.

* **[CHD-4200] [Mail/Compose/Usability/Shortcuts]** Implemented keyboard shortcuts on the mail compose popup. From the textbox, the status can be set with Ctrl+Shift+ O (open), (W) waiting, or (C) closed. The 'send' button can be focused with Ctrl+Shift+Enter.