---
layout: post
title:  "7.1.1"
excerpt: Cerb 7.1.1 is a maintenance update released in December 2015 with 37 fixes and minor features from community feedback.
author: The Cerb Team
date:   2015-12-23 13:00:00 -0700
permalink: /releases/7.1.1/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 37
---

**Cerb ({{ page.title }})** is a **{{ page.release.type }}** released on {{ page.date | date: "%B %d, %Y" }}; it contains **{{ page.release.count }}** improvements from community feedback covering the [7.1](/releases/7.1/) update. You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[CHD-4262] [Profiles/Ticket]** Fixed an issue that prevented owners from being removed on the ticket edit popup.

* **[Profiles/Ticket]** Fixed an issue on ticket profiles where changing the participants rendered them unclickable as peek popups.

* **[Profiles/Ticket]** The participants popup on ticket profiles now uses a single email address chooser instead of multiple controls.

* **[CHD-4261] [Choosers/Workers]** Worker choosers now display a 'me' shortcut to quickly set the field to the current worker. This existed previously on some forms but was implemented redundantly.

* **[Virtual Attendants/Simulator]** Fixed an issue where the Virtual Attendant simulator wasn't showing the 'Target:' text for message-based events.

* **[Virtual Attendants/Simulator/Recipients]** Fixed an issue in the Virtual Attendant simulator with message-based events using the 'Remove recipients' action. The simulator output for this action wasn't showing up.

* **[Virtual Attendants/Tickets]** Fixed an issue in ticket-based and message-based Virtual Attendant behaviors where the 'Spam training' and 'Status' conditions only showed a text box rather than a picklist of possible values (e.g. open, waiting, closed, deleted).

* **[Avatars/Chooser/Gravatar]** When setting a profile picture on a record, only valid suggested images will be shown.  For instance, if there isn't a result in Gravatar for a given email address then no icon will be shown at all, rather than the default Gravatar logo.

* **[Avatars/Contacts/Gravatar]** When setting a profile picture on a contact, Gravatar pictures will be checked for all of the contacts' email addresses (previously, only the primary was checked).  Additionally, the recommendations now work when adding a new contact as well.

* **[Avatars/Org/Gravatar]** When setting a profile picture on organization records, Gravatar will be checked for images for the top 10 email addresses of that organization that don't have a contact assigned (e.g. support@, sales@, etc).

* **[Avatars/Workers/Gravatar]** When adding a new worker record and setting the profile picture, the Gravatar suggestion will now work properly for the given email address.

* **[Profiles/Tickets]** Fixed an issue where non-admin workers couldn't edit tickets from profiles.

* **[Worklists/Tickets/Bulk]** Fixed an issue with the new choosers when bulk updating ticket worklists.  If org/owner values were not provided then they were cleared on the selected records.

* **[Worklists/Tickets/Piles]** Fixed an issue with the pile sorter on ticket worklists. It wasn't refreshing the worklist after running.

* **[Worklists/Addresses/Bulk]** Added a new organization chooser to bulk update on email address worklists. This includes the 'create' shortcut and improved autocompletion.

* **[Worklists/Tickets/Bulk]** Added new worker choosers to bulk update on ticket worklists when adding/removing watchers. This includes the 'me' shortcut and improved autocompletion.

* **[Workers/Settings/Avatars]** Workers can now edit their own account fields from the Settings page (name, title, gender, location, phone, mobile, DOB, @mention, and photo). Previously, an administrator was required to change any of these details.

* **[UI/Aesthetics]** Date input fields now display a calendar icon to the right, which better indicates what that button does. Previously, it was a vague ellipsis (...).

* **[Platform/Choosers]** Fixed an issue where the new choosers didn't allow multiple record selection where enabled. This required the chooser to be re-opened to add each new record. This mainly just affected ticket 'bulk update' when adding/removing watchers.

* **[Virtual Attendants/Simulator/Calendar]** In Virtual Attendants, added the 'Also create records in simulator mode' option to the 'Create calendar event' action.

* **[Virtual Attendants/Calendars]** In Virtual Attendants, added the 'Add object to list variable' option to the 'Create calendar event' action. This allows other behaviors to run against the newly created record.

* **[Workers/Preferences]** Fixed an issue that prevented workers from verifying new alternative email addresses on their accounts.

* **[Choosers/Autocompletes]** Fixed an issue where some email address autocomplete fields inserted a numeric ID rather than the actual email address.

* **[Choosers/Autocomplete/Email]** Email addresses that are marked as defunct or banned will no longer be suggested in autocomplete fields.

* **[CHD-4269] [Import]** When previewing an import from CSV, email address and organization records are no longer automatically created when they don't already exist.  They are now only created on an actual import.

* **[Contacts/Worklists/Import]** When importing contact records from CSV, custom fields and fieldsets are now available to be imported into.

* **[Cards/Messages]** Implemented card popups for message records. These now display the details (and preview) of a single message, and they contain a link to their ticket for viewing everything else.

* **[Cards/Tickets/Messages]** When previewing message content from ticket and message cards, any custom fields on those messages are now displayed in the preview.

* **[Virtual Attendants/Performance]** Fixed an inefficiency in the way Virtual Attendants check conditions in outcomes. This was causing some behaviors with hundreds of conditions to take an unacceptable 20+ seconds to run, even though the underlying checks themselves took milliseconds. The problem was caused by a complex object that was built from scratch every time a condition was checked; and that object is now properly cached and reused. In one particular environment, this resulted in a 10,000% performance improvement (from 20000ms to 200ms per run of the behavior).

* **[Virtual Attendants/Simulator]** When running the Virtual Attendant simulator, a "spinner" is now shown while waiting for the results and the 'Simulate' button temporarily disappears. Previously, nothing happened until the output was ready, which could look like nothing was happening at all.

* **[Virtual Attendants/Simulator/Tasks]** In Virtual Attendants, added the 'Also create records in simulator mode' option to the 'Create task' action.

* **[Virtual Attendants/Tasks]** In Virtual Attendants, added the 'Add object to list variable' option to the 'Create task' action. This allows other behaviors to run against the newly created record.

* **[Virtual Attendants/Tasks]** In Virtual Attendants, added the 'Link to:' option to the 'Create task' action. This allows the newly created record to be linked to other records using placeholders and behavior variables.

* **[Virtual Attendants/Simulator/Tickets]** In Virtual Attendants, added the 'Also create records in simulator mode' option to the 'Create ticket' action.

* **[Virtual Attendants/Tickets]** In Virtual Attendants, added the 'Add object to list variable' option to the 'Create ticket' action. This allows other behaviors to run against the newly created record.

* **[CRM/Opportunities]** Added the new email address chooser to the opportunities edit popup. Cleaned up the two-part "Amount" field into a single input box. Added card popups for email and org to the opp profile page.

* **[Virtual Attendants/Opportunities]** Added a 'Create opportunity' action to Virtual Attendant behaviors. This allows opportunity records to be created automatically, along with custom fields and record links, and the new record can be appended to a variable to run additional behaviors on it.
