---
layout: post
title:  "7.1.2"
excerpt: Cerb 7.1.2 is a maintenance update released in January 2016 with 28 fixes and minor features from community feedback.
author: The Cerb Team
date:   2016-01-05 13:00:00 -0700
permalink: /releases/7.1.2/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 28
---

**Cerb ({{ page.title }})** is a **{{ page.release.type }}** released on {{ page.date | date: "%B %d, %Y" }}; it contains **{{ page.release.count }}** improvements from community feedback covering the [7.1](/releases/7.1/) update. You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[CHD-4246] [Profiles/Ticket/Comments]** When following a message or comment permalink on a ticket profile, the 'Timeline' tab will now always be selected. Previously, the selected tab was whatever had focus last.

* **[Virtual Attendants/Groups/Buckets]** In Virtual Attendants, group and bucket placeholders are now available for the reply-to address (e.g. group_replyto_address, bucket_replyto_address). These include all the extra fields on address records as well.

* **[Setup/Mail]** Fixed a PHP/MySQL notice when deleting mail transports.

* **[Watchers]** Fixed an issue that prevented workers from removing watchers on non-ticket records from the popup on worklists.

* **[Choosers/Usability]** The new chooser widget will no longer auto-focus the first result in the dropdown menu. This resolves the issue where tabbing away from the field (such as toward the (+) button) would select the first item.

* **[Profiles/Photos]** Fixed some inconsistencies in the caching of profile pictures. This resolves various issues where different default pictures are shown throughout the UI for the same record.

* **[Profiles/Pictures]** Fixed an issue when adding a profile picture using the 'Get image from URL' option with an internal Cerb URL (another avatar, etc). This was being blocked in the proxy by the lack of the session cookie and CSRF header token.

* **[Profiles/Pictures]** When a default silhouette is displayed for an address, contact, org, or worker record, the same image will always be used for a given record. Previously, these default images were randomized, and every time the record was updated the default image could confusingly change.

* **[Profiles/Pictures/Monograms]** When displaying a default profile picture for address, contact, or worker records, a monogram image is now created with their initials. Previously, a random gender-specific silhouette picture was displayed, and if the gender was unknown then the image could be of either gender. The monogram images have randomly colored backgrounds, which provide a much more helpful visual cue of different authors when viewing conversation histories. The silhouette default images can still be used as an option in Setup->Configure->Avatars.

* **[Profiles/Pictures/Contacts]** When a contact's profile picture is changed, the cache is now cleared for all of their email address records. Previously, the address records were cached separately and these could show the previous image until the cache expired.

* **[Profiles/Pictures/Orgs]** When an org's profile picture is changed, the cache is now cleared for all of their non-contact email address records. Previously, the address records were cached separately and these could show the previous image until the cache expired.

* **[Profiles/Pictures]** The default silhouette images are now available in the profile picture editor popup. These can be used in lieu of a personalized image. Previously, these images were assigned randomly and they couldn't be easily changed.

* **[Profiles/Pictures/Editor]** The profile picture editor now provides the option to specify a background color. When an image is fetched or uploaded that uses transparency, its background color can be changed in real-time. Previously, these images were always saved with a white background.

* **[Profiles/Pictures/Editor]** The profile picture editor now provides an option to create a new image (instead of fetching or uploading one). Any text can be provided as a label to be drawn on the new image, including Emoji icons. This is particularly useful in OSX on Macs with the Ctrl+Cmd+Space keyboard shortcut for inserting full-color, high-resolution Emoji icons. This makes it very easy to create a personalized avatar image from scratch.

* **[Choosers/Usability]** When setting a worker in a chooser, the 'me' shortcut is now on the left of the autocomplete input.

* **[CHD-2898] [Mail/Attachments/Reply]** Files can now be dragged from the local filesystem and dropped into the 'Attachments:' section of the reply form.  The drop zone will be highlighted with a green dashed border.

* **[Mail/Attachments/Compose]** Files can now be dragged from the local filesystem and dropped into the 'Attachments:' section of the compose form.  The drop zone will be highlighted with a green dashed border.

* **[Choosers/Autocomplete/Virtual Attendants]** Choosers with autocompletes are now able to show placeholders in the menu. This is particularly useful for Virtual Attendant behaviors, since variables may be used in place of specific records.

* **[Plugins/Servers/Cards]** Implemented card popups for server records.

* **[Plugins/Servers/Choosers/Autocomplete]** Implemented autocomplete for server records in choosers.

* **[Plugins/Servers/VAs]** Implemented a 'Create server' action in Virtual Attendant behaviors.

* **[Plugins/Domains/Virtual Attendants]** Implemented a 'Create domain' action in Virtual Attendant behaviors. This action permits variables for the 'Server' and 'Contacts' fields, can set custom fields, and can save the new domain record into a behavior variable.

* **[Plugins/Domains/Cards]** Implemented card popups for domain records.

* **[Plugins/Domains/Choosers]** Implemented autocomplete for domain records in chooser fields.

* **[Plugins/Calls/Virtual Attendants]** When using the 'Create call' action in Virtual Attendant behaviors, a 'Create records in simulator' option is now available.

* **[Plugins/Calls/Virtual Attendants]** When using the 'Create call' action in Virtual Attendant behaviors, a 'Link to:' option is now provided that can accept multiple records and placeholders. Previously this was limited to a single target with the 'On:' option.

* **[Plugins/Calls/Virtual Attendants]** When using the 'Create call' action in Virtual Attendants, the newly created record can be set in a behavior variable for further automation.

* **[Plugins/Assets/Virtual Attendants]** Added a 'Create asset' action to Virtual Attendant behaviors. This can set fields and custom fields, add comments, set links, add the newly created record to a variable for further automation, etc.
