---
layout: post
title: "7.3.1"
excerpt: Cerb 7.3.1 is a maintenance update released in February 2017 with 29 fixes and minor features from community feedback.
author: The Cerb Team
date: 2017-02-14 10:00:00 -0700
permalink: /releases/7.3.1/
redirect_from:
  - /7.3.1/
  - /wiki/7.3.1/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 29
---

**Cerb (7.3.1)** is a **{{ page.release.type }}** released on February 15, 2017. It includes **{{ page.release.count}}** fixes and minor features from community feedback covering the [7.3](/releases/7.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Profiles/Comments]** Fixed an issue with the 'Comment' button on the 'Comments' tabs of some profile pages.

* **[Installer/Database]** Made 'InnoDB' the default MySQL storage engine in the installer.

* **[Installer/Database]** The installer will now verify that the MySQL version is 5.6+ when using the InnoDB engine (required for FULLTEXT indexes).

* **[Profiles/Tickets]** Fixed an overzealous 'Access denied' error on ticket profiles for non-manager group members.

* **[Choosers/Workers]** Fixed an issue with worker autocomplete suggestions.

* **[Storage/S3]** Fixed an issue with the S3 storage engine. The storage scheduler wasn't moving objects to S3 if the 'Host' setting wasn't explicitly set. This defaults properly now.

* **[Worklists/Broadcast/Domains]** Fixed an issue with broadcasts from bulk update on domain worklists.

* **[Records/API/Links]** Fixed an issue with retrieving record 'links' from placeholder dictionaries.

* **[Attachments/Cards]** Fixed an issue with the 'Download' button not appearing on attachment cards for some workers.

* **[CHD-4473] [Cards/Tickets/Usability]** When editing a ticket card, the owner autocomplete will now only show workers from the currently selected group.

* **[Classifiers/Worklists]** Fixed an issue with explore mode on classifier example worklists.

* **[Worklist/Export]** Fixed an 'access denied' issue when certain workers attempted to download a worklist export file.

* **[Worklists/Custom Fields]** Fixed an issue in worklists where filtering by a previously deleted custom field returned zero results. These filters were ignored in versions earlier than 7.3, and they're ignored again now.

* **[Comments/Cards]** Fixed an error message when viewing the card of a previously deleted comments from a stale worklist.

* **[Profiles/Attachments/Usability]** When clicking on an attachment, holding SHIFT or CMD will download the attachment in a new window/tab. Previously, an extra step was added in 7.3 to open the attachment card and then click 'Download'.

* **[Browsers/IE]** Fixed a "dangling comma" in UI tabs that may affect older versions of Internet Explorer.

* **[Scheduler/Mailboxes]** Added temporary `APP_MAIL_IMAP_DISABLE_NTLM` and `APP_MAIL_IMAP_DISABLE_GSSAPI` settings to `framework.config.php` for working around POP3/IMAP authentication issues until these options can be added to the UI.

* **[Worklists/Comments]** Fixed an issue with explore mode on comment worklists.

* **[Attachments/Permissions]** Drastically improved the performance of privilege checks when viewing and downloading attachments that are linked to thousands of records. This was causing out-of-memory and script timeout issues in a production environment with image attachments (from signatures) linked to 58,000+ messages.

* **[Attachments/Usability]** Added support for streaming file attachment downloads. This was preventing audio and video files from being playable within the browser.

* **[Attachments/Cards/Usability]** When opening an attachment card, a preview of the file contents is now displayed for many file common types (images, audio, video, text files, HTML, PDFs, etc). For audio or video files, an HTML5 player is provided to play the content directly from the browser. Screenshots are scaled and displayed. Text, HTML, CSV, XML, JSON, CSS, and Javascript are displayed inline.  PDFs are displayed inline if a browser plugin is installed. This was the original plan for the 7.3 release, and we apologize the usability issues in the meantime.

* **[Attachments/Cards]** The 'Download' button on attachment cards now forces the browser to save and download a file. Previously this attempted to open the file in another window or tab.  With file previews now available on cards, the download option should be needed less often.

* **[Platform/Windows]** Fixed an issue with older versions of Internet Explorer and Safari on Windows. If HTML5 audio wasn't supported by the browser, it was throwing an error and breaking tabs on workspace pages.

* **[Search/Usability]** Fixed a usability issue with the global Search menu. Previously, if the mouse cursor strayed even the slightest bit out of the menu it would close instantly. Now the mouse cursor must remain outside the menu for 500ms before the menu closes.

* **[Comments/Cards/Usability]** On comment cards, added a 'Reply' button for quickly responding to a comment. This opens the comment editor with the same target record as the original comment.

* **[Comments/Cards/Usability]** Fixed a usability issue on the comment editor popup where the text box wasn't automatically focused.

* **[Activity Log/Notifications/Comments]** Improved the usability of the activity log and notification worklists.  Previously, any linked records opened up the full profile page. Links now open record card popups. This also improves the usability of the 'Worker commented on record' log entries, since the 'commented' opens up the comment card with formatting, links, attachments, and the ability to instantly reply.

* **[Attachments/Usability]** Improved the usability of attachments on messages and comments. In the 7.3 update, attachments open cards rather than opening files in new browser tabs. Downloading files required knowing the Shift+Click keyboard shortcut, or opening the card and clicking the 'Download' button.  A hover menu on attachments now provides one-click access to 'Download' and 'Open in browser'. The default action for attachments continues to be opening a card (for access to custom fields, links, comments, bot automation, etc).

* **[Worklists/Tickets]** Fixed an issue with the 'Organization' filter on ticket worklists. No options were displayed when using the helper to add an organization filter.

