---
layout: post
title: "7.3.3"
excerpt: Cerb 7.3.3 is a maintenance update released in February 2017 with 19 fixes and minor features from community feedback.
author: The Cerb Team
date: 2017-02-28 18:30:00 -0700
permalink: /releases/7.3.3/
redirect_from:
  - /7.3.3/
  - /wiki/7.3.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 19
---

**Cerb (7.3.3)** is a **{{ page.release.type }}** released on February 28, 2017. It includes **{{ page.release.count}}** fixes and minor features from community feedback covering the [7.3](/releases/7.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Tickets/Sticky Notes/Usability]** Fixed an issue with sticky notes on ticket profiles. When replying to a ticket, adding a sticky note or comment to a ticket refreshed the message and closed the reply form. New comments and messages are now inserted into the timeline dynamically so they don't interfere with other functionality.

* **[Profiles/Bots/Scheduled Behavior]** Fixed an issue that prevented scheduled behaviors from being deleted on profiles.

* **[Bots/Email]** In bots, the 'Send email' action now supports the 'Cc:' and 'Bcc:' headers.

* **[Mail/Attachments/Usability]** When viewing a ticket profile, each expanded message with attachments now has a new button in its top right toolbar as a visual indication of this. Clicking on this button displays all the attachments linked to the message in a search popup. This addresses feedback where workers could miss attachments on messages with long blocks of quoted text (that pushed the attachments below the fold) when using the `R` shortcut to reply.

* **[Installer/Platform]** Fixed an issue with the requirements checker when PHP's memory_limit is `-1` (disabled) in the `php.ini` file.

* **[Installer/MariaDB]** Fixed an issue in the installer requirements checker when using MariaDB. Previously, the MySQL version test returned inconsistent results between MySQL, MariaDB, and Aurora. Now the installer just attempts to create a table with a fulltext index using the selected engine and reports if the test fails.

* **[Debug/Status]** Updated the `/debug/status` report to track activity counts using the activity log rather than sessions. Old sessions can be cleaned up, which misreports activity.

* **[Debug/Status]** On the `/debug/status` report, the enabled plugin count is now accurate. Previously this included any installed plugins that may have been disabled.

* **[Debug/Status]** Added new counts to the `/debug/status` report: `workers_active_12h`, `workspace_pages`, `workspace_tabs`, `workspace_widgets`.

* **[Platform/Localization]** Replaced all instances of `strtolower()` and `strtoupper()` with multibyte-safe equivalents.

* **[Mail/Drafts]** Improved error reporting when mail fails to send and is saved as a draft. In some situations, mail fails to send due to "RFC compliance exceptions".  These error messages are now added as sticky notes on the draft. Errors from mail transports were already being reported like this.

* **[Worklists/Tickets/Subtotals]** Fixed an issue on ticket worklists. Clicking on organization subtotals wasn't adding a new filter.

* **[Bots/Cards]** Fixed an issue when adding or editing bots. The 'Mention:' field was being auto-focused instead of 'Name:'.

* **[Worklists/Comments/Usability]** On comment worklists, added the `Shift/Cmd+Click` shortcut for opening profile links in new browser tabs/windows rather than cards.

* **[Setup/Mail/Transports]** When deleting a mail transport from Setup, the transport is no longer tested first. Some users were trying to delete invalid mail transports and were being improperly blocked by the validity test.

* **[Worklists/Tickets]** On ticket worklists, fixed an issue where the 'spam' and 'not spam' buttons had no effect if the ticket was already trained.

* **[Bots/Cards/Usability]** Added a 'Simulator' button to the top of behavior cards. Previously, this option was in the decision tree menu, which wasn't very obvious.

* **[Bots/Cards/Usability]** When viewing a bot behavior card with an empty decision tree, helper text is now displayed that explains what to do next.

* **[Workers/Impersonation]** Fixed an issue in Chrome (and possibly other non-Webkit browsers). When un-impersonating a worker as an admin, if the last thing you did was change the worker's settings, then the same settings would be saved to your own account as well. This happened because the `window.location.reload()` function resubmitted the form in both sessions.