---
layout: post
title: "7.3.6"
excerpt: Cerb 7.3.6 is a maintenance update released in March 2017 with 19 fixes and minor features from community feedback.
author: The Cerb Team
date: 2017-03-20 11:05:00 -0700
permalink: /releases/7.3.6/
redirect_from:
  - /7.3.6/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 19
---

**Cerb (7.3.6)** is a **{{ page.release.type }}** released on March 20, 2017. It includes **{{ page.release.count}}** fixes and minor features from community feedback covering the [7.3](/releases/7.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Choosers/Usability]** When a new record is added from a chooser, it is now automatically selected. Previously, a worker had to create the record and then find it in the worklist to select it. If the chooser is in 'single selection' mode it will close with the selection after creating the record.

* **[Choosers/Usability]** Fixed an issue on choosers where the worklist toolbar icons were being resized too small.

* **[Links/Search/Usability]** When opening a worklist from a search button in the 'Links:' section of a card or profile, quick search is now available above the list. Previously this had to be opened manually from the search icon above the worklist.

* **[Profiles/Tasks]** Added the 'Owner' field to the properties at the top of task profiles.

* **[Profiles/Tasks]** Added the 'Importance' field to the properties at the top of task profiles.

* **[Bots/Actions/Tasks]** On task-related bot behaviors, the 'Importance' field can now be set.

* **[Bots/Actions/Tasks]** On task-related bot behaviors, the 'Owner' field can now be set using values or variables.

* **[Bots/Actions/Tasks]** On task-related bot behaviors, the 'Set status' action now properly shows simulator output.

* **[Bots/Actions/Tasks]** On task-related bot behaviors, fixed a defect where the 'Set due date' action could also affect the importance field.

* **[Bots/Actions/Tasks]** In bots, when using the 'Create task' action, the 'Owner' field can now be set using placeholders, variables, or workers.

* **[Bots/Actions]** In bots, when using a 'Set' action on an owner field or worker custom field, variables and placeholders can now be used.

* **[Bots/Actions/Tickets]** In bots, when using the 'Create ticket' action, the 'Owner' field can now be set using placeholders, variables, or workers.

* **[Bots/Scripts/Snippets]** Fixed an issue in bot scripts and snippets where the `|bytes_pretty` and `|date_pretty` filters only worked with text input. It's now possible to use numbers again as well.

* **[Bots/Actions/Tickets]** In bots, fixed an issue with the 'Create ticket' action. Setting the 'Status:' field to 'closed' didn't work as expected.

* **[Preferences]** Fixed an issue that prevented some workers from saving their preference settings.

* **[Installer]** Fixed an issue in the installer. If PHP's opcache was enabled and the installer changed the `framework.config.php` file, the next step could receive a stale version of the config file even after the previous step validated the database connection settings.  This is due to the `opcache.revalidate_freq` setting, which by default checks a file every 2 seconds for changes. This caused a blank while screen in the installer, and a page refresh after 2 seconds would resume the installer properly.  Now the installer will pause for 2.5 seconds after writing the config file, and it will show a proper error screen (with a retry button) if the database still doesn't connect properly.

* **[Installer]** The installer now checks for the 'mbstring' extension before running. The template service requires this, so a pretty error in the requirements can't be displayed without it. When mbstring was missing the installer was just displaying a blank white page.

* **[Bots/Notifications]** Fixed an issue with the 'Create notification' action in bots. Placeholders weren't being evaluated in the notification URL.

* **[Notifications]** Fixed an issue with notification worklists where custom notification URLs weren't being displayed properly.

