---
layout: post
title: "7.3.8"
excerpt: Cerb 7.3.8 is a maintenance update released in April 2017 with 19 fixes and minor features from community feedback.
author: The Cerb Team
date: 2017-04-03 10:20:00 -0700
permalink: /releases/7.3.8/
redirect_from:
  - /7.3.8/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 19
---

**Cerb (7.3.8)** is a **{{ page.release.type }}** released on April 3, 2017. It includes **{{ page.release.count}}** fixes and minor features from community feedback covering the [7.3](/releases/7.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[API]** Fixed an issue in the API with `/tickets/reply.json` where a _"Context_Ticket not found"_ error was being thrown.

* **[Bots/Comments/Mentions]** When using the 'Create comment' action from bots, `@mentions` in the comment text now properly notify workers.

* **[Bots/Behaviors/Usability]** When viewing an empty behavior worklist, a help box is now displayed with instructions on how to add a behavior.

* **[Bots/Behaviors/Usability]** When viewing a bot card with no behaviors, and the worker has permission to modify the bot, a help box is displayed with instructions on creating the first bot behavior.

* **[Profiles/Bots]** Fixed an issue with scheduled behaviors on profiles. If a scheduled behavior was edited, clicking on a bot in the refreshed fieldset no longer opened up a card.

* **[Worklists/Bulk]** When using the 'Schedule Behavior' action from bulk update on worklists, list-based behavior variables are now properly supported.

* **[Cards/Owners]** Improved validation of the 'Owner' field on several records. The possible options are now restricted based on the active worker's permissions.

* **[Mentions]** `@mention` names can now include dashes.

* **[Platform/Database]** Fixed a few `$db->GetArray()` calls that weren't using `$db->GetArrayReader()`.

* **[Search]** The search worklist popup is now titled with a "Search:" prefix and the plural form of the record type.  For instance "Search: Tickets". This is very minor, but a worklist like "Search: Saved Searches" is less confusing than "Saved Search Search".

* **[Search]** Fixed an issue in the search menu where 'Contact' wasn't pluralized as a record label.

* **[Bots/Scripts/Snippets]** In bot/snippet scripting, added autocompletion for several more commands: `do`, `filter`, `dict_set`, `verbatim`, and `with`.

* **[Bots/Scripts/Snippets]** In bot/snippet scripting, added autocompletion for all available functions. These are accessed by typing `{% raw %}{{{% endraw %}`.
	
* **[Bots/Scripts/Snippets]** In bot/snippet scripting, added autocompletion for a few more filters: `batch`, `convert_encoding`, and `raw`.

* **[Developers/Platform/Scripting]** Moved all the Twig `.atwho` autocompletion to a `.cerbTwigCodeCompletion()` plugin. This cleans up redundant code and makes the autocompletion more maintainable.

* **[Bots/Scripting]** Added a `cerb_avatar_image()` function to bot scripting. This generates an `<img>` tag for a given record (worker, org, contact, etc). This is primarily useful for conversational bots.

* **[Bots/Scripting]** Added a `cerb_avatar_url()` function to bot scripting. This generates the URL for a given record's avatar picture (worker, org, contact, etc). This is primarily useful for conversational bots.

* **[Bots/Scripting]** Added a `cerb_url()` function to bot scripting. This uses Cerb's URL service to generate links, which handles URL rewriting and proxies that change the hostname. This is useful for bots that need to generate internal URLs within Cerb (primarily for conversational bots).

* **[Security/Bots/Scripting]** Added a sandbox security policy to Twig template scripting (bots/snippets) with an allowlist of available commands, filters, and functions. This removes a few commands and functions that weren't needed for our use case (like `include()` and `macro`).