---
layout: post
title: "Recent announcements from Cerb: April 2017"
excerpt: "A summary of recent Cerb news: 1 sneak peek, 1 security notice, 6 maintenance updates, 6 how-to guides, and 10 tips."
author: The Cerb Team
date: 2017-04-04 19:35:00 -0700
tags: cerb announcements
---

## The sneak peek

* [Kanban-style project boards with bot automation in 7.4](/blog/2017/04/04/Sneak-peek-at-project-boards/)

## The security notice

We strongly recommend that you upgrade to the latest version.

During one of our own security audits, we recently discovered a potential information leak that could be abused by a malicious worker under the right conditions.  We have no evidence that the vulnerability has ever been used.  It only affects a small number of self-hosted environments where common security practices already aren't being followed; but it would be possible back to 5.x versions.

If you use Cerb Cloud, we've already upgraded you.  Cerb Cloud wasn't vulnerable to this issue.

We believe in [responsible disclosure](https://en.wikipedia.org/wiki/Responsible_disclosure).  We will refrain from publishing any details about the potential vulnerability for a few weeks so that you have a chance to upgrade first.

Please [contact us](/contact/) if you require any assistance during the upgrade process.

## 6 new maintenance updates

Since our last announcement, there have been six weekly maintenance updates with a total of 90 minor features and fixes from community feedback.

You can find those release notes here:

* [7.3.3](/releases/7.3.3/) with 19 improvements.
* [7.3.4](/releases/7.3.4/) with 11 improvements.
* [7.3.5](/releases/7.3.5/) with 9 improvements.
* [7.3.6](/releases/7.3.6/) with 19 improvements.
* [7.3.7](/releases/7.3.7/) with 13 improvements.
* [7.3.8](/releases/7.3.8/) with 19 improvements.

## 6 new how-to guides

We recently added these new how-to guides:

* [Close idle tickets with bots](/guides/bots/close-idle-tickets/)
* [Relay worker comment notifications to email](/guides/bots/relay-comment-notifications-email/)
* [Dispatch assignments to available workers using bots](/guides/bots/dispatch-assignments/)
* [Launch EC2 instances in Amazon Web Services](/guides/installation/ec2/)
* [Install Cerb on Amazon Linux](/guides/installation/amazon-linux/)
* [Install Cerb on Ubuntu Linux](/guides/installation/ubuntu/)

We'll be posting new guides and tips every week.  Let us know what other topics you'd like us to write about.

Follow us on [Twitter](https://twitter.com/cerb_ai) for real-time updates about new articles.

## 10 new tips

Here are the new tips and tricks:

* [Drag and drop attachments](/tips/drag-drop-attachments/)
* [Save Cerb mobile as an iPhone shortcut](/tips/save-cerb-mobile-iphone-shortcut/)
* [Quickly close popups](/tips/quickly-close-popups/)
* [Quickly add or remove yourself as a watcher from worklists](/tips/quickly-watch-records-from-worklists/)
* [Review bot behaviors by event](/tips/review-bot-behaviors-by-event/)
* [Build a worklist of tickets owned or watched by me](/tips/owned-or-watched-by-me/)
* [Quickly create calendar events](/tips/calendar-event-shortcut/)
* [Use prompted placeholders in snippets](/tips/snippet-prompted-placeholders/)
* [Archive a copy of all inbound mail](/tips/archive-inbound-mail/)
* [Find other senders from the same email host](/tips/find-similar-senders/)

## Thanks for using Cerb!

Thanks for supporting Cerb's development.  Keep the great feedback coming!
