---
layout: post
title: "8.0.3"
excerpt: Cerb 8.0.3 is a maintenance update released in July 2017 with 22 minor features and fixes from community feedback.
author: The Cerb Team
date: 2017-07-17 12:00:00 -0700
permalink: /releases/8.0.3/
redirect_from:
  - /8.0.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 22
---

**Cerb (8.0.3)** is a **{{ page.release.type }}** released on July 17, 2017. It includes **{{ page.release.count}}** fixes and minor features from community feedback covering the [8.0](/releases/8.0/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Platform/Windows]** Fixed an issue with Smarty in Windows. Filenames were being created with colons (`:`), which are valid in Linux/BSD but not Windows.

* **[Bots/Interactions]** Fixed an issue where changes to bot interactions from **Setup >> Import Package** weren't immediately visible. The cache wasn't being invalidated properly.

* **[Worklists/Contacts/Search]** On contact worklists, added a `lastLogin:` filter for searching for contacts based on the last time they logged into a community portal (or not).

* **[Profiles/Contacts]** On contact profile pages, added the `phone` and `mobile` fields to the record summary at the top.

* **[Files]** Fixed an issue where downloaded attachments could be renamed using URL escaping (e.g. spaces to `+`).

* **[Worklists/Search]** Fixed an issue with ticket worklists where an extra 'in groups of worker' filter was being added every time the worklist opened.

* **[Worklists/Tickets]** On ticket worklists, date-based columns (e.g. created/updated/closed/reopen) provide a `data-timestamp` attribute with a Unix-based timestamp. This simplifies many bot behaviors that modify the worklist.

* **[Platform]** Added a `DevblocksPlatform::strParseQueryString()` method to avoid inherent issues with PHP's `parse_str()` function (e.g. dots in URL param names via AWS).

* **[Bots]** In bots, fixed an issue with the 'Execute HTTP request' action where a multiple line script for the URL field was converted to a single line.

* **[Bots/Custom Fields]** In bots, placeholders are now available for worker-based custom fields on a record.  For instance: `ticket.custom_123__label` and `ticket.custom_123_full_name`.

* **[Roles/Comments]** Added a worker-level permission for "Can edit own comments". This allows admins to determine when a worker is able to edit their own comments. In some environments, comments are considered part of a permanent immutable record.

* **[Bots]** In bots, fixed an issue where "Behavior" showed up twice in the "On:" field for some events. The second entry should have been labeled "Bot".

* **[Mail/Localization]** Fixed an issue when editing comments. The "Reply" button wasn't being translated properly.

* **[Performance/Profiles]** On ticket cards and profiles, optimized the method for counting attachments on messages, comments, and sticky notes. This total was shown on the 'Attachments' search button at the top of the profile, and was inefficient in some environments.

* **[API]** Fixed a PHP notice when connecting to the API using the PHP library on the command line.

* **[Security/Login]** On the default login form, browser autocompletion is now disabled on the 'Password:' field. This is often reported on by scanners for PCI compliance.

* **[Security/Login]** In the default login process, added the 'secure' flag to the cookie under SSL when checking the 'Remember me' box.  This came up in PCI compliance scans.

* **[Mail/Parser]** Improved error checking/logging in the inbound email parser when a malformed MIME message fails to parse.

* **[Bots/Interactions/Prompts]** In bot interactions, when using a 'Prompt with chooser' action, a new 'autocomplete' option controls whether the chooser allows typing in addition to the popup search window.

* **[Mail/Compose/Usability]** When composing from a ticket worklist, the default 'From:' bucket and group will inherit those filters from worklist.

* **[Bots/Behaviors]** Removed an extraneous 'Bot' reference from 'On:' actions in 'Custom behavior on bot' events.

* **[Mail/Parser]** Fixed an issue with mail parsing where a new message subject line containing `[#]` could thread to an existing ticket if it didn't have a mask.
