---
layout: post
title: "8.0.4"
excerpt: Cerb 8.0.4 is a maintenance update released in July 2017 with 18 minor features and fixes from community feedback.
author: The Cerb Team
date: 2017-07-25 12:50:00 -0700
permalink: /releases/8.0.4/
redirect_from:
  - /8.0.4/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 18
---

**Cerb (8.0.4)** is a **{{ page.release.type }}** released on July 25, 2017. It includes **{{ page.release.count}}** fixes and minor features from community feedback covering the [8.0](/releases/8.0/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Bots/Messages]** In bots and snippets, added new message-based placeholders for `reply_to` and `reply_cc`.  These provide a list of "reply to all" recipients based on the headers of the target message. For instance, this simplifies an auto-responder bot that needs to send a confirmation to all parties and not just the original sender.

* **[Bots/Actions]** In bots, when using the 'Execute HTTP Request' action, new HTTP methods are available: `PATCH`, `HEAD`, and `OPTIONS`.  In particular, `PATCH` is used by some APIs (like Salesforce) to support "upserts".

* **[Profiles/UI]** Fixed an issue on ticket profiles when Cerb was embedded an in `IFRAME` from another site.  The `.visible()` jQuery plugin was throwing an error and interrupting other scripts.

* **[Bots/Actions]** In bots, when using the 'Send email' action, the `To:`/`Cc:`/`Bcc:` fields now save multiple line scripts as their value. Previously these were being saved as a single line.

* **[UI/Platform]** Added an explicit white background color to Cerb's stylesheet. For instance, this prevents a different background color from being inherited when embedded in an `IFRAME`.

* **[Dashboards/Worklists]** Fixed an issue with worklist widgets on dashboards. In some cases, the associated worklist couldn't be re-edited.

* **[Worklists/Search/Tickets]** On ticket worklists, added a `closed:` filter for searching by ticket closure date.

* **[Bots/Behaviors/Simulator]** On bot behaviors, actions that use 'Execute jQuery script' now have simulator output for the script.

* **[Mail/Compose/Worklists]** The compose popup now only inherits the group/bucket filter of an underlying worklist if they were singular. Previously, the first group was inherited as the 'From:' even if multiple groups were included in the filter.

* **[Platform]** Fixed an issue with `DevblocksPlatform::strParseQueryString()`. When passing an empty string, it returned a non-empty array with an empty string as a key.

* **[Bots/Behaviors]** Fixed an issue in 'Record commented on' behaviors. The placeholder for 'Comment Target' always inserted the comment's ID instead.

* **[Bots/Behaviors]** Fixed an issue with 'Record changed' behaviors where the `behavior_*` placeholders didn't always reflect the current behavior. This occurred when multiple behaviors answered the same event.

* **[Mail]** Fixed a PHP notice when the default sender address didn't have an HTML template assigned.

* **[Custom Fields/Buckets]** Custom fields can now be properly set when editing bucket records from cards.

* **[Localization]** Added a language pack for 'British English'.

* **[Bots/Behaviors]** On '[UI] Before displaying a worklist' behaviors, the current worker is now available as placeholders in conditions and actions.

* **[Notifications/Custom Fieldsets]** Adding or removing custom fieldsets on a record no longer generates worker notifications. This can still be monitored from the activity log.

* **[Plugin Library]** Connections to the plugin library now timeout in 10 seconds, rather than the default of 30. This helps prevent gateway timeouts during upgrades behind an outgoing firewall.