---
layout: post
title: "8.0.5"
excerpt: Cerb 8.0.5 is a maintenance update released in August 2017 with 21 minor features and fixes from community feedback.
author: The Cerb Team
date: 2017-08-08 18:00:00 -0700
permalink: /releases/8.0.5/
redirect_from:
  - /8.0.5/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 21
---

**Cerb (8.0.5)** is a **{{ page.release.type }}** released on August 8, 2017. It includes **{{ page.release.count}}** fixes and minor features from community feedback covering the [8.0](/releases/8.0/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Mail/Compose]** Fixed an issue with the compose popup inheriting the 'From:' group and bucket from the worklist. This should now properly use the worker's preference when the worklist doesn't contain a single group or bucket filter.

* **[Attachments]** Fixed an issue with Firefox truncating attachment file names on a space.

* **[Worklists/Search]** Fixed an issue with negating deep searches in some situations. For instance, it wasn't possible to negate `messages:!(search text)` from ticket worklists.

* **[Debug/Status]** In the `/debug/status` report, added a `bot_events` section that subtotals behaviors by event.

* **[Debug/Status]** In the `/debug/status` report, added a count for `project_boards`.

* **[Debug/Status]** In the `/debug/status` report, added a count for `classifiers`.

* **[API/Addresses]** Fixed an issue with email addresses in the web API. When creating a new address or searching, the response was always _"Not implemented"_ even though the action was properly performed. Patch provided by [@kvdveer](https://github.com/kvdveer/).

* **[Platform/Developers]** Added a StyleCI configuration file for automated coding style analysis. Patch provided by [@nbeernink](https://github.com/nbeernink/).

* **[API/Mail/Parser]** Fixed an issue with importing mail through the web API. If a raw message didn't include a `Message-ID:` header then Cerb wasn't creating one. The header will be generated now when missing.

* **[Worklists/Searches]** On saved searches, the `tag` field is now optional and may be blank.

* **[Worklists/Mail/Compose]** On ticket worklists, an explicit default sender for composing new mail can be configured for each worklist. By default, the sender on compose will either inherit the worklist filters or use the last selection by the user. When a sender is configured it will always be used regardless of the defaults.

* **[Worklists/Addresses]** Fixed an issue with sorting address worklists by organization.

* **[File Bundles]** Fixed an issue where files couldn't be removed from file bundles.

* **[Snippets/Custom Fields]** Fixed an issue with record link based custom fields on snippets. If a record link occurred deeper than the first level then it wasn't displayed in the placeholder menu. This was due to overly aggressive recursion detection.

* **[Bots/Simulator/Custom Fields]** In the bot simulator, when setting custom fields, custom fieldsets are now displayed in the output.

* **[Bots/Simulator/Custom Fields]** In the bot simulator, checkbox-based custom fields now display localized 'no' and 'yes' values, rather than 0/1.

* **[Platform/Installer]** When running the installer or updater, the tests will check if the 'vendor' directory exists. This is created by Composer. It's automatically handled in the `cerb/cerb-release` repository, but not the developer repositories (e.g. `jstanden/cerb`, `wgm/cerb`).

* **[Profiles/Ticket]** Fixed an issue on ticket profiles. The buttons for close, delete, and merge no longer appear if a worker doesn't have access to the ticket's group.

* **[Mail/Parser]** Fixed an issue in the email parser. When multiple attachments had the exact same filename only one of them was being saved.

* **[Platform/Installer]** When running the installer or updater, the tests will check if 'mailparse' version 3.0.2 or later is installed. The earlier 3.0.1 version has segfault bugs with PHP 7.0+.

* **[Plugins/Platform]** Fixed a PHP7 compatibility issue with PclZip, the library we use when the PHP 'zip' extension isn't installed.