---
layout: post
title: "8.1.4"
excerpt: Cerb 8.1.4 is a maintenance update released in October 2017 with 15 fixes and minor features from community feedback.
author: The Cerb Team
date: 2017-10-06 17:00:00 -0700
permalink: /releases/8.1.4/
redirect_from:
  - /8.1.4/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 15
---

**Cerb (8.1.4)** is a **{{ page.release.type }}** released on October 6, 2017. It includes **{{ page.release.count}}** fixes and minor features from community feedback covering the [8.1](/releases/8.1/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Choosers/Autocomplete]** Fixed an issue when using autocomplete inputs on choosers. Suggestions weren't being shown until at least 2 characters were entered for some record types (e.g. email addresses). Suggestions are now properly returned from the first typed character.

* **[Workspaces/Tasks/Usability]** On task worklists, the status icons now have more informative tooltips.

* **[Custom Fieldsets]** Fixed an issue that prevented the deletion of fields when editing custom fieldsets. [[#451](https://github.com/jstanden/cerb/issues/451)]

* **[Installer/Database]** Fixed an issue in the installer database tests. When testing table creation and FULLTEXT indices, the MySQL default storage engine was being used, rather than the engine selected during setup. [[#218](https://github.com/jstanden/cerb/issues/218)]

* **[Worklists/Tickets/Bulk]** When using bulk update on ticket worklists, the reopen date now allows calendar and relative date input (e.g. `+2 hours`). [[#450](https://github.com/jstanden/cerb/issues/450)]

* **[Bots/Tickets]** In bots, when using the 'Create ticket' action, a new 'Attach the files from these variables' option is available to attach files from behavior variables. This was already possible on the 'Send email' action. [[#455](https://github.com/jstanden/cerb/issues/455)]

* **[UI/Template Editor]** Fixed an issue with the popup template editor. Autocompletion of Twig syntax and filters is now working properly. [[#456](https://github.com/jstanden/cerb/issues/456)]

* **[Bots/Mail/Filtering]** On bots, in 'Before new incoming message is accepted' events, the 'Parent ticket' placeholder is now available as an 'On:' target in actions. [[#372](https://github.com/jstanden/cerb/issues/372)]

* **[Bots/Behaviors]** In bot conditions and actions, fixed an issue with the script tester where testing an empty script returned an error.

* **[Bots/Loops]** In bots, the loop editor now includes a placeholder menu (like conditions and actions). Scripting syntax is also autocompleted in the editor.

* **[Bots]** In bots, suppressed PHP notices when testing scripts. For instance: `"Array to string conversion"`.

* **[Worklists/Export]** Fixed an issue when exporting worklist data. In some situations, submenus on the field menu could open upward and become truncated by the top of the worklist. [[#320](https://github.com/jstanden/cerb/issues/320)]

* **[Bots/Tickets]** In bots, when using the 'Create ticket' action, the selected group is now properly applied to the ticket. Previously this relied on existing mail routing rules based on the group's email address. [[#275](https://github.com/jstanden/cerb/issues/275)]

* **[Mail/Compose]** When composing mail, the 'Send' button now blocks multiple clicks before the process has finished. [[#251](https://github.com/jstanden/cerb/issues/251)]

* **[Mail/Drafts]** Attachments are now visible on draft previews. [[#237](https://github.com/jstanden/cerb/issues/237)]

