---
layout: post
title: "8.2.2"
excerpt: Cerb 8.2.2 is a maintenance update released in November 2017 with 31 minor features and fixes from community feedback.
author: The Cerb Team
date: 2017-11-13 08:00:00 -0700
permalink: /releases/8.2.2/
redirect_from:
  - /8.2.2/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 31
---

**Cerb (8.2.2)** is a **{{ page.release.type }}** released on November 13, 2017. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [8.2](/releases/8.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Worklists/Search]** On worklists, quick search queries can include `page:n` to advance the results to a specific page. This is particularly useful in bots and the API.

* **[Worklists/Search]** On worklists, quick search queries can include `limit:n` to determine the number of results to display per page. This is particularly useful in bots and the API.

* **[Bots/Records]** Added a 'Record Create' action to all bot behaviors. This allows a bot to create a record of any type from any behavior based on the permissions of the bot's owner. Custom records are supported, as are all built-in and custom fields. Unlike the built-in 'Create' actions, every field value in this action can be set using placeholders. A dictionary with the new record information (including the generated ID) is returned by the action.

* **[Bots/Records]** Added a 'Record Update' action to all bot behaviors. This takes an input, ID, and changeset as inputs. The changeset is a JSON object keyed on field names. Every field value can be provided from placeholders. The action returns the dictionary for the updated record.

* **[Bots/Records]** Added a 'Record Delete' action to all bot behaviors.  The action takes a record type (context) and ID as inputs. Permission to delete a record is based on the bot's owner.

* **[Bots/Records]** Added a 'Record Upsert' action to all bot behaviors. This action takes a record type (context), query, and changeset as inputs. The query is used to determine if a matching record exists or not. When a match exists, the changeset is used to update it. When a match isn't found, the changeset is used to create a new record. The changeset is a JSON object keyed on dictionary field names. The values of any built-in or custom field can be set using placeholders. Permissions to create or update a record are based on the bot owner. The action returns the dictionary of the created or updated record.

* **[Bots/Records]** Added a 'Record Retrieve' action to all bot behaviors. This action takes a record type (context) and ID as inputs. The action returns the dictionary of the retrieved record.

* **[Bots/Records]** Added a 'Record Search' action to all bot behaviors. The action takes a record type (context), query, and list of keys to expand as input. The query is used to retrieve records, including the new `limit:n` and `page:n` filters. The action returns an array of record dictionaries. The "keys to expand" option uses an efficient bulk expansion method across the list of returned dictionaries. For instance, a single query is used to expand organization info on a list of tickets rather than "n" queries for expanding each ticket individually in a loop afterwards. This action is a convenient way to load records without using behavior list variables, when the results don't need to be used as an 'On:' target in another action. The results can still be set on a behavior variable by passing the IDs to a 'set variable' query.

* **[Knowledgebase/Profiles]** Fixed an issue on knowledgebase article profile pages that prevented the edit button from functioning properly.

* **[Records/Validation]** Fixed an issue on records with validating 'timezone' or 'language' fields. They weren't allowed to be blank even when they weren't required by the record.

* **[Records/Validation]** Fixed an issue with record when validating 'language' fields. Only enabled language packs were being permitted.

* **[Custom Records/Import]** Implemented 'import' functionality for custom record worklists.

* **[Workspaces/Pages]** Fixed an issue when creating or editing workspace pages. The owner menu caused the popup to scroll rather than displaying on top of it.

* **[Bots/Email]** On bots, fixed an issue with the 'Send email' and 'Send email to recipients' actions when using HTML mode. There were two conflicting editors (Ace and markItUp) that prevented the message contents from being editable. markItUp has been removed, and a simpler toolbar for toggling HTML mode, inserting inline images, and previewing the content has been implemented. HTML templates are also selected with a chooser rather than a dropdown list.

* **[Cards/HTML Templates]** On HTML template cards, the content and signature are now previewed without having to edit the record. This saves a step when confirming that the right HTML template is being used when sending mail, and it's also usable by workers who can use the template but not edit it.

* **[Custom Records/Roles]** When creating a new custom record, role permissions can now be set at the same time. This makes it much simpler to add custom records in an environment with many roles. [[#524](https://github.com/jstanden/cerb/issues/524)]

* **[Worklists/Search]** Added a `signature.id:` quick search filter to group and bucket worklists.

* **[Worklists/Search]** Added a `template.id:` quick search filter to group and bucket worklists.

* **[Cards/Email/Signatures]** Email signature cards now have search count buttons for the groups and buckets using the signature. [[#525](https://github.com/jstanden/cerb/issues/525)]

* **[Cards/Email/Templates]** Email template cards now have search count buttons for the groups and buckets using the HTML template. [[#525](https://github.com/jstanden/cerb/issues/525)]

* **[Cards/Email/Transports]** Email transport cards now have search count buttons for the email addresses using the transport. [[#525](https://github.com/jstanden/cerb/issues/525)]

* **[Cards/Email]** Email address cards now have search count buttons for the groups and buckets using the sender address. [[#525](https://github.com/jstanden/cerb/issues/525)]

* **[Worklists/Search]** Added a `send.as:` quick search filter to group and bucket worklists.

* **[Worklists/Search]** Added a `send.from.id:` quick search filter to group and bucket worklists.

* **[Worklists/Search]** In worklist quick searches, added a `:!` field operator for negation. For instance, `subject:!test` on a ticket worklist would find all records without the term `test` in the subject. This also works for sets, like `group.id:![1,2,3]`, and custom fields like `someField:!null`. [[#434](https://github.com/jstanden/cerb/issues/434)] [[#505](https://github.com/jstanden/cerb/issues/505)]

* **[Custom Records/Worklists/Usability]** On custom record worklists, when the `name` column is removed the worklist will switch to two-row display mode (like tickets) with the name on its own row and the field columns afterwards. This provides more columnar space on records with a lot of fields. [[#514](https://github.com/jstanden/cerb/issues/514)]

* **[Cards/Groups]** Fixed an issue on group cards where a bot interaction menu could scroll within the card rather than float above it.

* **[Custom Records/Custom Fields]** Deleting a custom record now properly deletes all of its custom fields. [[#511](https://github.com/jstanden/cerb/issues/511)]

* **[Custom Records]** Custom record types may only be deleted if all child records have been deleted first.

* **[Choosers]** Fixed an issue with worker choosers where the 'me' shortcut button has an invalid CSS class. This complicated jQuery selectors in bot automation.

* **[Bots/Mail]** In bots, when using the 'Send email' action, the 'Send as' option is now available for specifying a personalized sender name using placeholders. [[#507](https://github.com/jstanden/cerb/issues/507)]

