---
layout: post
title: "8.2.3"
excerpt: Cerb 8.2.3 is a maintenance update released in November 2017 with 26 minor features and fixes from community feedback.
author: The Cerb Team
date: 2017-11-20 11:40:00 -0700
permalink: /releases/8.2.3/
redirect_from:
  - /8.2.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 26
---

**Cerb (8.2.3)** is a **{{ page.release.type }}** released on November 20, 2017. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [8.2](/releases/8.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Portals]** Fixed a cookie issue when Cerb is using SSL but a community portal isn't. The new `secure` flag being proxied on cookies was preventing them from being set.

* **[Mail/Relay]** Fixed an issue with relaying mail where the "spoof sender" option refused to send mail from non-local addresses.

* **[Bots/Portals/Interactions]** In bots, on 'Conversation with portal visitor' behaviors, added the following actions: Create ticket, create notification, create task, and create ticket.

* **[Bots/Portals/Interactions]** In bots, on 'Conversation with portal visitor' behaviors, added the 'Send email' action. [[#254](https://github.com/jstanden/cerb/issues/254)]

* **[Bots/Interactions]** In bots, on 'Conversation with worker' behaviors, added the 'Send email' action.

* **[API/Records/Activity Log]** Added an `activity_point` key to activity log record dictionaries.

* **[API/Usability]** In the API, the `show_meta` option now defaults to disabled rather than enabled.

* **[Bots/Interactions]** Fixed an issue with bot interactions that used the 'Switch Behavior' action in a conversational behavior. These didn't always pass public variable inputs to the new behavior.

* **[Bots/Behaviors/Import]** On bots, fixed an issue when importing a behavior fragment at the event-level. A PHP notice could prevent the import popup from closing properly.

* **[Bots/Interactions]** In bots, on 'Conversation with portal visitor' behaviors, added a 'Behavior has parent' placeholder. This is `true` when the behavior was called by another behavior, and `false` otherwise. This is useful when you want a conversation to return to a menu behavior, whether it was called from the menu or invoked directly.

* **[Bots/Behaviors]** Fixed an issue on bot behavior worklists where more than one behavior couldn't be opened at once because they shared the same card popup. Now any number of behaviors may be opened at the same time (for comparison, etc).

* **[Bots/Placeholders]** In bot behaviors, the `|json_encode` filter now works properly on dictionary objects.

* **[Bots/Records]** In bots, when using the 'Record Search' action, a blank result now properly overwrites a previous result that used the same placeholder.

* **[Bots/Records]** In bots, fixed an issue with 'Record Retrieve'. A blank record will now properly overwrite a previously loaded record that used the same placeholder.

* **[Bots/Records]** In bots, fixed an issue with 'Record Create'. If there was an error creating the record, the result will now properly overwrite a previous result that used the same placeholder name.

* **[Bots/Records]** In bots, fixed an issue with 'Record Update'. If there was an error updating the record, the result will now properly overwrite a previous result that used the same placeholder name.

* **[Bots/Portals]** Fixed an issue with portal bots in Safari. With a cold cache, the initial page load could display the bot badge in the lower right with a squared (rather than rounded) inner border. This is due to a bug with `background-repeat: no-repeat;` CSS in WebKit.

* **[Bots/Portals]** In bots on portals, the jQuery dependency is now loaded from the `code.jquery.com` CDN rather than `googleapis.com`.

* **[Bots/Portals]** In bots on portals, the `#bot/interaction` shortcuts in URLs now work on pages that have already been loaded. Previously these links only worked on the first page load from an external link.

* **[Mobile/Keyboard]** Fixed an issue with keyboard shortcuts in some browsers (particularly the iPhone simulator w/ a hardware keyboard).

* **[Mobile/Usability]** Prevented Safari on iPhone from automatically resizing fonts in the Cerb UI.

* **[Bots/Interactions]** Fixed an 'Unhandled promise rejection' browser error when opening the bot chat window.

* **[Bots/Interactions/Mobile]** Fixed an issue with the bot interactions menu when using a mobile device. The expanding menus could overflow the screen width.

* **[Search/UX]** The global search menu is now responsive based on the device/browser width. The number of columns is determined by the available space.

* **[Bots/Mobile/Usability]** When using bot interactions from a mobile device (like an iPhone), text input should no longer change the zoom of the page.

* **[Bots/Interactions/Usability]** When using bot interactions, the chat window is now responsive based on the dimensions of the device/browser. Previously the popup chat window was a fixed size which complicated its use outside of desktop browsers.

