---
layout: post
title: "8.2.4"
excerpt: Cerb 8.2.4 is a maintenance update released on November 27 2017 with 37 minor features and fixes from community feedback.
author: The Cerb Team
date: 2017-11-27 09:30:00 -0700
permalink: /releases/8.2.4/
redirect_from:
  - /8.2.4/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 37
---

**Cerb (8.2.4)** is a **{{ page.release.type }}** released on November 27, 2017. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [8.2](/releases/8.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[API/Packages]** Packages can now be imported from the API using the [/packages](/docs/api/endpoints/packages/) module.

* **[Installer/API]** The 'Web API' plugin is now enabled by default in the installer.

* **[Mail/Transports]** Fixed an issue in mail transports where the "Maximum Deliveries Per SMTP Connection" setting appeared to reset to the default (`20`) when re-edited. [[#540](https://github.com/jstanden/cerb/issues/540)]

* **[Installer]** The installer no longer creates 'Support' and 'Sales' groups by default. This can be done with packages now.

* **[Setup/Packages]** The 'Import packages' page in Setup now provides a link to the packages library.

* **[Installer]** The installer no longer creates a default ticket. This can now be done through packages.

* **[Installer]** The installer no longer requires the `/update` page to run immediately afterwards.

* **[Bots/Interactions]** Fixed a bug with bot interactions when the global interaction button wasn't present in the lower right.

* **[Records/Tickets]** In the records API, on tickets, the `org` field can be given instead of `org_id`. This is a string that will try and find an exact match on an existing org (or create a new record), and set `org_id` to that.

* **[Records/Tickets]** In the records API, on tickets, the `bucket_id` field is no longer required. If a bucket_id is not given on a new ticket, the default bucket of the `group_id` will be automatically used. This simplifies packages.

* **[Cards/Buckets]** When opening a card for an invalid bucket (e.g. previously deleted), a proper error message is now displayed.

* **[Cards/Groups]** When opening a card for an invalid group (e.g. previously deleted), a proper error message is now displayed.

* **[Records/Groups]** In the records API, groups can now provide a `members` key on inserts/updates. This is an array with keys `manager`, `member`, or `remove` that contain a comma-separated list of worker IDs. These changes to the group roster are incremental (e.g. they don't modify existing members who aren't referenced).

* **[Records/Groups]** In the records API, on groups, the `reply_address_id` field is no longer required during creation. If not provided, the default sender address will be used. This simplifies packages and group creation.

* **[Packages]** In packages, default values for worker preferences can now be provided. This is particularly helpful in packages that create the initial environment.

* **[Packages]** In packages, default values for plugin settings can now be provided. This is particularly helpful in packages that create the initial environment (installer, tutorial).

* **[Custom Records]** When deleting custom records, their card preferences are now properly removed as well.

* **[Scheduler/Import]** Removed the background importer job (cron.import) from the scheduler. This was used to import legacy content from Cerb 2.x/3.x, which is pretty rare these days. Those older installations can still upgrade first to an older version with the importer (e.g. 8.2), import, and then upgrade to current. This cleans up a lot of code that wasn't well-maintained.

* **[Packages/Developers]** When packages are imported, the `$records_created` response is now indexed by the unique ID (`uid`) of each object in the package. This makes it easy to procedurally import a package and then retrieve the new IDs of specific objects. This is also returned when importing packages from the API.

* **[Pages/Wizard]** The page creation wizard now uses packages to create new content in the UI. Previously, the scripts to create new workspaces were much more complicated.

* **[Records/Roles]** In the records API, on roles, the `params` field can be set using an array of keys/values.

* **[Installer/Usability]** In the installer, removed the extra step for configuring the default sender address. This has been combined with the outgoing mail setup page.

* **[Installer/Packages]** The installer now uses package to configure the initial environment. The user is given an option between a 'Production' and 'Tutorial' environment. The tutorial environment creates a bunch of sample data to demonstrate Cerb's functionality. Optional packages can also be imported during installation: Auto-Reply Bot, Chat Bot, Customer Satisfaction Surveys, and Reminder Bot.

* **[Installer/Usability]** The installer registration step now directly opens the bot interaction on cerb.ai for generating a free 3-seat license.

* **[Installer/Usability]** The installer no longer creates an empty 'Delivery denylist' bot behavior. This was historically created in 5.5 when filtering behaviors moved into bots. The original patch didn't check if any filters existed before creating the default bot.

* **[Installer]** Fixed a bug in the installer that always created default 'Next Step' and 'Lead Source' custom fields on opportunity records.

* **[Installer]** The installer now creates default calendars for Office Hours and Office Holidays.

* **[Project Boards]** On project boards with custom templates, the `.cerb-search-trigger` class is now enhanced with `cerbSearchTrigger()` when the `data-context` and `data-query` attributes are provided.

* **[Installer/Usability]** In the installer, when using either Production or Tutorial environments, a 'Getting Started' project board is created with an interactive quick start checklist.

* **[Cards/Workers]** When editing workers from a card, group membership has been simplified with a simple matrix. Clicking on a column heading for Member, Manager, or Neither, will quickly select that option for every group. Previously, this was handled with dropdowns, which provided poor UX.

* **[Cards/Groups]** When editing groups from a card, group membership has been simplified with a simple matrix. Clicking on a column heading for Member, Manager, or Neither, will quickly select that option for every group. Previously, this was handled with dropdowns, which provided poor UX.

* **[Records]** Fixed an issue that prevented some lists of record types from being properly alphabetized.

* **[Cards/Tickets]** Fixed an issue on ticket cards that always displayed the message preview with a fixed width. This now properly resizes with the card's popup.

* **[Cards/Tickets/UX]** Fixed an issue on ticket cards that caused long subject lines to wrap below the profile picture.

* **[Cards/Tickets/UX]** Fixed an issue on address cards that caused long email addresses to wrap below the profile picture.

* **[Mail/Reply]** When replying to a ticket, the `From:` field now shows the group/bucket's reply from, reply as, and mail transport. Previously this just displayed a group name with no indication of what the recipient would see.

* **[Mail/Reply/Usability]** When replying to a ticket, if the ticket's bucket or group is configured to use a "null" mail transport (i.e. discard outgoing messages) then a warning is displayed to the user so they're aware this is happening. This is particularly useful during the transition from a tutorial to production.

