---
layout: post
title: "8.2.5"
excerpt: Cerb 8.2.5 is a maintenance update released in December 2017 with 17 minor features and fixes from community feedback.
author: The Cerb Team
date: 2017-12-04 18:30:00 -0700
permalink: /releases/8.2.5/
redirect_from:
  - /8.2.5/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 17
---

**Cerb (8.2.5)** is a **{{ page.release.type }}** released on December 4, 2017. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [8.2](/releases/8.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[API/Workers]** When deleting a worker, their API credentials are now properly cleaned up.

* **[Records/API]** In the records API, on worker records, the `password` field can now be set during creation, updates, and upserts.

* **[Tickets/Merge]** When merging tickets, the deleted post-merge tickets now have `-MERGED` appended to their masks. This forces the ticket mask forwarding behavior to begin immediately. Previously, forwarding only worked when `cron.maint` removed the deleted tickets from the database.

* **[Pages/Wizard]** Fixed an issue with the page wizard creating new 'Mail' pages with an invalid required filter on the worklist.

* **[Installer/Packages]** Fixed an issue with the installer packages where the first admin account wasn't added to the Support group if they weren't ID #1 (due to automation scripts, etc).

* **[Worklists/Email]** Email address worklists can be subtotaled by mail transport. [[#546](https://github.com/jstanden/cerb/issues/546)]

* **[API]** Fixed an issue in the API where `PUT` and `PATCH` requests couldn't specify parameters in the HTTP body, and could only use query string arguments. [[#544](https://github.com/jstanden/cerb/issues/544)]

* **[Bots/Behaviors/HTTP]** In bots, when using the 'Execute HTTP Request' action, the response `headers` are now available in the response object. [[#513](https://github.com/jstanden/cerb/issues/513)]

* **[Bots/Simulator/HTTP]** In bots, when using the 'Execute HTTP Request' action, the response HTTP headers are now displayed in the simulator. [[#547](https://github.com/jstanden/cerb/issues/547)]

* **[Bots/Behaviors]** In bots, fixed an issue where disabled behaviors still executed with the 'Run behavior' action. [[#545](https://github.com/jstanden/cerb/issues/545)]

* **[Bots/Behaviors/Interactions]** In bot interactions, fixed an issue where disabled behaviors still executed with the 'Switch behavior' action. [[#545](https://github.com/jstanden/cerb/issues/545)]

* **[Mail/Attachments]** When dragging and dropping attachments in compose or reply, the created attachment record is now properly clickable to open its card preview. [[#538](https://github.com/jstanden/cerb/issues/538)]

* **[Worklists/Buckets/Subtotals]** Bucket worklists can be subtotaled by group. [[#548](https://github.com/jstanden/cerb/issues/548)]

* **[Worklists/Buckets/Search]** Bucket worklists can be filtered by a new `group.id:` quick search filter.

* **[Developers/Platform/Cards]** Card popups can now be opened using a record type alias (e.g. `attachment` vs `cerberusweb.contexts.attachment`).

* **[API/Security]** Fixed an issue that allowed deactivated workers to use the API if they had active credentials.

* **[API/Records]** Fixed an issue in the Records API where multiple value custom fields couldn't be set (e.g. multiple checkboxes).