---
layout: post
title: "8.2.6"
excerpt: Cerb 8.2.6 is a maintenance update released in December 2017 with 10 minor features and fixes from community feedback.
author: The Cerb Team
date: 2017-12-19 18:30:00 -0700
permalink: /releases/8.2.6/
redirect_from:
  - /8.2.6/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 10
---

**Cerb (8.2.6)** is a **{{ page.release.type }}** released on December 19, 2017. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [8.2](/releases/8.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Mail/HTML]** Fixed an issue with sending HTML mail. When a mail template used HTML in the signature, this was being included in the plaintext part saved by Cerb. This is now down-converted to plaintext using the same method as the plaintext part we send. In the near future, this will be improved by using mail signature records in templates and allowing signatures to have plaintext and HTML variations.

* **[Bots/Behaviors]** In bots, fixed an issue with the 'Execute HTTP Request' action. If an HTTP response had duplicate headers, these were not being handled properly. They should be appended together and delimited with a comma. [[#555](https://github.com/jstanden/cerb/issues/555)] Thanks [@mrlilly](https://github.com/mrlilly)!

* **[Bots/Behaviors]** In bots, fixed an issue with the 'Execute HTTP Request' action. If a response contained invalid characters for the given charset (e.g. utf-8) then the body wasn't returned. We now attempt to correct encoding with `mb_convert_encoding()`.

* **[Bots/Interactions]** In bot interactions with workers, any messages with `cerb-search-trigger` or `cerb-bot-trigger` CSS classes are now automatically feature enhanced into a search popup or a bot interaction, respectively. This already occurred with `cerb-peek-trigger` and card popups.

* **[Bots/Packages]** Admin-owned bots can use a new 'Import Package' action to quickly create sets of new records (including fully populated workspaces, dashboards, project boards, and bots).

* **[Bots/Scripting]** In bot scripting, added a new `placeholders_list()` function that returns all the placeholders in the current behavior as keys and values.

* **[Bots/Portals]** On bot website interactions, added a 'Close chat window' action. [[#549](https://github.com/jstanden/cerb/issues/549)]

* **[Bots/Actions]** In all bot behaviors, added an 'Execute email parser' action. This can process raw email messages into inbound tickets. It can also handle inbound replies if the `In-Reply-To:` or `References:` headers are set to an existing `Message-Id:`. This makes it much simpler for bots to create basic tickets.

* **[Scheduler/Maint/Attachments]** Fixed an issue where the maintenance scheduler job didn't properly clean up message attachments. [[#459](https://github.com/jstanden/cerb/issues/459)]

* **[Scheduler/Maint/Attachments]** Fixed an issue where the maintenance scheduler job didn't properly clean up draft attachments. [[#458](https://github.com/jstanden/cerb/issues/458)]

