---
layout: post
title: "8.3.1"
excerpt: Cerb 8.3.1 is a maintenance update released in March 2018 with 10 minor features and fixes from community feedback.
author: The Cerb Team
date: 2018-03-10 00:00:00 -0700
permalink: /releases/8.3.1/
redirect_from:
  - /8.3.1/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 10
---

**Cerb (8.3.1)** is a **{{ page.release.type }}** released on March 12, 2018. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [8.3](/releases/8.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Bots/Interactions]** In bot interaction behaviors, prompt actions can now automatically save the user's next response to a placeholder. Previously, this required a 'Set custom placeholder' action after every prompt. This makes it simpler to build conversational behaviors. [[#586](https://github.com/jstanden/cerb/issues/586)]

* **[Bots/Interactions]** In bot interaction behaviors, prompt actions can now specify a format template when setting a placeholder. For instance, a date can be formatted as a timestamp, a yes/no question can be formatted as a 0/1 boolean, a number can be formatted to the proper precision, etc. Previously this required a separate 'Set custom placeholder' action.

* **[Bots/Interactions]** In bot interaction behaviors, prompt actions can now specify a validation template. For instance, a number can be confirmed to be numeric and within certain bounds (e.g. 1-100). Any output in the validation template is considered to be an error and this will be used as the bot's response to the input. A blank validation response indicates success. Previously, this level of validation required a good amount of work: loops (retry until successful input is given), decisions (is this valid input?), outcomes (yes/no), and additional actions (error messages). This is all handled in a simple and elegant manner from a single prompt action now. This makes the process of creating conversational behaviors significantly simpler. [[#622](https://github.com/jstanden/cerb/issues/622)]

* **[Packages/Behaviors]** In packages, it's now possible to import behaviors for existing bots. Previously, it was only possible to create behaviors on a new bot included in the package. This is used for a migration script that converts Cerb 7.x macros to 8.x-style bot interactions.

* **[Bots/Actions]** In bots, the 'Run behavior' action can now run behaviors against 'Mixed Record' list variables. This allows the same behavior to be reused by multiple interactions against different record types.

* **[Security/Feedback]** Fixed a potential XSS issue in feedback entry records.

* **[Feedback/UX]** When editing feedback entry records, the email address chooser now allows autocomplete input.

* **[Bots/Scripting]** In bot scripting, fixed an issue with the `secs_pretty` filter. It was failing when given integer inputs rather than strings. Now either works.

* **[Developers/Bots]** Added a `DevblocksDictionaryDelegate->set($key, $value)` method for setting dynamic keys in dictionaries. Previously, keys required a separate temporary variable before using the `__set()` magic method.

* **[Bots/Actions]** In bots, when using the 'Run behavior' action, placeholders can now be used when passing in checkbox, picklist, and worker variables. Previously, these could only be set to a specific value, which complicated automation. 

