---
layout: post
title: "8.3.3"
excerpt: Cerb 8.3.3 is a maintenance update released in March 2018 with 10 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/8.3/8.3.3.png
author: The Cerb Team
date: 2018-03-26 00:00:00 -0700
permalink: /releases/8.3.3/
redirect_from:
  - /8.3.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 10
---

<div class="cerb-screenshot">
<img src="/assets/images/releases/8.3/8.3.3.png" class="screenshot">
</div>

**Cerb (8.3.3)** is a **{{ page.release.type }}** released on March 26, 2018. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [8.3](/releases/8.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Packages/Performance]** Optimized the package importer to more efficiently handle larger JSON files (e.g. tens of megabytes). This can occur when entire tickets are packaged with their messages, attachments, and comments.

* **[Mail/HTML]** In the email parser, fixed an issue with links when creating a plaintext part from an HTML message. If the `<a>` tag contained nested nodes, their text and the link was ignored. [[#642](https://github.com/jstanden/cerb/issues/642)]

* **[Plugins/JIRA]** Fixed an issue with the 'Jira issue commented on' bot event also triggering on comment updates rather than only inserts.

* **[API/Records/Search]** In API searches using queries, placeholders like `current_worker_id` now work properly. [[#637](https://github.com/jstanden/cerb/issues/637)]

* **[Records/Messages]** Message records now include a `content_html` placeholder. This provides access to the optional HTML version of the message. [[#640](https://github.com/jstanden/cerb/issues/640)]

* **[Bots/Scripting]** In bot scripting, the `xml_decode()` function now accepts an optional third argument for `mode`. When set to `html`, an HTML document is converted into XML while ignoring the quirks of its markup. This allows HTML (like `content_html`) to be parsed using XPath.

* **[Records/Tickets]** On ticket worklists, added a `responsibility:` filter to quick search. It accepts an integer between `0` and `100`. This also allows `sort:-responsibility` in queries.

* **[Mail/Relay/API]** Fixed an issue with replying to tickets from the API, relay, or mobile UI. When a `group_id` or `bucket_id` wasn't explicitly provided, group-based placeholders weren't available in bot behaviors. The main web interface always provides these values. [[#625](https://github.com/jstanden/cerb/issues/625)]

* **[Notifications/UX]** The unread notifications badge and Worker->Notifications popup now both share a worklist. Customizations like columns, sort order, and subotals are no longer reset every time the notification popup opens. The Worker->Notifications popup no longer resets the filters to unread. [[#629](https://github.com/jstanden/cerb/issues/629)]

* **[Records/Tickets/Merge]** When merging tickets, the preferred value of the 'Updated' field can now be selected. [[#638](https://github.com/jstanden/cerb/issues/638)]

