---
layout: post
title: "8.3.4"
excerpt: Cerb 8.3.4 is a maintenance update released in March 2018 with 11 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/8.3/8.3.4.png
author: The Cerb Team
date: 2018-03-30 00:00:00 -0700
permalink: /releases/8.3.4/
redirect_from:
  - /8.3.4/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 11
---

<div class="cerb-screenshot">
<img src="/assets/images/releases/8.3/8.3.4.png" class="screenshot">
</div>

**Cerb (8.3.4)** is a **{{ page.release.type }}** released on March 30, 2018. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [8.3](/releases/8.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Packages]** In packages, if a prompted chooser key ends with `_id` then all of that record's placeholders will be available in the package. For instance, if a chooser sets `worker_id`, then placeholders like `worker__label` and `worker_first_name` are available.

* **[Security]** Added the `noopener` flag to outbound links from Cerb to combat tabnabbing.

* **[Packages/Messages]** When importing message records in packages, the `content` field can now be blank. [[#647](https://github.com/jstanden/cerb/issues/647)]

* **[Packages/Tickets]** When importing ticket records in packages, the `participants` field can be empty.

* **[Bots/Conditions]** In bots, added a new outcome condition for `Calendar day of month`. Previously this had to be handled with a custom script condition. [[#646](https://github.com/jstanden/cerb/issues/646)]

* **[Bots/Prompts]** In conversational bots, when using chooser prompts, if the saved placeholder ends with `_id` then all of the placeholders of that record will be available. For instance, a placeholder like `prompt_worker_id` can then refer to `prompt_worker__label` and `prompt_worker_first_name`.

* **[Records/Tickets/Search]** When searching ticket records, the `comments:` filter is now capable of deep searching. For instance `comments:(id:>0)` to only search tickets with comments. [[#650](https://github.com/jstanden/cerb/issues/650)]

* **[Records/Messages/Search]** When searching message records, the `notes:` filter is now capable of deep searching.

* **[Bots/Prompts/Files]** In conversational bots, when using file upload prompts, placeholders for the uploaded file are available if the key ends with `_id`. For instance, for a placeholder like `prompt_file_id` you can access `prompt_file__label`, `prompt_file_mime_type`, and `prompt_file_size`. This simplifies validation.

* **[Bots/Prompts/Files]** In conversational bots, when using file upload prompts, the 'save to placeholder, formatting, and validation options are now available.

* **[Bots/Prompts]** In conversational bots that use prompts, failing validation now clears any placeholders that were previously set by that prompt.

