---
layout: post
title: "8.3.6"
excerpt: Cerb 8.3.6 is a maintenance update released in April 2018 with 17 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/8.3/8.3.6.png
author: The Cerb Team
date: 2018-04-16 00:00:00 -0700
permalink: /releases/8.3.6/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 17
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (8.3.6)** is a **{{ page.release.type }}** released on April 16, 2018. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [8.3](/releases/8.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Bots/Actions/PHP]** Fixed a PHP 7.2 'countable' warning in bots when adding actions to a behavior.

* **[Mail/Compose]** Fixed an issue with recipient suggestions when composing mail. Previously, if the given organization name contained an ampersand (`&`) then no suggestions were returned. [[#666](https://github.com/jstanden/cerb/issues/666)]

* **[Records/Saved Searches/Custom Fields]** Added custom fields and fieldsets to saved search records. [[#636](https://github.com/jstanden/cerb/issues/636)]

* **[Installer/Search/UX]** The installer now runs the search indexer for any initial records. This fixes a usability issue in testing/evaluation where records couldn't be found in a search until the scheduler ran for the first time. [[#654](https://github.com/jstanden/cerb/issues/654)]

* **[Records/Merge]** Fixed an issue when merging records where invalid values in a picklist or multi-checkbox aborted the merge. Values that don't match the possible options on the field are now ignored during a merge. [[#627](https://github.com/jstanden/cerb/issues/627)]

* **[Records/Contacts/Choosers]** In contact choosers, starting the autocomplete with `@` allows matching by email host. [[#618](https://github.com/jstanden/cerb/issues/618)]

* **[Records/Addresses/Bulk]** When bulk updating email address records, the 'Mail Transport' field can now be set. [[#614](https://github.com/jstanden/cerb/issues/614)]

* **[Records/Groups/Bulk]** When bulk updating group records, the 'Send as' field can now be set. [[#587](https://github.com/jstanden/cerb/issues/587)]

* **[Records/Groups/Bulk]** When bulk updating group records, the 'Send from' field can now be set.

* **[Records/Groups/Bulk]** When bulk updating group records, the 'Signature' field can now be set.

* **[Records/Groups/Bulk]** When bulk updating group records, the 'Email Template' field can now be set.

* **[Records/Groups/Bulk]** When bulk updating group records, the 'Is Private' field can now be set.

* **[API/Records]** When expanding the `attachments` key on message records from the API, the SHA-1 hash of the attachments is now provided as well. [[#478](https://github.com/jstanden/cerb/issues/478)]

* **[Records/Attachments/Bulk]** Attachments can once again be bulk updated and deleted by admins. [[#175](https://github.com/jstanden/cerb/issues/175)] [[#417](https://github.com/jstanden/cerb/issues/417)]

* **[Mail/Relay]** Updated links to the documentation for email relay functionality. [[#349](https://github.com/jstanden/cerb/issues/349)]

* **[Bots/Portals/UX/Mobile]** On conversational bots deployed to websites and viewed with a mobile device, the chat window now scrolls down completely when the on-screen keyboard is shown or hidden.

* **[Bots/Portals/UX]** On conversational bots deployed to websites, text prompts now include a 'Send' button. Some mobile end-users were confused about the need to press 'Go' in the on-screen keyboard. Some desktop users were confused about needing to press the `<ENTER>` key.

