---
layout: post
title: "8.3.9"
excerpt: Cerb 8.3.9 is a maintenance update released in June 2018 with 9 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/8.3/8.3.9.png
author: The Cerb Team
date: 2018-06-27 00:00:00 -0700
permalink: /releases/8.3.9/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 9
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (8.3.9)** is a **{{ page.release.type }}** released on June 27, 2018. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [8.3](/releases/8.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Performance/Log]** In activity worklists, the `entry:` filter has been removed. This could cause full-table scans with a major negative performance impact on larger sites. Such searches can be performed more efficiently using the meta info. E.g. rather than searching for a wildcard like _"you"_, which isn't even stored in the data, use `actor.worker:(id:123)`

* **[Bots/Custom Fields]** Fixed an issue with conditions in bot behaviors. Conditions from record-link custom fields weren't showing their options.

* **[Attachments/Cards]** Fixed an issue with attachment cards where some file previews (like HTML) were being blocked by the browser's X-Frame-Options rules.

* **[Setup/Mail]** Fixed an issue in Setup. Leaving the 'Incoming Mail' page after selecting the 'Import' tab was returning to a blank page. This now properly returns to the 'Incoming Mail' page. [[#684](https://github.com/jstanden/cerb/issues/684)]

* **[Worklists/Tasks]** On task worklists, records can now be subtotaled by 'Owner'. [[#678](https://github.com/jstanden/cerb/issues/678)]

* **[Worklists/Tasks]** On task worklists, records can now be subtotaled by 'Importance'.

* **[API/Search]** In the REST API, when performing a `/rest/records/<record>/search.json`, the page `limit` is returned in the response as well. This simplifies paging functionality. [[#682](https://github.com/jstanden/cerb/issues/682)]

* **[Records/Custom Records]** Fixed an issue when creating/editing custom records. The label for the record 'Alias' field was misleading by stating dashes could be used, when only letters, numbers, and underscores can be. [[#686](https://github.com/jstanden/cerb/issues/686)]

* **[Bots]** Fixed an issue in ticket-related bot behaviors where the 'Ticket first resolution/response' conditions weren't matching properly. [[#691](https://github.com/jstanden/cerb/issues/691)]

