---
layout: post
title: "9.0.3"
excerpt: Cerb 9.0.3 is a maintenance update released in August 2018 with 15 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.0/9.0.3.png
author: The Cerb Team
date: 2018-08-27 00:00:00 -0700
permalink: /releases/9.0.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 15
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.0.3)** is a **{{ page.release.type }}** released on August 27, 2018. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.0](/releases/9.0/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Platform/Logo]** Fixed an issue with the default logo not showing up in Windows environments.

* **[Setup/Branding]** In **Setup >> Configure >> Branding**, the company logo can now be uploaded rather than requiring an external URL. When referring to the logo in a custom stylesheet, it's `url(logo)`. Without a custom stylesheet, Cerb will automatically take care of expiring browser caches when the logo changes.

* **[Workspaces/Dashboards]** On workspace dashboards, widgets have an 'Export widget' option in their menu. This exports the widget's configuration to package format, which can also be imported in the 'Add widget' popup to share widgets.

* **[Workspaces/Dashboards]** On workspace dashboards, widget data can be exported from the 'Export widget data' option in each widget's menu. By default, this returns the widget data in JSON (e.g. apps) and CSV (e.g. Excel) formats.

* **[UI/Popups/UX]** Popups now include a show/hide button in the top right (next to the close button). Hiding a popup will make its content temporarily disappear so that only the titlebar is visible. This allows you to read content that was obscured by the popup without having to close or resize it (e.g. reading a prior message on a ticket profile while replying; using a global bot interaction on a mobile device when it's covered by the reply popup). Unhiding the popup will make the content visible again.

* **[Mail/Reply]** On ticket profiles, if the 'Reply' button is clicked when the popup is already open, the popup is now focused rather than replaced.

* **[Dashboards/Project Boards]** On dashboards, fixed an issue with project board widgets where the buttons and links weren't working if you had multiple boards on one tab, or multiple tabs of boards on the same workspace page.

* **[Project Boards]** When adding a new card directly to a project board column, any behaviors configured on that column will now run. Previously, column behaviors only ran when the card was dragged into the column from a different one. This also fixes the issue where project column behaviors didn't run if a link was created between a record and the column from bots, the API, card popups, etc.

* **[Workspaces/Dashboards/Performance]** Workspace widgets that use data queries (e.g. pie, table, time series) can be configured to cache their results for a given number of seconds. This improves performance on large teams with highly shared dashboards.

* **[Profiles/Behavior Tree]** Fixed an issue on 'Behavior Tree' profile widgets. Editing the widget didn't show the existing value of the 'Behavior ID' option.

* **[Profiles/Dashboards/Usability]** On profile dashboards, widgets can now be imported and exported. To export a widget, expand its menu and select "Export Widget". This outputs the widget in the JSON package format. Widgets can be imported by clicking the 'Add' button, selecting the 'Import' tab, and pasting the package.

* **[Mail/Preferences/UX]** In worker settings, added back the "Always read all" option for ticket message conversations. This is inefficient, but apparently still widely used. [[#718](https://github.com/jstanden/cerb/issues/718)]

* **[Mail/UX]** Fixed an issue on ticket profiles where links in HTML messages weren't opening in a new tab, and instead replaced the current page. [[#721](https://github.com/jstanden/cerb/issues/721)]

* **[Developers/Profiles/Tickets]** On ticket profiles, added Ajax endpoints for changing ticket statuses and reporting spam. This allows the reintroduction of "one keystroke" shortcuts for the 'close' and 'delete' buttons, etc. [[#724](https://github.com/jstanden/cerb/issues/724)]

* **[Data Queries/Subtotals]** In data queries using the `worklist.subtotals` type, date-based fields can be now grouped by `@week`. This defaults to Monday as the first day of the week. An `@week-sunday` grouping is available for weeks starting on Sunday. In chart visualizations, the returned date format is `%Y-%m-%d`. Previously, grouping was only available by year, month, and day. [[#707](https://github.com/jstanden/cerb/issues/707)]

