---
layout: post
title: "9.0.5"
excerpt: Cerb 9.0.5 is a maintenance update released in September 2018 with 11 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.0/9.0.5.png
author: The Cerb Team
date: 2018-09-25 00:00:00 -0700
permalink: /releases/9.0.5/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 11
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.0.5)** is a **{{ page.release.type }}** released on September 25, 2018. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.0](/releases/9.0/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Platform/Scaling/Plugins]** Bundled plugins can be located in a new top-level `./plugins/` directory. In Cloud environments, this makes it easier to distribute version-linked plugins to application servers when multiple versions of Cerb are in use. User-managed plugins from the Plugin Library are still located in `./storage/plugins/`.

* **[Dashboards/Calendars]** Fixed an issue with calendar widgets on dashboards. The first load of a calendar widget didn't occlude available time with busy events (e.g. Labor Day). Subsequent reloads and next/prev did. This now works properly. [[#751](https://github.com/jstanden/cerb/issues/751)]

* **[Profiles/Print/UX]** Added a basic print "stylesheet" to format profile pages for printing through standard browser functionality. You can use the optional "Legacy Printing" plugin to re-enable the old functionality. [[#755](https://github.com/jstanden/cerb/issues/755)]

* **[Dashboards/Bots]** On workspace dashboards, 'Bot Custom Widgets' now have access to all widget placeholders. Previously they could only see `widget_id`.

* **[Support Center/History]** In the Support Center portal, the 'History' ticket worklist now has simple filters for 'Created', 'Status', and 'Search'. These automatically build a search query without the end-user needing to understand the syntax. In 9.0.0, the legacy filters were removed from these worklists and they could no longer be searched. [[#737](https://github.com/jstanden/cerb/issues/737)] [[#763](https://github.com/jstanden/cerb/issues/763)]

* **[Support Center/History]** In the Support Center, the status labels are now consistent with the worker interface. Previously, the 'open' and 'waiting' labels were intentionally swapped, as 'waiting' depended on the perspective. Now the 'waiting' status displays as 'waiting for client' in the Support Center. [[#764](https://github.com/jstanden/cerb/issues/764)]

* **[Records/Cards/Tickets]** On ticket cards, any 'Cc:' recipients are now shown in message previews. [#773](https://github.com/jstanden/cerb/issues/773)]

* **[Portals]** Fixed an issue in the deployed `index.php` proxy script for community portals. This affected the new ticket history filtering feature. When a POST field contained an array nested more than one level deep, it was proxied incorrectly (e.g. `prompts[status][0]`).

* **[UI/UX]** In the worker menu in the top-right, added a shortcut to 'Settings'. Previously, workers had to click on "my profile" and then click the "Settings" tab.

* **[Records/Editors]** Fixed an issue when creating and editing contact and worker records. The "Date of Birth" field was not saving properly.

* **[Workspaces/Pages]** When editing a workspace tab and changing its name, the tab's label now immediately reflects the change. Previous, the workspace had to reload first.

