---
layout: post
title: "9.0.8"
excerpt: Cerb 9.0.8 is a maintenance update released in November 2018 with 11 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.0/9.0.8.png
author: The Cerb Team
date: 2018-11-23 00:00:00 -0700
permalink: /releases/9.0.8/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 11
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.0.8)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.0](/releases/9.0/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Bots/Records/UX]** In bots, the 'Record' actions all provide reference links to the documentation for proper syntax.

* **[Packages/Choosers]** Fixed an issue when importing packages that use multiple selection chooser prompts. Only the first selection was being used.

* **[Search/Queries]** On ticket worklists, the `inGroupsOf:` filter also accepts a worker ID as the expression.

* **[Search/Queries]** In search queries using `[]` array syntax, quoted elements are literal and can include the comma delimiter in their text. This is useful for matching picklist values that contain commas. [[#812](https://github.com/jstanden/cerb/issues/812)]

* **[Bots/Scripting]** Added a `|base_convert(from,to)` filter to bot scripting. For instance, this can convert between decimal, hex, and binary representations.

* **[Records/Links/Fieldsets]** When a custom fieldset is being linked to a record, it will now be converted to the proper request. Links are no longer used to associate fieldsets with records; but legacy bot behaviors and API integrations still rely on this.

* **[Bots/Actions/Custom Fields]** Fixed an issue in bot actions where setting custom fields from a fieldset didn't also link the fieldset to the target record.

* **[Records/Search/Tickets]** On ticket records, added a `watchers.count:` filter for matching records with a specific number of watchers. The expression can be a number (equals), a negation (!0), a math operator (`>1`), a set `[1,2,3]`, or between (`5...10`). [[#821](https://github.com/jstanden/cerb/issues/821)]

* **[Bots/Actions/HTTP]** In bot behaviors, the 'Execute HTTP Request' action can now use bot scripting and placeholders to determine the connected account to use for authentication. This makes it possible to reuse code when different backends or accounts are involved depending on the current record.

* **[Plugins/JIRA]** In the JIRA plugin, JIRA Projects no longer use the 'Sync:' field. Instead, a new 'Connected Account:' field determines which account each project synchronizes issues from. This makes it possible to synchronize issues from multiple JIRA instances and make API calls back to the proper backend for each issue. A JIRA Project record must first be created in Cerb before it synchronizes, and the 'Key:' field must match a JIRA project key.

* **[Plugins/JIRA/Cards]** In the JIRA plugin, JIRA Projects can now be created and edited from Cerb. JIRA project records have cards and popup editors.

