---
layout: post
title: "9.0.9"
excerpt: Cerb 9.0.9 is a maintenance update released in December 2018 with 11 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.0/9.0.9.png
author: The Cerb Team
date: 2018-12-14 00:00:00 -0700
permalink: /releases/9.0.9/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 11
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.0.9)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.0](/releases/9.0/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Plugins/Twitter]** In the Twitter plugin, imported tweets can now contain emoji characters (and other 4-byte UTF-8).

* **[Cards/Search]** Fixed an issue on cards where search buttons could change the filters on search worklists.

* **[Bots/Actions]** Fixed an issue in bot actions when setting a multi-checkbox custom field. In delta mode, the new values are now properly added to the existing values in the placeholder rather than replacing them.

* **[Portals]** Fixed an issue with the built-in `/portal` hosting when Cerb itself is already behind a proxy. This is more common in Cerb Cloud when an instance uses a personalized domain rather than the `*.cerb.me` domains. In these double-proxy situations, portal links and forms weren't working properly, and most redirected to the Cerb login form. [[#822](https://github.com/jstanden/cerb/issues/822)]

* **[Bots/Filtering]** On mail filtering bot behaviors, a new set of 'Routing Group' placeholders are available. These represent the group that the message would be routed to (based on routing rules) if accepted. This allows filtering behaviors to make decisions based on the route. [[#829](https://github.com/jstanden/cerb/issues/829)]

* **[Profiles/Widgets]** Fixed an issue on profiles where certain misconfigured widgets couldn't be deleted. For instance, adding a message-based 'Record Fields' widget. [[#830](https://github.com/jstanden/cerb/issues/830)]

* **[Profiles/Messages]** On profiles, it's now possible to add message-based 'Record Fields' widgets.

* **[UX/Menus/Firefox]** Fixed a usability issue with menus in Firefox. Particularly with the 'Links' menu on profiles, mouse hover events could change the position of menu items. If this left the cursor outside of the menu it would close. [[#831](https://github.com/jstanden/cerb/issues/831)]

* **[Records/Workers]** Fixed an issue when deleting worker records where their associated email addresses weren't unassigned.

* **[Bots/Behaviors]** Fixed an ancient issue in bot behaviors that used worker-based conditions. When removing a worker from the chooser, it was possible to enter a state where no changes to the condition could be saved until it was deleted and re-added. [[#834](https://github.com/jstanden/cerb/issues/834)]

* **[Bots/Actions]** Fixed an obscure issue with bot behaviors that set multi-checkbox custom fields. After setting the multi-checkboxes within an action, it was possible for subsequent actions in the same action node to be skipped (particularly 'set owner' on 'new message' behaviors).