---
layout: post
title: "9.1.1"
excerpt: Cerb 9.1.1 is a maintenance update released in January 2019 with 9 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.1/9.1.1.png
author: The Cerb Team
date: 2019-01-09 00:00:00 -0700
permalink: /releases/9.1.1/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 9
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.1.1)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.1](/releases/9.1/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[API]** Fixed an issue with key expansion in the API. [[#841](https://github.com/jstanden/cerb/issues/841)]

* **[Installer]** Added a test to the installer to make sure the MySQL version supports SPATIAL indexes. This catches cases where forks like MariaDB have different versioning. [[#843](https://github.com/jstanden/cerb/issues/843)]

* **[Updater]** Added a test to the updater to make sure the current MySQL version supports SPATIAL indexes. This catches cases where forks like MariaDB have different versioning. [[#843](https://github.com/jstanden/cerb/issues/843)]

* **[Bots/Scripting]** Fixed an issue in bot behavior scripts where temporary variables could overwrite placeholders of the same name. [[#842](https://github.com/jstanden/cerb/issues/842)]

* **[Mail/Reply/Drafts]** Fixed an uncommon issue when replying to tickets. If a draft auto-saved at the same moment a message was being sent, a new draft could be created after the message was sent.

* **[Mail/Routing/UX]** When configuring mail routing rules in Setup->Mail->Incoming, the textbox for the 'To/Cc:' criteria is now multiple lines in height. Previously this was a single line, which was difficult to use with more than a few destinations. [[#851](https://github.com/jstanden/cerb/issues/851)]

* **[Mail/Reply/Drafts]** Fixed an issue when replying to tickets with the "inline form" rather than the popup. It was possible to double-click the 'Reply' button and start two drafts. After sending the message, the second draft would be removed and the original draft would remain with a copy of the original quoted message.

* **[Workspaces/Dashboards]** On workspace dashboards, a new 'thirds' layout is available with three columns. This emulates how dashboards worked in versions before 9.0. This layout is still responsive; a column will wrap if there's not enough horizontal screen space to display it. On narrow devices, like a smartphone in portrait, the columns will still be shown vertically rather than horizontally. However, the widgets within the column will remain in order (all of the first columns widgets, then the second's, then the third's). [[#852](https://github.com/jstanden/cerb/issues/852)]

* **[API/Usability]** When performing searches in the API, the `total`, `limit`, and `page` keys in the JSON response are now always formatted as numbers. In some cases these alternated between strings and numbers, which caused headaches in statically typed languages like Golang.

