---
layout: post
title: "9.1.2"
excerpt: Cerb 9.1.2 is a maintenance update released in January 2019 with 15 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.1/9.1.2.png
author: The Cerb Team
date: 2019-01-14 00:00:00 -0700
permalink: /releases/9.1.2/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 15
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.1.2)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.1](/releases/9.1/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Dashboards/Data Queries]** Fixed in an issue in subtotal data queries where inactive worker names were displayed as their ID instead. [[#856](https://github.com/jstanden/cerb/issues/856)]

* **[Devblocks/Developers]** Added `->has4ByteChars()` and `->strip4ByteChars()` to the strings service in Devblocks. This helps identify and cleanup Emoji in fields that aren't ready for them yet (e.g. ticket subjects).

* **[Mail/Parser]** Mitigated an issue in the email parser where subjects containing 4-byte emoji characters became '(no subject)'. As a stopgap, these characters are now stripped and the rest of the subject is properly preserved. In the near future, the schema will be updated to support emoji in ticket subjects. [[#855](https://github.com/jstanden/cerb/issues/855)]

* **[Records/Messages]** When using the records API or packages, message records may provide a `worker` field with a full name or at-mention name as an alternative to the `worker_id` field.

* **[Plugins/JIRA]** JIRA issue records can now be managed using the records API and record-based bot actions.

* **[Bots/Usability]** In bot behaviors, the "Custom behavior on..." events are now named "Record custom behavior on..." so they sort into the "Record" submenu where they're easier to find.

* **[Scheduler/Import/Packages]** A new "Packages Importer" scheduled job can automatically handle background imports of a large number of pages. For instance, when importing ticket content from the package exporter tool. This can be enabled in Setup->Configure->Scheduler.

* **[Extras/ImpEx]** Updated the bundled `cerb-package-exporter.php` script to support custom mappings for worker IDs, group/bucket IDs, and custom field IDs. This makes it much easier to move content between environments. The ticket owner field, ticket comments by workers, message workers, and ticket custom fields are now included in the default output.

* **[Login/Security/MFA]** Fixed an issue with logins where some workers had multi-factor authentication required if they previously used the 'Password + Two-Factor' method, even if it wasn't fully configured.

* **[Worklists/Custom Fields]** Fixed an issue on worklists that displayed an invalid custom field as a column. This prevented the worklist from loading.

* **[Worklists/Tickets]** Fixed an issue on ticket worklists where using an address-based custom field as a column could prevent the list from loading.

* **[UI/UX]** Fixed a display issue with Firefox where the search query textbox above worklists was very narrow rather than spanning the entire width of the page/popup. [[#858](https://github.com/jstanden/cerb/issues/858)]

* **[Records/Search/Workers]** On worker worklists, a new `group.manager:` deep search field allows filtering by group managership. [[#849](https://github.com/jstanden/cerb/issues/849)]

* **[Records/Search/Groups]** On group worklists, a new `manager:` deep search field allows filtering by group managership. [[#850](https://github.com/jstanden/cerb/issues/850)]

* **[Records/Drafts]** When creating drafts through the records API, the `params` field may now be provided with key/value pairs. This allows the full details of the draft to be created; e.g. ticket, To/Cc, status, reopen at, attachments, etc. [[#859](https://github.com/jstanden/cerb/issues/859)]

