---
layout: post
title: "9.1.3"
excerpt: Cerb 9.1.3 is a maintenance update released in January 2019 with 11 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.1/9.1.3.png
author: The Cerb Team
date: 2019-01-22 00:00:00 -0700
permalink: /releases/9.1.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 11
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.1.3)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.1](/releases/9.1/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Dashboards/Filters]** On dashboards, pressing `<RETURN>` in a date filter textbox will update the dashboard. Additionally, clicking a date filter preset now focuses the cursor into the text box. Previously you had to click the 'Update' button. [[#784](https://github.com/jstanden/cerb/issues/784)]

* **[Platform/Database]** Fixed an issue with the database service that prevented MySQL error codes from being logged properly.

* **[Tickets/Merged]** When merging tickets, fixed a failing database query when the project boards plugin isn't installed or enabled.

* **[Extras/ImpEx]** Updated the `cerb-package-exporter.php` script to also export time tracking entries and their comments when linked to tickets.

* **[Workspaces/Worklists]** Fixed an issue when copying worklists. The required query wasn't being copied.

* **[Dashboards/Filters]** On dashboards filters, added a new `multiple: true` option to picklist filters. This allows the selection of multiple options from a checkbox menu rather than a single selection from a dropdown list. The value is an array of the selected options. [[#846](https://github.com/jstanden/cerb/issues/846)]

* **[Plugins/JIRA]** In JIRA issue records, the 'Status' and 'Type' fields are now stored as text. Previously these were IDs based on id/label pairs in the parent JIRA project record. This makes working with the records API easier, and it makes synchronization more efficient.

* **[Platform/Developers/Events]** Added the ability to procedurally enable/disable the event system. For instance, this is useful when importing thousands of historical packages where you don't want to trigger notifications or bot behaviors.

* **[Packages/ImpEx]** In packages, a `disable_events` option now prevents events from triggering when the package imports. For instance, this can prevent notifications and bot behaviors from triggering when importing historical data. This can be configured per package.

* **[ImpEx]** The `cerb-package-exporter.php` helper script now exports packages with events disabled by default.

* **[Setup]** Fixed an issue in Setup->Configure->Security with the form saving on every click (rather than submit). [[#874](https://github.com/jstanden/cerb/issues/874)]

