---
layout: post
title: "9.1.4"
excerpt: Cerb 9.1.4 is a maintenance update released in February 2019 with 11 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.1/9.1.4.png
author: The Cerb Team
date: 2019-02-05 00:00:00 -0700
permalink: /releases/9.1.4/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 11
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.1.4)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.1](/releases/9.1/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Mail/Parser/Scheduler]** Fixed an issue in the email parser when an inbound message had an invalid `From:` sender. This could cause processing to halt and temporarily delay inbound mail.

* **[Data Queries]** Fixed an obscure issue with data queries (e.g. worklist.subtotals) when using nested queries (e.g. `query:(picklist:["Option 1","Option 2"])`) with an array-based filter that included terms separated with spaces (e.g. `filter:["Option 1","Option 2"]`). The quotes were being removed from the terms, so `"Option 1"` became `'Option' OR '1'`. In certain situations this could return expected results. For instance, with an exclusive filter the results could include everything, since no options were exactly matched.

* **[Pages]** Removed the mandatory "Currently active" section from the bottom of every workspace page. This can be reproduced as a dashboard widget now where desirable. [[#882](https://github.com/jstanden/cerb/issues/882)]

* **[Bots/Scripting]** In bot scripting, fixed an issue where the `|e` shortcut for `|escape` was being blocked by the "allowed filters" sandbox. [[#885](https://github.com/jstanden/cerb/issues/885)]

* **[Dashboards/Pie]** On dashboards, pie chart widgets now show the category counts in the legend when enabled. [[#886](https://github.com/jstanden/cerb/issues/886)]

* **[Bots/Behaviors]** In bots, fixed an issue where orphaned behaviors (i.e. no bot parent) weren't editable to correct the issue.

* **[Packages]** Fixed an issue in packages where a required field with a value of '0' (zero) was failing as empty during validation.

* **[Plugins/Print]** In the legacy printing plugin, the HTML version of messages is now displayed for printing when available. [[#889](https://github.com/jstanden/cerb/issues/889)]

* **[Installer/Updater]** Fixed an issue with the upgrade process to 9.1 when the 'spatial index' test failed. If MySQL was upgraded or the default storage engine changed, the older test table remained in the way.

* **[Dashboards/Filters]** Fixed an issue with dashboard filters where an invalid filter syntax could display an 'Update' button with no options.

* **[Dashboards]** Fixed an issue on dashboards pages when using the 'Edit Dashboard' button to rename or delete the dashboard. Changes weren't reflected after saving, but only after reloading the page.

