---
layout: post
title: "9.1.5"
excerpt: Cerb 9.1.5 is a maintenance update released in February 2019 with 14 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.1/9.1.5.png
author: The Cerb Team
date: 2019-02-13 00:00:00 -0700
permalink: /releases/9.1.5/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 14
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.1.5)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.1](/releases/9.1/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Workspaces/Widgets/UX]** Fixed an issue when creating or editing workspace widgets. When the 'Name:' field was blank, the validation error confusingly referred to the internal field name of 'label'. [[#892](https://github.com/jstanden/cerb/issues/892)]

* **[Bots/Behaviors/Loops]** Fixed an issue in bot behaviors. When deleting a loop node the editor popup didn't close, but the decision tree refreshed properly. [[#894](https://github.com/jstanden/cerb/issues/894)]

* **[Login/Sessions]** When cleaning up abandoned sessions, unauthenticated sessions are now removed after 15 minutes. Previously, unauthenticated sessions had the same max lifetime as authenticated cookies (e.g. by default 1 day, but up to 30 days in some environments). This was potentially abusable.

* **[Login/Sessions]** Fixed a potential memory issue when logging in. This could occur when there was a large number of unauthenticated sessions from an automated process like uptime monitoring. Affected workers would receive a blank page after logging in. [[#873](https://github.com/jstanden/cerb/issues/873)]

* **[Bots/Records/Custom Fields]** Fixed an issue where bots couldn't remove picklist custom fields by setting them to a blank value.

* **[Bots/Records/Custom Fields]** Fixed an issue where bots couldn't remove multi-checkbox custom fields by setting them to a blank value.

* **[Bots/Simulator]** Fixed an error in the bot behavior simulator when a used action is no longer available (e.g. changed bot permissions).

* **[Dashboards/Roles]** Fixed an issue where non-admin workers couldn't modify dashboards they owned.

* **[Workspaces/Worklists/UX]** On custom fieldset worklists, the owner column now displays owner profile pictures, and clicking opens their card.

* **[Workspaces/Worklists/UX]** On calendar worklists, the owner column now displays owner profile pictures, and clicking opens their card.

* **[Records/Custom Fieldsets]** When a custom fieldset is unlinked from a record, its values are now removed as well. This makes it easier to automate workflows from bots and the API.

* **[Records/Workers/Usability]** On worker records, the preferred filter for mention nicknames is now `mention:` rather than `mentionName:`. Both filter names will work.

* **[Bots/Behaviors]** Fixed an issue with "After ticket profile viewed by a worker" bot behaviors. These events weren't triggering properly.

* **[Worklists/Search]** Fixed an issue with worker-based search filters when filtering by an inactive worker.