---
layout: post
title: "9.1.6"
excerpt: Cerb 9.1.6 is a maintenance update released in February 2019 with 14 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.1/9.1.6.png
author: The Cerb Team
date: 2019-02-19 00:00:00 -0700
permalink: /releases/9.1.6/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 14
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.1.6)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.1](/releases/9.1/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Search/Performance]** Optimized mixed filters and full-text searches on ticket records. If the filters include `updated:` or `created:` then the descending sort happens on that date column to match recent content rather than `id:`. In benchmarking this approach was 10-15X faster for those queries.

* **[Search/Performance]** Optimized mixed filters and full-text searches on message records. If the filters included `created:` then the descending sort happens on that date column to match recent content rather than `id:`. In benchmarking this approach was 10-15X faster for those queries.

* **[Search/Performance]** Mitigated a potential deadlock issue where a long-running full-text search with specific filters could prevent updates to the `message` table for its duration. The transaction isolation level is now reduced when creating temporary tables of search results to prevent locking. This sacrifices strong consistency for performance, because search results are usually historical rather than being sensitive to the past few seconds.

* **[API/Mail Templates]** Fixed an API issue with searching and retrieving mail HTML templates. [[#900](https://github.com/jstanden/cerb/issues/900)]

* **[Data Queries/Series]** In data queries, fixed a bug with `type:worklist.series` when each series had different time period ranges. This excluded some x-axis ticks.

* **[Data Queries/Metrics]** On `type:worklist.metrics` data queries, each series can include a `metric:` expression for formatting the response values using `x` as their placeholder. For instance, `x/100`.

* **[Data Queries/Series]** On `type:worklist.series` data queries, each series can include a `y.metric:` expression for formatting the y-axis values using `y` as their placeholder. For instance, `y*100`.

* **[Data Queries/XY]** On `type:worklist.xy` data queries, each series can include `x.metric:` and `y.metric:` expressions for formatting the values using `x` and `y` placeholders. For instance, `(x+y)**2`.

* **[Time Tracking/Records/ACL]** Fixed an inconsistency between time tracking cards and profile pages. On cards, only admins and the worker the time slip was attributed to could edit the record. On profiles anyone with time tracking create/update privileges could edit the records (as intended).

* **[Opportunities/Records]** Fixed an issue in opportunity placeholder dictionaries where the `closed_at` date field wasn't available. [[#902](https://github.com/jstanden/cerb/issues/902)]

* **[Data Queries/Series]** On `worklist.series` data queries using `format:timeseries`, the x-axis dates are now interpolated if there are data gaps in the given interval (i.e. day, week, month, year). This produces more readable charts. [[#903](https://github.com/jstanden/cerb/issues/903)]

* **[Worklists/Export]** Fixed an issue with exporting records from worklists. If an invalid field was included in the record defaults (e.g. previously changed/deleted) then the export failed to complete. This affected opportunity records after the 'Lead email' field was removed.

* **[Records/Opportunities]** Removed an invalid default field from opportunity records. The 'Email' field was migrated to record links.

* **[Records/Roles]** Fixed an issue with role editors where clicking the "Save & Continue" button multiple times created duplicate roles. [[#904](https://github.com/jstanden/cerb/issues/904)]

