---
layout: post
title: "9.1.7"
excerpt: Cerb 9.1.7 is a maintenance update released in February 2019 with 8 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.1/9.1.7.png
author: The Cerb Team
date: 2019-02-26 00:00:00 -0700
permalink: /releases/9.1.7/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 8
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.1.7)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.1](/releases/9.1/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Records/Custom Fields/Files]** Fixed an issue with 'Files:' custom fields. Only the last file in the set was being linked to the custom field, causing nightly maintenance to remove the rest of the files. [[#906](https://github.com/jstanden/cerb/issues/906)]

* **[Records/Custom Fields/API]** Fixed an issue with the record API where 'Files:' custom fields couldn't be removed. [[#907](https://github.com/jstanden/cerb/issues/907)]

* **[Workspaces/Worklists/Snippets]** Fixed an issue when adding a 'Snippet' view to a workspace worklists tab. The created worklist used a deprecated filters by default rather than a query. [[#909](https://github.com/jstanden/cerb/issues/909)]

* **[Platform/Debug]** Updated the `/debug` endpoint to include MySQL version info.

* **[Packages/Messages]** In packages, message records may now specify a `ticket_mask` field as an alternative to `ticket_id`. This is particularly useful in partial migrations where messages from an old environment may need to thread to existing tickets in the new environment, and the mask is known. [[#911](https://github.com/jstanden/cerb/issues/911)]

* **[Workspaces/Dashboards]** Fixed an issue with 'Clock' and 'Countdown' widgets that prevented them from updating in real-time. [[#912](https://github.com/jstanden/cerb/issues/912)]

* **[Data Queries/Subtotals]** In `worklist.subtotals` data queries that use a date aggregation (e.g. `@month`) in the `by:` field, the limit for that column is automatically set to the maximum. Previously, subtotals defaulted to the top 25 distinct values, which doesn't even cover 1 month of daily totals. [[#809](https://github.com/jstanden/cerb/issues/809)]

* **[Platform/Database/Localization]** Cerb now uses 'utf8mb4' (4-byte UTF-8) encoding for the database connection. This is backwards compatible with the 3-byte 'utf8' encoding we've used historically, while allowing us to begin transitioning the schema and data to full support for the full UTF-8 range (Emoji, Chinese, etc).