---
layout: post
title: "9.1.8"
excerpt: Cerb 9.1.8 is a maintenance update released in March 2019 with 14 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.1/9.1.8.png
author: The Cerb Team
date: 2019-03-04 00:00:00 -0700
permalink: /releases/9.1.8/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 14
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.1.8)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.1](/releases/9.1/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Workspaces/Worklists]** Fixed an issue on 'Worklists' workspaces where exporting and importing a tab lost the required query on the worklists. [[#918](https://github.com/jstanden/cerb/issues/918)]

* **[Knowledgebase/Articles]** Fixed an issue with knowledgebase article worklists that used a `category.id:` filter. The "records per page" option of the worklist could affect how many total articles were displayed. An article in multiple categories could be duplicated in the results from the database but was consolidated by the worklist. This was fixed by modernizing the knowledgebase `category.id:` filter to use subqueries rather than joins. [[#916](https://github.com/jstanden/cerb/issues/916)]

* **[Knowledgebase/Subtotals]** Knowledgebase article worklists can now be subtotaled by category. Previously they could only be subtotaled by topic (i.e. top-level category).

* **[Login/Recovery]** Fixed an issue where using a mixed-case email address could prevent account recovery confirmation codes from being accepted.

* **[Data Queries]** Fixed an issue with subtotal data queries when specifying a date grouping like `by:[created]` without a time unit like `by:[created@week]`. This was grouping by seconds. The default is now `month`.

* **[Saved Searches/Performance]** Implemented a `::getAll()` cache for saved searches. This removes extraneous queries from popup editors with comment boxes, etc.

* **[Comments/Performance]** Improved the performance of comment boxes with `@mention` suggestions. The results were looking up worker email address records when they weren't necessary.

* **[Roles/Performance]** Improved the performance of retrieving a list of roles by ID. Previously this always ran a database query rather than using the cache.

* **[Bots/Ajax]** In '[UI] Respond to Ajax request' bot events, placeholders are now available for the current worker session. [[#920](https://github.com/jstanden/cerb/issues/920)]

* **[Bots/Scripting]** In bot scripting, added filters for `|base64url_encode()` and `|base64url_decode()`. These use the URL-safe variant of Base64 encoding.

* **[Records/File Bundles]** Fixed an issue with file bundle editor popups. The owner menu wasn't being built properly.

* **[Bots/Scripting]** In bot scripting, the `|hash_hmac()` filter now accepts an optional third argument for whether to return the hash in binary (true) or hex (false/default). Previously this only returned the hex version, and some technologies (like JWT) use binary hashes.

* **[Custom Fields/UX]** When creating a decimal custom field, it is now more obvious that the placeholder on "Decimal places:" is not a default. [[#774](https://github.com/jstanden/cerb/issues/774)]

* **[Worklists/Notifications]** Fixed an issue with bulk update on notification worklists when using MariaDB.

