---
layout: post
title: "9.2.1"
excerpt: Cerb 9.2.1 is a maintenance update released in March 2019 with 17 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.2/9.2.1.png
author: The Cerb Team
date: 2019-03-22 00:00:00 -0700
permalink: /releases/9.2.1/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 17
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.2.1)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.2](/releases/9.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Bots/Usability]** Added an '(optional)' placeholder to the 'URI' field when creating/editing bot behaviors.

* **[Installer/Packages]** Removed the 'Auto-Reply Bot' optional package from the installer since this can now be created from the package library.

* **[Installer/Tour]** In the installer, the 'Tutorial' option has been replaced with a 'Demo' package. This resolves some issues where the tutorial left sample data in systems that later went into production. The demo is intended to be discarded after demonstration or evaluation. The tutorial will move into the package library so it's also available to new workers in existing instances.

* **[Scheduler/Maintenance/Notifications]** In the nightly maintenance scheduler job, notifications are only deleted when they are read and at least 7 days old. Previously, read notifications were deleted regardless of age. This caused some obscure issues, like a notification disappearing from a result set created just before maintenance ran.

* **[Records/Workers]** Fixed an issue with editing worker records and changing their default calendar.

* **[Package Library/Workspaces]** In the package library, added default artwork to workspace page packages.

* **[Package Library/Workspaces]** Updated the 'Mail' workspace package. The 'Needs attention' worklist includes 'Organization' in the default columns. The 'My sent messages' tab is now 'Sent messages' and includes replies by all workers with subtotals by worker.

* **[Package Library/Workspaces]** Added an 'Empty Workspace' package to the workspace page library. This removes the extra step of having to switch to the 'Build' tab.

* **[Dashboards/Filters]** On workspace dashboards, counters and gauges may now use the dashboard filter placeholders in their data queries.

* **[Installer/Demo]** Added a new corpus of sample tickets to the Demo package in the installer. These are based on frequently asked questions about Cerb.

* **[Package Library/Bots]** Added an 'Exit' package to the bot action library for all events.

* **[Package Library/Bots]** Added an 'Execute jQuery Script' package to the bot action library for the "[UI] Before composing a worker reply" event.

* **[Package Library/Bots]** Added a 'Respond with HTTP body' package to the bot action library for the webhook listener event.

* **[Package Library/Bots]** Added a 'Respond with HTTP header' package to the bot action library for the webhook listener event.

* **[Package Library/Bots]** Added a 'Respond with HTTP status code' package to the bot action library for the webhook listener event.

* **[Package Library/Connected Services]** Added a 'Smartsheet' package to the connected service library.

* **[Bots/Scripting]** Added an `array_column(array, column_key, index_key)` function to bot scripting. This creates a new array with only the particular field specified by `column_key`. If the optional `index_key` argument is provided, that field is used as the index of the new array. For instance, if the input is a `$people` array of objects with keys like id, full_name, age, gender, dob, and email, then `array_column($people, 'email', 'id')` would return an array of email addresses keyed by person ID in the same order as the original array.

