---
layout: post
title: "9.2.2"
excerpt: Cerb 9.2.2 is a maintenance update released in March 2019 with 22 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.2/9.2.2.png
author: The Cerb Team
date: 2019-03-29 00:00:00 -0700
permalink: /releases/9.2.2/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 22
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.2.2)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.2](/releases/9.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Platform]** Fixed some syntax warnings for PHP 7.3 compatibility.

* **[Bots/Packages]** In the bot behavior library, the 'Chat interaction with worker' package now demonstrates both global and record-based interactions. The record-based interactions pass a record ID, load it, and use its placeholders in the example response.

* **[Setup/Developers]** Added a 'Bot Scripting Tester' option to the Setup->Developers menu. This makes it much easier to experiment with bot scripting. [[#927](https://github.com/jstanden/cerb/issues/927)]

* **[Bots/Simulator]** Fixed an issue in the bot simulator. When changing the date/time in the simulator it wasn't properly affecting "Set date by calendar availability" with using relative dates (e.g. "+2 hours'). This made it difficult to test behaviors like SLAs. [[#926](https://github.com/jstanden/cerb/issues/926)]

* **[Packages/Bots]** In packages, fixed an issue where the specified owner of a bot was always ignored and 'Cerb' was used instead.

* **[Packages/Saved Searches]** In packages, fixed an issue where the specified owner of a saved search was always ignored and 'Cerb' was used instead.

* **[Packages/Calendars]** In packages, fixed an issue where the specified owner of a calendar was always ignored and 'Cerb' was used instead.

* **[Packages/Classifiers]** In packages, fixed an issue where the specified owner of a classifier was always ignored and 'Cerb' was used instead.

* **[Bots/Package Library]** Implemented the package library when creating bot records.

* **[Connected Services/HTTP/Security]** In connected services using 'Http Basic' authentication method, a new 'URL Allowlist' option is available for determining which URLs will be signed. Previously, the base URL was always authorized, but some APIs (like Twilio) use multiple subdomains within their API. The URL allowlist exists to prevent a malicious bot owner from discovering connected service credentials by sending signed requests to an arbitrary URL they control. HTTP Basic authentication is very unsophisticated and easy to decode in this manner.

* **[Bots/Packages]** Added 'Twilio Bot' to the bot package library. This demonstrates Twilio integration.

* **[Bots/Behaviors]** Fixed an issue with explore mode on bot behavior worklists.

* **[Bots/Reminders]** Fixed an issue with the 'Create reminder' bot action. Existing reminder behaviors didn't open their card when clicked. This was only working for newly added behaviors.

* **[Bots/Actions]** Fixed an issue in the bot action editor where any fieldset inside of an action was draggable and could be dropped outside of the action. Now only the outer action container is properly draggable.

* **[Bots/Library]** Added 'Reminder Bot' to the bot package library. This assists with scheduling reminders from any record profile or card.

* **[Developers/OAuth/Setup]** Added an 'OAuth2 Token Generator' option to the Setup->Developers menu. This bypasses the 3-legged user login/consent and allows admins to quickly create access/refresh tokens for automated scripts.

* **[API/OAuth2]** When accessing the REST API using an expired OAuth2 token, a `401` (Unauthorized) status code is returned. This makes it easier for a client application to know when to use its refresh token. [[#854](https://github.com/jstanden/cerb/issues/854)]

* **[API]** When accessing the REST API using legacy signatures, a `401` (Unauthorized) status code is returned for authentication errors. [[#854](https://github.com/jstanden/cerb/issues/854)]

* **[Data Queries/Subtotals/Custom Fields]** Fixed an issue with `worklist.subtotals` data query aggregations on multi-value custom fields (e.g. multiple checkboxes). When a record has multiple values set, these should now be counted in multiple tallies. Previously, each record was only being counted once, arbitrarily on one of their values for the field.

* **[Plugins/Print]** In the "Legacy Printing" plugin, fixed an issue where custom logos weren't being used at the top of printouts. [[#928](https://github.com/jstanden/cerb/issues/928)]

* **[Mail/Tickets/UX]** Improved the auto-hyperlinking of plain text email. Custom protocols (e.g. `radar://`, `mailto://`) are now supported, and URLs no longer require a protocol like `https://` (e.g. `www.cerb.ai`). Thanks [John Gruber](https://daringfireball.net/2010/07/improved_regex_for_matching_urls) [[#781](https://github.com/jstanden/cerb/issues/781)]

* **[Mobile/Android]** Fixed an issue with selecting pages and tabs in some Android mobile browsers. Taps were interfering with drag/drop events. These items are no longer sortable in Android browsers but otherwise work properly.

