---
layout: post
title: "9.2.3"
excerpt: Cerb 9.2.3 is a maintenance update released in May 2019 with 17 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.2/9.2.3.png
author: The Cerb Team
date: 2019-05-06 00:00:00 -0700
permalink: /releases/9.2.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 17
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.2.3)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.2](/releases/9.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Calendars/Sync]** Fixed an issue with calendars when syncing using a worklist and a date-based custom field. [[#932](https://github.com/jstanden/cerb/issues/932)]

* **[Mail/Comments]** Fixed an issue with auto-hyperlinking functionality in email messages and comments.

* **[Mail/Reply]** Fixed an issue where some workers were able to double-click the 'Send message' button while replying to messages. This was possible when the validation step was delayed by the server for any reason (e.g. network).

* **[Mail/Reply/UX]** When sending a mail reply, there is now immediate visual feedback when the 'Send message' button is clicked. Previously, the loading spinner only appeared _after_ form validation, which encouraged double clicks.

* **[Bots/Behaviors]** Fixed an issue in bot behaviors where some ID-based placeholders (e.g. `parent_ticket_id` in mail filtering) weren't working properly in numerical conditions (e.g. greater than, not equals).

* **[Data Queries/Subtotals]** In `type:worklist.subtotals` data queries, duplicate labels (e.g. bucket "Inbox") are no longer consolidated into a single result. This was preventing API users and bots from retrieving distinct IDs from these tallies, and it prevented the "click to search" feature from automatically adding the right filters.

* **[API/Attachments]** Fixed an "out of memory" issue when uploading files in the API. This had to do with 4-byte UTF-8 validation on very long strings.

* **[Records/Tasks/UX]** On task worklists and peek editors, the "Importance" field now has a tooltip on the slider to show the actual value. [[#939](https://github.com/jstanden/cerb/issues/939)]

* **[Records/Tickets/UX]** On task worklists and peek editors, the "Importance" field now has a tooltip on the slider to show the actual value. [[#939](https://github.com/jstanden/cerb/issues/939)]

* **[Mail/UX]** Fixed an issue in email messages and comments with auto-hyperlinking links like `www.example.com` (without `http://`). A link was being created to the current page. These links now default to `http://` when no protocol is specified.

* **[Custom Fields/Number]** Number-based custom fields may now contain negative numbers. [[#940](https://github.com/jstanden/cerb/issues/940)]

* **[Records/Knowledgebase]** Fixed an obscure issue in knowledgebase article dictionaries where all keys were removed after the 'content' key was loaded, due to nested invocations of the template builder service. The second invocation cleared the dictionary before the first invocation finished. These now use separate instances of the service.

* **[Bots/Scripting]** In bot scripting, added a `|permalink()` filter for converting text into a URL-friendly format. For example, "This sentence has spaces" would permalink as "This-sentence-has-spaces". The filter accepts a single argument for the character to use to replace spaces, which defaults to dash (`-`).

* **[Search/Performance]** In **Setup >> Configure >> Search**, optimized the search index counts when using MySQL Fulltext. InnoDB isn't efficient at strong consistency on `COUNT (*)`, so we use the cached approximation.

* **[Profiles/Tickets/Convo/UX]** On ticket profiles, the 'Conversation' widget has new configuration options for comments. Comments can be shown or hidden. When hidden, this allows comments to be grouped together in a separate 'Comments' widget. An additional "Show with the latest comment pinned to the top" option improves the workflow where comments keep track of the current status. This will display the latest comment at the top of the timeline and ignore its chronological order. Everything else remains chronologically ordered.

* **[Records/Tickets/Search]** On ticket records, a new `messages.firstOutgoing:` filter allows deep searches against the first outgoing (worker) message in a ticket thread. For instance, this is useful for building a list of tickets where a particular worker sent the first response.

* **[Mail]** When displaying plaintext messages on ticket profiles, added a stopgap to the auto-hyperlinking functionality to display the original content without links when a fatal issue occurs (e.g. catastrophic backtracking in regexp). There's a reported issue with links formatted like `http://example.com(http://example.com`.