---
layout: post
title: "9.2.4"
excerpt: Cerb 9.2.4 is a maintenance update released in June 2019 with 9 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.2/9.2.4.png
author: The Cerb Team
date: 2019-06-10 00:00:00 -0700
permalink: /releases/9.2.4/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 9
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.2.4)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.2](/releases/9.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Performance/Records]** Improved performance when loading a large number of records per page (e.g. API). There were some inefficiencies in sorting keys within dictionaries to discover key expansion paths.

* **[Performance/Records]** Improved performance when loading a large number of record dictionaries. Previously, dictionaries returned deep keys as hints for expansion (e.g. `ticket_latest_message_sender_org_id`). This was originally useful for creating placeholder menus in bot behaviors and snippets; but as more functionality has taken advantage of dictionaries the performance cost of crawling for deep keys has increased. Outside of placeholder menus, dictionaries now only return the next level of keys (e.g. `ticket_latest_message_` and not `ticket_latest_message_sender_`). Key expansion still works to an infinite depth, and in data queries or API requests it is assumed that desired keys are known in advance.

* **[Records/Dictionaries]** Fixed an issue where null context dictionaries weren't distinguishing between an empty string and NULL. This affected the returned label prefixes.

* **[API/Records/Search/Performance]** Significantly improved the performance of the `/rest/records/<type>/search.json` API endpoint. The results now only include the next level of key expansion hints (e.g. ticket -> ticket_group_). Key expansion to any depth is still with the `expand` parameter.

* **[API/Records/Search/Performance]** In the API, the `/records/<type>/search.json` endpoint may now return a maximum of 500 results per page.
	
* **[Records/Profiles/Widgets]** Added a `type:` filter to profile widget worklists.

* **[Import/Export]** Added a `package-import-cli.php` script to `/install/extras/impex/`. This tool is used to do distributed imports of packages from the command line.

* **[Mail/UX]** In plaintext email and comments, updated the auto-hyperlinking filter to convert Markdown-formatted links to a more readable format. This also avoids "catastrophic backtracking" issues in the "GruberV2" regular expression.

* **[Mail/UX]** In plaintext email and comments, the auto-hyperlinking filter no longer creates links for text like `key:value`.
