---
layout: post
title: "9.3.4"
excerpt: Cerb 9.3.4 is a maintenance update released in September 2019 with 10 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.3/9.3.4.png
author: The Cerb Team
date: 2019-09-22 00:00:00 -0700
permalink: /releases/9.3.4/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 10
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.3.4)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.3](/releases/9.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Search/UX]** Fixed an issue in the search popup title when a record type contained special characters like `&`. These were being shown as escaped HTML entities (e.g. `&amp;`).

* **[Installer]** Fixed an issue with the requirements tester in the installer. The `SPATIAL INDEX` test could fail in MySQL 5.7 because it must be added when the table is empty (`POINT` columns can't be `NULL`).

* **[Dashboards/Form Interactions]** Fixed an issue in form interaction widgets where multiple choice prompts were only using the last selected value.

* **[Profiles/Comments]** Fixed an issue with comment widgets on profiles. Comments were only being displayed for the current record, even if a different target record was specified.

* **[Profiles/Comments/UX]** On profiles, permalinks to specific comments are now available for every record type. Previously this was only supported on tickets. [[#975](https://github.com/jstanden/cerb/issues/975)]

* **[Sheets]** On sheet widgets on profiles and dashboards, the `label_template:` parameter on `search` columns may now include basic HTML formatting (e.g. size, color). Previously this was sanitized. [[#981](https://github.com/jstanden/cerb/issues/981)]

* **[API/Records/Subtotals]** Fixed an issue in the API when using the `subtotals` option on `/rest/records/{alias}/search.json`.

* **[Profiles/Comments/UX]** On profiles, when a comment's author is a worker, their title is now displayed to the right of their name. This is consistent with how messages display on tickets. [[#985](https://github.com/jstanden/cerb/issues/985)]

* **[Records/Profiles]** On profiles for custom records, the `Owner` field is now available in 'Record Fields' widgets. [[#987](https://github.com/jstanden/cerb/issues/987)]

* **[Form Interactions/UX]** In form interactions, increased the size of the multi-line text prompt.