---
layout: post
title: "9.3.5"
excerpt: Cerb 9.3.5 is a maintenance update released in October 2019 with 17 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.3/9.3.5.png
author: The Cerb Team
date: 2019-10-10 00:00:00 -0700
permalink: /releases/9.3.5/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 17
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.3.5)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.3](/releases/9.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Mail/Tickets]** Fixed an exceptionally rare issue in random ticket mask generation. In very specific circumstances it was possible for the same mask to be used on more than one ticket when created from the web UI at the same moment (within a few hundred milliseconds). This had to do with profile pictures (consistently colored monograms) overriding the random number generator seed to be deterministic and not resetting it afterwards. If two workers performed exactly the same steps in near unison, and managed to hit the same backend servers on subsequent requests, they could briefly synchronize their mask generators. In the environment where this was discovered, this occurred  once in 1.5+ million tickets over 14 years with 70+ daily workers.

* **[Plugins/LDAP]** Fixed an issue with the 8.0.0 migration patch in the LDAP plugin. This caused trouble when upgrading old instances.

* **[API/Mail]** In the API, the `/rest/tickets/compose.json` endpoint now accepts a `dont_send=1` parameter to open tickets without sending email to the participants.

* **[Bots/Scripting]** Fixed an issue with bot scripting where the `|json_pretty` filter only formatted arrays and discarded strings. It now properly works for something like: {% raw %}`{{"some text"|json_encode|json_pretty}}`{% endraw %}.

* **[Sheets]** Fixed a minor issue in sheet schemas with `card` columns, where an `image: false` parameter still displayed the image. Only the presence of the parameter was being checked; not its value. Thanks to Ryan Bantz for reporting.

* **[Form Interactions/Prompts]** In form interactions, the 'Prompt with single choice' action now offers a 'picklist' style in addition to 'radios' and 'buttons'. [[#1001](https://github.com/jstanden/cerb/issues/1001)]

* **[Mail/Compose/Drafts]** Fixed an issue with composing new mail. When a draft didn't exist (e.g. API), and the mail transport failed, it was possible for the generated draft to not retain the message content.

* **[Setup/Developers/Icons]** In **Setup >> Developers**, added an icons reference page. This displays a grid of icon names along with their image. This is useful when building sheets, plugins, etc.

* **[Form Interactions/UX]** In form interaction widgets, changed the message when empty from 'No interactions are configured' to 'No interactions are available'. The latter better denotes that interactions may be configured, but they are not available on the current record or by the current worker.

* **[Records/Scheduled Behaviors/Subtotals]** Fixed an issue in scheduled behavior worklists. When subtotaling by the 'On' target, clicking a grouping didn't add a filter to the worklist.

* **[Developers/Platform/Code Editors]** In the Devblocks Javascript library, the `.cerbCodeEditor()` plugin now looks for `data-editor-lines` (max line height of editor), `data-editor-line-numbers` (show line numbers in left gutter), `data-editor-gutter` (show left gutter), and `data-editor-readonly` (disable changes in editor) on the selector element.

* **[Profiles/Sheets]** On profiles, 'Sheet' widgets can now use `search` columns.

* **[Comments]** Fixed an issue where attachments couldn't be removed from the comment editor.

* **[Mail/Signatures/Attachments]** In the mail signature editor, attachments can now be managed. This will make it much easier to use images in signatures. [[#494](https://github.com/jstanden/cerb/issues/494)]

* **[Setup/Mail/Import]** Fixed an issue in Setup->Mail->Import that prevented an error message from displaying when importing a message from a banned sender. [[#1009](https://github.com/jstanden/cerb/issues/1009)]

* **[Storage/Profiles]** Fixed an issue when creating a new storage profile. The 'Engine:' picklist default didn't match the configuration options.

* **[Storage/Profiles]** When configuring the S3 storage engine, added a help link for AWS S3 regional endpoints. The default of `s3.amazonaws.com` is only valid for the `us-east-1` region. The resulting unhelpful 'Access denied' error has confused a few clients.

