---
layout: post
title: "9.3.7"
excerpt: Cerb 9.3.7 is a maintenance update released in November 2019 with 21 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.3/9.3.7.png
author: The Cerb Team
date: 2019-11-08 00:00:00 -0700
permalink: /releases/9.3.7/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 21
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.3.7)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.3](/releases/9.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Connected Services/OAuth2]** Fixed an issue with OAuth2 service providers where the refresh token didn't fetch a new access token.

* **[Mail/Parser]** Fixed an issue in the email parser when creating tickets with a subject line longer than 255 characters. Previously, the subjects were blank. Now they are truncated.

* **[Package Library/Connected Services/Google]** Updated the 'Google' connected service in the package library. The example wasn't requesting a refresh token (i.e. `access_type=offline`), so the access token expired after an hour and required the connected account to be re-linked manually.

* **[Dashboards/Record Fields]** Fixed an issue on 'Record Fields' workspace widgets. If the selected record type was 'Notification' then the widget returned an error and was no longer editable or deletable. [[#1030](https://github.com/jstanden/cerb/issues/1030)]

* **[Records/API]** Set `image` on orgs from records API. [[#1036](https://github.com/jstanden/cerb/issues/1036)]

* **[Records/API]** Set `image` on contacts from records API. [[#1037](https://github.com/jstanden/cerb/issues/1037)]

* **[Records/API]** Set `image` on bots from records API. [[#1039](https://github.com/jstanden/cerb/issues/1039)]

* **[Records/API]** Set `image` on custom records from records API. [[#1038](https://github.com/jstanden/cerb/issues/1038)]

* **[Records/API]** In the records API, profile `image` fields can be cleared by setting them to `data:null`.

* **[Custom Records]** Fixed an issue with custom records where a renderer (e.g. widget) could attempt to load all records in order to display labels. This now properly just loads the involved records (e.g. links).

* **[Custom Records/Performance]** Improved the performance of custom records. When information about an individual custom record was loaded it wasn't using the cache. This caused extraneous database queries on some requests.

* **[Records/Performance/Messages]** Improved the performance of message worklists. Contact records were being fetched individually rather than as a single set. This caused extraneous database queries on some requests.

* **[Mail/Attachments/UI]** On message cards and conversations, the 'Attachments' section is now styled consistently with custom fields.

* **[Custom Records/Autocomplete/UX]** On custom record worklists, the `name:` filter is now recommended first, and it suggests autocompletion values from live data.

* **[Security/Dependencies/Composer]** Updated the `robrichards/xmlseclibs` dependency of the SAML service due to a security advisory.

* **[UI/Aesthetics]** Fixed a stylistic issue in Chrome and Opera where relative dates in worklists (e.g. "2 hours ago") had two different underline styles. [[#1044](https://github.com/jstanden/cerb/issues/1044)]

* **[Records/Connected Accounts]** On connected account cards and profiles, the 'Service' field is now clickable and opens that record's card.

* **[Records/Drafts]** On draft profiles, 'Record Fields' widgets can now display more fields: draft type, is queued, # queue fails, queue delivery date, and worker.

* **[Records/Search]** On workspace page worklists, the `name:` filter autocompletion now suggests possible values from existing data.

* **[Bots/Behaviors]** In bot behaviors, fixed an issue where 'Record ID' variables no longer supported key expansion when used with 'Run Behavior' or 'Schedule Behavior' actions.

* **[Records/Workers/Search]** In worker worklists, added a `using.workspace:` filter. This returns the workers who are using the matching workspace pages in their navigation menu. The workspace pages may be specified using a deep search (e.g. `using.workspace:(name:"Development")`).

