---
layout: post
title: "9.3.8"
excerpt: Cerb 9.3.8 is a maintenance update released in November 2019 with 20 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.3/9.3.8.png
author: The Cerb Team
date: 2019-11-24 00:00:00 -0700
permalink: /releases/9.3.8/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 20
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.3.8)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.3](/releases/9.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Bots/Scripting/Help]** Updated the documentation links in the 'Help' popup of bot scripting.

* **[Records/Images]** Increased the maximum file size for profile pictures from 100KB to 1MB. This would fit an uncompressed 500x500 pixel RGBA image.

* **[Records/Workers/UX]** In worker worklists, the `mention:` query filter will no longer suggest deactivated workers.

* **[Sheets/Cards]** In sheets, `card` columns may now use `label_template`, `context_template`, and `id_template` to dynamically set those options using bot scripting. [[#1049](https://github.com/jstanden/cerb/issues/1049)]

* **[Records/Packages]** In packages and the API, the `params` field may be set for custom record types. For instance, enabling comments/attachments, or selecting the possible owner types (e.g. role, group, worker).

* **[Bots/Behaviors/Interactions]** Fixed an issue with key expansion in 'Record ID' behavior variables when set in form interaction widgets.

* **[Bots/Behaviors/UX]** In bot behaviors, renamed the 'Set custom placeholder using a snippet' action to 'Set snippet placeholder'. This should help avoid a lot of confusion when attempting to set a placeholder but expanding the extra menu for the infrequently used snippet option.

* **[Mail/UX]** Fixed an issue in some HTML messages where links weren't clickable when the 'Tidy' PHP extension was installed. This had to do with Tidy enforcing HTML standards and not allowing block-level elements inside links. For instance, Facebook ad reviews inexplicably use the retired `<center>` tag inside of links. We now strip this tag before processing.

* **[Records/Search]** In activity log worklists, when querying by `activity:`, autocomplete suggestions are now provided based on existing data.

* **[Records/Search]** In attachment worklists, when querying by `mimetype:`, autocomplete suggestions are now provided based on existing data.

* **[Records/Search]** In calendar recurring event worklists, when querying by `timezone:`, autocomplete suggestions are now provided based on existing data.

* **[Records/Search]** In contact worklists, when querying by `timezone:`, autocomplete suggestions are now provided based on existing data.

* **[Records/Search]** In custom field worklists, when querying by `context:`, autocomplete suggestions are now provided based on existing data.

* **[Records/Search]** In custom field worklists, when querying by `type:`, autocomplete suggestions are now provided based on existing data.

* **[Records/Search]** In custom fieldset worklists, when querying by `context:`, autocomplete suggestions are now provided based on existing data.

* **[Records/Search]** In draft worklists, when querying by `type:`, autocomplete suggestions are now provided based on existing data.

* **[Records/Search]** In notification worklists, when querying by `activity:`, autocomplete suggestions are now provided based on existing data.

* **[Records/Search]** In profile tab worklists, when querying by `record:`, autocomplete suggestions are now provided based on existing data.

* **[Records/Search]** In worker worklists, when querying by `timezone:`, autocomplete suggestions are now provided based on existing data.

* **[Form Interactions]** Fixed an issue with form interactions where a 'Prompt with submit' that had no other form fields blocked the behavior from continuing.

