---
layout: post
title: "9.4.2"
excerpt: Cerb 9.4.2 is a maintenance released in December 2019 with 8 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.4/9.4.2.png
author: The Cerb Team
date: 2019-12-16 00:00:00 -0700
permalink: /releases/9.4.2/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 8
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.4.2)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.4](/releases/9.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Records/Search/UX]** In data queries and search queries, date range filters now act more intuitively. Previously, the ending time in an absolute date range had to be explicit (e.g. "Jan 1 2020 to Dec 31 2020 23:59:59"), otherwise it was implied to be at the start of the given date. Nearly all humans would assume the ending date includes that entire day, and this confusion could lead to misleading results and reports. When using an absolute ending date, the implied ending time is now always the last second of that day. When providing an explicit ending time (e.g. "Dec 31 2020 5pm") that is used. When using relative end days (e.g. "yesterday to tomorrow", "-30 days to -7 days") the implied ending time is the full day. The relative term "now" still implies the current time. [[#1101](https://github.com/jstanden/cerb/issues/1101)]

* **[Records/Email Addresses]** On email address records, added `last_recipient_message` and `last_sender_message` expansion keys. Respectively, these return the most recent message received by the email address and the most recent message sent by it (if any). Because we don't link To/Cc/Bcc recipients to email address records, the 'most recent received message' is considered to be the most recent message on a ticket where the email address is a participant. These keys can be used by sheets, bots, and the API, to report on the last interactions with a specific email address. [[#1040](https://github.com/jstanden/cerb/issues/1040)] [[#1097](https://github.com/jstanden/cerb/issues/1097)]

* **[Records/Contacts]** On contact records, added `last_recipient_message` and `last_sender_message` expansion keys. Respectively, these return the most recent message received by the contact and the most recent message sent by them (if any). Because we don't link To/Cc/Bcc recipients to email address records, the 'most recent received message' is considered to be the most recent message on a ticket where any of the contact's email addresses are a participant. These keys can be used by sheets, bots, and the API, to report on the last interactions with a specific contact. [[#1098](https://github.com/jstanden/cerb/issues/1098)]

* **[Records/Orgs]** On organization records, added `last_recipient_message` and `last_sender_message` expansion keys. Respectively, these return the most recent message received by any contact of the org and the most recent message sent by any of them (if any). Because we don't link To/Cc/Bcc recipients to email address records, the 'most recent received message' is considered to be the most recent message on a ticket where any of an org's contact are a participant. These keys can be used by sheets, bots, and the API, to report on the last interactions with a specific organization. [[#1099](https://github.com/jstanden/cerb/issues/1099)]

* **[Records/Cards/Snippets]** Fixed an issue where the 'Profile' button wasn't showing up at the top of snippet cards. [[#1102](https://github.com/jstanden/cerb/issues/1102)]

* **[Records/Snippets]** Converted the snippet editor from a code editor to a text editor so native browser spellchecking works.

* **[Bots/Export]** On bots, moved the 'Export' option into their editor popup. This was previously found on bot cards, but was missing after the 9.4 update. [[#1071](https://github.com/jstanden/cerb/issues/1071)]

* **[Bots/Behaviors/UX]** On behavior cards, added back 'Export' and 'Simulator' shortcut buttons. These now appear in a toolbar in the 'Behavior tree' widget rather than at the top of the card. [[#1087](https://github.com/jstanden/cerb/issues/1087)]

