---
layout: post
title: "9.4.3"
excerpt: Cerb 9.4.3 is a maintenance update released in December 2019 with 12 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.4/9.4.3.png
author: The Cerb Team
date: 2019-12-19 00:00:00 -0700
permalink: /releases/9.4.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 12
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.4.3)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.4](/releases/9.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Mail/Comments/UX]** Fixed an issue with the default stylesheet on formatted messages and comments. When a code block doesn't wrap, the container now scrolls horizontally rather than the text overflowing the box.

* **[Sheets/Dates]** On sheets, `date:` columns may now specify a `value_template:` parameter to dynamically fetch or generate the timestamp. This is particularly useful when using a timestamp from an array of deep linked records which can not be addressed by key.

* **[Records]** When using the `last_recipient_message` or `last_sender_message` expansion keys on email addresses, contacts, or organizations, it's now possible to directly retrieve nested keys without first loading the message (e.g. `last_recipient_message_created`).

* **[Pages/UX]** Fixed an issue with workspace pages where page names could contain leading whitespace but not display it. This appeared to cause strange sorting in the worklist. [[#1106](https://github.com/jstanden/cerb/issues/1106)]

* **[Roles/Groups]** Fixed an issue where the role member cache didn't update when group rosters changed. [[#1107](https://github.com/jstanden/cerb/issues/1107)]

* **[Form Interactions]** Fixed an issue when simulating a form interaction behavior where the worker placeholders weren't being set.

* **[Records/Comments]** Fixed an issue when commenting from a record editor. If an attachment was included on a comment without any text, the record would save but the comment wouldn't. This situation now returns an error that must be corrected before saving. [[#1110](https://github.com/jstanden/cerb/issues/1110)]

* **[Records/Email Addresses]** When creating or updating an email address through the records API and providing a contact, the contact's org will also be set on the email address. [[#1109](https://github.com/jstanden/cerb/issues/1109)]

* **[Records/Contacts]** When creating or updating a contact through the records API and providing an email address, a mutual link from the email address to the contact will properly be set. [[#1109](https://github.com/jstanden/cerb/issues/1109)]

* **[Bots/Behaviors/Mail]** On bot behaviors that have the 'Execution jQuery script' action, the default script now properly reflects the new layout of the compose and reply forms. Previously these had two form elements (fields/actions) and now they are combined into one.

* **[Mail/Reply/UX]** On the mail reply form, added a container around the "When should the message be delivered?" option to simplify jQuery selectors. For instance, a bot behavior that hides the option for workers who don't need it.

* **[Bots/Mail]** In bot behaviors, fixed an issue with the 'Create ticket' action where its properties (e.g. status, owner, group/bucket) overwrote any changes from 'New message' bot behaviors. The bot's properties are now set on the ticket record before any behaviors run.
