---
layout: post
title: "9.4.5"
excerpt: Cerb 9.4.5 is a maintenance update released in December 2019 with 11 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.4/9.4.5.png
author: The Cerb Team
date: 2019-12-31 00:00:00 -0700
permalink: /releases/9.4.5/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 11
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.4.5)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.4](/releases/9.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Mail/Snippets/UX]** When composing or replying to mail, a new `#snippet` command is available. This autocompletes the names of the most frequently used snippets that are usable by the current worker. When selected, the snippet content is inserted at the cursor. This allows the selection of snippets entirely from the keyboard. [[#1119](https://github.com/jstanden/cerb/issues/1119)]

* **[Mail/Comments/UX]** Improved the performance of the new `@mention` autocompletion in compose, reply, and comments. As of 9.4.0, suggestions were sent from the server after a small delay in keystrokes. This required two requests each time (worker names and saved searches). The mention suggestions now come from a single endpoint which is cached on the server until workers or saved searches change. The full mention list is also retrieved into a client browser on the first keystroke and reused for all subsequent suggestions for that interaction. [[#1117](https://github.com/jstanden/cerb/issues/1117)]

* **[Worklists/Tickets]** In ticket worklists, a new `status.id:` filter is available. This uses the numeric status codes (`0`=open, `1`=waiting, `2`=closed, `3`=deleted). It's primarily useful for sorting by status (e.g. `sort:status.id`).

* **[Bots]** Fixed extraneous logging with bots when using the 'Replace content' action in behaviors. If the action hadn't been edited in several versions, a notice was being logged for the newer missing `replace_mode` option on every invocation. This didn't affect the behavior, it just created noisy logs.

* **[Worklists/Snippets]** On snippet worklists, added a polymorphic `myUses:` filter. This can be a simple numeric expression, like `myUses:>10` to filter by all uses. It can also be a query expression with `hits:` and `date:` keys to filter hits over a specific date range (e.g. `myUses:(hits:>20 date:"-30 days to now")`).

* **[Mail/Reply]** Fixed an issue with inline images when using the legacy reply form (not the popup). The file wouldn't finish uploading because it assumed it would insert the inline image in a popup.

* **[Files/UX]** When the file chooser popup opens, the "Choose File" button is now focused by default. The button can be clicked with the keyboard rather than the mouse.

* **[Mail/Comments/UX]** When composing, replying, or commenting, the 'Insert Link' toolbar item now automatically focuses the example URL in the inserted text. This makes it simple to type or paste over the URL. Previously, the `https://example.com` text had to be manually selected and replaced.

* **[Mail/Comments/Keyboard]** When composing, replying, or commenting, keyboard shortcuts are now available for the most common toolbar buttons (e.g. `Ctrl+K` for 'Insert link'). The tooltip on each button displays its shortcut (if available).

* **[Mail/Comments]** When composing, replying, or commenting, and the autocomplete popup menu is open, the menu is now closed when clicking to move the cursor elsewhere. [[#1121](https://github.com/jstanden/cerb/issues/1121)]

* **[Mail/Comments]** When composing, replying, or commenting, a new `Ctrl+Space` shortcut opens the autocomplete suggestions menu. This is useful, for instance, if you type `@` for a list of mentions, then type `ESC` to close the menu. Previously, to re-open the menu you had to backspace the `@` and type it again. This was tedious if you had already typed part of a name.

