---
layout: post
title: "9.4.7"
excerpt: Cerb 9.4.7 is a maintenance update released in January 2020 with 24 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.4/9.4.7.png
author: The Cerb Team
date: 2020-01-10 00:00:00 -0700
permalink: /releases/9.4.7/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 24
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.4.7)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.4](/releases/9.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Mail/Compose]** Fixed an issue on the compose popup that prevented a worker's settings from determining the default status when not set by the draft. [[#1132](https://github.com/jstanden/cerb/issues/1132)]

* **[Installer]** Fixed an issue in the installer test suite that prevented the 'spatial index' requirements test from passing in Amazon Aurora MySQL 5.7.12.

* **[Records/Broadcast/Bulk]** Fixed an issue with broadcasting. If contact or organization records had a 'Record link' custom field to their same record type, a blank option showed up in the 'To:' field of the broadcast.

* **[Mail/Compose/Reply/UX]** When composing and replying to mail, the 'deliver later' option now has its own section. It defaults to collapsed for simplicity since the option is infrequently used. [[#1104](https://github.com/jstanden/cerb/issues/1104)]

* **[Mail/Compose/Reply/UX]** When composing and replying, the 'Custom fields' section is now indented to visually separate fieldsets from the other options.

* **[Preferences/Comments/UX]** Added a worker preference to disable comment formatting by default. This is found in worker Settings->Records. [[#1104](https://github.com/jstanden/cerb/issues/1122)]

* **[Login/SSO/OpenID]** Fixed an issue with single sign-on (SSO) logins using OpenID Connect. If the identity provider (IdP) didn't provide an `email` claim in the ID token, the login process was returning an HTTP `500` error.

* **[Records/Merge/UX]** When merging records, changing the target record now automatically changes the selected `name` (most records), `subject` (tickets), or `title` (tasks).

* **[Records/Merge/UX]** When merging records, the 'Updated' column now always sorts its default in descending order (most recent first). Previously, this defaulted to the updated date of the oldest ticket, which required workers to frequently change the column, or bury it further down a sorted worklist.

* **[Records/Merge/UX]** When merging ticket or task records, the 'Status' column now always sorts its default in the following order: `open`, `waiting`, `closed`, `deleted`. This has the effect of saying, "If any merged ticket is open, the final ticket is open", etc.

* **[Mail/Compose/Reply]** When composing or replying, the 'Encryption' option is now near the bottom of the form. If selected by its checkbox, it expands to reveal instructions and options. Previously, this option was near the top of the form, which confused some workers.

* **[Platform/Database]** Suppressed a misleading error about saving the worker session when the database connection is down.

* **[Records/Merge]** Fixed an issue when merging records that link to each other. Previously this resulted in a self-referencing link on the target record. Now these links are discarded. [[#1034](https://github.com/jstanden/cerb/issues/1034)]

* **[Records/Widgets]** On profiles and cards, when using 'Record Fields' widgets, the 'ID' column is now available for every record type.

* **[Records/Custom Fieldsets]** On custom fieldset cards, fixed an issue that prevented the 'Profile' button from showing up in the top toolbar.

* **[Bots/Records/UX]** In bot behaviors, the 'Record Create/Update/Upsert' actions now provide a default template for how the changeset JSON should look. [[#1035](https://github.com/jstanden/cerb/issues/1035)]

* **[Bots/Mail/Headers]** In bot behaviors on the 'Before sending' event, the 'Set header' action no longer munges linefeeds in the 'Header:' and 'Value:' templates. [[#1040](https://github.com/jstanden/cerb/issues/1040)]

* **[Bots/Behaviors/UX]** In the bot behavior action editor, the menu item now reads '(Common)' rather than '(Global)' for actions available on every event. This should resolve some confusion about what 'global' meant (programmer parlance).

* **[Mail/Compose]** When composing mail, it's possible to set watchers again. [[#1131](https://github.com/jstanden/cerb/issues/1131)]

* **[Dashboards/Prompts]** Added a new 'text' prompt to dashboard filters. This allows free-form text entry as a placeholder in widgets. [[#1133](https://github.com/jstanden/cerb/issues/1133)]

* **[Snippets/Worklists]** Fixed an issue on snippet worklists that prevented sorting on the 'My Uses' column. [[#1138](https://github.com/jstanden/cerb/issues/1138)]

* **[Mail/Snippets/Keyboard]** When composing and replying, a new `Ctrl+Shift+Period` keyboard shortcut automatically inserts the `#snippet ` text and offers autocomplete suggestions. This particular keyboard combination may change in the near future as we consolidate keyboard shortcuts to a set that doesn't interfere with common OS and browser shortcuts. [[#1136](https://github.com/jstanden/cerb/issues/1136)]

* **[Performance/Workers/Groups]** Fixed an issue with slow performance when saving worker and group editors. This had to do with recent changes to role cache invalidation, which used an inefficient strategy. [[#1139](https://github.com/jstanden/cerb/issues/1139)]

* **[Mail/Compose/Bots]** Fixed an issue with triggering 'New message received' events when composing outgoing messages.

