---
layout: post
title: "9.4.8"
excerpt: Cerb 9.4.8 is a maintenance update released in January 2020 with 7 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.4/9.4.8.png
author: The Cerb Team
date: 2020-01-17 00:00:00 -0700
permalink: /releases/9.4.8/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 7
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.4.8)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.4](/releases/9.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Mail/Comments/UX]** When composing, replying, or commenting, pasting an inline image from the clipboard now always toggles formatting on in the editor toolbar. Previously, formatting had to be enabled manually (if it wasn't already). [[#1082](https://github.com/jstanden/cerb/issues/1082)]

* **[Mail/Compose]** When composing mail, the form validation now ensures that a valid 'From:' group is selected. In rare situations, a bot behavior can modify the 'From:' field, or a worker may not have access to send from any groups. Previously, this was creating a draft for the failed message.

* **[Mail/Bots]** In 'Before message sent by worker' behaviors, fixed an issue where changing the 'send at' field affected the queue time but didn't update the saved draft. This could cause certain behaviors to endlessly reschedule the 'send at' date without ever sending the message.

* **[Mail/Bots]** When composing, 'Before message sent by worker' behaviors can now modify the 'send at' time on the outgoing message. For instance, this can enforce a review period for new messages sent by interns. Previously this was only possible when replying.

* **[Bots/Scripting]** In bot scripting, implemented a [**dict_unset()**](/docs/scripting/functions/#dict_unset) function to simplify removing items by keys from an array or object. [[#1141](https://github.com/jstanden/cerb/issues/1141)]

* **[Bots/Form Interactions]** In form interaction widgets, when using the 'Prompt with multiple choices' action, defaults can now be set for the prompt. [[#1144](https://github.com/jstanden/cerb/issues/1144)]

* **[Data Queries/Subtotals]** On `worklist.subtotals` data queries, it's now possible to group dates by `hour` (e.g. `by.count:[created@hour]`). This is still subject to result limits and should be used for fairly short intervals (e.g. up to a week). [[#1147](https://github.com/jstanden/cerb/issues/1147)]

