---
layout: post
title: "9.4.9"
excerpt: Cerb 9.4.9 is a maintenance update released in January 2020 with 12 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.4/9.4.9.png
author: The Cerb Team
date: 2020-01-28 00:00:00 -0700
permalink: /releases/9.4.9/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 12
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.4.9)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.4](/releases/9.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Time Tracking/Comments]** Fixed an issue when saving a time tracking entry. This creates a comment on the target record if it's an opportunity, task, or ticket. That comment didn't include the worker's notes.

* **[Platform/Dates]** Fixed an issue with date range filters where an expression like `big bang to -6 hours` included the entire current day without excluding the past 6 hours.

* **[Behaviors/Scheduled]** Fixed an issue with scheduled behaviors when setting a 'Record ID' behavior variable with an `_id` suffix. This was capable of blocking the scheduled behavior queue. Thanks to Ryan Bantz for reporting. [[#1162](https://github.com/jstanden/cerb/issues/1162)]

* **[Platform/Cache]** Suppressed a `chmod()` warning when another process removes a disk-based cache file before the current process has set permissions on it. This is rare, but for instance can occur during high-volume imports.

* **[Workspaces/Lists/Import]** Fixed an issue when importing workspace lists in packages and from UI exports. The legacy 'required filters' option wasn't being imported. New widgets use the query options, but the required filters could be included in packages exported from older versions.

* **[Packages/Workspaces]** Fixed an issue in packages where bundled workspaces were always created with 'Cerb' as the owner. These now utilize the given owner (e.g. role, group, worker).

* **[Records/Tickets/UX]** In ticket dictionaries, when using the `requesters` expansion key, the `id` attribute is now included in the object for each participant. Previously the ID was the array key, which complicated iteration (e.g. bot loops).

* **[Bots/Data Queries/UX]** In 'Data query datasource' bot behaviors, the 'Return data' action now has a default example of how the return format JSON should look.

* **[Profiles/Bots]** Fixed an issue on bot-powered 'custom' profile widgets. It's now possible to use key expansion on 'Record ID' behavior variables.

* **[Workspaces/Bots]** Fixed an issue on bot-powered 'custom' workspace widgets. It's now possible to use key expansion on 'Record ID' behavior variables.

* **[Data Queries/Bots]** Fixed an issue on bot-powered data query datasources. It's now possible to use key expansion on 'Record ID' behavior variables.

* **[Records/Workers]** When creating worker records from the API, the primary email address is now properly linked back to the worker. [[#963](https://github.com/jstanden/cerb/issues/963)]

