---
layout: post
title: "9.4.11"
excerpt: Cerb 9.4.11 is a maintenance update released in February 2020 with 22 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.4/9.4.11.png
author: The Cerb Team
date: 2020-02-12 00:00:00 -0700
permalink: /releases/9.4.11/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 22
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.4.11)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.4](/releases/9.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Records/Mailboxes]** On mailbox worklists, added an `enabled:` filter. [[#1177](https://github.com/jstanden/cerb/issues/1177)]

* **[Records/Mailboxes]** On mailbox worklists, added a `fail.count:` filter. [[#1176](https://github.com/jstanden/cerb/issues/1176)]

* **[Bots]** In bot behaviors, conditions based on addresses may now use the 'Host' field.

* **[Data Queries/Subtotals]** Fixed an issue with `type:worklist.subtotals` data queries using `format:dictionaries` and more than one `by:` field. The labels weren't being returned properly. [[#1183](https://github.com/jstanden/cerb/issues/1183)]

* **[Records/Snippets]** On snippet records, the `usableBy.worker:` filter may now use the relative expression `me` for the current worker.

* **[Mail/Snippets]** When composing and replying, the `#snippet` command now properly filters snippets to only those usable by the current worker. [[#1180](https://github.com/jstanden/cerb/issues/1180)]

* **[Platform/PHP]** Cerb 9.4.x will refuse to run on PHP 7.4 due to compatibility issues with some dependencies. This is remedied in the upcoming Cerb 9.5 release.

* **[Snippets/Bots]** Snippets can now be created for bot records. This is useful in behaviors when using the 'Set snippet placeholder' action, as targeting the current bot allows for scripting. This wasn't possible when using plaintext snippets. [[#1187](https://github.com/jstanden/cerb/issues/1187)]

* **[Records/Search]** Fixed an issue with record search queries where autocomplete suggestions weren't provided for values that had whitespace in them. For instance, `group:(name:` wouldn't suggest "Human Resources". [[#1185](https://github.com/jstanden/cerb/issues/1185)]

* **[Records/Search/UX]** Improved the usability of record search queries when suggestions contained quoted values. Often extra quotes would be added. Now when an autocomplete suggestion is selected, quotes are intelligently handled. If autocompleting within quotes (e.g. `name:""`), the inserted text won't be wrapped in quotes. If autocompleting in an empty filter expression (e.g. `name:`), inserted text with whitespace will be wrapped in quotes. If autocompleting into a leading quote (e.g. `name:"`) then only a trailing quote will be added.

* **[Records/Search/UX]** In record search queries, autocomplete suggestions are no longer case-sensitive.

* **[Records/Tickets]** Added a `participants` expansion key to ticket records. This returns a list of participant email addresses which also supports key expansion (e.g. email->contact->org). [[#1193](https://github.com/jstanden/cerb/issues/1193)]

* **[Cards/Widgets/Conversation]** On cards, 'conversation' widgets now properly check group rosters when viewing ticket conversations. Thanks to [@beatbesmer](https://github.com/beatbesmer) for the report.

* **[Bots/Scripting]** In bot scripting, the `array_diff()` and `array_intersect()` functions now properly deal with null values as either argument. These are treated as empty arrays. Thanks to [@mryanb](https://github.com/mryanb) for reporting. [[#1200](https://github.com/jstanden/cerb/issues/1200)]

* **[Records/Workers/UX]** Fixed an issue with worker records where first and last names could have leading/trailing whitespace. This affected search filters (e.g. `watchers:`) and worklist sorting. [[#1179](https://github.com/jstanden/cerb/issues/1179)]

* **[Records/Bulk/Behaviors]** Fixed an issue with bulk update where only changing custom fields didn't trigger 'Record changed' behaviors. Thanks to [@mryanb](https://github.com/mryanb) for reporting. [[#1203](https://github.com/jstanden/cerb/issues/1203)]

* **[Mail/Compose/Reply]** Fixed an issue when composing and replying. If an email address started with a number then it wasn't autocompleted in `To:`/`Cc:`/`Bcc:`.

* **[Records/Buckets]** On bucket profiles and cards, the 'Send from', 'Send as', 'Template', and 'Signature' fields are now available.

* **[Worklists/Search]** Improved an inefficiency with some worklist query filters. If the field didn't provide suggestions, the server was still being checked for suggestions on new keystrokes. This reduces extraneous network traffic.

* **[Records/Bulk/Custom Fields]** Fixed an issue with worklists when bulk updating to set new custom fields. If the fields were part of a new fieldset, it wasn't linked to the record, but the values were properly set. [[#770](https://github.com/jstanden/cerb/issues/770)]

* **[Records/Worklists/Bulk]** Fixed an issue with bulk update on record worklists. It was not possible to set 'Record Links' custom fields. They could be selected but the values weren't saved. Thanks to [@mryanb](https://github.com/mryanb) for reporting. [[#1204](https://github.com/jstanden/cerb/issues/1204)]

* **[Bots/Data Queries]** On bot-powered data query types, the `format:` preference is now passed to the behavior as the `query_format` placeholder. The selected `format` is also returned in the results metadata, which allows them to be used in widgets that require a specific format (e.g. charts). Thanks to [@beatbesmer](https://github.com/beatbesmer) for the suggestion. [[#1208](https://github.com/jstanden/cerb/issues/1208)]

