---
layout: post
title: "9.5.3"
excerpt: Cerb 9.5.3 is a maintenance update released in April 2020 with 16 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.5/9.5.3.png
author: The Cerb Team
date: 2020-04-13 00:00:00 -0700
permalink: /releases/9.5.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 16
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.5.3)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.5](/releases/9.5/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[API/Mail/Compose]** Fixed an issue with the `/tickets/compose.json` endpoint in the API. When using the `send_at` option, the draft record wasn't being returned. [[#1257](https://github.com/jstanden/cerb/issues/1257)]

* **[Records/Tickets]** When composing tickets, the "Send later" option now returns the new draft record above the worklist. Previously, only new tickets were returned.

* **[Workers/Mentions]** Fixed an issue with worker mention nicknames, where dots were allowed in the field, but not recognized when detecting `@mentions` in text.

* **[Workers/Mentions]** When editing worker records, the mention nickname is now validated more strictly. Previously, disallowed characters (e.g. spaces) were being automatically converted to dashes. This could lead to a mismatch with user expectations. Now, an error is displayed with a description of allowed characters.

* **[API/Sessions]** Fixed an issue with the REST API where many abandoned sessions could be created in a short amount of time. This could eventually cause issues with logins and functionality that calculated active sessions, like the watchers popup.

* **[API/Tickets]** Fixed an issue with the `/tickets/compose.json` endpoint in the REST API. When using PHP 7.2 (rather than 7.3+), the `send_at` option didn't return the draft. Thanks to [@beatbesmer](https://github.com/beatbesmer) for the report. [[#1260](https://github.com/jstanden/cerb/issues/1260)]

* **[Storage/S3]** Fixed an issue with S3-based storage profiles. The tester wasn't returning errors due to a change in the underlying library. Thanks to [@ksuther](https://github.com/ksuther) for the report.

* **[Workspaces/Tabs/UI]** Fixed an issue on workspace pages where dragging tabs didn't save the new order.

* **[Webhooks]** Fixed an issue with creating new webhook listeners. Thanks to [@mryanb](https://github.com/mryanb) for the report.

* **[Bots/Export]** Fixed an issue when exporting a bot that contained an empty behavior tree. It wasn't possible to reimport these packages without editing them. [[#1261](https://github.com/jstanden/cerb/issues/1261)]

* **[Storage/S3]** Fixed an issue with S3 storage profiles when receiving HTTP/2 responses from endpoints (e.g. S3-compatible Google Storage). Thanks to [@ksuther](https://github.com/ksuther) for the patch.

* **[Database/MySQL]** Fixed an error when installing/upgrading past the 9.0 update when using MySQL 8.0.

* **[Worklists/Bulk]** Fixed an issue with the bulk update feature when using MySQL 8.0. There was a user variable named `@rank` which conflicted with the new `RANK()` SQL function.

* **[Bots/Scripting]** Implemented a `cerb_extract_uris()` function in bot scripting. This returns an array of URLs found in HTML content, along with metadata (e.g. tag, attributes, URI parts). The URLs can be rewritten and then substituted with the `|replace()` filter.

* **[Tickets/Profiles/Packages]** On ticket profiles, added a 'Draft Generator' widget to the library. This form interaction widget uses a bot behavior to create drafts for various situations as the current worker and then open the reply popup immediately for editing. It is fully customizable by admins. This is far more capable than snippets, since beyond message content, defaults can also be provided for the group/bucket, status/reopen, custom fields, formatting, attachments, send later, and more.

* **[Groups]** Fixed an issue when editing the 'Send As' field on group records. The template editor tester wasn't displaying output. [[#1264](https://github.com/jstanden/cerb/issues/1264)]


