---
layout: post
title: "9.5.4"
excerpt: Cerb 9.5.4 is a maintenance update released in April 2020 with 12 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.5/9.5.4.png
author: The Cerb Team
date: 2020-04-20 00:00:00 -0700
permalink: /releases/9.5.4/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 12
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.5.4)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.5](/releases/9.5/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Mail/UX]** When replying to mail, the `#delete_quote_from_here` command now deletes the rest of the current line from the cursor, regardless of whether it begins with a `>` or not. The rest of the lines are filtered as before. This makes it easier to trim entire quoted blocks including the "Contact wrote:" heading, as well as partially quoting a longer line.

* **[Mail/Snippets]** When composing and replying, the `#snippet` command can now be used in the middle of a line. Previously this removed all of the text on the current line. For instance, you can type "Our phone number is" and then `#snippet phone` to complete the sentence. [[#1226](https://github.com/jstanden/cerb/issues/1226)]

* **[Mail/Snippets]** Pasting a snippet no longer forces a newline at the end of the text. If the snippet contains one or more trailing newlines they will be preserved as-is. A snippet without a trailing newline will paste inline with the cursor at the end of the text. [[#1053](https://github.com/jstanden/cerb/issues/1053)]

* **[Bots/Scripting]** Added a `|markdown_to_html` filter to [bot scripting](/docs/scripting/). This converts Markdown formatting into HTML, which is particularly useful in profile custom widgets when dealing with data from remote APIs.

* **[Worklists/Behaviors]** On scheduled behavior worklists, the `behavior:` filter is now capable of deep searching. Previously this just matched the name field on behaviors. Thanks to [@mryanb](https://github.com/mryanb) for the suggestion.

* **[Mail/Snippets]** When composing and replying, fixed an issue in some browsers where the Ctrl+Shift+Period shortcut inserted the `#snippet` command but didn't open the autocomplete menu.

* **[Mail/Snippets]** When composing and replying, fixed an issue when inserting a long snippet where the new cursor location wasn't visible in the textarea if scrolling down was required. This scrolling now happens automatically. [[#958](https://github.com/jstanden/cerb/issues/958)]

* **[Mail/Images/UX]** When composing, replying, or commenting, and inserting an image from the formatting toolbar, the cursor is now properly focused at the end of the inserted image text.

* **[Bots/Mail/Relay]** In bot behaviors that relay mail to workers' personal email accounts, the `From:` address is now a ticket's group rather than the default sender. This makes it easier for workers to filter noteworthy messages and set up notifications. [[#1265](https://github.com/jstanden/cerb/issues/1265)]

* **[Cards/Widgets]** Fixed an issue with configuring 'Record Fields' card widgets when more than one card of the same record type was open.

* **[Developers/Platform/Javascript]** Fixed an issue in the `Devblocks.objectToFormData()` helper. This wasn't properly handling primitives in deeply nested arrays.

* **[Developers/Platform/Devblocks]** Added an `indentWith()` method to the Devblocks strings library. This prefixes lines of text with an arbitrary marker.

