---
layout: post
title: "9.5.6"
excerpt: Cerb 9.5.6 is a maintenance update released in May 2020 with 17 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.5/9.5.6.png
author: The Cerb Team
date: 2020-05-22 00:00:00 -0700
permalink: /releases/9.5.6/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 17
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (9.5.6)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.5](/releases/9.5/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Plugins/Twitter]** On Twitter message worklists, fixed an issue with the 'close' action button. Thanks to [@ksuther](https://github.com/ksuther) for the report. [[#1284](https://github.com/jstanden/cerb/issues/1284)]

* **[Bots/Behaviors]** Fixed an issue with the 'Set placeholder using snippet' action in bot behaviors. The popup was stuck showing 'Loading...' and the snippet wasn't selectable. Thanks to [@iammattmartin](https://github.com/iammattmartin) for the report and verifying the fix.

* **[Profiles/Watchers/UX]** On profile pages, a new `Shift+W` keyboard shortcut quickly toggles the current worker as a watcher of the current record. This was also possible with Shift+Click on the button, but required the use of the mouse. Thanks to [@flexibits](https://twitter.com/flexibits) for the suggestion. 

* **[Mail/Reply]** Fixed an issue when replying to mail. It wasn't possible to set custom fieldsets on the ticket if there weren't already custom fields at the record level. [[#1286](https://github.com/jstanden/cerb/issues/1286)]

* **[Bots/Behaviors/Mail]** Fixed an obscure issue when using the 'Send email to recipients' action in ticket- and message-based bot behaviors. If a 'Before sending mail' behavior existed, this was initializing several empty properties on the draft (e.g. status, owner, to/cc). The empty status property was being interpreted as 'open', which could re-open previously closed tickets after auto-replying. Thanks to [@iammattmartin](https://github.com/iammattmartin) for the report and debugging assistance.

* **[Records/Contacts/Bulk]** When bulk updating contact worklists, the `gender` field can now also be unset. [[#1296](https://github.com/jstanden/cerb/issues/1296)]

* **[Records/Workers/Bulk]** When bulk updating worker worklists, the `gender` field can now also be unset. [[#1296](https://github.com/jstanden/cerb/issues/1296)]

* **[Mail/Compose/Templates]** When composing mail with formatting enabled, it's again possible to select a specific mail layout/template to use. Previously this was only using the group/bucket default. [[#1298](https://github.com/jstanden/cerb/issues/1298)]

* **[Mail/Reply/Templates]** When replying to mail with formatting enabled, it's again possible to select a specific mail layout/template to use. Previously this was only using the group/bucket default. [[#1298](https://github.com/jstanden/cerb/issues/1298)]

* **[Data Queries/Metrics]** In `worklist.metrics` data queries, `format:pie` is now available to prepare data for pie/donut chart widgets.

* **[Plugins/Twitter]** In the Twitter plugin, when responding to tweets, the character count is now displayed numerically rather than as a percentage. This also resolves inconsistencies with the 280 character limit. Thanks to [@flexibits](https://github.com/flexibits/) for the request. [[#1300](https://github.com/jstanden/cerb/issues/1300)]

* **[Support Center/Mail]** In the Support Center, it's now possible for clients to attach more than one file when replying through the portal. Thanks to [@mediafly](https://github.com/mediafly/) for the report. [[#1305](https://github.com/jstanden/cerb/issues/1305)]

* **[Bots/Packages]** In the bot behavior package library, the 'Auto-Reply' example now filters out messages from `mailer-daemon@` and `postmaster@`. This helps avoid mail loops on bounces.

* **[Cards/Widgets/Sheets]** On cards, fixed an issue where two opened card popups of the same type prevented sheet widgets from paging.

* **[Platform/Choosers]** When widgets open a chooser, it's now possible to override the displayed columns on the worklist. The chooser trigger should contain a `data-worklist-columns` attribute with a comma-separated list of worklist column IDs from: <https://cerb.ai/docs/records/types/>. Thanks to [@agilebits](https://github.com/agilebits) for the suggestion.

* **[Mail/Encryption]** When receiving PGP encrypted messages, fixed an issue with senders using Outlook/OpenPGP where messages weren't automatically decrypted due to subtle differences in the message format. [[#1307](https://github.com/jstanden/cerb/issues/1307)]

* **[API/OAuth/Developers]** In Setup->Developers->OAuth2 Token Generator, it's now possible to set the lifespan of the access token. Previously this was always `1 hour`. This makes it easier to use long-lived tokens in automated scripts.

