---
layout: post
title: "9.5.9"
excerpt: Cerb 9.5.9 is a maintenance update released in July 2020 with 8 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.5/9.5.9.png
author: The Cerb Team
date: 2020-07-30 00:00:00 -0700
permalink: /releases/9.5.9/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 8
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" alt="9.5.9" width="500">
</div>

**Cerb (9.5.9)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.5](/releases/9.5/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Classifiers]** Fixed an issue with classifier training examples that contained HTML tags. These were not being properly escaped when labeling.

* **[Form Interactions/UX]** In form interaction behaviors, when using the 'Prompt with record chooser' action with the 'worker' record type, the 'me' shortcut is now displayed for quick selection by the current worker.

* **[Records/Logs]** Fixed an issue with logging deletions in the activity log on 'email template' records.

* **[Mail/Attachments]** Fixed an issue with 'message/rfc822' attachments (`.eml`) sent from Cerb. Some clients reported these were blank when opened in Outlook. By default, attachments are base64-encoded, but this is not allowed by the RFC-2822 for attached messages. As a workaround, we save these attachments as `application/octet-stream` so the receiving email client can make a decision based on the file extension instead. This worked when testing in Outlook and Thunderbird. Ideally we would treat `message/rfc822` attachments as text, but this requires upstream changes to the Swiftmailer library.

* **[Records/Subtotals/UX]** On the worklist subtotals sidebar, increased the truncation threshold from 25 characters to 32. This shows a bit more of a long record name before adding "`...`". 

* **[Mail/HTML]** Fixed an issue with composing and replying to email with formatting enabled, where certain links (e.g. those with nested brackets in their label) could be unexpectedly rewritten or broken in the plaintext part. This is a stopgap that's properly fixed in 9.6, where we preserve the Markdown formatting as the plaintext part.
 
* **[Mail/HTML]** Fixed an issue in composing and replying email with formatting enabled, where the preview feature didn't display the selected mail template.

* **[Records/Tickets/Bulk/Broadcast]** Fixed an issue with broadcasting replies from bulk update on ticket worklists. Non-admin workers could fail a permissions check even when they had the 'Ticket: Broadcast' privilege in their role.