---
layout: post
title: "9.5.10"
excerpt: Cerb 9.5.10 is a maintenance update released in August 2020 with 11 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.5/9.5.10.png
author: The Cerb Team
date: 2020-08-05 00:00:00 -0700
permalink: /releases/9.5.10/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 11
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" alt="9.5.10" width="500">
</div>

**Cerb (9.5.10)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.5](/releases/9.5/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Sheets]** Fixed a bug in sheets. When using a `date` column with a custom `format:` parameter, blank dates were displaying as the Unix epoch (1-Jan-1970 UTC). These are now always blank. Thanks to [@mryanb](https://github.com/mryanb) for the report.

* **[Records/API]** In the records API, when creating a `ticket` record, it's now possible to only set the `group_id` and have the default `bucket_id` discovered automatically. Previously it was possible to only provide a `bucket_id` and have the `group_id` auto-discovered.

* **[Email/Parser]** Fixed an issue where invalid email addresses could be added with certain invalid characters (e.g. Unicode zero-width spaces) which prevented delivery. [[#1349](https://github.com/jstanden/cerb/issues/1349)]

* **[Records/Contacts]** When creating contact records, the `org` field is now an alternative to `org_id`. The new field allows the organization name to be specified as text. It will match an existing org or create a new one.

* **[API/Bots]** When running custom bot behaviors through the API, a behavior can now be requested by its URI alias rather than ID. [[#1279](https://github.com/jstanden/cerb/issues/1279)]

* **[Worklists/UX]** When adding records to a worklist, the "New record created:" link in the marquee above the list now allows opening the record in a new tab by shift-clicking. Normal clicks still open a record's card popup. [[#1331](https://github.com/jstanden/cerb/issues/1331)]

* **[Project Boards/Behaviors]** Fixed an issue with adding behaviors to project board columns. Thanks to [@beatbesmer](https://github.com/beatbesmer) for the report. [[#1271](https://github.com/jstanden/cerb/issues/1271)]

* **[Records/Behaviors/Search]** When searching behavior worklists, the `uri:` filter suggests autocompletions.

* **[Form Interaction/Prompts]** On form interaction widgets using the 'Prompt with single choice' action, the default value is now properly selected for the 'Buttons' style. Thanks to [@beatbesmer](https://github.com/beatbesmer) for the report. [[#1293](https://github.com/jstanden/cerb/issues/1293)]

* **[Mail/Transports]** When testing mail transport records, the SMTP connection timeout is 10 seconds rather than the configured value (e.g. 30 seconds). This prevents unnecessarily long waits. [[#1326](https://github.com/jstanden/cerb/issues/1326)]

* **[Mail/Compose]** When composing mail, the 'Organization:' field is now properly used to set the org on the created ticket, regardless of the participants (and when there are none). It worked this way prior to 9.5.0. [[#1267](https://github.com/jstanden/cerb/issues/1267)]
