---
layout: post
title: "9.6.1"
excerpt: Cerb 9.6.1 is a maintenance update released in August 2020 with 8 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.6/9.6.1.png
author: The Cerb Team
date: 2020-08-17 10:00:00 -0700
permalink: /releases/9.6.1/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 8
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" alt="9.6.1" width="500">
</div>

**Cerb (9.6.1)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.6](/releases/9.6/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Bots/Behaviors/Loops]** Fixed an issue in bot behavior loop nodes. When an iterator was zero (`0`) the loop repeated infinitely (until PHP timeout). Thanks to [@mryanb](https://github.com/mryanb) for the report. [[#1353](https://github.com/jstanden/cerb/issues/1353)]

* **[Mail/IMAP]** Fixed an issue with some non-standard IMAP mail servers. The new IMAP library used a feature (`UID SEARCH NOT`) that wasn't supported on these servers, which prevented downloaded messages from being deleted. The same messages could be duplicated on the next mailbox check. This wasn't an issue with IMAP on Gmail or Exchange/O365 (nor with POP3).

* **[Mail/HTML]** Fixed an issue when processing email messages with malformed HTML parts and no text part. For instance, it was possible for a message to fail if there was a `<BLOCKQUOTE>` at the top-level with no parent (normally at least `<BODY>`). A client-provided sample closed `</BODY></HTML>` before a blockquote element. This failed the message and left the parser scheduled job in a locked state that temporarily delayed other incoming mail.

* **[Profiles/Tickets/UX]** On ticket profiles, the "There are messages without a response" warning is now shorter and only links to the first message of the sequence. The warning can also be targeted with the `.cerb-conversation--new-messages-warning` CSS selector in the custom stylesheet to hide it. [[#1356](https://github.com/jstanden/cerb/issues/1356)]

* **[Records/Search/Orgs]** When searching organization records, new filters are available for `ticket.id:` and `tickets:`. These return organizations with matching tickets assigned to them. [[#1354](https://github.com/jstanden/cerb/issues/1354)]

* **[Cards/Profiles/Choosers]** Fixed an issue on card popups and profiles where nested editors could refresh prematurely and lose other changes. For instance, if you edited a ticket then added or edited a participant in a second popup editor, the ticket popup would close after the participant was saved. This was caused by a recent change for refreshing sheets.

* **[Workspaces/Widgets/Interactions]** Fixed an issue with workspace interaction widgets not refreshing other widgets when specified by name.

* **[UI/Styles]** Added CSS selectors to make it easier to style comment threads on profiles.

