---
layout: post
title: "9.6.2"
excerpt: Cerb 9.6.2 is a maintenance update released in August 2020 with 20 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/9.6/9.6.2.png
author: The Cerb Team
date: 2020-08-21 12:00:00 -0700
permalink: /releases/9.6.2/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 20
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" alt="9.6.2" width="500">
</div>

**Cerb (9.6.2)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [9.6](/releases/9.6/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Mail/Signatures]** Fixed an issue where the `#signature` command wasn't replaced in compose/reply if a 'Before message sent by worker' behavior appended content immediately following it. Thanks to [@mryanb](https://github.com/mryanb) for the report! [[#1363](https://github.com/jstanden/cerb/issues/1363)]

* **[Records/Custom Fields]** Fixed an issue with displaying labels for message records targeted by 'record link' custom fields.

* **[Mail/Signatures/HTML]** Fixed an issue with editing HTML email signatures where uploading a new image from the editor toolbar didn't insert the `![inline-image]` text. [[#1365](https://github.com/jstanden/cerb/issues/1365)]

* **[Dashboards/Bots]** In bots, 'Dashboard render widget' behaviors now have access to placeholders for the current worker.

* **[Platform/Dates]** Fixed a potential infinite loop with date range interpolation (`dateLerpArray`) when using an unknown time unit (e.g. translated 'days' or 'months').

* **[Data Queries/Subtotals]** Fixed an issue with `worklist.subtotals` [data queries](/docs/data-queries/worklist/subtotals/) where using the `group:` roll-up option prevented `format:timeseries` from being plotted as a single series.

* **[Workspaces/Dashboards]** In workspace dashboards, 'Bot Custom' widgets configuration now has placeholders for the current worker and widget.

* **[Data Queries/Subtotals]** In `worklist.subtotals` [data queries](/docs/data-queries/worklist/subtotals/), date fields can now be [grouped](/docs/data-queries/worklist/subtotals/#date-histograms) by `@hourofday` (e.g. `23:00`). Thanks to [1Password](https://1password.com/) for the feature request.

* **[Data Queries/Subtotals]** In `worklist.subtotals` [data queries](/docs/data-queries/worklist/subtotals/), date fields can now be [grouped](/docs/data-queries/worklist/subtotals/#date-histograms) by `@dayofmonth` (e.g. `31`).

* **[Data Queries/Subtotals]** In `worklist.subtotals` [data queries](/docs/data-queries/worklist/subtotals/), date fields can now be [grouped](/docs/data-queries/worklist/subtotals/#date-histograms) by `@dayofweek` (e.g. `Wednesday`).

* **[Data Queries/Subtotals]** In `worklist.subtotals` [data queries](/docs/data-queries/worklist/subtotals/), date fields can now be [grouped](/docs/data-queries/worklist/subtotals/#date-histograms) by `@monthofyear` (e.g. `December`).

* **[Data Queries/Subtotals]** In `worklist.subtotals` [data queries](/docs/data-queries/worklist/subtotals/), date fields can now be [grouped](/docs/data-queries/worklist/subtotals/#date-histograms) by `@weekofyear` (e.g. `52`).

* **[Data Queries/UX]** In `worklist.subtotals` [data queries](/docs/data-queries/worklist/subtotals/), the available [histogram options](/docs/data-queries/worklist/subtotals/#date-histograms) for date fields (e.g. `@hourofday`) now autocomplete in the editor.

* **[Records/Tasks]** Implemented autocomplete functionality for task records when used in 'Record Link' custom fields.

* **[Records/Search/Dates]** Added a new `month:` filter to [advanced date filters](/docs/search/#dates); e.g. `created:(months:Jan,Dec)`

* **[Records/Search/Dates]** Added a new `weeks:` filter to [advanced date filters](/docs/search/#dates); e.g. `created:(weeks:1,26,52)`. This uses Sunday-based weeks of the year.

* **[Records/Search/Dates]** Added a new `dom:` filter to [advanced date filters](/docs/search/#dates) for matching by day of the month (e.g. `1` to `31`).

* **[Mail/HTML]** In HTML mail templates, there are now placeholders for `message_id_header`, `group_id`, `group__label`, `bucket_id`, and `bucket__label`. This makes it easier to customize mail templates based on characteristics of the outgoing message. The `message_id_header` placeholder can be used to create links that refer to the message (e.g. satisfaction surveys). The template editor can insert placeholders from the toolbar.

* **[Mail/HTML]** When creating a new HTML mail template, the default content covers more styles.

* **[Mail/HTML]** In HTML mail templates, the preview action now has a more complete example of styles.

