---
layout: post
title: "10.0.1"
excerpt: Cerb 10.0.1 is a maintenance update released in May 2021 with 13 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/10.0/10.0.1.png
author: The Cerb Team
date: 2021-05-26 00:00:00 -0800
permalink: /releases/10.0.1/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 13
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" alt="10.0.1" width="500">
</div>

**Cerb (10.0.1)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.0](/releases/10.0/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Portals/Webhooks]** On webhook portals, requests are now handled with `webhook.respond` automations. Behaviors are still supported through 10.x but should be migrated to automations.

* **[Mail/Templates]** On mail HTML templates, a new `message_token` placeholder is now available. The placeholder value is a unique token on the draft that is synchronized with the eventual message once delivered. This makes it much easier to implement links that securely refer back to a specific message.

* **[Automations/Help]** In the automations editor, when using the 'Trigger:' chooser interaction, the sheet now contains a description for each trigger.

* **[Automations]** Fixed an issue on the automation editor when using the 'Trigger:' chooser interaction where filtering the sheet didn't work.

* **[Records/Drafts]** In draft record dictionaries, the `type` key is now available (`mail.compose`, `mail.transactional`, `ticket.reply`, `ticket.forward`).

* **[Records/Drafts]** In draft record dictionaries, the `params` key is now available. This contains all of the draft parameters based on the type. See: <https://cerb.ai/docs/records/types/draft/>

* **[Automations]** In automations, the `var.expand:` command no longer requires a `key:` input. When omitted, key expansion happens in the root dictionary.

* **[Mail/Reply]** Fixed an issue with the compose and reply editors where a `To:`, `Cc:`, or `Bcc:` with a symbol like `#` returned an error. Thanks to [@mryanb](https://github.com/mryanb) for the bug report! [[#1456](https://github.com/jstanden/cerb/issues/1456)]

* **[Toolbars/Help]** In toolbar editors, the help button now provides a full reference for: placeholders, inputs, output, and `after:` options.

* **[Resources/Storage]** Fixed an issue when deleting 'Resource' records where the underlying storage object wasn't removed.

* **[Automations/Log]** In automations, fixed an issue with the `log:` command where an error was returned if the log message was empty. The command is now just ignored in that situation.

* **[Website Interactions]** On website interactions, improved how the `form:title:` is escaped. This fixed an issue where some special characters were escaped as HTML entities.

* **[Website Interactions/UX]** In the automation editor for website interactions, autocompletion is now provided for `await:form:elements:text:`, and `await:form:elements:textarea:`.

