---
layout: post
title: "10.0.2"
excerpt: Cerb 10.0.2 is a maintenance update released in June 2021 with 8 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/10.0/10.0.2.png
author: The Cerb Team
date: 2021-06-01 00:00:00 -0800
permalink: /releases/10.0.2/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 8
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" alt="10.0.2" width="500">
</div>

**Cerb (10.0.2)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.0](/releases/10.0/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Profiles/Interactions]** Fixed an issue with 'Interaction Toolbar' profile widgets when using the legacy behaviors format. This was failing to pass the `inputs:` to the behavior.

* **[Behaviors/Mail]** Temporarily restored the 'Before composing a new message' (`event.mail.compose.pre.ui.worker`) behavior event. This will be replaced with automations in the 10.1 update.

* **[Behaviors/Mail]** Temporarily restored the 'Before composing a message reply' (`event.mail.reply.pre.ui.worker`) behavior event. This will be replaced with automations in the 10.1 update.

* **[Records/Interactions]** Fixed an issue with 'Interaction Toolbar' widgets on cards, profiles, and workspaces. When displaying legacy behaviors, a PHP notice could be logged if there was a trailing item in the YAML list of behaviors.

* **[UI]** Fixed a visual issue on split buttons (e.g. 'Reply') where the right side didn't line up properly.

* **[Bots/Reminders]** Fixed an issue with the 'Create Reminder' action in legacy bot behaviors. This failed to create the record because it referenced an old field for specifying the behaviors to run. These now always use the built-in notification action.

* **[Profiles/Bots]** On record profiles, deprecated chat bot behaviors are now appended to the end of the toolbar in a '...' menu. This makes it easier to transition them to interaction automations over time without immediately interrupting existing workflows. Chat bots will be removed in v11.0 in favor of automations.

* **[Reminders/UX]** Reminders functionality has been simplified. In 10.0, reminder records had automations attached to them for notification methods. Prior to 10.0, reminder records had behaviors attached to them. Neither of these approaches was easy for workers to understand. Now, when a reminder reaches its deadline, it triggers the `reminder.remind` automation event. The KATA on the event can use attributes of the reminder and the worker to determine the notification methods. A multi-checkbox custom field on reminder records, or custom fieldsets, can be used to describe alternative notification methods (e.g. email, text message, phone, Slack). This can be easily customized for each environment. By default, all reminders generate a notification in Cerb.

