---
layout: post
title: "10.0.3"
excerpt: Cerb 10.0.3 is a maintenance update released in June 2021 with 8 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/10.0/10.0.3.png
author: The Cerb Team
date: 2021-06-07 00:00:00 -0800
permalink: /releases/10.0.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 8
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" alt="10.0.3" width="500">
</div>

**Cerb (10.0.3)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.0](/releases/10.0/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Automations/Scripting]** Added an `|append(suffix, delimiter, trim)` filter to automation scripting. In its simplest usage, it appends a `suffix` to the current text. An optional `delimiter` argument will be added between the current text and the suffix, only if the current text is non-empty. An optional `trim` argument is used to remove characters from the end of the current value (e.g. dangling commas), and when omitted the trim is set to the same value as the delimiter. This makes it much simpler to append to comma-separated lists without requiring extra scripting logic.

* **[Automations/Events]** Fixed an issue with Automation Event records that prevented 'Record Fields' card and profile widgets from working properly.

* **[UI/Dates]** When generating a human-readable duration (e.g. "2 hours, 5 mins"), fixed an issue that could generate text like "1 year 12 months" because "month" is an imprecise measurement (30 days? 365/12 days?).

* **[Records/Drafts]** Draft dictionaries of type `ticket.reply` can now expand the `ticket_` key for data about the ticket being replied to.

* **[Custom Fieldsets/Roles]** Fixed an issue with creating custom fieldsets as a non-admin worker. Thanks to [@baknight1975](https://github.com/cerb/cerb-release/discussions/32) for the report!

* **[Records/Search]** Fixed an issue in record search queries when using the `OR` operator with an unknown filter name. Thanks to [@mryanb](https://github.com/mryanb) for reporting.

* **[Interactions/Sheets]** In interaction automations, fixed an issue with paging sheet elements that have no name.

* **[Automations/Usability]** When opening the automation editor from a `cerb:` URI link (e.g. from a toolbar or event), if the automation doesn't exist the name will be pre-filled in the creation editor.

