---
layout: post
title: "10.0.4"
excerpt: Cerb 10.0.4 is a maintenance update released in June 2021 with 10 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/10.0/10.0.4.png
author: The Cerb Team
date: 2021-06-22 00:00:00 -0800
permalink: /releases/10.0.4/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 10
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" alt="10.0.4" width="500">
</div>

**Cerb (10.0.4)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.0](/releases/10.0/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Toolbars/UI]** Fixed custom toolbar alignment issues on card popups.

* **[Toolbars/UI]** In custom toolbars, improved the style on split buttons above code editors to be consistent.

* **[Automations]** Fixed an issue with `text:type:bool` inputs in automations. A `default:yes` parameter always overwrote an explicit `false` value if `default@bool: yes` was used. The input was expecting text rather than a boolean. Thanks to [@mryanb](https://github.com/mryanb) for reporting!
  
* **[Records/Search]** Fixed an issue with record link filters when using the `recordLink.id:123` variation. The matching record label was only displayed if the record type had a `name` field. This now uses dictionaries for the uniform `_label` field. Thanks to [@mryanb](https://github.com/mryanb) for reporting!

* **[Records/Dictionaries/Custom Fields]** In record dictionaries, 'Record Link' custom field URIs now properly support key expansion. For instance, {% raw %}`{{ticket.testFieldset_recordLink__label}}`{% endraw %}. Thanks to [@mryanb](https://github.com/mryanb) for reporting!

* **[Cards/Toolbars]** On `record.card` toolbars, the `after:close@bool: yes` option may now close the card popup when the interaction finishes. Thanks to [@mryanb](https://github.com/mryanb) for the feature request!

* **[Worklists/Subtotals]** On worklist subtotals, fixed an issue when grouping by a 'Record Link' custom field. This wasn't showing the default '(no data)' category.

* **[Worklist/Subtotals]** Fixed an issue with subtotals on ticket worklists. When totaling by 'Group' or 'Bucket', blank categories were added for tickets with an invalid group.

* **[Search/Tickets]** Fixed an issue with search filter autocompletion suggestions on ticket worklists when using PHP8. Thanks to [@passmark](https://github.com/passmark) for the report!

* **[Automations/Scripting]** In automation scripting, added a new `array_count_values()` function. This takes an array of values as input, and returns an array with distinct values as keys and their count of occurrences. This function only works on arrays of strings or numbers. Thanks to [1Password](https://1password.com/) for the feature request!

