---
layout: post
title: "10.0.5"
excerpt: Cerb 10.0.5 is a maintenance update released in July 2021 with 9 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/10.0/10.0.5.png
author: The Cerb Team
date: 2021-07-21 00:00:00 -0800
permalink: /releases/10.0.5/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 9
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" alt="10.0.5" width="500">
</div>

**Cerb (10.0.5)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.0](/releases/10.0/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Connected Accounts]** In connected account records, the 'URI' field now clearly allows dots. Thanks to [@mryanb](https://github.com/mryanb/) for reporting the inconsistency!

* **[Automations]** Fixed an issue in automations using the `log:` command, when the message used scripting and evaluated to a blank message. This was still returning an error for 'A log message is required.' when the command should have just been ignored.

* **[Tickets/Attachments]** Fixed an issue on ticket profiles for messages and comments. When opening the attachment menu, clicking on the 'Download' text did nothing, while clicking in whitespace in the same row did. [[#998](https://github.com/jstanden/cerb/issues/998)]

* **[Automations/Help]** In the Automation Event editor, the help link now properly points to the documentation. [[#1451](https://github.com/jstanden/cerb/issues/1451)]

* **[Bots/Behaviors]** In bot behaviors, fixed an issue on the 'Schedule behavior' action when the targeted behavior is missing. Previously, this automatically selected the first option in the list, which could cause people to mistakenly save with a new target. Now, the list allows a blank selection. Thanks to [@mryanb](https://github.com/mryanb) for the report! [[#1480](https://github.com/jstanden/cerb/issues/1480)]

* **[Support Center/Knowledgebase]** In the Support Center, the knowledgebase RSS feeds now use the `application/rss+xml` MIME type. [[#742](https://github.com/jstanden/cerb/issues/742)]

* **[Pages]** Fixed an issue with workspace pages where a worker without access to a role-owned page would see a blank page or a single empty tab. This now displays a more helpful error. [[#965](https://github.com/jstanden/cerb/issues/965)]

* **[Automation/Scripting]** Added `|kata_encode` to automation scripting autocompletion suggestions.

* **[Project Boards/UI]** Fixed a visual issue on project boards when using the Brave browser. The column set horizontal scrollbar (below the board) was always visible. This is now properly hidden.
