---
layout: post
title: "10.1.2"
excerpt: Cerb 10.1.2 is a maintenance update released in September 2021 with 17 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/10.1/10.1.2.png
author: The Cerb Team
date: 2021-09-29 12:00:00 -0700
permalink: /releases/10.1.2/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 17
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" alt="10.1.2" width="500">
</div>

**Cerb (10.1.2)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.1](/releases/10.1/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Automations/Validation]** Fixed an issue where automation validation of the [var.unset:](/docs/automations/commands/var.unset/) command reported the `output:`, `on_success:`, and `on_error:` options as unknown.

* **[Automations/KATA]** In automations, fixed an issue with [var.unset:](/docs/automations/commands/var.unset/) where a key part of `0` couldn't be unset. For instance `inputs:tickets:0`.

* **[Sheets/Validation]** Fixed an issue with sheet widget validation on the `schema:layout:title_column:` option.

* **[Records/Tickets/Avatars]** When requesting a profile image for a ticket record, the image of its current group is returned.

* **[Records/Buckets/Avatars]** When requesting a profile image for a bucket record, the image of its group is returned.

* **[Automations/Scripting]** In automation scripting, added a [\|str_pos(needle,offset,ignoreCase)](/docs/scripting/filters/#str_pos) filter for returning the position of a substring (needle) within a larger text (haystack). This returns an integer position, or `-1` when not found.

* **[Automations/Scripting]** In automation scripting, added a [\|str_sub(from,to)](/docs/scripting/filters/#str_sub) filter for returning a substring from a larger string using starting and ending positions. This is an alternative to [\|slice(from,length)](/docs/scripting/filters/#slice).

* **[Automations]** In automations, the [var.push:](/docs/automations/commands/var.push/) command may now push an empty `value:` into a `key:`. Previously, the value was required to be non-null.

* **[Automations/UX]** In [interaction.worker](/docs/automations/triggers/interaction.worker/) automations, using an `await:form:` continuation, the autocompletion for [sheet:](/docs/automations/triggers/interaction.worker/elements/sheet/) elements with automation-backed `data:` now defaults to a fully working example using `cerb.data.records`. Previously, this had `automation.name` placeholder text.

* **[Sheets]** [Sheets](/docs/sheets/) using `layout:style: grid` can now properly `bold@bool: yes` columns.

* **[Data Queries]** In [record.types](/docs/data-queries/record/types/) data queries, the record types are now properly sorted by plural label.

* **[Sheets]** In sheets, a column with `image@bool: yes` now fetches profile images using a record alias (e.g. `group`) rather than extension ID (e.g. `cerberusweb.contexts.group`). This is more consistent with the rest of the system and makes better use of the browser cache.

* **[Interactions]** In [interaction.worker](/docs/automations/triggers/interaction.worker/) automations, the editor will properly autocomplete `sheet:` options for: `context`, `context_template`, `id`, `id_template`, `label`, and `label_template`. Previously, this only autocompleted the `context_key`, `id_key`, and `label_key` options.

* **[Records]** Fixed an issue with fetching record metadata for invalid IDs.

* **[Records/Tickets]** When creating or modifying a ticket record, a `bucket_id` may now be provided without a `group_id`. The latter will be set automatically. In a high volume process, it's recommended to provide both `group_id` and `bucket_id` to avoid the extra lookup.

* **[Behaviors/Comments]** In bot behaviors, the 'Create comment' action can now enable Markdown formatting for the contents.

* **[Sheets]** In [sheets](/docs/sheets/), [card:](/docs/sheets/#card), [icon:](/docs/sheets/#icon), and [text:](/docs/sheets/#text) columns can use a new `icon:record_uri:` option to display a record profile image rather than an icon. This takes a URI string (e.g. `cerb:group:1`). For instance, a sheet of ticket records can show their group icon next to the ticket label.

