---
layout: post
title: "10.1.3"
excerpt: Cerb 10.1.3 is a maintenance update released in October 2021 with 11 minor features and fixes from community feedback.
social_image_url: /assets/images/releases/10.1/10.1.3.png
author: The Cerb Team
date: 2021-10-25 00:00:00 -0700
permalink: /releases/10.1.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 11
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" alt="10.1.3" width="500">
</div>

**Cerb (10.1.3)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.1](/releases/10.1/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

* **[Data Queries]** Fixed an issue with data queries not respecting higher `timeout:` limits. Thanks to [@mryanb](https://github.com/mryanb) for reporting.

* **[Automations/Validation]** In automations, fixed a validation issue when returning dictionaries from the `simulate.success:` and `simulate.error:` actions. [[#1532](https://github.com/jstanden/cerb/issues/1532)]

* **[Sheets/UX]** On sheets with a `selection:` column, a "select all" checkbox is now available when column headings are enabled. Thanks to [@mryanb](https://github.com/mryanb) for the feature request and testing.

* **[Dashboards/Prompts/UX]** On dashboard workspace pages with prompts enabled, a 'Reset' button quickly resets filters to their default values and updates the widgets. Thanks to [Advance Local](https://www.advancelocal.com) for the feature request. [[#1294](https://github.com/jstanden/cerb/issues/1294)]

* **[Interactions/Sheets]** On `interaction.worker` automations, `await:form:` sheet elements with toolbars now properly show and hide them on row selection events.

* **[Records/Search/Watchers]** In worklist search queries, fixed an issue with negating watcher deep searches. For instance `watchers:!(id:[1,2,3])`

* **[Knowledgebase/Explore]** Fixed an issue with using explore mode on knowledgebase article worklists.

* **[Automations/Records]** In `record.changed` automations, the `was_record_` placeholders now include the past values for all custom field URIs. Previously this only worked for IDs like `custom_123`.

* **[Automations/Records]** `record.changed` automations now properly trigger when removing an entire custom fieldset from a record.

* **[Tickets/Mail]** When replying to a ticket, if the draft fails to deliver then the ticket is now automatically reopened. Previously it was possible for these tickets to remain 'waiting' and unnoticed. Thanks to [1Password](https://1password.com/) for the report.

* **[Automations/Comments]** Fixed an issue with legacy 'Comment on ticket in group' behaviors that had migrated to the `record.changed` automation event. After the migration, these behaviors were triggering for comments in all groups unless the constraints were manually added back. The underlying code now enforces that the group of the comment's target ticket matches the behavior's group owner.

