---
layout: post
title: "10.2.1"
excerpt: Cerb 10.2.1 is a maintenance update released in March 2022 with 12 improvements from community feedback.
author: The Cerb Team
date: 2022-03-11 15:00:00 -0800
permalink: /releases/10.2.1/
social_image_url: /assets/images/releases/10.2/10.2.1.png
redirect_from:
  - /10.2.1/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 12
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.2.1)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.2](/releases/10.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Data Queries/Subtotals]** In `worklist.subtotals` data queries on `ticket` records, the `by:` can subtotal on a new virtual `group_bucket` field. This returns both the group and bucket names in the label. Previously, grouping by `bucket` returned just the bucket name, which often contained many ambiguous duplicates like "Inbox". Thanks to [1Password](https://1password.com/) for the feature request.

## Changed

* **[Records/Fieldsets]** In the records API, using the `fieldsets` field, fieldsets can now be removed by prefixing their IDs with a minus sign (`-`).
  
* **[Mail/Notes]** When sending mail, the `#start note` command now defaults to Markdown enabled.
  
* **[Packages/Demo]** In the demo package, replaced the Russian example company with a Ukrainian company. 🇺🇦 Stand with Ukraine.
  
* **[Data Queries/Subtotals]** In `worklist.subtotals` data queries, an error is now returned for unknown `by:` fields. Previously these were ignored.

* **[Dashboards/Charts]** In pie chart widgets on profiles and workspaces, data queries can now use the {% raw %}`${key}`{% endraw %} untrusted placeholder syntax.
  
* **[Interactions/Worker]** On `interaction.worker` automations, `await:interaction:inputs:` now provides autocomplete suggestions.

## Removed

* **[Localization]** Removed the Russian translation.

## Fixed

* **[Behaviors/Metrics]** Fixed an issue with metrics on behaviors. These weren't being recorded for behaviors that ran outside of events (e.g. conversations, record changed, macros).
  
* **[Sheets/UI]** Fixed an issue in Firefox with sheets using the 'columns' layout. A single option could be split across multiple columns (e.g. icon, title, content). Thanks to [@mryanb](https://github.com/mryanb) for reporting.

* **[Interactions/Workers]** Fixed an issue with worker interactions when using an `await:interaction:` before an `await:form:`. Thanks to [1Password](https://1password.com/) for reporting the issue.

* **[Custom Fields]** Fixed an issue when editing custom fields within a fieldset. After saving, the fieldset was inefficiently re-linked to all records with a value, which could be expensive for commonly used fields. This linking now only happens when the fieldset changes. Thanks to [@mryanb](https://github.com/mryanb/) for the bug report.
