---
layout: post
title: "10.2.2"
excerpt: Cerb 10.2.2 is a maintenance update released in March 2022 with 15 improvements from community feedback.
author: The Cerb Team
date: 2022-03-17 19:00:00 -0700
permalink: /releases/10.2.2/
social_image_url: /assets/images/releases/10.2/10.2.2.png
redirect_from:
  - /10.2.2/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 15
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.2.2)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.2](/releases/10.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Automations/Attachments]** When creating [attachments](/docs/records/types/attachment/) from an automation using the `record.create:` command, the `mime_type:` can now be `application/vnd.cerb.uri` with an [automation resource](/docs/records/types/automation_resource/) URI as the `content:`. This makes it possible to pipe `http.request:` output directly to an attachment record in all cases (text, binary, large binary stream). Large files (e.g. 100MB) can be efficiently fetched and saved from a URL this way with very low memory usage. The bytes are never loaded into the automation state. Thanks to [1Password](https://1password.com/) for the request.
  
* **[Search/Performance]** In **Setup->Configure->Search**, custom stop words can be added to MySQL Fulltext search schemas. This makes searches more efficient by ignoring very common words. We automatically include the [InnoDB stop words list](https://dev.mysql.com/doc/refman/8.0/en/fulltext-stopwords.html#fulltext-stopwords-stopwords-for-innodb-search-indexes). Custom stop words might be 'http' or your organization's name. Keep an eye on the slow query log for tuning this. It will generally only be useful once you have millions of records.

## Changed

* **[Automations/Editor]** In the automation editor, the script and policy syntax are now validated before running the simulator. Previously, these issues were only reported when saving.

## Fixed

* **[Search/Custom Fields/Performance]** In worklists, optimized sorting by a high-usage custom field. Some queries that previously timed out are now properly instantaneous.
  
* **[Worklists/Subtotals]** In worklists, improved performance when subtotaling on a high-usage custom field.

* **[Records/Merge]** Fixed an issue with merging ticket records where the `updated` field wasn't shown in the merge mapping popup. Thanks to [1Password](https://1password.com/) for the report.

* **[Support Center]** Fixed an issue in the Support Center when displaying a custom field in the knowledgebase article or ticket history worklists.
  
* **[Packages]** In Setup->Packages, an error is now returned if the imported package wouldn't create or modify any records. Previously, this returned a blank summary with no indication of what happened.

* **[Portals/Interactions]** Fixed website interaction portals in browsers that (properly) hide the `nonce` attribute from the DOM. After recent browser updates this included everything except for Safari. This has been tested in the most recent version of Chrome, Firefox, Safari, Safari Technology Preview, Edge, Brave, and Opera.
  
* **[Tickets/Drafts]** Fixed an issue where `ticket.reply` drafts couldn't be resumed or sent on a ticket if it had no other messages.

* **[Automations]** Fixed an issue with running an automation that has a malformed policy. The policy is validated before saving, so this generally only affected the simulator.

* **[Project Boards]** Fixed an issue in project boards where unlinked cards weren't being removed. Thanks to [@DaftBrit](https://github.com/DaftBrit) for the report. [[#1633](https://github.com/jstanden/cerb/issues/1633)]

* **[Project Boards]** Fixed an issue on project boards where the events for card popups were added after each redraw of the board. For instance, if a project board widget was reloaded five times and then a card was edited, the card would also be refreshed five times.

* **[Tasks]** Fixed an issue with creating tasks from the package library.

## Security

* **[Security/Portals/Interactions]** Improved the security of website interaction portals. All script blocks must now include a unique `nonce` attribute which must match the original request headers to be included. Previously, this attribute was validated on the first script block, but automatically added to subsequent scripts from Ajax requests.
