---
layout: post
title: "10.2.4"
excerpt: Cerb 10.2.4 is a maintenance update released in April 2022 with 12 improvements from community feedback.
author: The Cerb Team
date: 2022-04-29 11:00:00 -0700
permalink: /releases/10.2.4/
social_image_url: /assets/images/releases/10.2/10.2.4.png
redirect_from:
  - /10.2.4/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 12
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.2.4)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.2](/releases/10.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Automations/Scripting]** In automation scripting, added a `|parse_csv(separator,enclosure,escape)` filter for parsing a comma-separated values string into an array of columns and rows.

* **[Automations/KATA]** In automations, added a `kata.parse:` command for parsing arbitrary KATA documents with placeholders and schema validation.

* **[Interactions/Editor]** In worker interactions, `editor:` prompts can now use KATA syntax with dynamic autocompletion based on any given schema.

## Changed

* **[Automations/Records]** In automations, the `record.create:` action can now create tickets with only a `bucket_id:` field. Previously, the `group_id:` always had to be provided.

* **[Mail/Reply]** When replying to a ticket, the 'Recent activity' interaction now ignores bot activity when warning about a duplication of effort.
  
* **[Automations]** In automations, the `output:` key on the `record.create:` action is no longer required.

* **[Automations]** In automations, the `output:` key on the `record.update:` action is no longer required.

* **[Automations]** In automations, the `output:` key on the `record.upsert:` action is no longer required.

## Fixed

* **[Windows/Mail/Attachments]** Fixed an issue on Windows Server with downloading all message attachments as a ZIP file.

* **[PHP]** Additional PHP 8.1 compatibility fixes.

* **[Installer]** Fixed a validation issue with the 'Demo' package in the installer.

## Security

* **[Security/Dependencies]** Updated the async.js dependency to v2.6.4 to address a security notice.