---
layout: post
title: "10.2.5"
excerpt: Cerb 10.2.5 is a maintenance update released in July 2022 with 22 improvements from community feedback.
author: The Cerb Team
date: 2022-07-13 00:00:00 -0700
permalink: /releases/10.2.5/
social_image_url: /assets/images/releases/10.2/10.2.5.png
redirect_from:
  - /10.2.5/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 22
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.2.5)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.2](/releases/10.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Dashboards]** On dashboards, a `chooser:` [prompt](/docs/dashboards/#chooser) may now provide a default `query:` to filter the worklist popup.

* **[Dashboards/Prompts]** On dashboard `chooser:` [prompts](/docs/dashboards/#chooser) with single selection, if a key name ends with an `_id` suffix then it now supports key expansion for all placeholders on that record type. For instance, a 'Worker' chooser can pass the selected worker's email to widgets on the dashboard. Previously, these choosers only returned record IDs.

* **[KATA/Syntax]** In KATA, a new `@float` [annotation](/docs/automations/#annotations) formats values as floating point numbers. This complements the `@int` and `@bool` annotations.

* **[Data Queries/Series]** On [worklist.series](/docs/data-queries/worklist/series/) data queries, `format:pie` is now available. This rolls up the x-axis into series totals for visualizing as pie chart wedges.

* **[Automations]** In automations using the [var.set:](/docs/automations/commands/var.set/) command, a custom `delimiter:` may now be provided for key paths. This is useful when path element names contain the default delimiter (`:`), like with `hour:minute` timestamps.

* **[Dashboards/Prompts]** On dashboards, prompts can now use placeholders for the current worker and workspace tab/page. For instance, a dashboard chooser prompt can provide a default query based on the owner of the workspace page. Thanks to [1Password](https://1password.com/) for the feature request.

* **[Records/Custom Fields]** In custom field record dictionaries, a new `search_filter` placeholder is populated with the legacy search filter name for the custom field. This makes it much easier to procedurally build search queries and data queries from automations. Thanks to [1Password](https://1password.com/) for the feature request.

* **[Data Queries/Subtotals]** In `worklist.subtotal` data queries, it is now possible to subtotal ticket records by the `participant` field.

## Changed

* **[Performance]** On record editors, owner chooser menus no longer show profile images. In large environments this could result in hundreds of requests on a cold cache and trigger rate-limits.

* **[Records/Search/Worklists]** In record worklists, sorting a 'Record Links' column now orders by the number of links. Previously, this (less helpfully) sorted by linked record IDs. Thanks to [Flexibits](https://flexibits.com/) for the feature request and testing.

* **[Dashboards/Workspaces]** On workspaces, 'Interaction Toolbar' widgets can now use dashboard prompt placeholders.

* **[Mail/Reply/Automations]** In worker interactions on the `mail.reply` toolbar (email reply editor popup), a new `caller_params.text` placeholder includes the full text of the editor. Previously this only provided the `selected_text`. For instance, this change makes it easier to translate an entire message from the toolbar without having to select it first.

## Fixed

* **[API/OAuth2]** Fixed an issue with manually generating OAuth2 tokens from Setup->Developers.

* **[Tickets/Automations]** Fixed an issue with the `bucket_id` field not being set properly on `ticket` records from automations.

* **[Attachments/UX]** On attachment cards, the 'Download' button no longer opens a new blank tab. [[#1646](https://github.com/jstanden/cerb/issues/1646)]

* **[Mail/Drafts]** Fixed an issue with sending a `mail.transactional` draft that has no recipients. This failed silently and removed the draft from the queue. Now the draft will remain in the failed state with an explanatory sticky note.

* **[Metrics/Data Queries]** Fixed an issue with `metrics.timeseries` data queries where the `min` aggregation returned the same value as `max`.

* **[Setup/Sessions]** Fixed an issue with deleting sessions from **Setup->Security->Active Sessions**.

* **[Metrics]** Fixed an issue with creating new metrics that could break search popups. The issue could trigger by adding a new metric immediately after deleting another one, or by setting a description between 129-254 characters (a mismatch between the schema and validation).

* **[Search/Elasticsearch]** Fixed an issue with searching using Elasticache. In PHP8, if there were no full-text results, an error could be returned rather than an empty list. Thanks to [Qweb.nl](https://www.qweb.nl) for the report.

## Security

* **[Security/Dependencies]** Updated Smarty to 4.1.1 in response to a security advisory.

* **[Security/Dependencies]** Updated Guzzlehttp to 6.5.8 in response to four security advisories.