---
layout: post
title: "10.2.6"
excerpt: Cerb 10.2.6 is a maintenance update released in August 2022 with 14 improvements from community feedback.
author: The Cerb Team
date: 2022-08-15 00:00:00 -0700
permalink: /releases/10.2.6/
social_image_url: /assets/images/releases/10.2/10.2.6.png
redirect_from:
  - /10.2.6/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 14
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.2.6)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.2](/releases/10.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Automations/Scripting]** In automation scripting, added a [dns_host_by_ip()](/docs/scripting/functions/#dns_host_by_ip) function for resolving hostnames from IPs. If a name can't be resolved for a valid IP, the IP is returned. If an invalid IP is provided, the result is an empty string.

* **[Automations/Scripting]** In automation scripting, added a [dns_get_record(host,type)](/docs/scripting/functions/#dns_get_record) function for resolving DNS records by hostname and type. The supported types are: `a`, `aaaa`, `caa`, `cname`, `mx`, `ns`, `ptr`, `soa`, `srv`, `txt`. This enables workflows like verifying domain ownership via TXT records, validating SPF/DKIM, verifying MX servers, etc.

* **[Automations]** In automations, the [record.create:](/docs/automations/commands/record.create/) action now has an `inputs:disable_events@bool:` option to avoid triggering events for newly created records. This is particularly useful for import workflows where events like auto-responders and auto-assignment shouldn't be triggered. Thanks to [1Password](https://1password.com/) for the feature request! [[#1351](https://github.com/jstanden/cerb/issues/1351)]

* **[Automations]** In automations, the [record.update:](/docs/automations/commands/record.update/) action now has an `inputs:disable_events@bool:` option to avoid triggering events for updated records.

* **[Automations]** In automations, the [record.upsert:](/docs/automations/commands/record.upsert/) action now has an `inputs:disable_events@bool:` option to avoid triggering events for newly created or updated records.

## Changed

* **[Worklists/Export]** When exporting a worklist, worker-based custom fields now provide expanded placeholders (e.g. first/last name, email, location).

* **[Calendars/Data Queries]** In [calendar.events](/docs/data-queries/calendar/events/) data queries, new dictionary keys for `ts_range_start` and `ts_range_end` provide the full extents for events that span multiple days. Previously, multiple day events were split into an event per day, which made it difficult for automations to determine if an event ended at midnight or continued into the next day. For instance, an automation might need to send a summary at the end of worker shifts.

* **[Automations/Developers]** In automations, the `key:` parameter of the [var.unset:](/docs/automations/commands/var.unset/) action now accepts either a string or an array. The latter allows unsetting multiple variables at once.

* **[Automations/Editor/UX]** In the automation editor, in the 'Run' section, the Simulate/Execute toggle is now underlined to make it more obvious.

* **[Automations/Editor/UX]** In the automation editor, the 'Indents may not use tabs' error now provides the offending line number.

* **[Automations/Scripting]** In automation scripting, the [\|split_crlf()](/docs/scripting/filters/#split_crlf) filter has options for `keep_blanks` and `trim_lines`. The options default to `false` and `true` respectively, and were previously hardcoded.

* **[Connected Services/LDAP]** When configuring an LDAP connected service, an explicit 'Encryption' option is now available. This can be set to: Automatic (based on port), TLS (StartTLS on port 389), SSL (implied SSL on port 636), or Disabled (plaintext auth). This makes it possible to use TLS on non-standard ports, and to disable TLS on a private network, or during development. Previously, TLS was always enabled on port 389 and SSL was always enabled on port 636.

## Fixed

* **[Connected Services]** On 'bearer token' connected services, the `token` field may now contain up to 4,096 characters. Previously this was limited to a mere 255 characters.

* **[Automations]** Fixed an issue in automation validation for `inputs:text:type_options:`.
