---
layout: post
title: "10.2.7"
excerpt: Cerb 10.2.7 is a maintenance update released in September 2022 with 11 improvements from community feedback.
author: The Cerb Team
date: 2022-09-03 00:00:00 -0700
permalink: /releases/10.2.7/
social_image_url: /assets/images/releases/10.2/10.2.7.png
redirect_from:
  - /10.2.7/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 11
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.2.7)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.2](/releases/10.2/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Interactions/Workers]** On worker interactions, the `editor:` form element can now specify a `readonly@bool:` option. This prevents text in the editor from being modified, but still provides syntax highlighting and toolbar functionality.

* **[Interactions/Worker]** In worker interactions, the `editor:` form element can use the `line_numbers@bool:` option to show or hide line numbers in the left gutter. Line numbers are shown by default.

* **[UI/Stylesheet]** On ticket profiles, added a new `data-cerb-message-sender` DOM attribute on messages. This makes it easier to override UI styles based on sender.

* **[Automation/Scripting]** In automation scripting, the `dict_set()` function can now specify an optional delimiter. The default delimiter is a period (`.`) which can occasionally conflict with key names in the path.

## Changed

* **[Time Tracking/UX]** When creating a new time tracking entry, the default time input is blank rather than '0 secs' and it is automatically focused when started from an interaction. Previously, this tediously required workers to highlight the default text, delete it, and replace it.

* **[Records/Search]** In record worklists, the `links:` filter now offers autocomplete suggestions for possible record types.

## Fixed

* **[Mail/Compose]** When composing a new email, the 'Organization:' field will now properly create new organizations. Thanks to [@Edward-git0](https://github.com/Edward-git0) for reporting!  [[#1669](https://github.com/jstanden/cerb/issues/1669)]

* **[Interactions/Worker]** In worker interactions, the `sheet:toolbar:` option now properly provides syntax autocompletion suggestions. This adds toolbars to `sheet:` elements in forms.

* **[Records/Avatars]** Fixed an issue with the profile image editor where the current profile image could initially appear blank until manipulated in some way (e.g. panned, zoomed).

* **[Records/Avatars]** Fixed an issue with the profile image editor when selecting one of the default silhouettes. Manipulating the image after selection (e.g. panning, zooming) would revert to the previous image.

* **[Automations/Files]** In automations, the `file.read:` command now properly runs `on_error:` or exits in the `error` state if a file is unreadable (e.g. malformed, encrypted).