---
layout: post
title: "10.3.2"
excerpt: Cerb 10.3.2 is a maintenance update released in October 2022 with 16 improvements from community feedback.
author: The Cerb Team
date: 2022-10-27 12:00:00 -0700
permalink: /releases/10.3.2/
social_image_url: /assets/images/releases/10.3/10.3.2.png
redirect_from:
  - /10.3.2/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 16
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.3.2)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.3](/releases/10.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Automations]** Added the [data.query](/docs/automations/triggers/data.query/) automation event. This generates custom data query results using an automation (e.g. read from a resource file, fetch from an external API, post-process from search results, etc). It's now possible to work with third-party data sources in any feature that supports data queries (sheets, charts, etc).

* **[Data Queries/Automations]** Added a new [automation.invoke](/docs/data-queries/automation/invoke/) data query type. This invokes a `data.query` automation to retrieve query results, which enables integration with nearly any data source (APIs, data silos, precomputed datasets, etc). It can also be used to combine multiple data queries into a single result set.

* **[Automations/Scripting]** In automation scripting, added a [\|parse_user_agent](/docs/scripting/filters/#parse_user_agent) filter. This parses a user agent string and returns an array with keys for: `platform`, `browser`, and `version`.

* **[Chart DATA/Datasets]** On [Chart KATA](/docs/dashboards/widgets/chart-kata/) widgets, datasets may now specify an optional `key_map:` to override series names. The value can be a comma-separated list in the format `oldKey1,newKey1`, or an object with keys (to replace) and values (to replace with). For instance, when using a `worklist.subtotals` dataQuery on a field like message `isOutgoing` the series names are 'yes' and 'no'. These labels may now be renamed to something more useful like 'Outgoing' and 'Incoming'.

* **[Chart KATA/Export]** Chart KATA widgets now support exporting data in JSON or CSV format from dashboards.

* **[Data Queries/Subtotals]** On [worklist.subtotals](/docs/data-queries/worklist/subtotals/) data queries, 'message' records may be subtotaled by `ticket.bucket.id`, `ticket.bucket.name`, `ticket.group.id`, and `ticket.group.name`. The keys suffixed with `.id` return a record ID (e.g. `123`), and the `.name` suffixes keys return the record label (e.g. `Support`).

* **[Resources]** Added a new 'Dataset (.csv)' type to [resource](/docs/resources/) records. This can be used to store precomputed datasets for sheets, charts, and automations.

* **[Automations/FileRead]** In automations, the [file.read:](/docs/automations/commands/file.read/) command can now read `resource` records. For instance, a precalculated dataset can be stored in a resource and updated externally (e.g. API, webhooks, automations).

* **[Resources/Records]** On [resource](/docs/records/types/resource/) records, a new `content` field allows the file content to be set by automations and the API. Previously, it was only possible for workers to upload a resource file in the browser.

## Changed

* **[Interactions/Website]** In website interactions, an [await:form:fileUpload:](/docs/automations/triggers/interaction.website/elements/fileUpload/) element now provides a more useful error message when an uploaded file is bigger than the server allows. This covers cases like a proxy rejecting an upload before Cerb's code runs.

* **[Automations/Editor]** In the automation editor, the 'Change History' now displays to the past 50 changes rather than the past 10.

* **[Data Queries/Subtotals/Performance]** Significantly improved the performance of grouping `message` records by the parent ticket's group or bucket.

## Fixed

* **[Resources/SVG]** Fixed an issue with 'Image' [resource](/docs/resources/) records when uploading an SVG file with a BOM (byte order) marker. These files are now properly converted.

* **[Chart KATA/Automations]** Chart KATA widgets are now properly restricted to [ui.chart.data](/docs/automations/triggers/ui.chart.data/) automations.

* **[Widgets/Sheets/UI]** When configuring sheet widgets, fixed a visual issue where the 'close' icon was partially transparent.

* **[Data Queries/Subtotals]** In [worklist.subtotals](/docs/data-queries/worklist/subtotals/) data queries, fixed an issue with `format:dictionaries` when subtotaling by the same field more than once (e.g. `by:[created@year,created@hourofday]`). The time grouping is now included in the field key.