---
layout: post
title: "10.3.3"
excerpt: Cerb 10.3.3 is a maintenance update released in November 2022 with 9 improvements from community feedback.
author: The Cerb Team
date: 2022-11-04 12:00:00 -0700
permalink: /releases/10.3.3/
social_image_url: /assets/images/releases/10.3/10.3.3.png
redirect_from:
  - /10.3.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 9
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.3.3)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.3](/releases/10.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Chart KATA]** [Chart KATA](/docs/dashboards/widgets/chart-kata/) widgets can now specify formatters for the `x` and `y` axis labels in the `axis:x:tick:format:` option. There are formatters for `number:` (default), `date:`, and `duration:`. The `duration:` formatter defines a `unit:` (milliseconds, seconds, minutes, hours) and a `precision@int:` to format a number like `1803` as `30m,3s`. The `number:` and `date:` formatters provide a `pattern:` using `d3.format()` and `strftime()` specifiers respectively.

* **[Widgets/Sheets]** On dashboards, sheet widgets now support the 'Export Data' feature in CSV and JSON formats. [[#1623](https://github.com/jstanden/cerb/issues/1623)]

* **[Interactions/Worker]** In `interaction.worker` automations, `await:form:elements:text:` prompts may now use `type: password` to obscure the input of sensitive information.

## Changed

* **[Sheets]** In sheets, the column parameter `value_template:` now always defaults to the `@raw` annotation. This preserves placeholders until each row is evaluated.

* **[Worklists/UX]** When customizing a worklist, the available 'Columns:' fields are now displayed in columns when there are more than 15.

## Fixed

* **[Automations/Editor]** Fixed an issue in the automation editor where autocompletion was giving suggestions while typing within a commented line.

* **[Automations/Editor]** In the automation editor, fixed an issue where autocomplete suggestions weren't offered when a partially typed new key followed an indented block.

* **[Chart KATA]** Fixed an issue in Chart KATA when using a `category` axis and numeric labels (e.g. 2020, 2021, 2022).

* **[Chart KATA]** In Chart KATA widgets, fixed an issue with 'click-to-search' functionality when using a `dataQuery` dataset with `format:categories` and a single `by:` grouping.