---
layout: post
title: "10.3.5"
excerpt: Cerb 10.3.5 is a maintenance update released in January 2023 with 8 improvements from community feedback.
author: The Cerb Team
date: 2023-01-13 12:00:00 -0700
permalink: /releases/10.3.5/
social_image_url: /assets/images/releases/10.3/10.3.5.png
redirect_from:
  - /10.3.5/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 8
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.3.5)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.3](/releases/10.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Changed

* **[Automations/Editor/UX]** When saving the automation editor, the code and policy are now properly validated first. Any unresolved errors will prevent the save from continuing. This makes it harder to unwittingly deploy a script with non-obvious errors (e.g. scripting syntax in logic that runs infrequently).

* **[Automations/Events/UX]** When saving the automation event editor, the event KATA syntax is now properly validated first. Any unresolved errors will prevent the save from continuing.

* **[Maint/Performance]** Slightly improved the performance of the maintenance scheduler when purging orphaned attachments.

* **[Search/Fulltext]** Added a few more 'stop words' to the full-text search indexer. This can speed up multiple term searches.

* **[Sheets/Export]** When exporting data from sheet widget to CSV or JSON, a text format is now used rather than HTML. [[#1711](https://github.com/jstanden/cerb/issues/1711)]

## Fixed

* **[Mail/Parser]** Fixed an issue when parsing an email message with a `text/html` part and no `text/plain` part. If an `img` tag contained a `src` attribute without a valid URL (e.g. Content-ID), then the message could be left in the fail queue.

* **[Automations/Groups]** Fixed an issue with legacy group behaviors that moved to the `record.changed` automation event ("Ticket Assigned/Moved/Closed in Group"). In some cases these could trigger multiple times.

* **[Automations/Interactions/UX]** Fixed an issue in worker interactions where multiple text fields set the cursor focus. This led to odd outcomes like the last field in a form having focus. Thanks to [Flexibits](https://flexibits.com/) for the bug report! [[#1703](https://github.com/jstanden/cerb/issues/1703)]