---
layout: post
title: "10.3.6"
excerpt: Cerb 10.3.6 is a maintenance update released in January 2023 with 10 improvements from community feedback.
author: The Cerb Team
date: 2023-01-27 12:00:00 -0700
permalink: /releases/10.3.6/
social_image_url: /assets/images/releases/10.3/10.3.6.png
redirect_from:
  - /10.3.6/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 10
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.3.6)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.3](/releases/10.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Records/Resources]** When creating a 'Resource' record, the `content` field can now be a Cerb URI referencing an automation resource (e.g. `cerb:automation_resource:TOKEN`). This streams content from the automation resource into the resource record; which makes it easier to work with large/binary files.

* **[Webhooks/Automations]** Automation-backed webhooks may now return Cerb URIs for HTTP response body content. For instance, an automation resource (`cerb:automation_resource:TOKEN`) or resource (`cerb:resource:NAME`) record can be streamed as the output. This makes it much easier to work with large/binary content. [[#1710](https://github.com/jstanden/cerb/issues/1710)]

* **[Automations/FileWrite]** In automations, the `file.write:` command now supports appending to an existing automation resource record when providing a Cerb URI in the `input:uri:` field. For instance, this makes it possible to do an incremental export in a loop where each page of results is exported separately.

* **[Metrics/Data Queries]** In `metrics.timeseries` data queries, the `query:` filter for a record-based dimension can now be a deep search. For instance: `query:(worker:(group:Support))`. [[#1715](https://github.com/jstanden/cerb/issues/1715)]

* **[Data Queries/Metrics]** In `metrics.timeseries` data queries, `function:distinct` now counts the number of distinct samples per bin and `by:` dimensions. For instance, the `cerb.workers.active` metric can be queried for how many distinct workers logged in on a given day over a month.

## Changed

* **[Platform/PHP/Logging]** Suppressed PHP 8.2 deprecation warnings in production. These are still raised in `DEVELOPMENT_MODE`.

## Fixed

* **[Behaviors/Logs]** Fixed an issue with legacy group-owned behaviors (e.g. ticked assigned, moved, commented, closed) where the activity log could attribute the current worker rather than the bot for actions like commenting.

* **[Scheduler/Mailbox]** Fixed an issue with checking POP3 mailboxes where the 'Timeout' setting could be manually set to `0` (from default `30`). This wasn't infinite, it just timed out very quickly.

* **[UI/Menu]** Fixed an issue with the top pages navigation menu in some browsers. There could be a small gap between the page name and the menu, causing the menu to collapse if the mouse didn't move quickly enough. [[#1694](https://github.com/jstanden/cerb/issues/1694)]

* **[Data Queries/Metrics]** Fixed an issue with `metrics.timeseries` data queries when aggregating with a `period:` of `week`, `month`, or `year` using dimensions.