---
layout: post
title: "10.3.7"
excerpt: Cerb 10.3.7 is a maintenance update released in March 2023 with 10 improvements from community feedback.
author: The Cerb Team
date: 2023-03-23 12:00:00 -0700
permalink: /releases/10.3.7/
social_image_url: /assets/images/releases/10.3/10.3.7.png
redirect_from:
  - /10.3.7/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 10
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.3.7)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.3](/releases/10.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Metrics/Data Queries]** In [metrics.timeseries](/docs/data-queries/metrics/timeseries/) data queries, dimension filters in the `query:` can now use negation. For instance, `query:(worker_id:![1,2,3])`. [[#1716](https://github.com/jstanden/cerb/issues/1716)]

* **[Metrics/Data Queries]** In [metrics.timeseries](/docs/data-queries/metrics/timeseries/) data queries, added a new `@week-sun` date aggregation. This calculates week starting on Sunday, rather than the default of Monday.

* **[Search/Contacts]** On [contact](/docs/records/types/contact/#search-query-fields) worklists, implemented a `title:` quick search filter with autocompletion suggestions. Thanks to [@mryanb](https://github.com/mryanb/) for the feature request!

* **[Automations/Records]** In automations, the [record.search:](/docs/automations/commands/record.search/) command has a new `inputs:validation@raw:` option. This accepts a template with scripting syntax where any output is considered to be an error that triggers the `on_error:` event. For instance, a `record.search:` with an `id:123 limit:1` query that fails the automation if the expected record is not found. This is a shortcut for adding an `on_success:outcome:if@bool:` for every lookup.

## Fixed

* **[Bots/Behaviors]** Fixed an issue with legacy bot behaviors in PHP 8.1+. The 'In groups:' and 'In group buckets:' conditions could trigger an error if the lists were blank.

* **[Data Queries/Bots/Performance]** Massively improved the performance of the `usage.behaviors` data query. The data query is used on the 'Behavior Usage' tab of the default reporting page. In some environments the query could take over 100,000ms due to inefficient joins. The new query runs in 70ms in the same environments (by eliminating joins and adding behavior details from the cache).

* **[API/OAuth2]** Fixed an issue with the REST API and the `refresh_token` grant type. This could prevent exchanging a previous refresh token for a new access/refresh token.

* **[KATA]** Fixed an issue when emitting KATA with a multiple line value that contained leading whitespace. The whitespace was being trimmed when it could be syntactically important (e.g. automation scripts or policies).

* **[KATA]** Fixed an issue with KATA where a document with an empty string (`key@text:`) parsed and re-emitted as an array (`key:`). This now properly includes the `@text` annotation.

* **[Automations/Editor]** In the automation editor, fixed an issue with the 'Output:' YAML where multiple-line values had blank lines removed.
