---
layout: post
title: "10.3.8"
excerpt: Cerb 10.3.8 is a maintenance update released in April 2023 with 15 improvements from community feedback.
author: The Cerb Team
date: 2023-04-21 12:00:00 -0700
permalink: /releases/10.3.8/
social_image_url: /assets/images/releases/10.3/10.3.8.png
redirect_from:
  - /10.3.8/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 15
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.3.8)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.3](/releases/10.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Devblocks/Platform]** Added a stats service to the platform to simplify computing: count, max, mean, median, min, mode, stdevp, stdevs, sum, varp, vars.

* **[Automations/Scripting]** Added a [\|stat(measure,decimals)](/docs/scripting/filters/#stat) filter to automation scripting. The `measure` may be one of: `count, max, mean, median, min, mode, stdevp, stdevs, sum, varp, vars`. Rounding is performed with the optional `decimals` argument.

* **[Behaviors/Automations]** Added an `APP_OPT_GROUP_BEHAVIOR_TRIGGERS` option (default `false` ) to re-enable the legacy triggering of 'Ticket moved in group' behaviors. By default, these behaviors are now triggered in the [record.changed](/docs/automations/triggers/record.changed/) automation event at the end of the request. This can cause a problem with cascading routing behaviors (e.g. Support->Corporate->Development). Enabling this option in `framework.config.php` will trigger the behavior for every ticket move during a single request (e.g. mail parsing) and not on the automation event.
  
* **[Time Tracking/Usability]** In worker interactions, a new [return:timer:](/docs/automations/triggers/interaction.worker/#return) option starts the floating time tracking timer with a pre-created time entry ID. For instance, a button on record profiles can show a menu with various activity presets (e.g. tech support, development).

* **[Records/Messages]** On message records, added a `size:` filter for searching by the size of message content in bytes.

## Changed

* **[Snippets]** In snippets, a prompt may now define `required@bool: no` to be optional. Previously, text-based snippet prompts were always required.

## Fixed

* **[Worklists/Explore]** Fixed an inefficiency in explore mode for ticket/message worklists where an extra page was loaded but not used.

* **[Records/Tickets]** On ticket worklists, fixed the `spam.score:` filter so it properly works with percentage values like `>50`, `<90`, or `25...75`.

* **[Records/Links/Logs]** When platform events are disabled (e.g. imports, automations), the activity log no longer adds entries for record links.

* **[Time Tracking/UI]** Fixed the style of the floating time tracking timer in browsers that don't support CSS3 gradients and opacity.

* **[Automations/Interactions]** In worker interaction with an `await:record:` prompt using a record ID, the opened record now always starts properly in edit mode. In some cases (e.g. time tracking) this could start as a card that required an extra click on the 'Edit' button'.

* **[Widgets/Record Fields]** Fixed an issue with 'Record Fields' widgets on cards, profiles, and workspaces. When editing the configuration, the existing value of the 'Toolbar' option didn't load properly.

* **[Automations/Scripting]** In the automation editor, added an autocompletion suggestion for the `var.set:inputs:delimiter:` key.

## Security

* **[Security/Smarty]** Updated the Smarty template engine to v4.3.1 in response to a security advisory.

* **[Security/Guzzle]** Updated the `guzzle/psr7` library to v1.9.1 in response to a security advisory.