---
layout: post
title: "10.3.9"
excerpt: Cerb 10.3.9 is a maintenance update released in May 2023 with 8 improvements from community feedback.
author: The Cerb Team
date: 2023-05-08 12:00:00 -0700
permalink: /releases/10.3.9/
social_image_url: /assets/images/releases/10.3/10.3.9.png
redirect_from:
  - /10.3.9/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 8
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.3.9)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.3](/releases/10.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Automations/Scripting]** In automation scripting, the [cerb_placeholders_list()](/docs/scripting/functions/#cerb_placeholders_list) function now has optional arguments for `extract` (only return key suffixes with the matching prefix) and `prefix` (prepend a new prefix). This makes it much easier to slice a sub-dictionary (e.g. `message_ticket_`) into a new keyspace.

* **[Records/Comments]** Added a `comments:` search filter to custom records. This allows deep searches with any comment filters.

* **[Data Queries/Subtotals]** On `worklist.subtotals` data queries using the `format:dictionaries` output, more record-based fields are now properly key expandable. For instance, previously the `contact.org` field couldn't expand org keys.

* **[Tickets/Masks/UX]** Added a simple profanity filter to ticket mask generation for problematic 3-letter combinations.

## Fixed

* **[Packages]** Fixed an issue with packages when events are disabled. The ticket `participants` field was being ignored.

* **[Platform]** Fixed an issue with automatically detecting filesystem path changes on Windows. Due to inconsistent path delimiters, Cerb could constantly clear the server-side cache.

* **[Log/Performance]** Significantly improved performance when searching activity log entries using the `actor.worker:` or `target.worker:` filters.

* **[Setup]** Fixed an issue on the 'setup' page where an invalid URL could prevent switching setup sections until logging out and back in.