---
layout: post
title: "10.3.10"
excerpt: Cerb 10.3.10 is a maintenance update released in June 2023 with 13 improvements from community feedback.
author: The Cerb Team
date: 2023-06-17 00:00:00 -0700
permalink: /releases/10.3.10/
social_image_url: /assets/images/releases/10.3/10.3.10.png
redirect_from:
  - /10.3.10/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 13
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.3.10)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.3](/releases/10.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Automations/Scripting]** In automation scripting, autocompletion suggestions now provide an `xml_decode` example for parsing HTML documents.

## Changed

* **[Data Queries/Subtotals]** In `worklist.subtotal` data queries `by:` a custom field, the results now include empty field values by default. This allows reporting on all matching records and not just those with a value set, which is consistent with subtotaling against built-in fields. Empty fields can be excluded with a `customFieldName:!null` filter.

* **[Installer/UX]** The installer now sets the login cookie with the default worker's email address. This saves an extra step during installation, testing, etc.

## Fixed

* **[Cards/Sheets]** Fixed an issue on card sheet widgets. The expected `record_type` caller parameter wasn't set for interactions launched from a sheet toolbar.
  
* **[Sessions]** Fixed an issue where a worker session cookie could be refreshed multiple times concurrently due to Ajax request timing. This is suspected of potentially causing premature logouts in Safari.

* **[Browsers/Safari]** Requests by Safari for `/apple-touch-icon.png` are now answered with an appropriate icon. Previously, these requests were redirected to the login form rather than returning a 404 "Not Found". This created many extraneous no-worker sessions in environments with Safari users.

* **[UI/Styles]** Fixed an issue with formatting in email messages, record comments, and knowledgebase articles. In some browsers (e.g. Edge), code snippets always showed a horizontal scrollbar, even when unnecessary.

* **[Browsers/Safari/Sessions]** Fixed an issue where Cerb issued new session cookies to browser prefetch requests (e.g. `/apple-touch-icon.png`). These don't use existing session cookies or persist new cookies.

* **[Mail/Parser]** Fixed an issue in the email parser that failed processing messages with more than one `Date:` header. These can now be retried from Setup->Mail->Incoming->Failed.

* **[Mail/Routing]** Legacy mail routing rules are now re-enabled in 10.3.x versions. This provides a simpler way to define mail routing. Previously legacy routing rules were disabled if no rules existed (including new installs). Legacy routing rules are deprecated and will be removed in v11.0 in favor of `mail.route` automations.

* **[Records/Email]** Fixed a validation issue with email address records. A mailbox of `0@` is valid but was being rejected.

* **[Setup/Mail/Routing]** Fixed an issue in **Setup->Mail->Incoming->Routing** when deleting a legacy mail routing rule. The current page didn't refresh properly.

* **[Cache/Redis]** Fixed a fatal error when Redis is configured as the cache engine and the server is unavailable. Cerb now properly fails gracefully to disk-based caching until the Redis server becomes available again.