---
layout: post
title: "10.3.11"
excerpt: Cerb 10.3.11 is a maintenance update released in July 2023 with 5 improvements from community feedback.
author: The Cerb Team
date: 2023-07-17 00:00:00 -0700
permalink: /releases/10.3.11/
social_image_url: /assets/images/releases/10.3/10.3.11.png
redirect_from:
  - /10.3.11/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 5
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.3.11)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.3](/releases/10.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Automations/Interactions]** `interaction.worker` automations now include `client_` placeholders for IP, browser, and platform.

## Fixed

* **[Automations]** In automations, fixed an issue with `http.request:inputs:headers:` when using a `@text` annotation with automatic content-type encoding (e.g. `application/json`).

* **[Records]** When updating a group record, the `members` field may now be a string (which is no longer double JSON-encoded), or an array of IDs which will be JSON encoded automatically. [[#1725](https://github.com/jstanden/cerb/pull/1725)]

* **[Browsers/UI/CSS]** Improved the browser scrollbar style in dark mode when using a mouse (rather than touchpad).

## Security

* **[Platform/Dependencies]** Updated the `league/oauth2-server` library in response to a vulnerability notice.