---
layout: post
title: "10.4.2"
excerpt: Cerb 10.4.2 is a maintenance update released in September 2023 with 13 improvements from community feedback.
author: The Cerb Team
date: 2023-09-07 12:00:00 -0700
permalink: /releases/10.4.2/
social_image_url: /assets/images/releases/10.4/10.4.2.png
redirect_from:
  - /10.4.2/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 13
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.2)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Toolbars/Avatars]** Added a new [record.profile.image.editor](/docs/toolbars/interactions/record.profile.image.editor/) toolbar. This is displayed on the record profile editor popup, and allows `interaction.worker` automations to generate profile images. For instance, creating images from text/emoji, file uploads, or APIs like Stable Diffusion. Interactions must return an `image:url:` or `image:text:` key. Built-in interactions are provided for text-based images, file uploads, and fetching images from an external URL. This improves on the previous built-in functionality by allowing admins to add custom logic to profile image creation -- for instance, profanity and adult content filters.

* **[Connected Services/Packages]** Added 'Stability.ai' to the package library when creating new connected services. This automatically configures a 'Token Bearer' service for access to Stable Diffusion image generation APIs.

* **[Records/Dictionaries]** All [record](/docs/records/types/) dictionaries now include a `comment_count` key expansion. This returns the number of comments on the record. For instance, a profile widget can be conditionally visible depending on the existence of comments. [[#1736](https://github.com/jstanden/cerb/issues/1736)]

* **[UI/Images]** Added an authenticated `/ui/image/` endpoint for serving automation resources as PNG images. This is used by sheets and record profile images.

* **[Interactions/Worker]** In [interaction.worker](/docs/automations/triggers/interaction.worker/) automations, the [file.upload:](/docs/automations/triggers/interaction.worker/elements/fileUpload/) form element has an `as:` option for creating an `automation_resource` or `attachment` record. Previously only attachments were created, which was undesirable for temporary file uploads. This remains the default for backwards compatibility.

* **[Sheets/Icons]** Sheet [icon:](/docs/sheets/#icon) columns may now directly display automation resources as images by providing their token. For instance, this makes it possible to generate images with an API like Stable Diffusion (or file upload) and then display them in a sheet.

## Changed

* **[Cards/Profiles/Widgets]** On card and profile 'Automation' widgets, the current `record_` dictionary is now available as a default input. The input is blank on workspace widgets. Thanks to [@flexibits](https://twitter.com/flexibits) for the suggestion.

* **[Automations]** In automations, the [file.write:](/docs/automations/commands/file.write/) command now returns a `token` key in its output. This previously had to be parsed out of the `uri` identifier.

* **[Records/Cards/UX]** When editing a record from a card, the profile image now refreshes immediately when it was changed. This is implemented for: custom records, bots, contacts, groups, orgs, roles, and workers.

* **[Automations/KATA]** In automations, when using [@json](/docs/automations/#annotations) annotation, any values with a key-expansion dictionary value will now be preserved. Previously these were converted into objects and key expansion no longer functioned.

## Fixed

* **[SSO/OIDC]** Fixed an issue with OpenID Connect SSO (single sign-on) logins after a phpseclib library update.

* **[Automations]** In automations, fixed an issue with the [file.write:](/docs/automations/commands/file.write/) command where `content:bytes:` only worked with ZIP file output. It's now possible to provide content as either `bytes:` or `text:` interchangeably.

* **[Roles]** Fixed a permissions check issue when a non-admin worker is a member of a role with 'All' permissions. Depending on the order the roles are checked, this can return `void` rather than the expected `true`. Thanks to [@tomryder-inspirenet](https://github.com/tomryder-inspirenet) for the bug report and patch! [[#1739](https://github.com/jstanden/cerb/issues/1739)]