---
layout: post
title: "10.4.3"
excerpt: Cerb 10.4.3 is a maintenance update released in September 2023 with 15 improvements from community feedback.
author: The Cerb Team
date: 2023-09-14 08:00:00 -0700
permalink: /releases/10.4.3/
social_image_url: /assets/images/releases/10.4/10.4.3.png
redirect_from:
  - /10.4.3/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 15
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.3)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Automations/Events]** Added a [record.merged](/docs/automations/events/record.merged/) automation event. This triggers after a set of records have been merged together into a target, but before the source records are deleted. Thanks to [1Password](https://1password.com/) for the feature request!

## Changed

* **[Automations/Resources]** In [resource.get](/docs/automations/triggers/resource.get/) automations, autocompletion suggestions are now offered for `return:file:`.

* **[Automations/Resources]** In automations, the [file.read:](/docs/automations/commands/file.read/) command now properly suggests resource records in the `uri:` option. Previously only automation resources and attachments were suggested.

* **[Resources/Performance]** Dynamic [resources](/docs/resources/) (`resource.get` automations) now cache their output on the server-side if `return:expires_at:` is provided. Previously, a browser was instructed to cache the response (for images) but repeated requests still ran the automation each time.

* **[Sheets/Icons]** In sheets, an [icon:](/docs/sheets/#icon) column may now define both `record_uri:` and `image:`. If the former is empty or invalid it will fall back to the latter.

* **[Interactions/Worker]** In [interaction.worker](/docs/automations/triggers/interaction.worker/) automations, `sheet` element paging links and checkboxes are no longer included when autofocusing the first interactive element. This is more likely to be a text input or button.

* **[Avatars/Resources/Sheets]** The `/avatars/` endpoint can now display image-based resource records. This can be used by sheets with `icon` columns to display arbitrary images.

* **[Dashboards/Prompts]** In [dashboard](/docs/dashboards/#prompts) workspace tabs, `text:` prompts may now use `params:hidden@bool:` to conditionally hide the prompt. This is particularly useful for storing constants shared by many widgets for simplified configuration. Thanks to [@mryanb](https://github.com/mryanb/) for the feature request!

## Fixed

* **[Automations]** In automations, fixed an issue with the [api.command:](/docs/automations/commands/api.command/) `cerb.commands.dataset.vector_similarity` where dynamic resources (`resource.get` automations) weren't loaded properly.

* **[Automations]** In automations, fixed an issue with [file.read:](/docs/automations/commands/file.read/) where dynamic resources (`resource.get` automations) weren't loaded properly.

* **[Automations/Timers]** Fixed an issue with recurring [automation timers](/docs/automations/#timers) where they would self-disable after any error in the automation or event. Failed timers now properly run again at the next interval as expected.

* **[Mail/Compose/Reply]** Fixed an issue when composing or replying to tickets. These actions are now more graceful in the rare event a message record fails to create in the database after sending (e.g. network trouble). The draft is no longer removed and the message can be retried.

* **[Log/Automations]** Fixed an issue with [record.changed](/docs/automations/triggers/record.changed/) automations not triggering for new activity log entries.

* **[Packages/Resources]** Fixed an issue with creating multiple [resource](/docs/records/types/resource/) records in the same [package](/docs/packages/).

* **[Toolbars]** The [comment.editor](/docs/toolbars/interactions/comment.editor/) toolbar now includes a caller parameter for the full `text` of the editor. Previously, only `selected_text` was available.
