---
layout: post
title: "10.4.4"
excerpt: Cerb 10.4.4 is a maintenance update released in November 2023 with 23 improvements from community feedback.
author: The Cerb Team
date: 2023-11-09 08:00:00 -0800
permalink: /releases/10.4.4/
social_image_url: /assets/images/releases/10.4/10.4.4.png
redirect_from:
  - /10.4.4/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 23
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.4)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Changed

* **[Explore/Automations]** In [interaction.worker.explore](/docs/automations/triggers/interaction.worker.explore/) automations, custom toolbar interactions support `after:` options for `explore_page` and `refresh_widgets`. The former provides a default for the next page in the explore set when the interaction doesn't return one, which is useful when reusing built-in interactions like `cerb.ticket.status` or `cerb.ticket.move`. The latter can refresh widgets if the page is a record profile (for instance, refreshing 'Status' after closing a ticket). Thanks to [@myranb](https://github.com/mryanb/) for the feature request.

* **[Scheduler/Mailbox]** When the scheduler downloads and queues messages from a POP3/IMAP mailbox (`cron.mailbox`), the filename is now logged to help trace deliveries. The email parser (`cron.parser`) displays the same filename.

* **[Interactions/Website]** In `interaction.website` automations, sheets with code blocks (e.g. Markdown) are now displayed with formatting.

## Performance

* **[Maintenance/Performance]** Nightly maintenance on email address records no longer redundantly detects orphaned `fulltext_address` search index records. These are properly removed when email addresses are deleted.

* **[Maintenance/Performance]** Nightly maintenance on comment records no longer redundantly detects orphaned `fulltext_comment_content` search index records. These are properly removed when comments are deleted.

* **[Maintenance/Performance]** Nightly maintenance on comment records no longer redundantly detects orphaned attachment links. These are properly removed when comments are deleted.

* **[Maintenance/Performance]** Nightly maintenance on contact records no longer redundantly detects orphaned `fulltext_contact` search index records. These are properly removed when contacts are deleted.

* **[Maintenance/Performance]** Nightly maintenance on organization records no longer redundantly detects orphaned `fulltext_org` search index records. These are properly removed when orgs are deleted.

* **[Maintenance/Performance]** Nightly maintenance on organization records no longer redundantly detects orphaned attachment links. These are properly removed when orgs are deleted.

* **[Maintenance/Performance]** Nightly maintenance on snippet records no longer redundantly detects orphaned `fulltext_snippet` search index records. These are properly removed when snippets are deleted.

* **[Maintenance/Performance]** Nightly maintenance on ticket records no longer redundantly detects orphaned participant records. These are properly removed when tickets are deleted.

* **[Maintenance/Performance]** Nightly maintenance on worker records no longer redundantly detects orphaned `fulltext_worker` search index records. These are properly removed when workers are deleted.

## Fixed

* **[Profiles/Widgets]** Fixed an issue with conditional profile widgets when using the `current_worker_` placeholders.

* **[Interactions/Worker]** Fixed an issue with `interaction.worker` automations that use `await:interaction:` to start another interaction. The interaction `caller_`, `client_`, and `worker_` placeholders weren't set properly.

* **[Comments]** Fixed an issue where comments didn't trigger @mention notifications from some record editors, or if using `#comment` when composing or replying to mail. This affected 10.4.x versions. It didn't affect the 'Comment' button on cards and profiles. [[#1743](https://github.com/jstanden/cerb/issues/1743)]

* **[Data Queries]** Fixed an issue with autocompletion on data queries where the autocompletion suggestions menu closed prematurely.
  
* **[Automations/Mail/Moved]** Fixed an issue with `mail.moved` automations where the `actor` dictionary was empty aside from its record type.

* **[Records/Comments]** Fixed an issue when comments are removed on a deleted record. The `record.changed` automation event wasn't triggered for these comments, and their search index data wasn't removed. 

* **[Records/Messages/Maintenance]** Fixed an issue where the search index for `message_headers` records never removed deleted records.

* **[Records/Tickets]** Fixed an issue where deleting old tickets from a worklist could purge them without the expected 'undo window'. The undo timer now properly starts from the moment they are deleted (e.g. 7 days of inactivity).

* **[Maintenance/Database]** Fixed an issue where `context_to_custom_fieldset` rows weren't cleaned up in the database after deleting their parent records.

* **[Records/Widgets]** Fixed an issue in 'Record Fields' widgets on cards/profiles/workspaces where custom fields in fieldsets didn't open card popups on click. Thanks to [@mryanb](https://github.com/mryanb/) for the bug report!

* **[Widgets/Permissions]** Fixed a permission issue when configuring some workspace widgets as a non-admin worker. Thanks to [@nicholsk18](https://github.com/nicholsk18) for the bug report! [[#1747](https://github.com/jstanden/cerb/issues/1747)]