---
layout: post
title: "10.4.5"
excerpt: Cerb 10.4.5 is a maintenance update released in November 2023 with 12 improvements from community feedback.
author: The Cerb Team
date: 2023-11-24 12:00:00 -0800
permalink: /releases/10.4.5/
social_image_url: /assets/images/releases/10.4/10.4.5.png
redirect_from:
  - /10.4.5/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 12
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.5)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Automations/Mail]** In [mail.filter](/docs/automations/events/mail.filter/) automations, added the ability to assign an [organization](/docs/records/types/org/) to the sender with `return:set:email_sender_org_id:`. This occurs before the message is parsed and the new organization can be used for routing.

* **[Records/Automations]** In [automation](/docs/records/types/automation/) dictionaries, the `script` key can now be expanded to access the KATA code. Thanks to [@mryanb](https://github.com/mryanb/) for the feature request!

* **[Records/Email Addresses]** When creating or updating [email address](/docs/records/types/address/) records, an organization name can now be set directly using the `org` field. This will link an existing organization or create a new one. Previously, an org record had to be created first to use its ID in the `org_id` field.

* **[Records/Contacts]** Added the `mobile:` filter when searching [contact](/docs/records/types/contact/) records.

* **[Records/Contacts]** Added the `phone:` filter when searching [contact](/docs/records/types/contact/) records.

* **[Records/Contacts]** Added the `username:` filter when searching [contact](/docs/records/types/contact/) records.

## Changed

* **[Automations/Records]** In automations, the `record.update:` command may now provide an empty `fields:` key. For instance, if all fields are `@optional` and blank. This bypasses updating the record but still returns successfully.

* **[Packages/Performance]** When importing a package with many records, the post-import summary only shows up to 12 record images (e.g. group profile images). This avoids a flurry of server requests that could trigger rate-limiting in some environments.

## Fixed

* **[Automations/Editor]** Fixed an issue with exporting a new unsaved automation in the editor.

* **[Records/Explore]** Fixed an issue with explore mode on custom record types where prev/next was hidden. Thanks to [@mryanb](https://github.com/mryanb/) for the bug report! [[#1749](https://github.com/jstanden/cerb/issues/1749)]

* **[Automations]** In automations, fixed a validation issue with the `var.set:` command when `inputs:value:` is a dictionary.

* **[Records/Portals]** Fixed an issue when creating community portals from the API with the `params` field. A cache invalidation issue prevented these preferences from being associated with a newly created portal.
