---
layout: post
title: "10.4.7"
excerpt: Cerb 10.4.7 is a maintenance update released in January 2024 with 12 improvements from community feedback.
author: The Cerb Team
date: 2024-01-12 12:00:00 -0800
permalink: /releases/10.4.7/
social_image_url: /assets/images/releases/10.4/10.4.7.png
redirect_from:
  - /10.4.7/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 12
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.7)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Search/Keyboard/UX]** Added `/` as a global keyboard shortcut for the search menu. Thanks to [Flexibits](https://flexibits.com/) for the feature request!

* **[Interactions/Worker]** In [interaction.worker](/docs/automations/triggers/interaction.worker/) automations, a `client_url` input now provides a worker's current URL. For instance, this can be used by a custom explore mode to return the worker to their original location once finished. Thanks to [@mryanb](https://github.com/mryanb/) for the feature request!

* **[Developers/Automations]** In **Setup >> Developers >> Automation Logs** the log entries are now filterable. Thanks to [@mryanb](https://github.com/mryanb/) for the feature request!

## Changed

* **[UI/Styles]** Date picker inputs now have a consistent style with the rest of the UI and properly adapt to dark mode.

* **[Interactions/Worker]** In [interaction.worker](/docs/automations/triggers/interaction.worker/) automations, `date` form elements now render the date picker. A calendar button simplifies selecting a day, and relative dates are converted in real-time (e.g. "+2 days 5pm"). Timezones are also supported ("Monday 8am Europe/Berlin"). [[#1752](https://github.com/jstanden/cerb/issues/1752)]

* **[Mentions/Performance]** Improved the performance of the `@mention` menu in environments with many workers. When replying or commenting, the autocompletion menu could load the profile image for every worker at once (potentially hundreds or thousands), which could lead to rate-limiting on the server. The images are now lazy-loaded when visible in the autocompletion menu. In many cases a worker will enter a few characters to filter the list and only a subset of images will ever be displayed at once.

* **[Profiles/Widgets]** On record profile pages, a count of hidden widgets is displayed in the top toolbar next to 'Hidden Widgets'. Previously the button label was 'Toggle Hidden'.

## Fixed

* **[API]** Fixed an issue in the API where JSON responses were empty if they contained invalid UTF-8 bytes. For instance, the `content_html` expansion key on `/records/search/message.json`. Thanks to [1Password](https://1password.com/) for the bug report.

* **[Search/UX]** Fixed keyboard navigation in the global search menu. It's now possible to select a record type with the `Enter` key.

* **[Records/Maint]** When records are deleted, the associated merge history entries are now properly removed as well.

* **[Metrics/Maint]** When custom metrics are deleted, their historical metric values are now properly deleted as well.

* **[Worklists/Search/UX]** On worklists, fixed an issue with the search popup when using a narrow display (e.g. smartphone). The popup was too narrow to view the full options from the '...' menu. It now uses the full width when in portrait mode. Thanks to [Flexibits](https://flexibits.com/) for the bug report!
