---
layout: post
title: "10.4.9"
excerpt: Cerb 10.4.9 is a maintenance update released in January 2024 with 9 improvements from community feedback.
author: The Cerb Team
date: 2024-01-30 12:00:00 -0800
permalink: /releases/10.4.9/
social_image_url: /assets/images/releases/10.4/10.4.9.png
redirect_from:
  - /10.4.9/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 9
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.9)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[API/Automations]** In the REST API, a new endpoint ([automations/logs/search.json](/docs/api/endpoints/automations/)) searches automation log entries using queries. This makes it much easier to keep an eye on automation errors with external monitoring tools. Thanks to [ChargeOver](https://chargeover.com/) for the feature request.

* **[Code Editors/UX]** In code editors (automations, events, toolbars), added keyboard shortcuts to resize the editor. `Ctrl+Shift+Down` grows the editor and `Ctrl+Shift+Up` shrinks it. These will have a UI eventually. Thanks to [@mryanb](https://github.com/mryanb/) for the feature request.

## Changed

* **[API/Mail/Reply]** When using the [tickets/reply.json](/docs/api/endpoints/tickets/#reply) API endpoint, if a `worker_id` is provided by an admin token, the activity log entries for the reply and its consequent actions (status, move, assign) are attributed to that impersonated worker and not the token's owner. This makes it easier for integrations to reply on behalf of multiple workers. Thanks to [1Password](https://1password.com/) for the feature request.

* **[Automations/Timers]** When an automation timer is disabled, its pending continuations are now automatically cancelled. Previously, there was no obvious way to reset an automation that ended in the `await:` state. Thanks to [@myranb](https://github.com/mryanb/) for the feature request.

* **[Custom Records/UX]** When editing custom records, if 'Cerb' is the only possible owner then the 'Owner:' field isn't displayed.

## Fixed

* **[Automations/Outcomes]** Fixed an obscure issue in [automations](/docs/automations/) where a standalone [outcome:](/docs/automations/commands/outcome/) command (not a child of `decision:`) re-evaluated its `if:` condition after every command in the `then:` branch. For instance, if an `outcome:if:` was originally `true`, it could become `false` due to an `outcome:then:set:` and refuse to run the remaining commands. The `if:` condition is now properly only evaluated once when entering the outcome.

* **[Explore/Interactions]** Fixed an issue in [interaction.worker.explore](/docs/automations/triggers/interaction.worker.explore/) automations where explore [toolbar](/docs/toolbars/) buttons could re-bind event listeners when the lower page refreshed. For instance, this could inexplicably open multiple interaction popups for a single button click.

* **[Worklists/Custom Records]** Fixed an issue in worklists where a 'record link' custom field column didn't properly display the record label if the target was a custom record type.
  
* **[Worklists/Subtotals/Custom Records]** Fixed an issue in worklists where subtotaling by a 'record link' custom field column didn't properly display the record label if the target was a custom record type.