---
layout: post
title: "10.4.11"
excerpt: Cerb 10.4.11 is a maintenance update released in April 2024 with 16 improvements from community feedback.
author: The Cerb Team
date: 2024-04-12 15:00:00 -0700
permalink: /releases/10.4.11/
social_image_url: /assets/images/releases/10.4/10.4.11.png
redirect_from:
  - /10.4.11/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 16
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.11)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Tickets/Merge/UX]** On ticket profiles, the sort order of the 'Merge' ticket chooser autocompletion is now configurable with the `APP_OPT_AUTOCOMPLETE_TICKET_QUERY` configuration setting. This defaults to `sort:-id` which is the most efficient, but some environments have requested `sort:-updated` to view recently updated tickets first.

* **[Sheets]** On sheets, `selection:` columns have an optional `selectable@bool:` parameter for conditionally disabling row selection. Thanks to [@mryanb](https://github.com/mryanb) for the feature request.

## Changed

* **[Records/Custom Fieldset]** In custom fieldset worklists, the `ID` column is now available.

* **[Activity Log/Performance]** The activity log no longer records when a worker deletes a draft.

* **[Notifications/Maintenance]** Unread notifications now expire after 6 months.

* **[Records/Automations]** The `record.viewed` automation event no longer triggers for record editor popups (only cards).

* **[Automations/Performance]** Automation record lookups are now cached for the duration of a request. Previously, toolbars like `mail.reply` on the ticket profile could load multiple copies of the same automation.

* **[Tickets/Merge/UX]** On ticket profiles, the 'Merge' chooser autocompletion now includes the created date, sender, and group. This makes it easier to differentiate tickets with similar subjects.

* **[Records/Tickets]** In ticket record dictionaries, optimized the `requesters` key expansion. Previously this ran individual queries to fetch contact information for each participant. It now runs a single query per ticket regardless of the number of participants.

* **[Profiles/Performance]** On record profiles, the 'Record Fields' widget is slightly more efficient. Previously, it could load a record twice if viewing the current profile record (opposed to viewing a related record).

* **[TimeTracking/Performance]** Time Tracking Activity records are now cached to reduce database queries.

* **[Tickets/Performance]** On ticket profiles, drastically optimized record lookups for attachments and comments. Previously, comments and sticky notes independently fetched their own attachments and custom fields. On a long ticket this could lead to 100+ extra queries. This data is now loaded preloaded once for all comments and notes.

## Fixed

* **[Profiles/Record Fields]** On record profiles, fixed an issue with 'Record Fields' widgets with long field values. For instance, a long 'URL' field could push other values off the page without wrapping.

* **[Records/Cache/Performance]** Fixed an issue with record dictionaries where the cache could be cleared too frequently during reads. The `record.changed` automation event establishes `was_record_` dictionaries from the database and ignores the cache (e.g. custom fields/fieldsets), but this unintentionally cleared the cache on other records (e.g. workers) and lead to extra database lookups.

* **[Tickets/Performance]** On ticket profiles, fixed an issue where messages without attachments lacked a negative cache from the initial preload. Each expanded message would independently load attachment data an extra time (which would also be blank).

## Security

* **[Security/Logging]** The `?loglevel` query parameter is now only available when `DEVELOPMENT_MODE` is enabled or a trusted IP is using the `/cron` endpoint.