---
layout: post
title: "10.4.12"
excerpt: Cerb 10.4.12 is a maintenance update released in April 2024 with 7 improvements from community feedback.
author: The Cerb Team
date: 2024-04-23 20:00:00 -0700
permalink: /releases/10.4.12/
social_image_url: /assets/images/releases/10.4/10.4.12.png
redirect_from:
  - /10.4.12/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 7
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.12)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Automations/Commands]** In automations, added `cerb.commands.activity.log` to `api.command:`. This creates arbitrary activity log entries and handles watcher notifications.

## Changed

* **[Scheduler/Mailboxes/Logging]** In the `cron.mailbox` scheduler job, added additional details to the app logs when an IMAP server returns an error.

* **[Connected Services/SSO]** OpenID Connect connected services now log which specific constraints failed token validation during SSO (single sign-on).

## Fixed

* **[Connected Services/SSO/]** Fixed an issue with OpenID Connect connected services. Requested scopes other than `openid` weren't being set on the ID token, so some identity providers (e.g. Okta) didn't return the `email` claim and SSO logins failed.

* **[Connected Services/SSO]** Fixed an issue with OpenID Connect connected services where the optional `nbf` (Not Before) claim was treated as required. Some popular identity providers (e.g. Okta) don't include `nbf`, which caused ID tokens to fail validation.

* **[Scheduler/Behaviors]** Fixed an issue where the `cron.parser` scheduler job could remain locked after a parse until the lock times out (10 mins). If a behavior or automation resulted in a worklist error, the platform would attempt to add the error to the marquee above the worklist for the current session. This makes sense in the UI, but the scheduler is usually stateless; so accessing the session redirected the browser to a platform error message and ended the request. This prevented the scheduler from removing the lock on the job. These errors are now handled more gracefully and don't abort the email parser job.

* **[Plugins/Search]** Fixed an issue with record types not updating in the search menu when enabling/disabling plugins.