---
layout: post
title: "10.4.13"
excerpt: Cerb 10.4.13 is a maintenance update released in May 2024 with 12 improvements from community feedback.
author: The Cerb Team
date: 2024-05-02 15:00:00 -0700
permalink: /releases/10.4.13/
social_image_url: /assets/images/releases/10.4/10.4.13.png
tags: cerb announcements releases
release:
  type: maintenance update
  count: 12
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.13)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Login/MOTD/Automations]** Added an optional 'Message of the Day' (MOTD) step to the login process (after authenticating password + MFA, but before permitting access). This is configured from the [worker.authenticated](/docs/automations/events/worker.authenticated/) automation event, which may now return an optional `motd` key. The 'Continue' button label is configurable (e.g. "I accept"). The MOTD can be used for dynamic announcements, terms of use, etc. It may show conditionally for only some workers, show different content depending on the worker, and fetch content from API/RSS (e.g. upcoming company calendar events). [[#1779](https://github.com/jstanden/cerb/issues/1779)]

* **[Automations/Commands]** In automations, added `cerb.commands.email.spam.train` to [api.command:](/docs/automations/commands/api.command/). This triggers spam training on the given ticket ID, which can be used in shortcuts (e.g. ticket profile toolbars). [[#1781](https://github.com/jstanden/cerb/issues/1781)]

* **[Automations/Scripting]** In automation scripting, added a new [\|hash(algo,raw)](/docs/scripting/filters/#hash) filter with many hashing algorithms: `crc32`, `md5`, `murmur3a`, `murmur3c`, `murmur3f`, `sha1`, `sha256`, `sha512/224`, `sha512/256`, `sha512`, `sha3-224`, `sha3-256`, `sha3-384`, `sha3-512`, `whirlpool`, `xxh32`, `xxh64`, `xxh3`, `xxh128`. A recent integration (PKCE) required a SHA-256 hash.

* **[Automations/Scripting]** Added a `cerb_extract_mentions()` function to automation scripting. This returns a list of worker dictionaries for matching `@mentions`.

## Changed

* **[Records/Custom Fields]** In record dictionaries, decimal custom fields now include a `_label` suffixed key with the formatted number.

* **[Records/Custom Fields]** On records, currency and decimal custom fields may now store negative numbers. Thanks to [@mryanb](https://github.com/mryanb/) for the feature request.

## Fixed

* **[SSO/SAML/Login]** Fixed an issue with SAML SSO where successful logins didn't redirect to the expected page. Thanks to [Flexibits](https://flexibits.com/) for the bug report.

* **[Support Center/KB]** Fixed an issue with the URL in Support Center knowledgebase RSS feeds.

* **[UI/Chooser]** Fixed an issue with the date chooser UI element where it wasn't visually distinguishing the current day from the selected one. Thanks to [Advance Local](https://www.advancelocal.com) for the bug report.

* **[Records/Messages]** Fixed an issue with deleting message records from the UI where the parent ticket stats weren't rebuilt properly (e.g. `num_messages`, `first_message_id`, `last_message_id`). Thanks to [@mryanb](https://github.com/mryanb/) for the bug report.

* **[Data Queries]** Fix an issue with data query autocompletion not updating suggestions properly.

## Security

* **[Platform/Security]** The `/debug` endpoint is now disabled by default unless `DEVELOPMENT_MODE_ALLOW_DEBUG` is enabled in the config file. 