---
layout: post
title: "10.4.14"
excerpt: Cerb 10.4.14 is a maintenance update released in May 2024 with 12 improvements from community feedback.
author: The Cerb Team
date: 2024-05-16 16:00:00 -0700
permalink: /releases/10.4.14/
social_image_url: /assets/images/releases/10.4/10.4.14.png
tags: cerb announcements releases
release:
  type: maintenance update
  count: 12
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.14)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Connected Accounts/OAuth2]** In OAuth2 connected accounts, a new 'Authorization Code with PKCE' grant type is available. This automatically handles the 'Proof Key for Code Exchange' extension for APIs that require it (e.g. Salesforce).

* **[Automations/Scripting]** Added a [cerb_current_worker()](/docs/scripting/functions/#cerb_current_worker) function to automation scripting to return the current worker session (if any). This is particularly useful in situations where a `current_worker_` placeholder isn't available (e.g. sheet profile widgets). The optional `expand` parameter provides a comma-separated list or array of keys to expand (e.g. `customfields`).

* **[Records/Addresses]** On [email address](/docs/records/types/address/) worklists, added a `worker:` deep search filter. For instance, this can filter email addresses linked to deactivated workers.

## Changed

* **[Automations/Connected Accounts]** In automations, the `http.request:` command with an OAuth2 connected account will now properly utilize refresh tokens in response to a '401 Unauthenticated' HTTP response. The refresh is only attempted once per request. Previously, this was only refreshing if the access token included an `expires_in` properly. This didn't handle other situations like server-revoked tokens or APIs that don't include an explicit expiration.

* **[Debug]** The `DEVELOPMENT_MODE_ALLOW_DEBUG` may now be a comma-delimited string with options `status,phpinfo,report,check` to enable only specific debug actions. A boolean value of `true` enables everything, and `false` or omission disables the debug endpoint.

* **[Automations]** The `cerb.ticket.assign` automation now accepts an optional `worker:` input for directly setting a new owner without prompting. This can be used to more easily add a 'Take' button to ticket profiles. [[#1784](https://github.com/jstanden/cerb/issues/1784)]

* **[Records/Log/Workers]** The activity log now records when a worker account is created using the `record.created` event. [[#1785](https://github.com/jstanden/cerb/issues/1785)]

* **[Interactions/Website/Styles]** In `interaction.website` interactions, removed the drop shadow from `sheet:` form elements.

* **[Worklists/Orgs]** Organization worklists may now be subtotalled by the 'Name' field.

## Fixed

* **[Connected Accounts/OAuth2]** In OAuth2 connected accounts, the `error` and `error_description` params are now properly cleared when an access token is successfully retrieved. Previously these keys were merged into the new token.

* **[Groups/Roles]** Fixed an issue when editing a worker where group memberships were updated after rebuilding roles. This caused any roles based on groups to not update properly. Thanks to [@nicholsk18](https://github.com/nicholsk18) for the bug report. [[#1770](https://github.com/jstanden/cerb/issues/1770)]

* **[Automations]** Fixed an issue in the automation editor where changing the trigger event removed the 'show changes' and 'export' buttons from the toolbar.