---
layout: post
title: "10.4.15"
excerpt: Cerb 10.4.15 is a maintenance update released in May 2024 with 11 improvements from community feedback.
author: The Cerb Team
date: 2024-05-29 13:00:00 -0700
permalink: /releases/10.4.15/
social_image_url: /assets/images/releases/10.4/10.4.15.png
tags: cerb announcements releases
release:
  type: maintenance update
  count: 11
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.15)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Records/Ticket]** On [ticket](/docs/records/types/ticket/#search-query-fields) records, added a new `mask.merged:` search filter for matching tickets based on source masks merged into them. This can be a single mask or an array. Thanks to [ChargeOver](https://chargeover.com/) for the feature request.

## Changed

* **[Metrics/Data Queries]** In [metrics.timeseries](/docs/data-queries/metrics/timeseries/) data queries, added new `function:` aggregations for `faceted_average`, `faceted_min`, `faceted_max` for gauges. These functions aggregate contemporary samples with different dimensions that aren't specified in `by:`. For instance, the `cerb.tickets.open` metric has dimensions for group/bucket, and `function:faceted_average` will return the average number of total open tickets as the sum of the bucket averages, while `function:average` returns a simple average across buckets. The `avg`, `min`, and `max` functions now act directly against samples. For instance, a gauge metric that samples the current temperature in various locations would never aggregate those locations into a total temperature; it would use a simple average across all samples for a regional/global average temperature at given times.

* **[Automations/Usability]** In automations, when using the [record.upsert:](/docs/automations/commands/record.upsert/) command, a policy was non-intuitively required for `record.upsert:`, `record.create:`, and `record.update:`. The `record.create:` and `record.update:` policies during an upsert are now optional and will otherwise use the same policy as `record.upsert:` (e.g. record type).

* **[Automations/Editor/Usability]** Improved error reporting in the automation editor. Command errors now include the key path in the script where the error was triggered.

* **[UI/Ajax/UX]** When an asynchronous (Ajax) request to the server receives an HTTP 504 (Gateway Timeout) response, a more helpful error code is displayed in the browser. Previously these requests could silently fail.

## Fixed

* **[Metrics/Data Queries]** Fixed an issue with faceted gauge [metrics](/docs/metrics/) like `cerb.tickets.open` when using a `period:` of `week`, `week-sun`, `month`, or `year`. These are expected to aggregate (avg/min/max) the daily totals within the period, but returned a sum of the daily aggregations instead. Thanks to [@mryanb](https://github.com/mryanb/) for the bug report.

* **[Data Queries/Subtotals]** Fixed an issue in [worklist.subtotals](/docs/data-queries/worklist/subtotals/) data queries when using `by.count:` on a worker-based custom field. Using `field` or `field.id` both returned the ID, when the former should have returned the name. Thanks to [@mryanb](https://github.com/mryanb/) for the bug report.

* **[Automations]** Fixed an issue with [record.upsert:](/docs/automations/commands/record.upsert/) in automations. Previously, query errors like unknown filters were ignored (e.g. `iid:` vs `id:`), which resulted in `record.create:` always triggering when `record.update:` was expected. Invalid queries now properly return an error.

* **[Automations]** Fixed an issue with [record.search:](/docs/automations/commands/record.search/) in automations. Previously, query errors like unknown filters were ignored and zero results were returned. Invalid queries now properly return an error.

* **[Records/Groups]** Fixed an issue where group-owned signatures were orphaned when a group was deleted. [[#1787](https://github.com/jstanden/cerb/issues/1787)]

## Security

* **[Security/Dependencies]** Updated the Smarty template library from v4.3.4 to v4.5.3 in response to a security advisory.