---
layout: post
title: "10.4.17"
excerpt: Cerb 10.4.17 is a maintenance update released in June 2024 with 9 improvements from community feedback.
author: The Cerb Team
date: 2024-06-19 00:00:00 -0700
permalink: /releases/10.4.17/
social_image_url: /assets/images/releases/10.4/10.4.17.png
tags: cerb announcements releases
release:
  type: maintenance update
  count: 9
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.17)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Tickets/Search/Performance]** On [ticket](/docs/records/types/ticket/) records, added `sender.first:` and `sender.last:` deep search filters. These can target any fields on an email address record for the first message sender and last message sender more efficiently than `messages.first:(sender:)` and `messages.last:(sender:)`.

## Changed

* **[Worklists/Copy/UX]** When using the 'copy' action from a [worklist](/docs/worklists/), only 'Worklists' tabs are shown as valid targets. A workspace page is hidden if it doesn't contain any target tabs.

* **[Roles/UX]** A [role](/docs/roles/) record may no longer be deleted if it owns: workspaces pages, custom fieldsets, bots, connected accounts, snippets, or calendars. These owned records must be deleted or reassigned first. Previously, a role's owned records were deleted with it without any warning.

* **[Cards/Widgets]** When editing card widget, `worker_` placeholders for the current worker are now available.

* **[Scheduler/Log]** In the `cron.parser` [scheduler](/docs/setup/configure/scheduler/) job, the log output now includes the duration of each triggered behavior. This helps with tuning email parser performance.

## Fixed

* **[Records/UI]** On record editors that use the owner chooser (e.g. bots, snippets), truncated labels (e.g. groups, roles) now show their full content in a tooltip when hovering.

* **[Roles/Tickets]** Fixed an issue on ticket [profiles](/docs/profiles/) where the ability to 'Sticky Note' on a message also required the 'Reply' permission. Sticky notes now only require the 'Comment create' and 'Message comment' permissions in a role.

* **[Roles/Files]** Fixed an issue where the attachment popup didn't check the 'Can download' permission on previews for some file types.

* **[Bots/Behaviors]** Fixed an issue with the 'Set links' action in legacy bot behaviors where some placeholders in the dropdown could appear blank.
