---
layout: post
title: "10.4.19"
excerpt: Cerb 10.4.19 is a maintenance update released in August 2024 with 12 improvements from community feedback.
author: The Cerb Team
date: 2024-08-09 16:00:00 -0700
permalink: /releases/10.4.19/
social_image_url: /assets/images/releases/10.4/10.4.19.png
tags: cerb announcements releases
release:
  type: maintenance update
  count: 12
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.19)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Worklists/Groups]** Group records can now be subtotaled by: email template, send as, send from, signature, and signing key.

* **[Encryption/PGP]** When generating a new PGP Private Key, a hash algorithm may be selected: SHA224, SHA256 (default), SHA384, SHA512.

## Changed

* **[Logs/Comments]** Deleted comments are now recorded in the Activity Log.

* **[Encryption/PGP]** `gpg.keyinfo` data queries now include `key_bits` for keys and subkeys (e.g. 2048, 3072, 4096).
  
* **[Encryption/PGP]** `gpg.keyinfo` data queries now include `algorithm` and `algorithm_name` for keys and subkeys (e.g. RSA).

* **[Encryption/PGP]** `gpg.keyinfo` data queries now include `hash_algorithm` and `hash_algorithm_name` for keys and subkeys (e.g. SHA256, SHA512).

* **[Encryption/PGP]** On PGP Public Key cards, the 'Subkeys' widget in the library now includes key length, algorithm, and hash algorithm.

* **[Encryption/PGP]** When generating a new PGP Private Key, the User ID is now included in header on the sharable public key output.

## Fixed

* **[Encryption/PGP]** Fixed an issue with signatures in the `openpgp-php` library that prevented Thunderbird and other RNP-based projects from importing keys and decrypting messages generated in Cerb.

* **[Encryption/PGP]** Fixed an issue with PGP encryption from automations and when sending email. In some situations, a non-encryption (e.g. signing) subkey from a recipient public key was included. This could prevent message decryption in strict clients; particularly those using the RNP library like Mozilla Thunderbird. This previously generated a warning in GPG/GnuPG-based clients.

* **[Code Cleanup/UI]** Fixed the autocompletion style on date input helpers (e.g. timezones).

* **[Worklists/Subtotals]** Fixed an issue with clicking subtotals on workspace widget records.
