---
layout: post
title: "10.4.20"
excerpt: Cerb 10.4.20 is a maintenance update released in August 2024 with 19 improvements from community feedback.
author: The Cerb Team
date: 2024-08-20 12:00:00 -0700
permalink: /releases/10.4.20/
social_image_url: /assets/images/releases/10.4/10.4.20.png
tags: cerb announcements releases
release:
  type: maintenance update
  count: 19
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.20)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Widgets/Charts]** In Chart KATA widgets, added an `axis:rotated@bool:` key to swap the X and Y axes. For instance, a categories chart with categories on the vertical axis and counts on the horizontal axis.

* **[Workspaces/Widgets]** When adding a new workspace widget, the 'Worklist' template in the library now includes a 'My Drafts' example.

* **[Workspaces/Widgets]** When adding a new workspace widget, the 'Worklist' template in the library now includes a 'My Notifications' example.

* **[Workspaces/Widgets/Chart]** When adding a workspace widget, a new 'Chart' template in the package library provides several examples of Chart KATA. This replaces the deprecated widget types like 'Chart: Categories' and ''Chart: Timeseries'.

* **[Records/Message]** In the records API, when creating a `message` record, an optional `content_html` shortcut will now automatically create an HTML attachment and link it to the message. Previously this had to be done manually.

* **[Data Queries/Sample]** Added a new `sample.records` data query type for generating a manual data set of record dictionaries.

## Changed

* **[Workspaces/Charts]** When editing a 'Chart KATA' workspace widget, an autocomplete button is now available in the datasets and chart editor toolbars.

* **[Workspaces/Pages]** When adding a new workspace page, the 'Home' template in the library now includes a 'My Notifications' worklist at the top of the dashboard. This helps ensure workers are aware of their recent notifications.

* **[Worklists/Tasks]** On task worklists, a compact single-line format can be used by adding 'Title' as a column. Otherwise, the default is to use two rows per record with the title on its own full line.

* **[Data Queries]** In `record.types` data queries, added an `exclude_custom:yes` option to exclude custom record types. The results also include an `is_custom` key to make it easier to differentiate them from the built-in record types.

* **[Sheets]** In sheets, the `search:` column now supports the `underline@bool:` option. This creates links without an underline text decoration.

* **[Sheets]** In sheets, `selection:` columns now autocomplete the `mode:` options (`single`, `multiple`).

* **[Records/Message]** In the records API, when creating or updating a `message` record with the `html_attachment_id` field, the targeted attachment is now automatically linked to the message. Previously, this required an additional update to link a new attachment and new message together.

## Fixed

* **[Workspaces/Widgets/Sheets]** Fixed an issue with Sheet workspace widgets where the interaction chooser in 'Display this sheet toolbar' didn't insert the KATA into the editor.

* **[Automations/PGP]** In automations, improved error checking on the `decrypt.pgp:` command. This now properly catches exceptions from OpenPGP or phpseclib.

* **[Worklists/Tasks]** Fixed an issue with task worklists where the 'Reopen At' column wasn't formatted as a date.

* **[Bots/Behaviors]** In bot behaviors using the 'Before message sent by worker' event, fixed an issue with 'Set header' when a draft's headers weren't in the expected format (e.g. from the API). This could block the 'Mail Queue Processor' scheduler job from continuing properly.

* **[UI/Popups]** Fixed an issue with minimizing popup windows where the top right icon didn't toggle between minimize/maximize.

* **[Sheets]** In sheets, fixed an issue with `search:` columns where the `query:` option couldn't be blank. It's a legitimate use case to open a search worklist with unfiltered records.
