---
layout: post
title: "10.4.21"
excerpt: Cerb 10.4.21 is a maintenance update released in August 2024 with 13 improvements from community feedback.
author: The Cerb Team
date: 2024-08-28 12:00:00 -0700
permalink: /releases/10.4.21/
social_image_url: /assets/images/releases/10.4/10.4.21.png
tags: cerb announcements releases
release:
  type: maintenance update
  count: 13
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.21)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Data Queries]** In `data.query.types` data queries, added an optional `exclude_custom` option to filter out bot-powered data queries.

* **[Sheets/Interactions]** In sheets, `interaction:` columns can now specify an optional `icon:`.

## Changed

* **[Automations/Scripting]** In automation scripting, added `image_info` to the filter autocompletion menu.

* **[Installer/Demo]** In the installer 'Demo' package, updated the default profile images for the example workers.

* **[Sheets/Interactions]** In sheets, added `bold:` as an option on `interaction:` columns.

* **[Worklists/Tasks]** In task worklists, the 'Status' column values are lowercase to be consistent with ticket worklists.

## Fixed

* **[Automations]** Fixed an issue in automation autocompletion where the `as:` option shows up in `file.write:` rather than `await:form:elements:fileUpload:`.

* **[Docker]** Fixed the Docker configuration for MySQL 8.4+.

* **[Interactions/Worker]** In `interaction.worker` automations, fixed an issue with sibling `editor:` form elements where the last toolbar could be reused on subsequent editors if they lacked a toolbar.

* **[Interactions/Worker]** In `interaction.worker` automations, fixed an issue where `fileDownload:` await form elements autocompleted with `uri: cerb:automation:`. Instead, this should be an `attachment`, `automation_resource`, or `resource`.
  
* **[Interactions/Worker]** In `interaction.worker` automations, fixed an issue with `editor:` form element syntax highlighting when using `html`, `json`, `markdown`, or `yaml`.

* **[Sheets]** In sheets, fixed an issue with `interaction:` columns where they always refreshed the current widget after running.

* **[Workspaces/Pages/UX]** Fixed an issue with workspace pages using 'menu' mode (rather than tabs) where the menu didn't render properly.