---
layout: post
title: "10.4.22"
excerpt: Cerb 10.4.22 is a maintenance update released in September 2024 with 8 improvements from community feedback.
author: The Cerb Team
date: 2024-09-12 12:00:00 -0700
permalink: /releases/10.4.22/
social_image_url: /assets/images/releases/10.4/10.4.22.png
tags: cerb announcements releases
release:
  type: maintenance update
  count: 8
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.4.22)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.4](/releases/10.4/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Changed

* **[Sheets/UX]** On sheet widgets, the example data query expands `customfields` rather than `custom_`. This returns custom fields as human readable URIs rather than IDs.

* **[Sheets]** In sheets, the `slider:` column now supports negative scales (e.g. -100 to +100) and values.

* **[Developers]** In the Setup->Developers menu, renamed 'Bot Scripting' to 'Automation Scripting'.

## Deprecated

* **[Plugins]** Marked several old plugins as deprecated: Opportunity Tracking, Legacy Knowledgebase, Call Logging, Servers, Domains, JIRA, and Notifications Emailer. These can be reimplemented with custom records and automations as workflows.

## Fixed

* **[Records/Tickets]** When updating a `ticket` record through automations or the API, the `content_html` field no longer creates a new `original_message.html` attachment if one already existed.

* **[Records/Tickets]** Fixed an issue with creating tickets through automations and the API where the `last_opened_at` field wasn't defaulted properly.

* **[Maint/Tickets]** Fixed an issue in the maintenance scheduler job. The ticket purge batch size couldn't be changed from `100` regardless of what was set.

* **[Automations]** Fixed an issue with `data.query` automations in the automation editor where common toolbar buttons like 'autocomplete' and 'export' weren't shown.