---
title: License
excerpt: The terms and conditions by which we license Cerb to you.
layout: page
jumbotron:
  title: Software License
  tagline: The terms and conditions by which we license Cerb to you.
---

# Devblocks Public License 1.0 (DPL)

The following are the terms and conditions by which __Webgroup Media, LLC__
("Licensor") grants you a License to use, modify, and redistribute this
software, which is protected as the exclusive intellectual property of
Licensor by U.S. copyright law.

Licensor's copyrights are also protected by international treaties where
applicable, including but not limited to: the Berne Convention, World
Intellectual Property Organization (WIPO), and the World Trade
Organization's (WTO) Trade-related Aspects of Intellectual Property
Rights (TRIPS).

By using this software, you acknowledge having read this License and
agree to be bound thereby.

* TOC
{:toc}

## Definitions

* The terms _"reproduce"_, _"reproduction"_, and _"distribution"_ have the same meaning here as under U.S. copyright law.

* _"You"_ means the licensee of the software.

- _"Your organization"_ means the company, institution, cause, or other group represented by you while using this software.

-  _"Private use"_ means use of this software within your organization, and it specifically excludes the right to distribute this software outside of your organization.

## Grant of Rights

-  **Copyright Grant** - Subject to the terms of this License, Licensor
   grants you a non-transferable, non-exclusive, worldwide, royalty-free
   copyright license to reproduce this software for private use.

-  **Modification and Redistribution of Derivative Works** - You are
   permitted to produce and distribute modifications to this software
   provided that the following conditions are met:

   -  You must not alter or obliterate any copyright notices found in
      this software or its source code.
   -  Your website and documentation must provide a clearly visible link to this
      software's official website. You must clearly state that your
      modifications are an unofficial version that is derived from this
      software.
   -  You are not permitted to produce or disseminate any technology or
      modifications to this software or source code which circumvent its
      digital copyright protection or interfere with the enforcement of
      per-seat licensing.
   -  This software must remain compatible with digital software
      licenses authorized and issued exclusively by Licensor.
   -  Your modifications must remain publicly available in source code
      form, and may not be encrypted, obfuscated, or otherwise rendered
      intentionally human-unreadable.
   -  Any modifications you make to this software and its source code
      must continue to be governed by this License.
   -  Neither the name of Licensor nor the names of its contributors may
      be used to endorse or promote redistributions of this software
      without prior written permission from Licensor.
   -  You are prohibited from charging a fee for redistributing this
      software without prior written permission from Licensor.

-  **Third-Party Plugins** - You are permitted to produce, install, and
   publicly distribute modifications to this software which operate as
   *"plugins"*. Third-party plugins do not modify or distribute the
   source code of this software; instead, plugins introduce new
   functionality through an Application Programming Interface (API) to
   utilize services and resources provided by this software.

   -  You retain the copyright to any plugins you create.
   -  You are not required to distribute your plugins.
   -  You may distribute your plugins under any software license.
   -  You may sell your plugins, or charge a fee for the development of
      new plugins.
   -  You agree that Licensor is not liable for the effects of any
      third-party plugins that you produce or install.

## Governing Law and Venue

This License, its construction, performance, scope, validity, and
effects are governed and shall be construed in accordance with the laws
applicable and in force in the United States.

The parties agree, for any claim or judicial proceedings for whatever
reason relating to this License, to designate and hereby designate the
courts of the judicial district of Orange County, California, as the
appropriate venue for the hearing of any such claims or judicial
proceedings, to the exclusion of any other courts, judicial district or
jurisdiction that may have the right to hear such dispute.

## Limited Warranty

Licensor warrants that this software will perform substantially in
accordance with the accompanying materials for a period of ninety (90)
days from the date of receipt. If an implied warranty or condition is
created by your state or jurisdiction, and federal, state, or provincial
law prohibits disclaimer of it, you also have an implied warranty or
condition, but only as to the defects discovered during the period of
this limited warranty (90 days). As to any defects discovered after the
90 day period, there is no warranty or condition of any kind. Some
states or jurisdictions do not allow limitations on how long an implied
warranty or condition lasts, so the above limitation may not apply to
you. Any updates or patches to this software provided to you after the
expiration of the 90 day Limited Warranty period are not covered by any
warranty or condition, express, implied, or statutory.

## Disclaimer of Warranties

The Limited Warranty described above is the only express warranty made
to you and is provided in lieu of any other express warranties or
similar obligations. Except for the Limited Warranty or when otherwise
stated in writing the copyright holders and/or other parties, and to the
extent permitted by applicable law, this software is provided to you
*"AS IS"* without warranty of any kind, either expressed or implied,
including, but not limited to, the implied warranties of merchantability
and fitness for a particular purpose. The entire risk as to the quality
and performance of the program is with you. Should the program prove
defective, you assume the cost of all necessary servicing, repairs, or
corrections.

## Limitation of Liability and Remedies

In no event unless required by applicable law or agreed to in writing
will Licensor be liable to you under any circumstances for any lost
profits or any indirect, special, consequential or punitive damages
including, without limitation, loss or alteration of data, failure to
provide support, interruption of business, or loss of employee work
time. Some jurisdictions do not allow the exclusion or limitation of
certain warranties or liability for loss or damage caused by negligence,
breach of contract or breach of implied terms, or incidental or
consequential damages. Accordingly, only the limitations which are
lawful in your jurisdiction will apply to you and Licensor's liability
will be limited to the maximum extent permitted by law. The entire
liability of Licensor shall not exceed the aggregate amount paid by you
for the software.
