---
layout: page
title: Pricing for self-hosted Cerb licenses
excerpt: Deploy Cerb in the cloud or host it yourself. Start a free trial.
permalink: /pricing/self-hosted/
redirect_from:
  - /download/
  - /pricing/site/
jumbotron: 
  title: Pricing for self-hosted Cerb licenses
  tagline: Deploy a self-managed copy of Cerb installation on your own hardware
keywords: pricing price cost download
---

<h1 id="cloud" style="
vertical-align: bottom;
    background-color: rgb(232, 232, 232);
    font-size: 32px;
    font-weight: normal;
    border: 1px solid rgb(181, 181, 181);
    color: rgb(120, 111, 114);
    padding: 5px 10px;
    border-bottom: 0;
    width: 40%;
    text-align: center;
    display: inline-block;
    border-radius: 5px 5px 0 0;
    margin: 0;
    z-index: 2;
    cursor: pointer;
    background: -webkit-linear-gradient(top, white, #c8c8c8);
    background: -moz-linear-gradient(270deg, white, #c8c8c8);
    background: -o-linear-gradient(top, white, #c8c8c8);
    background: -ms-linear-gradient(top, white, #c8c8c8);
    background: linear-gradient(top, white, #c8c8c8);"><a href="/pricing/" style="color:inherit;">Cerb Cloud</a></h1>
    
<h1 id="site-license" style="
vertical-align: bottom;
    position: relative;
    border: 1px solid rgb(150, 150, 150);
    padding: 5px 10px;
    display: inline-block;
    border-radius: 5px 5px 0px 0px;
    margin: 0;
    margin-left: -5px;
    width: 40%;
    text-align: center;
    border-bottom: 1px solid white;
    z-index: 2;
    color: rgb(18, 101, 186);
    background: -webkit-linear-gradient(top, #eff9ff, white);
    background: -moz-linear-gradient(270deg, #eff9ff, white);
    background: -o-linear-gradient(top, #eff9ff, white);
    background: -ms-linear-gradient(top, #eff9ff, white);
    background: linear-gradient(top, #eff9ff, white);">Self-Hosted</h1>
    
<div style="
position: relative;
    top: -1px;
    z-index: 0;
    margin: 0 0 10px 0;
    padding: 0;
    vertical-align: top;
    border-top: 1px solid rgb(150, 150, 150);"></div>

<div>
	<div style="font-size:125%;">
		<b>$37/seat-month</b> (billed yearly) or <b>$40/seat-month</b> (billed monthly):
	</div>
	
	<ul>
		<li><b>Seats</b> determine the maximum number of workers who can use Cerb at the same time.</li>
		<li><b>Cerb permits the use of a single seat for free.</b> Simply <a href="/docs/installation/">install Cerb</a> -- no registration is required.</li>
		<li>Self-hosted on your hardware and network.</li>
		<li>You're responsible for installation, upgrades, scaling, monitoring, security, and backups.</li>
		<li>Same business day support directly from Cerb's developers.</li>
		<li>Discount for <abbr title="Renew your license within 30 days after expiration to receive the timely renewal discount." style="cursor:help;">timely</abbr> future annual renewals (<b>$34/seat-month</b>).</li>
		<li>Ideal for regulatory compliance (GDPR, HIPAA, Sarbanes-Oxley).</li>
		<li>Requires PHP 7.0+ and MySQL 5.6+.</li>
		<li>Access to 100% of our source code on <a href="https://github.com/cerb/cerb-release/" target="_blank">GitHub</a>.</li>
		<li>Your license never expires for versions released during your software updates coverage.</li>
		<li><a href="/docs/upgrading/">Upgrade</a> from any version to the latest update within minutes.</li>
	</ul>
</div>

<a href="/signup/" class="cerb-button">Start a free evaluation</a>

<a href="/docs/installation/" class="cerb-button">Read the installation guide</a>

<button type="button" class="cerb-button" data-cerb-bot-interaction="license">Buy and manage licenses</button>

<div style="font-size:125%;">
	<b>Add enterprise technical support from Cerb's highly experienced developers with no long-term commitments:</b>
</div>

<div class="grid" style="margin-left:15px;">
	<div class="unit half">
			<div style="text-align:left;">
				<h2 style="color:rgb(100,100,100);"><b>Standard Support</b></h2>
				<b>Included with a self-hosted Cerb license:</b>
				<ul>
					<li>
						Support:
						<ul>
							<li>By email</li>
							<li>Same business day responses</li>
							<li>Concept-level guidance</li>
							<li>Covers the latest stable version</li>
						</ul>
					</li>
				</ul>
			</div>
	</div>
	
	<div class="unit half">
			<div style="text-align:left;">
				<h2 style="color:rgb(165,73,3);"><b>Enterprise Support</b></h2>
				<b>Greater of +$500/month or +$30/month per seat:</b>
				<ul>
					<li>
						Top-priority support, training, and consultation:
						<ul>
							<li>By email, phone, screen sharing, or Slack</li>
							<li>Same business day responses</li>
							<li>Emergency support within 1 hour (including nights, weekends, and holidays)</li>
							<li>Covers any <a href="/docs/history/">version</a> released within the past 12 months</li>
							<li>Hands-on guidance and review of your specific implementation</li>
							<li>Developer support for API usage, integration, plugin development</li>
							<li><abbr title="PHP/FPM, MySQL, Nginx/Apache/IIS, Redis/Memcached, etc.">Server</abbr> configuration</li>
							<li><abbr title="e.g. Accidental deletion, corruption.">Data recovery</abbr></li>
						</ul>
					</li>
				</ul>
			</div>
	</div>
</div>

{% include testimonials.html %}

<br/>

<h1 id="faq" style="font-size:2.5em;margin-bottom:20px;">FAQ</h1>

<div id="seats"></div>

## What are seats?

Seats determine the maximum number of workers who can use Cerb at the same time.

For example, a team of 30 workers who are evenly split into three, non-overlapping shifts (morning, day, night) would only require 10 seats. That's the highest number of workers who would ever be logged in at the same time.

You aren't paying per worker account, so there isn't a penalty for inviting everyone to participate: full-time staff, part-time contributors, busy executives, interns, temps, contractors, partners, and volunteers.

## How do I install Cerb on my own hardware?

Read the <a href="/docs/installation/">installation instructions</a> to get started.

<div id="renewal"></div>

## Do you provide a renewal discount for existing licenses?

Yes! We automatically add a 7.5% _"timely renewal_" discount to your invoice for any license that has not been expired for more than 30 days.

<div id="academic"></div>

## Do you provide an academic discount?

Yes. We offer a 25% discount in support of academic institutions.

To qualify for an academic discount, institutions must be accredited by an agency recognized by the U.S. Department of Education (or their own national equivalent).  All publicly funded K-12 and preschools automatically qualify.

[Contact us](/help/) for a coupon code.

<div id="non-profit"></div>

## What qualifies a charity or non-profit organization for a free license donation?

To receive a free Cerb license with ongoing software updates, a charity or non-profit must have a charter that seeks to improve the public good and be registered as a 501(c)(3) organization (or their own national equivalent).  The organization should be primarily funded through public donations or grants, and such contributions should be tax-deductible by the donors.

Please [contact us](/help/) for details.

<div id="opensource"></div>

## What qualifies an open source project for a free license donation?

To receive a free Cerb license with ongoing software updates, an open source project must have a website explaining the purpose of the project, 100% of source code available in a public repository like GitHub, and a self-hosted option with an open source license.

An open source license should only be used for that purpose, and not mixed with other commercial activity.

Please [contact us](/help/) for details.

## What if I plan to eventually switch to a Cerb Cloud subscription?

Your self-hosted Cerb configuration and data can be migrated to a Cerb Cloud subscription at any time.

[Contact us](/help/) to start the process.
