---
layout: post
title: "10.3.4"
excerpt: Cerb 10.3.4 is a maintenance update released in November 2022 with 15 improvements from community feedback.
author: The Cerb Team
date: 2022-11-26 12:00:00 -0800
permalink: /releases/10.3.4/
social_image_url: /assets/images/releases/10.3/10.3.4.png
redirect_from:
  - /10.3.4/
tags: cerb announcements releases
release:
  type: maintenance update
  count: 15
---

<div class="cerb-screenshot">
<img src="{{page.social_image_url}}" class="screenshot" width="500">
</div>

**Cerb (10.3.4)** is a **{{ page.release.type }}** released on {{page.date|date:'%B %d, %Y'}}. It includes **{{ page.release.count}}** minor features and fixes from community feedback covering the [10.3](/releases/10.3/) update.  You can [follow these instructions](/docs/upgrading/) to upgrade.

# Changelog

## Added

* **[Chart KATA/Tooltips]** On [Chart KATA](/docs/dashboards/widgets/chart-kata/) widgets, the `tooltip:` section now has a `ratios@bool:` option to display percentages next to each series in the tooltip. This is disabled by default. Thanks to [@mryanb](https://github.com/mryanb/) for the feature request!

* **[Chart KATA/Legends]** In Chart KATA widgets, legends now support multiple styles like `compact` and `table`. The table style displays series vertically with totals.

* **[Chart KATA/Legends]** In Chart KATA widgets, `table` legends can optionally also display series data in a grid.

* **[Chart KATA/Legends]** In Chart KATA widgets, legends now group series on the same y1/y2 axis. This makes it easier to do comparisons, and also produces more sensible computations.

* **[Chart KATA/Legends]** In Chart KATA widgets, `table` legends can compute and display any combination of `avg`, `sum`, `min`, and `max` across series.

## Fixed

* **[Profiles/Avatars]** Fixed an issue with the profile image editor where monogram text didn't use the full 256x256 resolution.

* **[UI/Popups]** Fixed an issue with the new "Are you sure?" confirmation popup. Pressing ESC twice now properly aborts the confirmation and returns to the editor. Thanks to [Flexibits](https://flexibits.com/) for the request!

* **[Comments/Autocompletion]** Fixed an issue when composing comments with an `@mention` where pressing ESC to ignore autocomplete suggestions also opened the "Are you sure you want to close this popup?" confirmation. Thanks to [@Flexibits](https://flexibits.com/) for the bug report!

* **[Mail/Drafts/Replies]** Fixed an issue where duplicate replies could be sent (usually 2-4) if a worker very rapidly clicked on the 'Resume' button of a draft in the ticket timeline. This was difficult to reproduce even with known steps (our tests were successful less than 3% of the time), but it was directly observed having taken place very rarely in a busy environment. Network latency seems to have played a part. Thanks to [1Password](https://1password.com/) for the bug report!

* **[Data Queries/Subtotals]** Fixed an issue in `worklist.subtotals` data queries where a 'Record Links' custom field in `by:` only returned IDs and not labels.

* **[Queues/Performance]** Improved the performance of the dequeue operation in queues. This now properly uses a database index to avoid table scans.

* **[Profiles/Links]** Fixed an issue with the 'Links' menu on record profiles. Clicks were ignored unless they were directly on the menu item text. Thanks to [ChargeOver](https://chargeover.com/) for the bug report!

* **[Chart KATA]** In Chart KATA widgets, fixed an issue with x-axis series consolidation. For instance, this could occur if a `worklist.subtotals` data query used `@monthofyear` with sparse results.

* **[PHP]** Miscellaneous code cleanup for PHP 8.1.

## Security

* **[Security]** Fixed a low-severity vulnerability that could only be exploited by an administrator. This will be disclosed at a later date once sufficient time has elapsed for self-hosted clients to update. We discovered the issue ourselves during a routine code audit.